
 /* NOTICE:                                             */
 /* THIS CODE IS NOT SUPPORTED, WARRANTED OR GUARANTEED */
 /* IN ANY WAY BY BROOKTREE CORPORATION.                */
 /* IT IS PROVIDED "AS IS" BECAUSE WE BELIEVE IT MAY    */
 /* BE USEFUL TO YOU.                                   */


#include <windows.h>

#include "api.h"
#include "ddiflags.h"
#include "audio.h"

/* The following typedefs define a bunch of function pointers. These functions
 * exist in the Bt848 capture driver and are available to anyone.
 */
// external video in channel  'set' group
typedef ErrorCode ( WINAPI *SETCONNECTOR_t )( Connector AConn, BOOL ApplyImm );
typedef ErrorCode ( WINAPI *SETSVIDEO_t )( State aState );

typedef ErrorCode ( WINAPI *SETBRIGHTNESS_t )( int percentOfFullScale );
typedef ErrorCode ( WINAPI *SETCONTRAST_t )( int percentOfFullScale );
typedef ErrorCode ( WINAPI *SETHUE_t )( int degrees );
typedef ErrorCode ( WINAPI *SETSATURATION_t )( int percentOfFullScale );
typedef ErrorCode ( WINAPI *SETVIDEOFORMAT_t)( VideoFormat aFormat );
typedef ErrorCode ( WINAPI *SETCCSTATUS_t)( int );
typedef void      ( WINAPI *SETCCFILENAME_t )( LPCSTR );
typedef void      ( WINAPI *SETCCALERT_t )( LPCSTR );
typedef void      ( WINAPI *SETCCCALLBACK_t )( CC_CALLBACK );

/* Now define actual pointers */
SETCONNECTOR_t  pSETCONNECTOR  = NULL;
SETSVIDEO_t     pSETSVIDEO     = NULL;

SETBRIGHTNESS_t pSETBRIGHTNESS = NULL;
SETCONTRAST_t    pSETCONTRAST    = NULL;
SETHUE_t         pSETHUE         = NULL;
SETSATURATION_t  pSETSATURATION  = NULL;

SETVIDEOFORMAT_t pSETVIDEOFORMAT = NULL;

SETCCSTATUS_t    pSETCCSTATUS    = NULL;

SETCCFILENAME_t  pSETCCFILENAME = NULL;
SETCCALERT_t     pSETCCALERT    = NULL;

SETCCCALLBACK_t  pSETCCCALLBACK = NULL;

// video in channel
typedef ErrorCode ( WINAPI *SETIMAGE_t)( LPRECT lpRect, ColFmt aFormat );
SETIMAGE_t pSETIMAGE = NULL;

// 'get' group
typedef Connector   ( WINAPI *GETCONNECTOR_t )( void );
typedef State       ( WINAPI *GETSVIDEO_t )( void );
typedef VideoFormat ( WINAPI *GETVIDEOFORMAT_t )( void );
typedef int         ( WINAPI *GETBRIGHTNESS_t )( void );
typedef int         ( WINAPI *GETCONTRAST_t )( void );
typedef int         ( WINAPI *GETHUE_t )( void );
typedef int         ( WINAPI *GETSATURATION_t )( void );
typedef int         ( WINAPI *GETIMAGESIZE_t )( LPRECT lpR );
typedef int         ( WINAPI *GETCCSTATUS_t )( void );
typedef void        ( WINAPI *GETCCFILENAME_t )( LPSTR, int );
typedef void        ( WINAPI *GETCCALERT_t )( LPSTR, int );
typedef DWORD       ( WINAPI *GETSTATUS_t )();

typedef void        ( WINAPI *PAUSE_t )();
typedef void        ( WINAPI *CONTINUE_t )();
typedef DWORD       ( WINAPI *GETOVLYFLAGS_t ) ();

GETCONNECTOR_t   pGETCONNECTOR   = NULL;
GETSVIDEO_t      pGETSVIDEO      = NULL;
GETVIDEOFORMAT_t pGETVIDEOFORMAT = NULL;
GETBRIGHTNESS_t  pGETBRIGHTNESS  = NULL;
GETCONTRAST_t    pGETCONTRAST    = NULL;
GETHUE_t         pGETHUE         = NULL;
GETSATURATION_t  pGETSATURATION  = NULL;
GETIMAGESIZE_t   pGETIMAGESIZE   = NULL;
GETCCSTATUS_t    pGETCCSTATUS    = NULL;
GETCCFILENAME_t  pGETCCFILENAME  = NULL;
GETCCALERT_t     pGETCCALERT     = NULL;
GETSTATUS_t      pGETSTATUS      = NULL;

PAUSE_t          pPAUSE          = NULL;
CONTINUE_t       pCONTINUE       = NULL;
GETOVLYFLAGS_t   pGETOVLYFLAGS   = NULL;

typedef int (WINAPI *GETIMAGEFORMAT_t)( ColFmt *pColFrmt );
GETIMAGEFORMAT_t pGETIMAGEFORMAT = NULL;

// this is needed to load dialog resources
static HINSTANCE ghModule;
HINSTANCE WINAPI GetOurInstance( void )
{ return ghModule; }

// these guys are used to select an appropriate audio input
extern SetAudioSource( DWORD );
extern SetAudioMute( DWORD );

#pragma argsused
#ifdef __cplusplus
extern "C"
{
#endif
int FAR PASCAL LibMain( HINSTANCE hInst, WORD w1, WORD w2, LPSTR str )
{
   ghModule = hInst;
   return 1;
}

/* API: Connect
 * Purpose: This function is called by the Bt848 video capture driver after it
 *   loads a DLL named Bt848dlg.dll to give a dialogs DLL a chance to initialize
 *   itself by obtaining all the exported entry points from the capture driver
 * Note: WINAPI calling convention is assumed by the bt848.drv
 *   Any DLL-specific activity can happen here ( except calling the exported functions
 *   as the capture driver is not fully initialized itself yet ).
 */
BOOL WINAPI _export Connect( HINSTANCE hDriver )
{
   // go and get all the exported functions
   pSETIMAGE       = (SETIMAGE_t)      GetProcAddress( hDriver, "SetImage" );
   pGETIMAGEFORMAT = (GETIMAGEFORMAT_t)GetProcAddress( hDriver, "GetImageFormat" );
   pSETCONNECTOR   = (SETCONNECTOR_t)  GetProcAddress( hDriver, "SetConnector" );
   pSETBRIGHTNESS  = (SETBRIGHTNESS_t) GetProcAddress( hDriver, "SetBrightness" );

   pSETSVIDEO      = (SETSVIDEO_t)     GetProcAddress( hDriver, "SetSVideo" );

   pSETCONTRAST    = (SETCONTRAST_t)   GetProcAddress( hDriver, "SetContrast" );
   pSETHUE         = (SETHUE_t)        GetProcAddress( hDriver, "SetHue" );
   pSETSATURATION  = (SETSATURATION_t) GetProcAddress( hDriver, "SetSaturation" );
   pSETVIDEOFORMAT = (SETVIDEOFORMAT_t)GetProcAddress( hDriver, "SetVideoFormat" );
   pSETCCSTATUS    = (SETCCSTATUS_t)   GetProcAddress( hDriver, "SetCCStatus" );
   pSETCCFILENAME  = (SETCCFILENAME_t) GetProcAddress( hDriver, "SetCCFileName" );
   pSETCCALERT     = (SETCCALERT_t)    GetProcAddress( hDriver, "SetCCAlert" );
   pSETCCCALLBACK  = (SETCCCALLBACK_t) GetProcAddress( hDriver, "SetCCCallback" );

   pGETCONNECTOR   = (GETCONNECTOR_t)  GetProcAddress( hDriver, "GetConnector" );
   pGETSVIDEO      = (GETSVIDEO_t)     GetProcAddress( hDriver, "GetSVideo" );
   pGETVIDEOFORMAT = (GETVIDEOFORMAT_t)GetProcAddress( hDriver, "GetVIdeoFormat" );
   pGETBRIGHTNESS  = (GETBRIGHTNESS_t) GetProcAddress( hDriver, "GetBrightness" );
   pGETCONTRAST    = (GETCONTRAST_t)   GetProcAddress( hDriver, "GetContrast" );
   pGETHUE         = (GETHUE_t)        GetProcAddress( hDriver, "GetHue" );
   pGETSATURATION  = (GETSATURATION_t) GetProcAddress( hDriver, "GetSaturation" );
   pGETIMAGESIZE   = (GETIMAGESIZE_t)  GetProcAddress( hDriver, "GetImageSize" );
   pGETCCSTATUS    = (GETCCSTATUS_t)   GetProcAddress( hDriver, "GetCCStatus" );
   pGETCCFILENAME  = (GETCCFILENAME_t) GetProcAddress( hDriver, "GetCCFileName" );
   pGETCCALERT     = (GETCCALERT_t)    GetProcAddress( hDriver, "GetCCAlert" );
   pGETSTATUS      = (GETSTATUS_t)     GetProcAddress( hDriver, "GetStatus" );
   pPAUSE          = (PAUSE_t)         GetProcAddress( hDriver, "Pause" );
   pCONTINUE       = (CONTINUE_t)      GetProcAddress( hDriver, "Continue" );

   pGETOVLYFLAGS   = (GETOVLYFLAGS_t)  GetProcAddress( hDriver, "GetOverlayFlags" );
   return TRUE;
}

/* API: Disconnect
 * Purpose: This function is called by the Bt848 capture driver to let a dialogs
 *   DLL know that a session is over
 */
void WINAPI _export Disconnect()
{
   // mute audio when terminates
   SetAudioSource( AUDIO_SOURCE_MUTE );
}

/* API: Initialize
 * Purpose: This function is called by the Bt848 capture driver when it is fully
 *   initialized. It is a good place to turn audio on, etc.
 */
ErrorCode WINAPI _export Initialize()
{
   // ask th capture driver about current video connector...
   Connector CurCon = GetConnector();
   // ... and set audio mux appropriately
   switch ( CurCon ) {
   case ConTuner:
      SetAudioSource( AUDIO_SOURCE_TVTUNER );
      break;
   case ConComposite:
   default:
      SetAudioSource( AUDIO_SOURCE_EXTAUDIO );
      break;
   }
   GetStatus();
   return Success;
}

/* The following functions are exported by the dialogs DLL so an application
 * can make use of the functionality as well ( without popping dialogs )
 */

// sets image dimentions and color format
ErrorCode WINAPI _export SetImage( LPRECT lpRect, ColFmt aFormat )
{
   return pSETIMAGE ? pSETIMAGE( lpRect, aFormat ) : Fail;
}

// gets image dimentions and color format
int WINAPI _export GetImageFormat( ColFmt *pColFrmt )
{
   return pGETIMAGEFORMAT ? pGETIMAGEFORMAT( pColFrmt ) : 0;
}

/* API:
 * Purpose: selects a video connector.
 * Input: AConn: Connector, video connector to use
 *   ApplyImm: BOOL, indicates if needs to be applied immediately
 */
ErrorCode WINAPI _export SetConnector( Connector AConn, BOOL ApplyImm )
{
   return  pSETCONNECTOR ? pSETCONNECTOR( AConn, ApplyImm ) : Fail;
}

ErrorCode WINAPI _export SetSVideo( State aState )
{
   return pSETSVIDEO ? pSETSVIDEO( aState ) : Fail;
}

// sets contrast
ErrorCode WINAPI _export SetContrast( int value )
{
   return pSETCONTRAST ? pSETCONTRAST( value ) : 1;
}

// sets brigtness
ErrorCode WINAPI _export SetBrightness( int value )
{
   return pSETBRIGHTNESS ? pSETBRIGHTNESS( value ) : Fail;
}

// sets hue
ErrorCode WINAPI _export SetHue( int value )
{
   return pSETHUE ? pSETHUE( value ) : 1;
}

// sets saturation
ErrorCode WINAPI _export SetSaturation( int value )
{
   return pSETSATURATION ? pSETSATURATION( value ) : 1;
}

// selects NTSC/PAL/SECAM
ErrorCode WINAPI _export SetVideoFormat( VideoFormat aFormat )
{
   return pSETVIDEOFORMAT ? pSETVIDEOFORMAT( aFormat ) : 1;
}

// sets closed captioning parameters
ErrorCode WINAPI _export SetCCStatus( int st )
{
   return pSETCCSTATUS ? pSETCCSTATUS( st ) : Fail;
}

// sets the name of a file with decoded closed caption data
void WINAPI _export SetCCFileName( LPCSTR name )
{
   if ( pSETCCFILENAME ) pSETCCFILENAME( name );
}

// sets the alert token wich will trigger a message box
void WINAPI _export SetCCAlert( LPCSTR token )
{
   if ( pSETCCALERT ) pSETCCALERT( token );
}

// gets current video connector
Connector WINAPI _export GetConnector( void )
{
   return  pGETCONNECTOR ? pGETCONNECTOR() : -1;
}

// gets state of SVideo bit
State WINAPI _export GetSVideo( void )
{
   return  pGETSVIDEO ? pGETSVIDEO() : Off;
}

// gets current video signal format ( NTSC/PAL/SECAM )
VideoFormat WINAPI _export GetVideoFormat( void )
{
   return  pGETVIDEOFORMAT ? pGETVIDEOFORMAT() : -1;
}

// obtains current brigtness settings
int WINAPI _export GetBrightness( void )
{
   return  pGETBRIGHTNESS ? pGETBRIGHTNESS() : -1;
}

// obtains current contrast
int WINAPI _export GetContrast( void )
{
   return  pGETCONTRAST ? pGETCONTRAST() : -1;
}

// obtains current hue value
int WINAPI _export GetHue( void )
{
   return  pGETHUE ? pGETHUE() : -1;
}

// obtains current saturation value
int WINAPI _export GetSaturation( void )
{
   return  pGETSATURATION ? pGETSATURATION() : -1;
}

// obtains current closed captioning status
int WINAPI _export GetCCStatus( void )
{
   return pGETCCSTATUS ? pGETCCSTATUS() : 0;
}

// obtains current image size
void WINAPI _export GetImageSize( LPRECT lpR )
{
   if ( pGETIMAGESIZE ) pGETIMAGESIZE( lpR );
}

// gets the name of a file with decoded closed caption data. cnt is the max # of bytes to get
void WINAPI _export GetCCFileName( LPSTR name, int cnt )
{
   if ( pGETCCFILENAME ) pGETCCFILENAME( name, cnt );
}

// gets the alert token wich will trigger a message box. cnt is the max # of bytes to get
void WINAPI _export GetCCAlert( LPSTR token, int cnt )
{
   if ( pGETCCALERT ) pGETCCALERT( token, cnt );
}

DWORD WINAPI _export GetStatus( void )
{
   return pGETSTATUS ? pGETSTATUS() : 0;
}

void WINAPI _export Pause( void )
{
   if ( pPAUSE )
      pPAUSE();
}

void WINAPI _export Continue( void )
{
   if ( pCONTINUE )
      pCONTINUE();
}

DWORD WINAPI _export GetOverlayFlags( void )
{
   return pGETOVLYFLAGS ? pGETOVLYFLAGS() : 0;
}

void WINAPI _export SetCCCallback( CC_CALLBACK cb )
{
   if ( pSETCCCALLBACK )
      pSETCCCALLBACK( cb );
}

#ifdef __cplusplus
}
#endif
