
 /* NOTICE:                                             */
 /* THIS CODE IS NOT SUPPORTED, WARRANTED OR GUARANTEED */
 /* IN ANY WAY BY BROOKTREE CORPORATION.                */
 /* IT IS PROVIDED "AS IS" BECAUSE WE BELIEVE IT MAY    */
 /* BE USEFUL TO YOU.                                   */


#include <stdlib.h>
#include <mem.h>
#include "api.h"       
#include "config.h"
#include "exviddlg.h"
#include "dialogs.h"

#include "bt848api.h"
#include "audio.h"

extern HINSTANCE WINAPI GetOurInstance( void );

static int SizeOption;
static int VidSourceUp;

typedef struct tag_combobox_entry
{
   WORD wValue;
   char *szText;
} COMBOBOX_ENTRY;


//
// Loads entries into a combobox, and selects the current index
// Parmameters:
//      hWnd of the parent dialog box
//      ID of the combobox
//      array of text and values
//      Count of entries in the COMBOBOX_ENTRY array
//      Initial value which should match the wValue field of the
//              COMBOBOX_ENTRY.  If no values match, the selection
//              defaults to the first entry in the combobox.
// Returns:
//      Returns the index of the selected item in the combobox.
//

static int WINAPI ConfigLoadComboBox( HWND hDlg, int wID, COMBOBOX_ENTRY *pCBE,
   int nEntries, WORD wInitialValue )
{
   int	j;
   int	nIndex = 0;	// Zero entry should be blank, None, etc.
   HWND hWndCB = GetDlgItem( hDlg, wID );

   // make sure no old strings are present
   int items = (int)SendMessage( hWndCB, CB_GETCOUNT, 0, 0 );
   for ( ; items >= 0; )
      SendMessage( hWndCB, CB_DELETESTRING, --items, 0 );

  // add new strings
   for ( j = 0; j < nEntries; j++ ) {
      SendMessage( hWndCB, CB_ADDSTRING, 0, (LONG)(LPSTR)((pCBE+j)->szText ) );
      if ( pCBE [j].wValue == wInitialValue )
         nIndex = j;
      }
   SendMessage( hWndCB, CB_SETCURSEL, nIndex, 0L );
   return nIndex;
}

static COMBOBOX_ENTRY gwSizeOptions[] [3] =
{
   {
      { 0, "160 x 120" },
      { 1, "320 x 240" },
      { 2, "640 x 480" }
   },
   {
      { 0, "192 x 142" },
      { 1, "384 x 284" },
      { 2, "768 x 568" }
   },
   {
      { 0, "1024 x 434" },
      { 1, "1024 x 868" },
      { 2, "1024 x 868" }
   }
};
#define N_SIZEOPTIONS (sizeof (gwSizeOptions [0] ) / sizeof (COMBOBOX_ENTRY))

static COMBOBOX_ENTRY gwFormatOptions[] =
{
   { CF_RGB32, "32 bit RGBA" },
   { CF_RGB24, "24 bit RGB"  },
   { CF_RGB15, "15 bit RGB"  },
   { CF_YUY2,  "YUY2"        },
   { CF_BTYUV, "BTYUV"       },
   { CF_YUV9,  "YUV9"        },
   { CF_I420,  "YUV12"       },
   { CF_RAW,   "Raw ADC data"}
};

#define N_FORMATOPTIONS (sizeof (gwFormatOptions) / sizeof (COMBOBOX_ENTRY))

RECT RectArr [] [3] =
{
   {
      { 0, 0, 160, 120 },
      { 0, 0, 320, 240 },
      { 0, 0, 640, 480 }
   },
   {
      { 0, 0, 192, 142 },
      { 0, 0, 384, 284 },
      { 0, 0, 768, 568 }
   },
   {
      { 0, 0, 1024, 434 },
      { 0, 0, 1024, 868 },
      { 0, 0, 1024, 868 }
   }
};

#define ARR_SIZE( arr ) sizeof( arr ) / sizeof( arr##[0] )

inline VOID UpdateSizeDisplay( HWND hDlg, WPARAM wIdx )
{
   SendDlgItemMessage( hDlg, ID_LBSIZE, CB_SETCURSEL, wIdx, 0L );
}

static WORD WINAPI ConfigGetComboBoxValue( HWND  hDlg, int wID,
   COMBOBOX_ENTRY *pCBE )
{
   int	nIndex;
   HWND	hWndCB = GetDlgItem( hDlg, wID );
   nIndex = (int) SendMessage( hWndCB, CB_GETCURSEL, 0, 0L );
   nIndex = max( 0, nIndex );//LB_ERR is negative
   return pCBE [nIndex].wValue;
}

///
#pragma argsused
int WINAPI _loadds VideoFormatDlgProc( HWND hDlg, UINT msg, WPARAM wParam,
   LPARAM lParam )
{
   ColFmt Col;
   RECT r;
   int i;

   switch ( msg ) {
   case WM_INITDIALOG:
      GetImageSize( & r );
      GetImageFormat( &Col );

      if ( !VidSourceUp )
         SizeOption = GetVideoFormat() == VFormat_NTSC ? 0 : 1;

      // raw mode has very different sizes
      if ( Col == CF_RAW )
         SizeOption = 2;

      // find our index
      for ( i = 0; i < ARR_SIZE( RectArr [0] ); i++ )
         // have to do 'C' comparison as this should be 'C' compileable
         if ( memcmp( &r, RectArr [SizeOption] + i, sizeof( RECT ) ) == 0 )
            break;
      if ( i >= ARR_SIZE( RectArr [0] ) )
         i = 1;

      ConfigLoadComboBox( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption],
         N_SIZEOPTIONS - ( SizeOption == 2 ), i );
      ConfigLoadComboBox( hDlg, ID_LBIMAGEFORMAT, gwFormatOptions,
         N_FORMATOPTIONS, Col );

      if ( VidSourceUp ) {
         HWND hCtl = GetDlgItem( hDlg, IDCANCEL );
         EnableWindow( hCtl, FALSE );
      }
      break;
      // User will unload this module at exit time, so make
      // sure that the dialog is gone if the user just quits
      // Windows with the dialog box up.
   case WM_ENDSESSION:
      if ( wParam )
         EndDialog( hDlg, IDCANCEL );
      break;

   case WM_COMMAND:
      switch ( wParam ) {
      case IDOK:
         if ( !VidSourceUp )
            SizeOption = GetVideoFormat() == VFormat_NTSC ? 0 : 1;

         Col = (ColFmt)ConfigGetComboBoxValue( hDlg, ID_LBIMAGEFORMAT, gwFormatOptions );
         if ( Col == CF_RAW )
            SizeOption = 2;

         SetImage( &RectArr [SizeOption] [ConfigGetComboBoxValue( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption] )],
            Col );
         EndDialog( hDlg, IDOK );
         break;
      case IDCANCEL:
         EndDialog( hDlg, IDCANCEL );
         break;
      case ID_LBIMAGEFORMAT:
         if ( HIWORD( lParam ) != CBN_SELCHANGE )
            break;
         if ( CF_RAW == (ColFmt)ConfigGetComboBoxValue( hDlg, ID_LBIMAGEFORMAT, gwFormatOptions ) )
            ConfigLoadComboBox( hDlg, ID_LBSIZE, gwSizeOptions [2],
               N_SIZEOPTIONS - 1, 0 );
         else {
            SizeOption = GetVideoFormat() == VFormat_NTSC ? 0 : 1;
            ConfigLoadComboBox( hDlg, ID_LBSIZE, gwSizeOptions [SizeOption],
               N_SIZEOPTIONS, 0 );
         }
         break;
      case ID_PBSIZEFULL:
         UpdateSizeDisplay( hDlg, 2 );
         break;
      case ID_PBSIZEHALF:
         UpdateSizeDisplay( hDlg, 1 );
         break;
      case ID_PBSIZEQUARTER:
         UpdateSizeDisplay( hDlg, 0 );
         break;
      case ID_PBSIZEEIGHTH:
         UpdateSizeDisplay( hDlg, ( ARR_SIZE( RectArr ) - 1 ) / 8 );
         break;
      default:
         break;
         }
      break;

   default:
      return FALSE;
   }
   return TRUE;
}

WORD WINAPI VidFormatDialog( HWND hParent )
{
   if ( DialogBox( GetOurInstance(), MAKEINTRESOURCE( DLG_VIDEOFORMAT ),
      hParent, VideoFormatDlgProc ) != -1 )
      return 0;
   return 1;
}


#define WM_UPDATEDIALOG  (WM_USER+200)

int ColorProcessScroll( HWND hDlg, HWND hCtl, WORD wParam, DWORD lParam,
   int iVal, WORD wIDEditBox )
{
   int iPageSize;
   int iMin, iMax;

   GetScrollRange( hCtl, SB_CTL, &iMin, &iMax );
   iPageSize = 1 + ( ( iMax - iMin ) / 10 );

   switch ( wParam ) {
   case SB_LINEDOWN:
      iVal++;
      break;
   case SB_LINEUP:
      iVal--;
      break;
   case SB_PAGEDOWN:
      iVal += iPageSize;
      break;
   case SB_PAGEUP:
      iVal -= iPageSize;
      break;
   case SB_THUMBTRACK:
      iVal = LOWORD ( lParam );
      break;
   default:
      break;
   }
   iVal = LimitRange( iVal, iMin, iMax );
   SetScrollPos( hCtl, SB_CTL, iVal, TRUE );
   SetDlgItemInt( hDlg, wIDEditBox, iVal, TRUE );
   return iVal;
}

DWORD FmtDlgHelpIDs [] = {
   ID_LBIMAGEFORMAT,   IDH_IMAGE_FORMAT,
   ID_PBSIZEFULL,      IDH_SIZE,
   ID_PBSIZEHALF,      IDH_SIZE,
   ID_PBSIZEQUARTER,   IDH_SIZE,
   ID_PBSIZEEIGHTH,    IDH_SIZE,
   ID_LBSIZE,          IDH_SIZE,
};

DWORD SrcDlgHelpIDs [] = {
   ID_RBSOURCE0,  IDH_VIDEO_CONNECT,
   ID_RBSOURCE1,  IDH_VIDEO_CONNECT,
   ID_RBSOURCE2,  IDH_VIDEO_CONNECT,
   ID_RBNTSC,	   IDH_VIDEO_STANDARD,
   ID_RBPAL,      IDH_VIDEO_STANDARD,
   ID_RBSECAM,    IDH_VIDEO_STANDARD
//   ID_CBSVHS,     IDH_VIDEO_STANDARD

};

/* Function:  GetAudioSource ( void )
 * Purpose: Get audio source
 * Input:   None
 * Output:  None
 * Return:  audio source - AUDIO_SOURCE_CDROM, AUDIO_SOURCE_EXTAUDIO,
                         AUDIO_SOURCE_TVTUNER, AUDIO_SOURCE_MUTE
*/
DWORD GetAudioSource( void )
{
   // read GPIE from pin (not register)
   SetGPIE( 0x00000000L );

   // ask GPIO what the setting is
   DWORD value;
   return ( GetGPDATABits( 0, 1, &value, 0 ) == Success ? value : -1 );
}


/* Method:  ULONG SetAudioSource ( ULONG audio )
 * Purpose: Set audio source
 * Input:   ULONG audio - AUDIO_SOURCE_CDROM, AUDIO_SOURCE_EXTAUDIO,
 *    AUDIO_SOURCE_TVTUNER, AUDIO_SOURCE_MUTE
 * Output:  None
 * Return:  TV control error value
*/
ErrorCode SetAudioSource( DWORD audio )
{
   if ( audio > AUDIO_SOURCE_MUTE )
      return Fail;

   // enables GPOE drivers for [1:0]
   // for whatever reason, need to set to 0x0F in order for the audio to work
   SetGPOE( 0x0000000FL );
   SetGPDATABits( 0, 1, audio, 0 );
   return Success;
/*
   // if already mute, don't change audio source, just remember it
   if ( GetAudioSource() == AUDIO_SOURCE_MUTE ) {
      return Success;
   } else {  // not in mute, change audio source
      if ( SetGPDATABits( 0, 1, audio, 0 ) == Success ) {
         return Success;
      } else
         return Fail;
   }
*/
}

/* Function: SetAudioMute
 * Purpose: Mute or UnMute audio
 * Input:   ULONG mute - 1 to mute; 0 to unmute
 * Output:  None
 * Return:  TV control error value
*/
ErrorCode SetAudioMute( DWORD mute )
{
   if ( mute > 1 )
      return Fail;

   // enables GPOE drivers for [1:0]
   // for whatever reason, need to set to 0x0F in order for the audio to work
   SetGPOE( 0x0000000FL );

   if ( mute == 1 ) {
      if ( GetAudioSource() == AUDIO_SOURCE_MUTE )
         return Fail;
      else
         return SetGPDATABits( 0, 1, AUDIO_SOURCE_MUTE, 0 );
   }
   return Success;
}


//
// Dialog proc for the video source dialog box (VIDEO_EXTERNALIN channel)
//
#pragma argsused
int WINAPI _loadds VideoSourceDlgProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
   static int Brightness;
   static int Contrast;
   static int Saturation;
   static int Hue;
   WORD wID;
   HWND hCtl;

   switch ( msg ) {
   case WM_INITDIALOG: {
         Connector CurCon;
         VideoFormat fmt;

         // start up audio not mute
         SetAudioMute( 0 );

         Brightness = GetBrightness();
         Contrast   = GetContrast();
         Saturation = GetSaturation();
         Hue        = GetHue();

         hCtl = GetDlgItem( hDlg, ID_SBBRIGHTNESS );
         SetScrollRange( hCtl, SB_CTL , 0, 255, FALSE );

         hCtl = GetDlgItem( hDlg, ID_SBCONTRAST );
         SetScrollRange( hCtl, SB_CTL, 0, 255, FALSE );

         hCtl = GetDlgItem( hDlg, ID_SBSATURATION );
         SetScrollRange( hCtl, SB_CTL, 0, 255, FALSE );

         hCtl = GetDlgItem( hDlg, ID_SBHUE );
         SetScrollRange( hCtl, SB_CTL, 0, 255, FALSE );

         // intentional fall-through
   case WM_UPDATEDIALOG:
         Brightness = LimitRange( Brightness, 0, 255 );
         SetDlgItemInt( hDlg, ID_EBBRIGHTNESS, Brightness, TRUE );
         hCtl = GetDlgItem( hDlg, ID_SBBRIGHTNESS );
         SetScrollPos( hCtl, SB_CTL, Brightness, TRUE );

         Contrast = LimitRange( Contrast, 0, 255 );
         SetDlgItemInt( hDlg, ID_EBCONTRAST, Contrast, FALSE );
         hCtl = GetDlgItem( hDlg, ID_SBCONTRAST );
         SetScrollPos( hCtl, SB_CTL, Contrast, TRUE );

         Saturation = LimitRange( Saturation, 0, 255 );
         SetDlgItemInt( hDlg, ID_EBSATURATION, Saturation, FALSE );
         hCtl = GetDlgItem( hDlg, ID_SBSATURATION );
         SetScrollPos( hCtl, SB_CTL, Saturation, TRUE );

         Hue = LimitRange( Hue, 0, 255 );
         SetDlgItemInt( hDlg, ID_EBHUE, Hue, TRUE );
         hCtl = GetDlgItem( hDlg, ID_SBHUE );
         SetScrollPos( hCtl, SB_CTL, Hue, TRUE );

         CurCon = GetConnector();
         CheckRadioButton( hDlg, ID_RBSOURCE0, ID_RBSOURCE2,
            CurCon == ConTuner ? 
               SetAudioSource( AUDIO_SOURCE_TVTUNER ), ID_RBSOURCE0 : 
               CurCon == ConComposite ? ID_RBSOURCE1 : ID_RBSOURCE2 );

         fmt = GetVideoFormat();
         CheckRadioButton( hDlg, ID_RBNTSC, ID_RBSECAM,
            fmt == VFormat_NTSC ? ID_RBNTSC : fmt == VFormat_PAL_BDGHI ? ID_RBPAL : ID_RBSECAM );

//         CheckDlgButton( hDlg, ID_CBSVHS, GetSVideo() );
         // after edit boxes were aupdated
         SetBrightness( Brightness );
         SetContrast( Contrast );
         SetSaturation( Saturation );
         SetHue( Hue );

         // re-enable the hue edit box which could be disabled. scroll bar gets
         // enabled by the SetScrollPos
         hCtl = GetDlgItem( hDlg, ID_EBHUE );
         EnableWindow( hCtl, TRUE );

         break;
      }
      // User will unload this module at exit time, so make
      // sure that the dialog is gone if the user just quits
      // Windows with the dialog box up.
   case WM_ENDSESSION:
      if ( wParam )
         EndDialog( hDlg, IDCANCEL );
      break;
   case WM_COMMAND:
      switch ( wParam ) {
      case IDOK:
         if ( IsDlgButtonChecked( hDlg, ID_RBSOURCE0 ) )
            SetConnector( ConTuner, TRUE );
         else
            if ( IsDlgButtonChecked( hDlg, ID_RBSOURCE1 ) )
               SetConnector( ConComposite, TRUE );
            else
               SetConnector( ConSVideo, TRUE );
         if ( IsDlgButtonChecked( hDlg, ID_RBNTSC ) )
            SetVideoFormat( VFormat_NTSC );
         else
            if ( IsDlgButtonChecked( hDlg, ID_RBPAL ) )
               SetVideoFormat( VFormat_PAL_BDGHI );
            else
               SetVideoFormat( VFormat_SECAM );

         EndDialog( hDlg, IDOK );
         break;
      case IDCANCEL:
         EndDialog( hDlg, IDCANCEL );
         break;
      case ID_RBSOURCE0:
         SetConnector( ConTuner, TRUE );
         SetAudioSource( AUDIO_SOURCE_TVTUNER );
         break;
      case ID_RBSOURCE1:
         SetConnector( ConComposite, TRUE );
         SetAudioSource( AUDIO_SOURCE_EXTAUDIO );
         break;
      case ID_RBSOURCE2:
         SetConnector( ConSVideo, TRUE );
         SetAudioSource( AUDIO_SOURCE_EXTAUDIO );
         break;
      case ID_RBPAL:
      case ID_RBSECAM:
         hCtl = GetDlgItem( hDlg, ID_EBHUE );
         EnableWindow( hCtl, FALSE );
         hCtl = GetDlgItem( hDlg, ID_SBHUE );
         EnableWindow( hCtl, FALSE );

         // make sure sizes are OK
         SizeOption = 1;
         VidFormatDialog( hDlg );
         break;
      case ID_RBNTSC:
         hCtl = GetDlgItem( hDlg, ID_EBHUE );
         EnableWindow( hCtl, TRUE );
         hCtl = GetDlgItem( hDlg, ID_SBHUE );
         EnableWindow( hCtl, TRUE );

         // make sure sizes are OK
         SizeOption = 0;
         VidFormatDialog( hDlg );
         break;                  
      case ID_PBDEFAULT:
         Brightness = 128;
         Contrast   = 128;
         Saturation = 128;
         Hue        = 128;
         SendMessage( hDlg, WM_UPDATEDIALOG, 0, 0L );
         break;
         /*
      case ID_CBSVHS:
         if ( IsDlgButtonChecked( hDlg, ID_CBSVHS ) )
            SetSVideo( On );
         else
            SetSVideo( Off );
         break;
         */
/*
      case 0x0053: //WM_HELP
      case WM_CONTEXTMENU:
         WinHelp( ((LPHELPINFO) lParam)->hItemHandle, szHelpFileName,
            HELP_WM_HELP, (DWORD) (LPSTR) aConfigDlgHelpIDs );
         break;
*/
      case ID_HELP:
         {
            char HelpFile [100];
            if ( LoadString( GetOurInstance(), IDS_HELPFILE, HelpFile, sizeof( HelpFile ) ) )
               WinHelp( hDlg, HelpFile, HELP_CONTEXT, (DWORD)SrcDlgHelpIDs );
            break;
         }
      case ID_EBBRIGHTNESS:
      case ID_EBCONTRAST:
      case ID_EBSATURATION:
      case ID_EBHUE:
         if ( HIWORD( lParam ) != EN_KILLFOCUS )
         return FALSE;

         Brightness = GetDlgItemInt( hDlg, ID_EBBRIGHTNESS, NULL, TRUE );
         Contrast = GetDlgItemInt( hDlg, ID_EBCONTRAST, NULL, FALSE );
         Saturation = GetDlgItemInt( hDlg,ID_EBSATURATION, NULL, FALSE );
         Hue = GetDlgItemInt( hDlg, ID_EBHUE, NULL, TRUE );
         SendMessage( hDlg, WM_UPDATEDIALOG, 0, 0L );
         break;
      }
      break;
   case WM_HSCROLL:

      hCtl = (HWND)HIWORD( lParam );
      wID = GetWindowWord( hCtl, GWW_ID );
      switch ( wID ) {
      case ID_SBBRIGHTNESS:
         Brightness = ColorProcessScroll( hDlg, hCtl,
            wParam, lParam, Brightness, ID_EBBRIGHTNESS );
         SetBrightness( Brightness );
         break;
      case ID_SBCONTRAST:
         Contrast = ColorProcessScroll( hDlg, hCtl,
            wParam, lParam, Contrast, ID_EBCONTRAST );
         SetContrast( Contrast );
         break;
      case ID_SBSATURATION:
         Saturation = ColorProcessScroll( hDlg, hCtl, wParam,
            lParam, Saturation, ID_EBSATURATION );
         SetSaturation( Saturation );
         break;
      case ID_SBHUE:
         Hue = ColorProcessScroll( hDlg, hCtl, wParam,
            lParam, Hue, ID_EBHUE );
         SetHue( Hue );
         break;
      }
      break;
   default:
      return FALSE;
   }

   return TRUE;
}

WORD WINAPI VideoSourceDialog( HWND hParent )
{
   Connector CurCon;
   VideoFormat fmt;
   int Brightness;
   int Contrast;
   int Saturation;
   int Hue;

   CurCon = GetConnector();
   fmt = GetVideoFormat();

   Brightness = GetBrightness();
   Contrast   = GetContrast();
   Saturation = GetSaturation();
   Hue        = GetHue();

   VidSourceUp = TRUE;

   switch ( DialogBox( GetOurInstance(), MAKEINTRESOURCE( DLG_VIDEOSOURCE ),
      hParent, VideoSourceDlgProc ) ) {
   case IDOK:
      break;
   case IDCANCEL:
      // restore the values
      SetConnector( CurCon, TRUE );
      SetVideoFormat( fmt );
      SetBrightness( Brightness );
      SetContrast( Contrast );
      SetSaturation( Saturation );
      SetHue( Hue );
      break;
   case -1:
      VidSourceUp = FALSE;
      return 1;
   }
   VidSourceUp = FALSE;
   return 0;
}

/* CALLBACK:
 * Purpose:
 */
int WINAPI _loadds VideoDisplayProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM )
{
   static int DoCC;
   switch ( msg ) {
   case WM_INITDIALOG: {
      int RB;
      char str [80];
      DoCC = GetCCStatus();
      if ( DoCC & 0x8000 ) {
         CheckDlgButton( hDlg, IDC_CBCC, 1 );
         RB = DoCC &  1 ? IDC_RBCC1 : IDC_RBCC2;
      } else {
         CheckDlgButton( hDlg, IDC_CBCC, 0 );
         RB = IDC_RBCC1;
         EnableWindow( GetDlgItem( hDlg, IDC_RBCC1 ), false );
         EnableWindow( GetDlgItem( hDlg, IDC_RBCC2 ), false );
         EnableWindow( GetDlgItem( hDlg, IDC_CCTOKEN ), false );
         EnableWindow( GetDlgItem( hDlg, IDC_FILENAME ), false );
      }
      CheckRadioButton( hDlg, IDC_RBCC1, IDC_RBCC2, RB );
      GetCCFileName( str, sizeof( str ) - 1 );
      SetDlgItemText( hDlg, IDC_FILENAME, str );
      GetCCAlert( str, sizeof( str ) - 1 );
      SetDlgItemText( hDlg, IDC_CCTOKEN, str );

      break;
      }
   case WM_COMMAND:
      switch ( wParam ) {
      case IDOK:
         if ( IsDlgButtonChecked( hDlg, IDC_CBCC ) ) {
            DoCC = 0x8000;
            if ( IsDlgButtonChecked( hDlg, IDC_RBCC1 ) )
               DoCC |= 0x0001;
            else
               DoCC |= 0x0002;
            char str [80];
            GetDlgItemText( hDlg, IDC_CCTOKEN, str, sizeof( str ) - 1 );
            SetCCAlert( str );
            GetDlgItemText( hDlg, IDC_FILENAME, str, sizeof( str ) - 1 );
            SetCCFileName( str );
         } else
            DoCC = 0;
         // no break
      case IDCANCEL:
         SetCCStatus( DoCC );
         EndDialog( hDlg, IDCANCEL );
         break;
      case IDC_CBCC:
         if ( !IsDlgButtonChecked( hDlg, IDC_CBCC ) ) {
            EnableWindow( GetDlgItem( hDlg, IDC_RBCC1 ), false );
            EnableWindow( GetDlgItem( hDlg, IDC_RBCC2 ), false );
            EnableWindow( GetDlgItem( hDlg, IDC_CCTOKEN ), false );
            EnableWindow( GetDlgItem( hDlg, IDC_FILENAME ), false );
         } else {
            EnableWindow( GetDlgItem( hDlg, IDC_RBCC1 ), true );
            EnableWindow( GetDlgItem( hDlg, IDC_RBCC2 ), true );
            EnableWindow( GetDlgItem( hDlg, IDC_CCTOKEN ), true );
            EnableWindow( GetDlgItem( hDlg, IDC_FILENAME ), true );
         }
         break;
      default:
         return FALSE;
      }
      break;
    default:
       return FALSE;
   }
   return TRUE;
}

/* Function: VideoDisplay
 * Purpose: Starts Video Display dialog
 */
WORD VideoDisplay( HWND hParent )
{
   return DialogBox( GetOurInstance(), MAKEINTRESOURCE( EXTVIDOUT_DLG ),
      hParent, VideoDisplayProc );
}

/* Function: VideoDialog
 * Purpose: Dialog dispatcher
 * Input: hParent: HWND, parent window
 *   dlg: int, dialog number
 */
#ifdef __cplusplus
extern "C"
#endif
WORD WINAPI _export VideoDialog( HWND hParent, int dlg )
{
   switch ( dlg ) {
   case VIDEO_SOURCE:
      return  VideoSourceDialog( hParent );
   case VIDEO_FORMAT:
      return VidFormatDialog( hParent );
   case VIDEO_DISPLAY:
      return VideoDisplay( hParent );
   default:
      return 0;
   }
}

