'------------------------------------------------------------------------------
' WINAPI.INC
'
' Windows NT 3.51 API, Constant, and Type definitions.
' Microsoft Test Version 4.0
'------------------------------------------------------------------------------
'$ifndef _WIN_API_INCLUDED_
'$define _WIN_API_INCLUDED_

' Type definitions to help simplify calling C routines and Window API
' The list is obviously incomplete
'-------------------------------------------------------------------------------
type HANDLE     as long
type HMODULE    as HANDLE
type HWND       as HANDLE
type HMENU      as HANDLE
type HICON      as HANDLE
type HCURSOR    as HANDLE
type HBITMAP    as HANDLE
type HIMAGELIST as HANDLE
type HTREEITEM  as HANDLE
type HKEY       as HANDLE
type HFILE      as HANDLE
type WPARAM     as long
type LPARAM     as long
type BOOL       as long
type ID         as integer

'*******************************************************************************
' ERROR values
'*******************************************************************************
const NO_ERROR = 0& ' dderror
const ERROR_SUCCESS = 0&
const ERROR_INVALID_FUNCTION = 1& ' dderror
const ERROR_FILE_NOT_FOUND = 2&
const ERROR_PATH_NOT_FOUND = 3&
const ERROR_TOO_MANY_OPEN_FILES = 4&
const ERROR_ACCESS_DENIED = 5&
const ERROR_INVALID_HANDLE = 6&
const ERROR_ARENA_TRASHED = 7&
const ERROR_NOT_ENOUGH_MEMORY = 8& ' dderror
const ERROR_INVALID_BLOCK = 9&
const ERROR_BAD_ENVIRONMENT = 10&
const ERROR_BAD_FORMAT = 11&
const ERROR_INVALID_ACCESS = 12&
const ERROR_INVALID_DATA = 13&
const ERROR_OUTOFMEMORY = 14&
const ERROR_INVALID_DRIVE = 15&
const ERROR_CURRENT_DIRECTORY = 16&
const ERROR_NOT_SAME_DEVICE = 17&
const ERROR_NO_MORE_FILES = 18&
const ERROR_WRITE_PROTECT = 19&
const ERROR_BAD_UNIT = 20&
const ERROR_NOT_READY = 21&
const ERROR_BAD_COMMAND = 22&
const ERROR_CRC = 23&
const ERROR_BAD_LENGTH = 24&
const ERROR_SEEK = 25&
const ERROR_NOT_DOS_DISK = 26&
const ERROR_SECTOR_NOT_FOUND = 27&
const ERROR_OUT_OF_PAPER = 28&
const ERROR_WRITE_FAULT = 29&
const ERROR_READ_FAULT = 30&
const ERROR_GEN_FAILURE = 31&
const ERROR_SHARING_VIOLATION = 32&
const ERROR_LOCK_VIOLATION = 33&
const ERROR_WRONG_DISK = 34&
const ERROR_SHARING_BUFFER_EXCEEDED = 36&
const ERROR_HANDLE_EOF = 38&
const ERROR_HANDLE_DISK_FULL = 39&
const ERROR_NOT_SUPPORTED = 50&
const ERROR_REM_NOT_LIST = 51&
const ERROR_DUP_NAME = 52&
const ERROR_BAD_NETPATH = 53&
const ERROR_NETWORK_BUSY = 54&
const ERROR_DEV_NOT_EXIST = 55& ' dderror
const ERROR_TOO_MANY_CMDS = 56&
const ERROR_ADAP_HDW_ERR = 57&
const ERROR_BAD_NET_RESP = 58&
const ERROR_UNEXP_NET_ERR = 59&
const ERROR_BAD_REM_ADAP = 60&
const ERROR_PRINTQ_FULL = 61&
const ERROR_NO_SPOOL_SPACE = 62&
const ERROR_PRINT_CANCELLED = 63&
const ERROR_NETNAME_DELETED = 64&
const ERROR_NETWORK_ACCESS_DENIED = 65&
const ERROR_BAD_DEV_TYPE = 66&
const ERROR_BAD_NET_NAME = 67&
const ERROR_TOO_MANY_NAMES = 68&
const ERROR_TOO_MANY_SESS = 69&
const ERROR_SHARING_PAUSED = 70&
const ERROR_REQ_NOT_ACCEP = 71&
const ERROR_REDIR_PAUSED = 72&
const ERROR_FILE_EXISTS = 80&
const ERROR_CANNOT_MAKE = 82&
const ERROR_FAIL_I24 = 83&
const ERROR_OUT_OF_STRUCTURES = 84&
const ERROR_ALREADY_ASSIGNED = 85&
const ERROR_INVALID_PASSWORD = 86&
const ERROR_INVALID_PARAMETER = 87& ' dderror
const ERROR_NET_WRITE_FAULT = 88&
const ERROR_NO_PROC_SLOTS = 89&
const ERROR_TOO_MANY_SEMAPHORES = 100&
const ERROR_EXCL_SEM_ALREADY_OWNED = 101&
const ERROR_SEM_IS_SET = 102&
const ERROR_TOO_MANY_SEM_REQUESTS = 103&
const ERROR_INVALID_AT_INTERRUPT_TIME = 104&
const ERROR_SEM_OWNER_DIED = 105&
const ERROR_SEM_USER_LIMIT = 106&
const ERROR_DISK_CHANGE = 107&
const ERROR_DRIVE_LOCKED = 108&
const ERROR_BROKEN_PIPE = 109&
const ERROR_OPEN_FAILED = 110&
const ERROR_BUFFER_OVERFLOW = 111&
const ERROR_DISK_FULL = 112&
const ERROR_NO_MORE_SEARCH_HANDLES = 113&
const ERROR_INVALID_TARGET_HANDLE = 114&
const ERROR_INVALID_CATEGORY = 117&
const ERROR_INVALID_VERIFY_SWITCH = 118&
const ERROR_BAD_DRIVER_LEVEL = 119&
const ERROR_CALL_NOT_IMPLEMENTED = 120&
const ERROR_SEM_TIMEOUT = 121&
const ERROR_INSUFFICIENT_BUFFER = 122& ' dderror
const ERROR_INVALID_NAME = 123&
const ERROR_INVALID_LEVEL = 124&
const ERROR_NO_VOLUME_LABEL = 125&
const ERROR_MOD_NOT_FOUND = 126&
const ERROR_PROC_NOT_FOUND = 127&
const ERROR_WAIT_NO_CHILDREN = 128&
const ERROR_CHILD_NOT_COMPLETE = 129&
const ERROR_DIRECT_ACCESS_HANDLE = 130&
const ERROR_NEGATIVE_SEEK = 131&
const ERROR_SEEK_ON_DEVICE = 132&
const ERROR_IS_JOIN_TARGET = 133&
const ERROR_IS_JOINED = 134&
const ERROR_IS_SUBSTED = 135&
const ERROR_NOT_JOINED = 136&
const ERROR_NOT_SUBSTED = 137&
const ERROR_JOIN_TO_JOIN = 138&
const ERROR_SUBST_TO_SUBST = 139&
const ERROR_JOIN_TO_SUBST = 140&
const ERROR_SUBST_TO_JOIN = 141&
const ERROR_BUSY_DRIVE = 142&
const ERROR_SAME_DRIVE = 143&
const ERROR_DIR_NOT_ROOT = 144&
const ERROR_DIR_NOT_EMPTY = 145&
const ERROR_IS_SUBST_PATH = 146&
const ERROR_IS_JOIN_PATH = 147&
const ERROR_PATH_BUSY = 148&
const ERROR_IS_SUBST_TARGET = 149&
const ERROR_SYSTEM_TRACE = 150&
const ERROR_INVALID_EVENT_COUNT = 151&
const ERROR_TOO_MANY_MUXWAITERS = 152&
const ERROR_INVALID_LIST_FORMAT = 153&
const ERROR_LABEL_TOO_LONG = 154&
const ERROR_TOO_MANY_TCBS = 155&
const ERROR_SIGNAL_REFUSED = 156&
const ERROR_DISCARDED = 157&
const ERROR_NOT_LOCKED = 158&
const ERROR_BAD_THREADID_ADDR = 159&
const ERROR_BAD_ARGUMENTS = 160&
const ERROR_BAD_PATHNAME = 161&
const ERROR_SIGNAL_PENDING = 162&
const ERROR_MAX_THRDS_REACHED = 164&
const ERROR_LOCK_FAILED = 167&
const ERROR_BUSY = 170&
const ERROR_CANCEL_VIOLATION = 173&
const ERROR_ATOMIC_LOCKS_NOT_SUPPORTED = 174&
const ERROR_INVALID_SEGMENT_NUMBER = 180&
const ERROR_INVALID_ORDINAL = 182&
const ERROR_ALREADY_EXISTS = 183&
const ERROR_INVALID_FLAG_NUMBER = 186&
const ERROR_SEM_NOT_FOUND = 187&
const ERROR_INVALID_STARTING_CODESEG = 188&
const ERROR_INVALID_STACKSEG = 189&
const ERROR_INVALID_MODULETYPE = 190&
const ERROR_INVALID_EXE_SIGNATURE = 191&
const ERROR_EXE_MARKED_INVALID = 192&
const ERROR_BAD_EXE_FORMAT = 193&
const ERROR_ITERATED_DATA_EXCEEDS_64k = 194&
const ERROR_INVALID_MINALLOCSIZE = 195&
const ERROR_DYNLINK_FROM_INVALID_RING = 196&
const ERROR_IOPL_NOT_ENABLED = 197&
const ERROR_INVALID_SEGDPL = 198&
const ERROR_AUTODATASEG_EXCEEDS_64k = 199&
const ERROR_RING2SEG_MUST_BE_MOVABLE = 200&
const ERROR_RELOC_CHAIN_XEEDS_SEGLIM = 201&
const ERROR_INFLOOP_IN_RELOC_CHAIN = 202&
const ERROR_ENVVAR_NOT_FOUND = 203&
const ERROR_NO_SIGNAL_SENT = 205&
const ERROR_FILENAME_EXCED_RANGE = 206&
const ERROR_RING2_STACK_IN_USE = 207&
const ERROR_META_EXPANSION_TOO_LONG = 208&
const ERROR_INVALID_SIGNAL_NUMBER = 209&
const ERROR_THREAD_1_INACTIVE = 210&
const ERROR_LOCKED = 212&
const ERROR_TOO_MANY_MODULES = 214&
const ERROR_NESTING_NOT_ALLOWED = 215&
const ERROR_BAD_PIPE = 230&
const ERROR_PIPE_BUSY = 231&
const ERROR_NO_DATA = 232&
const ERROR_PIPE_NOT_CONNECTED = 233&
const ERROR_MORE_DATA = 234& ' dderror
const ERROR_VC_DISCONNECTED = 240&
const ERROR_INVALID_EA_NAME = 254&
const ERROR_EA_LIST_INCONSISTENT = 255&
const ERROR_NO_MORE_ITEMS = 259&
const ERROR_CANNOT_COPY = 266&
const ERROR_DIRECTORY = 267&
const ERROR_EAS_DIDNT_FIT = 275&
const ERROR_EA_FILE_CORRUPT = 276&
const ERROR_EA_TABLE_FULL = 277&
const ERROR_INVALID_EA_HANDLE = 278&
const ERROR_EAS_NOT_SUPPORTED = 282&
const ERROR_NOT_OWNER = 288&
const ERROR_TOO_MANY_POSTS = 298&
const ERROR_MR_MID_NOT_FOUND = 317&
const ERROR_INVALID_ADDRESS = 487&
const ERROR_ARITHMETIC_OVERFLOW = 534&
const ERROR_PIPE_CONNECTED = 535&
const ERROR_PIPE_LISTENING = 536&
const ERROR_EA_ACCESS_DENIED = 994&
const ERROR_OPERATION_ABORTED = 995&
const ERROR_IO_INCOMPLETE = 996&
const ERROR_IO_PENDING = 997& ' dderror
const ERROR_NOACCESS = 998&
const ERROR_SWAPERROR = 999&
const ERROR_STACK_OVERFLOW = 1001&
const ERROR_INVALID_MESSAGE = 1002&
const ERROR_CAN_NOT_COMPLETE = 1003&
const ERROR_INVALID_FLAGS = 1004&
const ERROR_UNRECOGNIZED_VOLUME = 1005&
const ERROR_FILE_INVALID = 1006&
const ERROR_FULLSCREEN_MODE = 1007&
const ERROR_NO_TOKEN = 1008&
const ERROR_BADDB = 1009&
const ERROR_BADKEY = 1010&
const ERROR_CANTOPEN = 1011&
const ERROR_CANTREAD = 1012&
const ERROR_CANTWRITE = 1013&
const ERROR_REGISTRY_RECOVERED = 1014&
const ERROR_REGISTRY_CORRUPT = 1015&
const ERROR_REGISTRY_IO_FAILED = 1016&
const ERROR_NOT_REGISTRY_FILE = 1017&
const ERROR_KEY_DELETED = 1018&
const ERROR_NO_LOG_SPACE = 1019&
const ERROR_KEY_HAS_CHILDREN = 1020&
const ERROR_CHILD_MUST_BE_VOLATILE = 1021&
const ERROR_NOTIFY_ENUM_DIR = 1022&
const ERROR_DEPENDENT_SERVICES_RUNNING = 1051&
const ERROR_INVALID_SERVICE_CONTROL = 1052&
const ERROR_SERVICE_REQUEST_TIMEOUT = 1053&
const ERROR_SERVICE_NO_THREAD = 1054&
const ERROR_SERVICE_DATABASE_LOCKED = 1055&
const ERROR_SERVICE_ALREADY_RUNNING = 1056&
const ERROR_INVALID_SERVICE_ACCOUNT = 1057&
const ERROR_SERVICE_DISABLED = 1058&
const ERROR_CIRCULAR_DEPENDENCY = 1059&
const ERROR_SERVICE_DOES_NOT_EXIST = 1060&
const ERROR_SERVICE_CANNOT_ACCEPT_CTRL = 1061&
const ERROR_SERVICE_NOT_ACTIVE = 1062&
const ERROR_FAILED_SERVICE_CONTROLLER_CONNECT = 1063&
const ERROR_EXCEPTION_IN_SERVICE = 1064&
const ERROR_DATABASE_DOES_NOT_EXIST = 1065&
const ERROR_SERVICE_SPECIFIC_ERROR = 1066&
const ERROR_PROCESS_ABORTED = 1067&
const ERROR_SERVICE_DEPENDENCY_FAIL = 1068&
const ERROR_SERVICE_LOGON_FAILED = 1069&
const ERROR_SERVICE_START_HANG = 1070&
const ERROR_INVALID_SERVICE_LOCK = 1071&
const ERROR_SERVICE_MARKED_FOR_DELETE = 1072&
const ERROR_SERVICE_EXISTS = 1073&
const ERROR_ALREADY_RUNNING_LKG = 1074&
const ERROR_SERVICE_DEPENDENCY_DELETED = 1075&
const ERROR_BOOT_ALREADY_ACCEPTED = 1076&
const ERROR_SERVICE_NEVER_STARTED = 1077&
const ERROR_DUPLICATE_SERVICE_NAME = 1078&
const ERROR_END_OF_MEDIA = 1100&
const ERROR_FILEMARK_DETECTED = 1101&
const ERROR_BEGINNING_OF_MEDIA = 1102&
const ERROR_SETMARK_DETECTED = 1103&
const ERROR_NO_DATA_DETECTED = 1104&
const ERROR_PARTITION_FAILURE = 1105&
const ERROR_INVALID_BLOCK_LENGTH = 1106&
const ERROR_DEVICE_NOT_PARTITIONED = 1107&
const ERROR_UNABLE_TO_LOCK_MEDIA = 1108&
const ERROR_UNABLE_TO_UNLOAD_MEDIA = 1109&
const ERROR_MEDIA_CHANGED = 1110&
const ERROR_BUS_RESET = 1111&
const ERROR_NO_MEDIA_IN_DRIVE = 1112&
const ERROR_NO_UNICODE_TRANSLATION = 1113&
const ERROR_DLL_INIT_FAILED = 1114&
const ERROR_SHUTDOWN_IN_PROGRESS = 1115&
const ERROR_NO_SHUTDOWN_IN_PROGRESS = 1116&
const ERROR_IO_DEVICE = 1117&
const ERROR_SERIAL_NO_DEVICE = 1118&
const ERROR_IRQ_BUSY = 1119&
const ERROR_MORE_WRITES = 1120&
const ERROR_COUNTER_TIMEOUT = 1121&
const ERROR_FLOPPY_ID_MARK_NOT_FOUND = 1122&
const ERROR_FLOPPY_WRONG_CYLINDER = 1123&
const ERROR_FLOPPY_UNKNOWN_ERROR = 1124&
const ERROR_FLOPPY_BAD_REGISTERS = 1125&
const ERROR_DISK_RECALIBRATE_FAILED = 1126&
const ERROR_DISK_OPERATION_FAILED = 1127&
const ERROR_DISK_RESET_FAILED = 1128&
const ERROR_EOM_OVERFLOW = 1129&
const ERROR_NOT_ENOUGH_SERVER_MEMORY = 1130&
const ERROR_POSSIBLE_DEADLOCK = 1131&
const ERROR_MAPPED_ALIGNMENT = 1132&
const ERROR_BAD_USERNAME = 2202&
const ERROR_NOT_CONNECTED = 2250&
const ERROR_OPEN_FILES = 2401&
const ERROR_DEVICE_IN_USE = 2404&
const ERROR_BAD_DEVICE = 1200&
const ERROR_CONNECTION_UNAVAIL = 1201&
const ERROR_DEVICE_ALREADY_REMEMBERED = 1202&
const ERROR_NO_NET_OR_BAD_PATH = 1203&
const ERROR_BAD_PROVIDER = 1204&
const ERROR_CANNOT_OPEN_PROFILE = 1205&
const ERROR_BAD_PROFILE = 1206&
const ERROR_NOT_CONTAINER = 1207&
const ERROR_EXTENDED_ERROR = 1208&
const ERROR_INVALID_GROUPNAME = 1209&
const ERROR_INVALID_COMPUTERNAME = 1210&
const ERROR_INVALID_EVENTNAME = 1211&
const ERROR_INVALID_DOMAINNAME = 1212&
const ERROR_INVALID_SERVICENAME = 1213&
const ERROR_INVALID_NETNAME = 1214&
const ERROR_INVALID_SHARENAME = 1215&
const ERROR_INVALID_PASSWORDNAME = 1216&
const ERROR_INVALID_MESSAGENAME = 1217&
const ERROR_INVALID_MESSAGEDEST = 1218&
const ERROR_SESSION_CREDENTIAL_CONFLICT = 1219&
const ERROR_REMOTE_SESSION_LIMIT_EXCEEDED = 1220&
const ERROR_DUP_DOMAINNAME = 1221&
const ERROR_NO_NETWORK = 1222&
const ERROR_NOT_ALL_ASSIGNED = 1300&
const ERROR_SOME_NOT_MAPPED = 1301&
const ERROR_NO_QUOTAS_FOR_ACCOUNT = 1302&
const ERROR_LOCAL_USER_SESSION_KEY = 1303&
const ERROR_NULL_LM_PASSWORD = 1304&
const ERROR_UNKNOWN_REVISION = 1305&
const ERROR_REVISION_MISMATCH = 1306&
const ERROR_INVALID_OWNER = 1307&
const ERROR_INVALID_PRIMARY_GROUP = 1308&
const ERROR_NO_IMPERSONATION_TOKEN = 1309&
const ERROR_CANT_DISABLE_MANDATORY = 1310&
const ERROR_NO_LOGON_SERVERS = 1311&
const ERROR_NO_SUCH_LOGON_SESSION = 1312&
const ERROR_NO_SUCH_PRIVILEGE = 1313&
const ERROR_PRIVILEGE_NOT_HELD = 1314&
const ERROR_INVALID_ACCOUNT_NAME = 1315&
const ERROR_USER_EXISTS = 1316&
const ERROR_NO_SUCH_USER = 1317&
const ERROR_GROUP_EXISTS = 1318&
const ERROR_NO_SUCH_GROUP = 1319&
const ERROR_MEMBER_IN_GROUP = 1320&
const ERROR_MEMBER_NOT_IN_GROUP = 1321&
const ERROR_LAST_ADMIN = 1322&
const ERROR_WRONG_PASSWORD = 1323&
const ERROR_ILL_FORMED_PASSWORD = 1324&
const ERROR_PASSWORD_RESTRICTION = 1325&
const ERROR_LOGON_FAILURE = 1326&
const ERROR_ACCOUNT_RESTRICTION = 1327&
const ERROR_INVALID_LOGON_HOURS = 1328&
const ERROR_INVALID_WORKSTATION = 1329&
const ERROR_PASSWORD_EXPIRED = 1330&
const ERROR_ACCOUNT_DISABLED = 1331&
const ERROR_NONE_MAPPED = 1332&
const ERROR_TOO_MANY_LUIDS_REQUESTED = 1333&
const ERROR_LUIDS_EXHAUSTED = 1334&
const ERROR_INVALID_SUB_AUTHORITY = 1335&
const ERROR_INVALID_ACL = 1336&
const ERROR_INVALID_SID = 1337&
const ERROR_INVALID_SECURITY_DESCR = 1338&
const ERROR_BAD_INHERITANCE_ACL = 1340&
const ERROR_SERVER_DISABLED = 1341&
const ERROR_SERVER_NOT_DISABLED = 1342&
const ERROR_INVALID_ID_AUTHORITY = 1343&
const ERROR_ALLOTTED_SPACE_EXCEEDED = 1344&
const ERROR_INVALID_GROUP_ATTRIBUTES = 1345&
const ERROR_BAD_IMPERSONATION_LEVEL = 1346&
const ERROR_CANT_OPEN_ANONYMOUS = 1347&
const ERROR_BAD_VALIDATION_CLASS = 1348&
const ERROR_BAD_TOKEN_TYPE = 1349&
const ERROR_NO_SECURITY_ON_OBJECT = 1350&
const ERROR_CANT_ACCESS_DOMAIN_INFO = 1351&
const ERROR_INVALID_SERVER_STATE = 1352&
const ERROR_INVALID_DOMAIN_STATE = 1353&
const ERROR_INVALID_DOMAIN_ROLE = 1354&
const ERROR_NO_SUCH_DOMAIN = 1355&
const ERROR_DOMAIN_EXISTS = 1356&
const ERROR_DOMAIN_LIMIT_EXCEEDED = 1357&
const ERROR_INTERNAL_DB_CORRUPTION = 1358&
const ERROR_INTERNAL_ERROR = 1359&
const ERROR_GENERIC_NOT_MAPPED = 1360&
const ERROR_BAD_DESCRIPTOR_FORMAT = 1361&
const ERROR_NOT_LOGON_PROCESS = 1362&
const ERROR_LOGON_SESSION_EXISTS = 1363&
const ERROR_NO_SUCH_PACKAGE = 1364&
const ERROR_BAD_LOGON_SESSION_STATE = 1365&
const ERROR_LOGON_SESSION_COLLISION = 1366&
const ERROR_INVALID_LOGON_TYPE = 1367&
const ERROR_CANNOT_IMPERSONATE = 1368&
const ERROR_RXACT_INVALID_STATE = 1369&
const ERROR_RXACT_COMMIT_FAILURE = 1370&
const ERROR_SPECIAL_ACCOUNT = 1371&
const ERROR_SPECIAL_GROUP = 1372&
const ERROR_SPECIAL_USER = 1373&
const ERROR_MEMBERS_PRIMARY_GROUP = 1374&
const ERROR_TOKEN_ALREADY_IN_USE = 1375&
const ERROR_NO_SUCH_ALIAS = 1376&
const ERROR_MEMBER_NOT_IN_ALIAS = 1377&
const ERROR_MEMBER_IN_ALIAS = 1378&
const ERROR_ALIAS_EXISTS = 1379&
const ERROR_LOGON_NOT_GRANTED = 1380&
const ERROR_TOO_MANY_SECRETS = 1381&
const ERROR_SECRET_TOO_LONG = 1382&
const ERROR_INTERNAL_DB_ERROR = 1383&
const ERROR_TOO_MANY_CONTEXT_IDS = 1384&
const ERROR_LOGON_TYPE_NOT_GRANTED = 1385&
const ERROR_NT_CROSS_ENCRYPTION_REQUIRED = 1386&
const ERROR_NO_SUCH_MEMBER = 1387&
const ERROR_INVALID_MEMBER = 1388&
const ERROR_TOO_MANY_SIDS = 1389&
const ERROR_LM_CROSS_ENCRYPTION_REQUIRED = 1390&
const ERROR_NO_INHERITANCE = 1391&
const ERROR_FILE_CORRUPT = 1392&
const ERROR_DISK_CORRUPT = 1393&
const ERROR_NO_USER_SESSION_KEY = 1394&
const ERROR_INVALID_WINDOW_HANDLE = 1400&
const ERROR_INVALID_MENU_HANDLE = 1401&
const ERROR_INVALID_CURSOR_HANDLE = 1402&
const ERROR_INVALID_ACCEL_HANDLE = 1403&
const ERROR_INVALID_HOOK_HANDLE = 1404&
const ERROR_INVALID_DWP_HANDLE = 1405&
const ERROR_TLW_WITH_WSCHILD = 1406&
const ERROR_CANNOT_FIND_WND_CLASS = 1407&
const ERROR_WINDOW_OF_OTHER_THREAD = 1408&
const ERROR_HOTKEY_ALREADY_REGISTERED = 1409&
const ERROR_CLASS_ALREADY_EXISTS = 1410&
const ERROR_CLASS_DOES_NOT_EXIST = 1411&
const ERROR_CLASS_HAS_WINDOWS = 1412&
const ERROR_INVALID_INDEX = 1413&
const ERROR_INVALID_ICON_HANDLE = 1414&
const ERROR_PRIVATE_DIALOG_INDEX = 1415&
const ERROR_LISTBOX_ID_NOT_FOUND = 1416&
const ERROR_NO_WILDCARD_CHARACTERS = 1417&
const ERROR_CLIPBOARD_NOT_OPEN = 1418&
const ERROR_HOTKEY_NOT_REGISTERED = 1419&
const ERROR_WINDOW_NOT_DIALOG = 1420&
const ERROR_CONTROL_ID_NOT_FOUND = 1421&
const ERROR_INVALID_COMBOBOX_MESSAGE = 1422&
const ERROR_WINDOW_NOT_COMBOBOX = 1423&
const ERROR_INVALID_EDIT_HEIGHT = 1424&
const ERROR_DC_NOT_FOUND = 1425&
const ERROR_INVALID_HOOK_FILTER = 1426&
const ERROR_INVALID_FILTER_PROC = 1427&
const ERROR_HOOK_NEEDS_HMOD = 1428&
const ERROR_GLOBAL_ONLY_HOOK = 1429&
const ERROR_JOURNAL_HOOK_SET = 1430&
const ERROR_HOOK_NOT_INSTALLED = 1431&
const ERROR_INVALID_LB_MESSAGE = 1432&
const ERROR_SETCOUNT_ON_BAD_LB = 1433&
const ERROR_LB_WITHOUT_TABSTOPS = 1434&
const ERROR_DESTROY_OBJECT_OF_OTHER_THREAD = 1435&
const ERROR_CHILD_WINDOW_MENU = 1436&
const ERROR_NO_SYSTEM_MENU = 1437&
const ERROR_INVALID_MSGBOX_STYLE = 1438&
const ERROR_INVALID_SPI_VALUE = 1439&
const ERROR_SCREEN_ALREADY_LOCKED = 1440&
const ERROR_HWNDS_HAVE_DIFF_PARENT = 1441&
const ERROR_NOT_CHILD_WINDOW = 1442&
const ERROR_INVALID_GW_COMMAND = 1443&
const ERROR_INVALID_THREAD_ID = 1444&
const ERROR_NON_MDICHILD_WINDOW = 1445&
const ERROR_POPUP_ALREADY_ACTIVE = 1446&
const ERROR_NO_SCROLLBARS = 1447&
const ERROR_INVALID_SCROLLBAR_RANGE = 1448&
const ERROR_INVALID_SHOWWIN_COMMAND = 1449&
const ERROR_EVENTLOG_FILE_CORRUPT = 1500&
const ERROR_EVENTLOG_CANT_START = 1501&
const ERROR_LOG_FILE_FULL = 1502&
const ERROR_EVENTLOG_FILE_CHANGED = 1503&
const RPC_S_INVALID_STRING_BINDING = 1700&
const RPC_S_WRONG_KIND_OF_BINDING = 1701&
const RPC_S_INVALID_BINDING = 1702&
const RPC_S_PROTSEQ_NOT_SUPPORTED = 1703&
const RPC_S_INVALID_RPC_PROTSEQ = 1704&
const RPC_S_INVALID_STRING_UUID = 1705&
const RPC_S_INVALID_ENDPOINT_FORMAT = 1706&
const RPC_S_INVALID_NET_ADDR = 1707&
const RPC_S_NO_ENDPOINT_FOUND = 1708&
const RPC_S_INVALID_TIMEOUT = 1709&
const RPC_S_OBJECT_NOT_FOUND = 1710&
const RPC_S_ALREADY_REGISTERED = 1711&
const RPC_S_TYPE_ALREADY_REGISTERED = 1712&
const RPC_S_ALREADY_LISTENING = 1713&
const RPC_S_NO_PROTSEQS_REGISTERED = 1714&
const RPC_S_NOT_LISTENING = 1715&
const RPC_S_UNKNOWN_MGR_TYPE = 1716&
const RPC_S_UNKNOWN_IF = 1717&
const RPC_S_NO_BINDINGS = 1718&
const RPC_S_NO_PROTSEQS = 1719&
const RPC_S_CANT_CREATE_ENDPOINT = 1720&
const RPC_S_OUT_OF_RESOURCES = 1721&
const RPC_S_SERVER_UNAVAILABLE = 1722&
const RPC_S_SERVER_TOO_BUSY = 1723&
const RPC_S_INVALID_NETWORK_OPTIONS = 1724&
const RPC_S_NO_CALL_ACTIVE = 1725&
const RPC_S_CALL_FAILED = 1726&
const RPC_S_CALL_FAILED_DNE = 1727&
const RPC_S_PROTOCOL_ERROR = 1728&
const RPC_S_UNSUPPORTED_TRANS_SYN = 1730&
const RPC_S_UNSUPPORTED_TYPE = 1732&
const RPC_S_INVALID_TAG = 1733&
const RPC_S_INVALID_BOUND = 1734&
const RPC_S_NO_ENTRY_NAME = 1735&
const RPC_S_INVALID_NAME_SYNTAX = 1736&
const RPC_S_UNSUPPORTED_NAME_SYNTAX = 1737&
const RPC_S_UUID_NO_ADDRESS = 1739&
const RPC_S_DUPLICATE_ENDPOINT = 1740&
const RPC_S_UNKNOWN_AUTHN_TYPE = 1741&
const RPC_S_MAX_CALLS_TOO_SMALL = 1742&
const RPC_S_STRING_TOO_LONG = 1743&
const RPC_S_PROTSEQ_NOT_FOUND = 1744&
const RPC_S_PROCNUM_OUT_OF_RANGE = 1745&
const RPC_S_BINDING_HAS_NO_AUTH = 1746&
const RPC_S_UNKNOWN_AUTHN_SERVICE = 1747&
const RPC_S_UNKNOWN_AUTHN_LEVEL = 1748&
const RPC_S_INVALID_AUTH_IDENTITY = 1749&
const RPC_S_UNKNOWN_AUTHZ_SERVICE = 1750&
const EPT_S_INVALID_ENTRY = 1751&
const EPT_S_CANT_PERFORM_OP = 1752&
const EPT_S_NOT_REGISTERED = 1753&
const RPC_S_NOTHING_TO_EXPORT = 1754&
const RPC_S_INCOMPLETE_NAME = 1755&
const RPC_S_INVALID_VERS_OPTION = 1756&
const RPC_S_NO_MORE_MEMBERS = 1757&
const RPC_S_NOT_ALL_OBJS_UNEXPORTED = 1758&
const RPC_S_INTERFACE_NOT_FOUND = 1759&
const RPC_S_ENTRY_ALREADY_EXISTS = 1760&
const RPC_S_ENTRY_NOT_FOUND = 1761&
const RPC_S_NAME_SERVICE_UNAVAILABLE = 1762&
const RPC_S_INVALID_NAF_ID = 1763&
const RPC_S_CANNOT_SUPPORT = 1764&
const RPC_S_NO_CONTEXT_AVAILABLE = 1765&
const RPC_S_INTERNAL_ERROR = 1766&
const RPC_S_ZERO_DIVIDE = 1767&
const RPC_S_ADDRESS_ERROR = 1768&
const RPC_S_FP_DIV_ZERO = 1769&
const RPC_S_FP_UNDERFLOW = 1770&
const RPC_S_FP_OVERFLOW = 1771&
const RPC_X_NO_MORE_ENTRIES = 1772&
const RPC_X_SS_CHAR_TRANS_OPEN_FAIL = 1773&
const RPC_X_SS_CHAR_TRANS_SHORT_FILE = 1774&
const RPC_X_SS_IN_NULL_CONTEXT = 1775&
const RPC_X_SS_CONTEXT_DAMAGED = 1777&
const RPC_X_SS_HANDLES_MISMATCH = 1778&
const RPC_X_SS_CANNOT_GET_CALL_HANDLE = 1779&
const RPC_X_NULL_REF_POINTER = 1780&
const RPC_X_ENUM_VALUE_OUT_OF_RANGE = 1781&
const RPC_X_BYTE_COUNT_TOO_SMALL = 1782&
const RPC_X_BAD_STUB_DATA = 1783&
const ERROR_INVALID_USER_BUFFER = 1784&
const ERROR_UNRECOGNIZED_MEDIA = 1785&
const ERROR_NO_TRUST_LSA_SECRET = 1786&
const ERROR_NO_TRUST_SAM_ACCOUNT = 1787&
const ERROR_TRUSTED_DOMAIN_FAILURE = 1788&
const ERROR_TRUSTED_RELATIONSHIP_FAILURE = 1789&
const ERROR_TRUST_FAILURE = 1790&
const RPC_S_CALL_IN_PROGRESS = 1791&
const ERROR_NETLOGON_NOT_STARTED = 1792&
const ERROR_ACCOUNT_EXPIRED = 1793&
const ERROR_REDIRECTOR_HAS_OPEN_HANDLES = 1794&
const ERROR_PRINTER_DRIVER_ALREADY_INSTALLED = 1795&
const ERROR_UNKNOWN_PORT = 1796&
const ERROR_UNKNOWN_PRINTER_DRIVER = 1797&
const ERROR_UNKNOWN_PRINTPROCESSOR = 1798&
const ERROR_INVALID_SEPARATOR_FILE = 1799&
const ERROR_INVALID_PRIORITY = 1800&
const ERROR_INVALID_PRINTER_NAME = 1801&
const ERROR_PRINTER_ALREADY_EXISTS = 1802&
const ERROR_INVALID_PRINTER_COMMAND = 1803&
const ERROR_INVALID_DATATYPE = 1804&
const ERROR_INVALID_ENVIRONMENT = 1805&
const RPC_S_NO_MORE_BINDINGS = 1806&
const ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT = 1807&
const ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT = 1808&
const ERROR_NOLOGON_SERVER_TRUST_ACCOUNT = 1809&
const ERROR_DOMAIN_TRUST_INCONSISTENT = 1810&
const ERROR_SERVER_HAS_OPEN_HANDLES = 1811&
const ERROR_RESOURCE_DATA_NOT_FOUND = 1812&
const ERROR_RESOURCE_TYPE_NOT_FOUND = 1813&
const ERROR_RESOURCE_NAME_NOT_FOUND = 1814&
const ERROR_RESOURCE_LANG_NOT_FOUND = 1815&
const ERROR_NOT_ENOUGH_QUOTA = 1816&
const RPC_S_GROUP_MEMBER_NOT_FOUND = 1898&
const EPT_S_CANT_CREATE = 1899&
const RPC_S_INVALID_OBJECT = 1900&
const ERROR_INVALID_TIME = 1901&
const ERROR_INVALID_FORM_NAME = 1902&
const ERROR_INVALID_FORM_SIZE = 1903&
const ERROR_ALREADY_WAITING = 1904&
const ERROR_PRINTER_DELETED = 1905&
const ERROR_INVALID_PRINTER_STATE = 1906&
const ERROR_NO_BROWSER_SERVERS_FOUND = 6118&

'******************************************************************************
'*** From WINBASE.H: Kernel32 Types, Constants, Functions
'******************************************************************************

const MINCHAR     = &h80&
const MAXCHAR     = &h7f&
const MINSHORT    = &h8000&
const MAXSHORT    = &h7fff&
const MINLONG     = &h80000000&
const MAXLONG     = &h7fffffff&
const MAXBYTE     = &hff&
const MAXWORD     = &hffff&
const MAXDWORD    = &hffffffff&
const MAX_PATH    = 260

const INVALID_HANDLE_VALUE               = -1
const INVALID_FILE_SIZE                  = &HFFFFFFFF&
const FILE_BEGIN                         = 0
const FILE_CURRENT                       = 1
const FILE_END                           = 2
const TIME_ZONE_ID_INVALID               = &HFFFFFFFF&

'
'  File creation flags must start at the high end since they
'  are combined with the attributes
'

const FILE_FLAG_WRITE_THROUGH    = &H80000000&
const FILE_FLAG_OVERLAPPED       = &H40000000&
const FILE_FLAG_NO_BUFFERING     = &H20000000&
const FILE_FLAG_RANDOM_ACCESS    = &H10000000&
const FILE_FLAG_SEQUENTIAL_SCAN  = &H08000000&
const FILE_FLAG_DELETE_ON_CLOSE  = &H04000000&
const FILE_FLAG_BACKUP_SEMANTICS = &H02000000&
const FILE_FLAG_POSIX_SEMANTICS  = &H01000000&
const CREATE_NEW                 = 1
const CREATE_ALWAYS              = 2
const OPEN_EXISTING              = 3
const OPEN_ALWAYS                = 4
const TRUNCATE_EXISTING          = 5

'
'  Define the dwOpenMode values for CreateNamedPipe
'

const PIPE_ACCESS_INBOUND  = &H00000001&
const PIPE_ACCESS_OUTBOUND = &H00000002&
const PIPE_ACCESS_DUPLEX   = &H00000003&

'
'  Define the Named Pipe End flags for GetNamedPipeInfo
'

const PIPE_CLIENT_END = &H00000000&
const PIPE_SERVER_END = &H00000001&

'
'  Define the dwPipeMode values for CreateNamedPipe
'

const PIPE_WAIT             = &H00000000&
const PIPE_NOWAIT           = &H00000001&
const PIPE_READMODE_BYTE    = &H00000000&
const PIPE_READMODE_MESSAGE = &H00000002&
const PIPE_TYPE_BYTE        = &H00000000&
const PIPE_TYPE_MESSAGE     = &H00000004&

'
'  Define the well known values for CreateNamedPipe nMaxInstances
'

const PIPE_UNLIMITED_INSTANCES = 255

'
'  Define the Security Quality of Service bits to be passed
'  into CreateFile
'
'const SECURITY_ANONYMOUS        = ( SecurityAnonymous << 16 )
'const SECURITY_IDENTIFICATION   = ( SecurityIdentification << 16 )
'const SECURITY_IMPERSONATION    = ( SecurityImpersonation << 16 )
'const SECURITY_DELEGATION       = ( SecurityDelegation << 16 )
const SECURITY_CONTEXT_TRACKING = &H00040000&
const SECURITY_EFFECTIVE_ONLY   = &H00080000&
const SECURITY_SQOS_PRESENT     = &H00100000&
const SECURITY_VALID_SQOS_FLAGS = &H001F0000&

'
'   File structures
'

type OVERLAPPED
    Internal     as long
    InternalHigh as long
    Offset       as long
    OffsetHigh   as long
    hEvent       as long
end type

type SECURITY_ATTRIBUTES
    nLength              as long
    lpSecurityDescriptor as long
    bInheritHandle       as long
end type

type PROCESS_INFORMATION
    hProcess    as long
    hThread     as long
    dwProcessId as long
    dwThreadId  as long
end type

'
'   File System time stamps are represented with the following structure:
'

type FILETIME
    dwLowDateTime  as long
    dwHighDateTime as long
end type

'
'  System time is represented with the following structure:
'

type SYSTEMTIME
    wYear         as short
    wMonth        as short
    wDayOfWeek    as short
    wDay          as short
    wHour         as short
    wMinute       as short
    wSecond       as short
    wMilliseconds as short
end type


const DELETE                   = &H00010000&
const READ_CONTROL             = &H00020000&
const WRITE_DAC                = &H00040000&
const WRITE_OWNER              = &H00080000&
const SYNCHRONIZE              = &H00100000&
const STANDARD_RIGHTS_REQUIRED = &H000F0000&
const STANDARD_RIGHTS_READ     = READ_CONTROL
const STANDARD_RIGHTS_WRITE    = READ_CONTROL
const STANDARD_RIGHTS_EXECUTE  = READ_CONTROL
const STANDARD_RIGHTS_ALL      = &H001F0000&
const SPECIFIC_RIGHTS_ALL      = &H0000FFFF&

'
'  AccessSystemAcl access type
'

const ACCESS_SYSTEM_SECURITY = &H01000000&

'
'  MaximumAllowed access type
'

const MAXIMUM_ALLOWED = &H02000000&

'
'   These are the generic rights.
'

const GENERIC_READ    = &H80000000&
const GENERIC_WRITE   = &H40000000&
const GENERIC_EXECUTE = &H20000000&
const GENERIC_ALL     = &H10000000&

const MUTANT_QUERY_STATE       = &h0001&
const MUTANT_ALL_ACCESS        = STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or MUTANT_QUERY_STATE
const MUTEX_MODIFY_STATE       = MUTANT_QUERY_STATE
const MUTEX_ALL_ACCESS         = MUTANT_ALL_ACCESS

'
'  Serial provider type.
'

const SP_SERIALCOMM = (&H00000001&)

'
'  Provider SubTypes
'

const PST_UNSPECIFIED    = (&H00000000&)
const PST_RS232          = (&H00000001&)
const PST_PARALLELPORT   = (&H00000002&)
const PST_RS422          = (&H00000003&)
const PST_RS423          = (&H00000004&)
const PST_RS449          = (&H00000005&)
const PST_FAX            = (&H00000021&)
const PST_SCANNER        = (&H00000022&)
const PST_NETWORK_BRIDGE = (&H00000100&)
const PST_LAT            = (&H00000101&)
const PST_TCPIP_TELNET   = (&H00000102&)
const PST_X25            = (&H00000103&)

'
'  Provider capabilities flags.
'

const PCF_DTRDSR        = (&H0001&)
const PCF_RTSCTS        = (&H0002&)
const PCF_RLSD          = (&H0004&)
const PCF_PARITY_CHECK  = (&H0008&)
const PCF_XONXOFF       = (&H0010&)
const PCF_SETXCHAR      = (&H0020&)
const PCF_TOTALTIMEOUTS = (&H0040&)
const PCF_INTTIMEOUTS   = (&H0080&)
const PCF_SPECIALCHARS  = (&H0100&)
const PCF_16BITMODE     = (&H0200&)

'
'  Comm provider settable parameters.
'

const SP_PARITY       = (&H0001&)
const SP_BAUD         = (&H0002&)
const SP_DATABITS     = (&H0004&)
const SP_STOPBITS     = (&H0008&)
const SP_HANDSHAKING  = (&H0010&)
const SP_PARITY_CHECK = (&H0020&)
const SP_RLSD         = (&H0040&)

'
'  Settable baud rates in the provider.
'

const BAUD_075    = (&H00000001&)
const BAUD_110    = (&H00000002&)
const BAUD_134_5  = (&H00000004&)
const BAUD_150    = (&H00000008&)
const BAUD_300    = (&H00000010&)
const BAUD_600    = (&H00000020&)
const BAUD_1200   = (&H00000040&)
const BAUD_1800   = (&H00000080&)
const BAUD_2400   = (&H00000100&)
const BAUD_4800   = (&H00000200&)
const BAUD_7200   = (&H00000400&)
const BAUD_9600   = (&H00000800&)
const BAUD_14400  = (&H00001000&)
const BAUD_19200  = (&H00002000&)
const BAUD_38400  = (&H00004000&)
const BAUD_56K    = (&H00008000&)
const BAUD_128K   = (&H00010000&)
const BAUD_115200 = (&H00020000&)
const BAUD_57600  = (&H00040000&)
const BAUD_USER   = (&H10000000&)

'
'  Settable Data Bits
'

const DATABITS_5   = (&H0001&)
const DATABITS_6   = (&H0002&)
const DATABITS_7   = (&H0004&)
const DATABITS_8   = (&H0008&)
const DATABITS_16  = (&H0010&)
const DATABITS_16X = (&H0020&)

'
'  Settable Stop and Parity bits.
'

const STOPBITS_10  = (&H0001&)
const STOPBITS_15  = (&H0002&)
const STOPBITS_20  = (&H0004&)
const PARITY_NONE  = (&H0100&)
const PARITY_ODD   = (&H0200&)
const PARITY_EVEN  = (&H0400&)
const PARITY_MARK  = (&H0800&)
const PARITY_SPACE = (&H1000&)

type COMMPROP
    wPacketLength       as short
    wPacketVersion      as short
    dwServiceMask       as long
    dwReserved1         as long
    dwMaxTxQueue        as long
    dwMaxRxQueue        as long
    dwMaxBaud           as long
    dwProvSubType       as long
    dwProvCapabilities  as long
    dwSettableParams    as long
    dwSettableBaud      as long
    wSettableData       as short
    wSettableStopParity as short
    dwCurrentTxQueue    as long
    dwCurrentRxQueue    as long
    dwProvSpec1         as long
    dwProvSpec2         as long
    wcProvChar          as string * 1
end type

type COMSTAT
    lBitField as long
    '        DWORD fCtsHold : 1;
    '        DWORD fDsrHold : 1;
    '        DWORD fRlsdHold : 1;
    '        DWORD fXoffHold : 1;
    '        DWORD fXoffSent : 1;
    '        DWORD fEof : 1;
    '        DWORD fTxim : 1;
    '        DWORD fReserved : 25;
    cbInQue  as long
    cbOutQue as long
end type

'
'  DTR Control Flow Values.
'

const DTR_CONTROL_DISABLE   = &H00&
const DTR_CONTROL_ENABLE    = &H01&
const DTR_CONTROL_HANDSHAKE = &H02&

'
'  RTS Control Flow Values
'

const RTS_CONTROL_DISABLE   = &H00&
const RTS_CONTROL_ENABLE    = &H01&
const RTS_CONTROL_HANDSHAKE = &H02&
const RTS_CONTROL_TOGGLE    = &H03&

type DCB
    DCBlength as long ' sizeof(DCB)
    BaudRate  as long
    lBitField as long
    ' Baudrate at which running
    '         DWORD fBinary: 1; ' Binary Mode (skip EOF check)
    '         DWORD fParity: 1; ' Enable parity checking
    '         DWORD fOutxCtsFlow:1; ' CTS handshaking on output
    '         DWORD fOutxDsrFlow:1; ' DSR handshaking on output
    '         DWORD fDtrControl:2; ' DTR Flow control
    '         DWORD fDsrSensitivity:1; ' DSR Sensitivity
    '         DWORD fTXContinueOnXoff: 1; ' Continue TX when Xoff sent
    '         DWORD fOutX: 1; ' Enable output X-ON/X-OFF
    '         DWORD fInX: 1; ' Enable input X-ON/X-OFF
    '         DWORD fErrorChar: 1; ' Enable Err Replacement
    '         DWORD fNull: 1; ' Enable Null stripping
    '         DWORD fRtsControl:2; ' Rts Flow control
    '         DWORD fAbortOnError:1; ' Abort all reads and writes on Error
    '         DWORD fDummy2:17; ' Reserved
    wReserved as short ' Not currently used
    XonLim    as short ' Transmit X-ON threshold
    XoffLim   as short ' Transmit X-OFF threshold
    ByteSize  as string * 1 ' Number of bits/byte, 4-8
    Parity    as string * 1 ' 0-4=None,Odd,Even,Mark,Space
    StopBits  as string * 1 ' 0,1,2 = 1, 1.5, 2
    XonChar   as string * 1 ' Tx and Rx X-ON character
    XoffChar  as string * 1 ' Tx and Rx X-OFF character
    ErrorChar as string * 1 ' Error replacement char
    EofChar   as string * 1 ' End of Input character
    EvtChar   as string * 1 ' Recieved Event character
end type

type COMMTIMEOUTS
    ReadIntervalTimeout         as long ' Maximum time between read chars.
    ReadTotalTimeoutMultiplier  as long ' Multiplier of characters.
    ReadTotalTimeoutConstant    as long ' Constant in milliseconds.
    WriteTotalTimeoutMultiplier as long ' Multiplier of characters.
    WriteTotalTimeoutConstant   as long ' Constant in milliseconds.
end type

type SYSTEM_INFO
    wProcessorArchitecture      as short
    wReserved                   as short
    dwPageSize                  as long
    lpMinimumApplicationAddress as long
    lpMaximumApplicationAddress as long
    dwActiveProcessorMask       as long
    dwNumberOfProcessors        as long
    dwProcessorType             as long
    dwAllocationGranularity     as long
    wProcessorLevel             as short
    wProcessorRevision          as short
end type

' Processor types

const PROCESSOR_INTEL_386            = 386
const PROCESSOR_INTEL_486            = 486
const PROCESSOR_INTEL_PENTIUM        = 586
const PROCESSOR_MIPS_R4000           = 4000
const PROCESSOR_ALPHA_21064          = 21064
const PROCESSOR_ARCHITECTURE_INTEL   = 0
const PROCESSOR_ARCHITECTURE_MIPS    = 1
const PROCESSOR_ARCHITECTURE_ALPHA   = 2
const PROCESSOR_ARCHITECTURE_PPC     = 3
const PROCESSOR_ARCHITECTURE_UNKNOWN = &hFFFF

'  Global Memory Flags

const GMEM_FIXED          = &H0000&
const GMEM_MOVEABLE       = &H0002&
const GMEM_NOCOMPACT      = &H0010&
const GMEM_NODISCARD      = &H0020&
const GMEM_ZEROINIT       = &H0040&
const GMEM_MODIFY         = &H0080&
const GMEM_DISCARDABLE    = &H0100&
const GMEM_NOT_BANKED     = &H1000&
const GMEM_SHARE          = &H2000&
const GMEM_DDESHARE       = &H2000&
const GMEM_NOTIFY         = &H4000&
const GMEM_LOWER          = GMEM_NOT_BANKED
const GMEM_VALID_FLAGS    = &H7F72&
const GMEM_INVALID_HANDLE = &H8000&
const GHND                = (GMEM_MOVEABLE or GMEM_ZEROINIT)
const GPTR                = (GMEM_FIXED or GMEM_ZEROINIT)

'  Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE)

const GMEM_DISCARDED = &H4000&
const GMEM_LOCKCOUNT = &H00FF&

type MEMORYSTATUS
    dwLength        as long
    dwMemoryLoad    as long
    dwTotalPhys     as long
    dwAvailPhys     as long
    dwTotalPageFile as long
    dwAvailPageFile as long
    dwTotalVirtual  as long
    dwAvailVirtual  as long
end type

'  Local Memory Flags

const LMEM_FIXED          = &H0000&
const LMEM_MOVEABLE       = &H0002&
const LMEM_NOCOMPACT      = &H0010&
const LMEM_NODISCARD      = &H0020&
const LMEM_ZEROINIT       = &H0040&
const LMEM_MODIFY         = &H0080&
const LMEM_DISCARDABLE    = &H0F00&
const LMEM_VALID_FLAGS    = &H0F72&
const LMEM_INVALID_HANDLE = &H8000&
const LHND                = (LMEM_MOVEABLE or LMEM_ZEROINIT)
const LPTR                = (LMEM_FIXED or LMEM_ZEROINIT)
const NONZEROLHND         = (LMEM_MOVEABLE)
const NONZEROLPTR         = (LMEM_FIXED)

'  Flags returned by LocalFlags (in addition to LMEM_DISCARDABLE)

const LMEM_DISCARDED = &H4000&
const LMEM_LOCKCOUNT = &H00FF&

'
'  dwCreationFlag values
'

const DEBUG_PROCESS                 = &H00000001&
const DEBUG_ONLY_THIS_PROCESS       = &H00000002&
const CREATE_SUSPENDED              = &H00000004&
const DETACHED_PROCESS              = &H00000008&
const CREATE_NEW_CONSOLE            = &H00000010&
const NORMAL_PRIORITY_CLASS         = &H00000020&
const IDLE_PRIORITY_CLASS           = &H00000040&
const HIGH_PRIORITY_CLASS           = &H00000080&
const REALTIME_PRIORITY_CLASS       = &H00000100&
const CREATE_NEW_PROCESS_GROUP      = &H00000200&
const CREATE_NO_WINDOW              = &H08000000&
const PROFILE_USER                  = &H10000000&
const PROFILE_KERNEL                = &H20000000&
const PROFILE_SERVER                = &H40000000&

const THREAD_BASE_PRIORITY_LOWRT    = 15  ' value that gets a thread to LowRealtime-1
const THREAD_BASE_PRIORITY_MAX      = 2   ' maximum thread base priority boost
const THREAD_BASE_PRIORITY_MIN      = -2  ' minimum thread base priority boost
const THREAD_BASE_PRIORITY_IDLE     = -15 ' value that gets a thread to idle

const THREAD_PRIORITY_LOWEST        = THREAD_BASE_PRIORITY_MIN
const THREAD_PRIORITY_BELOW_NORMAL  = (THREAD_PRIORITY_LOWEST+1)
const THREAD_PRIORITY_NORMAL        = 0
const THREAD_PRIORITY_HIGHEST       = THREAD_BASE_PRIORITY_MAX
const THREAD_PRIORITY_ABOVE_NORMAL  = (THREAD_PRIORITY_HIGHEST-1)
const THREAD_PRIORITY_ERROR_RETURN  = (MAXLONG)
const THREAD_PRIORITY_TIME_CRITICAL = THREAD_BASE_PRIORITY_LOWRT
const THREAD_PRIORITY_IDLE          = THREAD_BASE_PRIORITY_IDLE

const DRIVE_REMOVABLE   = 2
const DRIVE_FIXED       = 3
const DRIVE_REMOTE      = 4
const DRIVE_CDROM       = 5
const DRIVE_RAMDISK     = 6
const FILE_TYPE_UNKNOWN = &H0000&
const FILE_TYPE_DISK    = &H0001&
const FILE_TYPE_CHAR    = &H0002&
const FILE_TYPE_PIPE    = &H0003&
const FILE_TYPE_REMOTE  = &H8000&
const STD_INPUT_HANDLE  = -10
const STD_OUTPUT_HANDLE = -11
const STD_ERROR_HANDLE  = -12
const NOPARITY          = 0
const ODDPARITY         = 1
const EVENPARITY        = 2
const MARKPARITY        = 3
const SPACEPARITY       = 4
const ONESTOPBIT        = 0
const ONE5STOPBITS      = 1
const TWOSTOPBITS       = 2
const IGNORE            = 0 ' Ignore signal
const INFINITE          = &HFFFFFFFF& ' Infinite timeout

'
'  Basud rates at which the communication device operates
'

const CBR_110    = 110
const CBR_300    = 300
const CBR_600    = 600
const CBR_1200   = 1200
const CBR_2400   = 2400
const CBR_4800   = 4800
const CBR_9600   = 9600
const CBR_14400  = 14400
const CBR_19200  = 19200
const CBR_38400  = 38400
const CBR_56000  = 56000
const CBR_57600  = 57600
const CBR_115200 = 115200
const CBR_128000 = 128000
const CBR_256000 = 256000

'
'  Error Flags
'

const CE_RXOVER   = &H0001& ' Receive Queue overflow
const CE_OVERRUN  = &H0002& ' Receive Overrun Error
const CE_RXPARITY = &H0004& ' Receive Parity Error
const CE_FRAME    = &H0008& ' Receive Framing error
const CE_BREAK    = &H0010& ' Break Detected
const CE_TXFULL   = &H0100& ' TX Queue is full
const CE_PTO      = &H0200& ' LPTx Timeout
const CE_IOE      = &H0400& ' LPTx I/O Error
const CE_DNS      = &H0800& ' LPTx Device not selected
const CE_OOP      = &H1000& ' LPTx Out-Of-Paper
const CE_MODE     = &H8000& ' Requested mode unsupported
const IE_BADID    = (-1) ' Invalid or unsupported id
const IE_OPEN     = (-2) ' Device Already Open
const IE_NOPEN    = (-3) ' Device Not Open
const IE_MEMORY   = (-4) ' Unable to allocate queues
const IE_DEFAULT  = (-5) ' Error in default parameters
const IE_HARDWARE = (-10) ' Hardware Not Present
const IE_BYTESIZE = (-11) ' Illegal Byte Size
const IE_BAUDRATE = (-12) ' Unsupported BaudRate

'
'  Events
'

const EV_RXCHAR   = &H0001& ' Any Character received
const EV_RXFLAG   = &H0002& ' Received certain character
const EV_TXEMPTY  = &H0004& ' Transmitt Queue Empty
const EV_CTS      = &H0008& ' CTS changed state
const EV_DSR      = &H0010& ' DSR changed state
const EV_RLSD     = &H0020& ' RLSD changed state
const EV_BREAK    = &H0040& ' BREAK received
const EV_ERR      = &H0080& ' Line status error occurred
const EV_RING     = &H0100& ' Ring signal detected
const EV_PERR     = &H0200& ' Printer error occured
const EV_RX80FULL = &H0400& ' Receive buffer is 80 percent full
const EV_EVENT1   = &H0800& ' Provider specific event 1
const EV_EVENT2   = &H1000& ' Provider specific event 2

'
'  Escape Functions
'

const SETXOFF  = 1 ' Simulate XOFF received
const SETXON   = 2 ' Simulate XON received
const SETRTS   = 3 ' Set RTS high
const CLRRTS   = 4 ' Set RTS low
const SETDTR   = 5 ' Set DTR high
const CLRDTR   = 6 ' Set DTR low
const RESETDEV = 7 ' Reset device if possible
const SETBREAK = 8 ' Set the device break line.
const CLRBREAK = 9 ' Clear the device break line.

'
'  PURGE function flags.
'

const PURGE_TXABORT = &H0001& ' Kill the pending/current writes to the comm port.
const PURGE_RXABORT = &H0002& ' Kill the pending/current reads to the comm port.
const PURGE_TXCLEAR = &H0004& ' Kill the transmit queue if there.
const PURGE_RXCLEAR = &H0008& ' Kill the typeahead buffer if there.
const LPTx          = &H80& ' Set if ID is for LPT device

'
'  Modem Status Flags
'

const MS_CTS_ON  = (&H0010)
const MS_DSR_ON  = (&H0020)
const MS_RING_ON = (&H0040)
const MS_RLSD_ON = (&H0080)

'
'  WaitSoundState() Constants
'

const S_QUEUEEMPTY   = 0
const S_THRESHOLD    = 1
const S_ALLTHRESHOLD = 2

'
'  Accent Modes
'

const S_NORMAL   = 0
const S_LEGATO   = 1
const S_STACCATO = 2

'
'  SetSoundNoise() Sources
'

const S_PERIOD512                = 0 ' Freq = N/512 high pitch, less coarse hiss
const S_PERIOD1024               = 1 ' Freq = N/1024
const S_PERIOD2048               = 2 ' Freq = N/2048 low pitch, more coarse hiss
const S_PERIODVOICE              = 3 ' Source is frequency from voice channel (3)
const S_WHITE512                 = 4 ' Freq = N/512 high pitch, less coarse hiss
const S_WHITE1024                = 5 ' Freq = N/1024
const S_WHITE2048                = 6 ' Freq = N/2048 low pitch, more coarse hiss
const S_WHITEVOICE               = 7 ' Source is frequency from voice channel (3)
const S_SERDVNA                  = (-1) ' Device not available
const S_SEROFM                   = (-2) ' Out of memory
const S_SERMACT                  = (-3) ' Music active
const S_SERQFUL                  = (-4) ' Queue full
const S_SERBDNT                  = (-5) ' Invalid note
const S_SERDLN                   = (-6) ' Invalid note length
const S_SERDCC                   = (-7) ' Invalid note count
const S_SERDTP                   = (-8) ' Invalid tempo
const S_SERDVL                   = (-9) ' Invalid volume
const S_SERDMD                   = (-10) ' Invalid mode
const S_SERDSH                   = (-11) ' Invalid shape
const S_SERDPT                   = (-12) ' Invalid pitch
const S_SERDFQ                   = (-13) ' Invalid frequency
const S_SERDDR                   = (-14) ' Invalid duration
const S_SERDSR                   = (-15) ' Invalid source
const S_SERDST                   = (-16) ' Invalid state
const NMPWAIT_WAIT_FOREVER       = &Hffffffff&
const NMPWAIT_NOWAIT             = &H00000001&
const NMPWAIT_USE_DEFAULT_WAIT   = &H00000000&

const FILE_CASE_SENSITIVE_SEARCH = &h00000001&
const FILE_CASE_PRESERVED_NAMES  = &h00000002&
const FILE_UNICODE_ON_DISK       = &h00000004&
const FILE_PERSISTENT_ACLS       = &h00000008&

const FS_CASE_IS_PRESERVED       = FILE_CASE_PRESERVED_NAMES
const FS_CASE_SENSITIVE          = FILE_CASE_SENSITIVE_SEARCH
const FS_UNICODE_STORED_ON_DISK  = FILE_UNICODE_ON_DISK
const FS_PERSISTENT_ACLS         = FILE_PERSISTENT_ACLS

const SECTION_QUERY              = &h0001&
const SECTION_MAP_WRITE          = &h0002&
const SECTION_MAP_READ           = &h0004&
const SECTION_MAP_EXECUTE        = &h0008&
const SECTION_EXTEND_SIZE        = &h0010&

const SECTION_ALL_ACCESS         = (STANDARD_RIGHTS_REQUIRED or _
                                    SECTION_QUERY            or _
                                    SECTION_MAP_WRITE        or _
                                    SECTION_MAP_READ         or _
                                    SECTION_MAP_EXECUTE      or _
                                    SECTION_EXTEND_SIZE)

const FILE_MAP_COPY              = SECTION_QUERY
const FILE_MAP_WRITE             = SECTION_MAP_WRITE
const FILE_MAP_READ              = SECTION_MAP_READ
const FILE_MAP_ALL_ACCESS        = SECTION_ALL_ACCESS
const PAGE_NOACCESS              = &H01&
const PAGE_READONLY              = &H02&
const PAGE_READWRITE             = &H04&
const PAGE_WRITECOPY             = &H08&
const PAGE_EXECUTE               = &H10&
const PAGE_EXECUTE_READ          = &H20&
const PAGE_EXECUTE_READWRITE     = &H40&
const PAGE_EXECUTE_WRITECOPY     = &H80&
const PAGE_GUARD                 = &H100&
const PAGE_NOCACHE               = &H200&
const MEM_COMMIT                 = &H1000&
const MEM_RESERVE                = &H2000&
const MEM_DECOMMIT               = &H4000&
const MEM_RELEASE                = &H8000&
const MEM_FREE                   = &H10000&
const MEM_PRIVATE                = &H20000&
const MEM_MAPPED                 = &H40000&
const MEM_TOP_DOWN               = &H100000&
const SEC_FILE                   = &H800000&
const SEC_IMAGE                  = &H1000000&
const SEC_RESERVE                = &H4000000&
const SEC_COMMIT                 = &H8000000&
const SEC_NOCACHE                = &H10000000&
const MEM_IMAGE                  = SEC_IMAGE
const OF_READ                    = &H00000000&
const OF_WRITE                   = &H00000001&
const OF_READWRITE               = &H00000002&
const OF_SHARE_COMPAT            = &H00000000&
const OF_SHARE_EXCLUSIVE         = &H00000010&
const OF_SHARE_DENY_WRITE        = &H00000020&
const OF_SHARE_DENY_READ         = &H00000030&
const OF_SHARE_DENY_NONE         = &H00000040&
const OF_PARSE                   = &H00000100&
const OF_DELETE                  = &H00000200&
const OF_VERIFY                  = &H00000400&
const OF_CANCEL                  = &H00000800&
const OF_CREATE                  = &H00001000&
const OF_PROMPT                  = &H00002000&
const OF_EXIST                   = &H00004000&
const OF_REOPEN                  = &H00008000&
const OFS_MAXPATHNAME            = 128

type OFSTRUCT
    cBytes     as string * 1
    fFixedDisk as string * 1
    nErrCode   as short
    Reserved1  as short
    Reserved2  as short
    szPathName as string * OFS_MAXPATHNAME
end type

declare function InterlockedIncrement lib "kernel32.dll" alias "InterlockedIncrement" (lpAddend as pointer to long) as long
declare function InterlockedDecrement lib "kernel32.dll" alias "InterlockedDecrement" (lpAddend as pointer to long) as long
declare function InterlockedExchange  lib "kernel32.dll" alias "InterlockedExchange"  (Target as pointer to long, Value&) as long
declare function FreeResource         lib "kernel32.dll" alias "FreeResource"         (hResData&) as long
declare function LockResource         lib "kernel32.dll" alias "LockResource"         (hResData&) as long

const MAXINTATOM   = &HC000&
const INVALID_ATOM = (0)

type OSVERSIONINFO
    dwOSVersionInfoSize as long
    dwMajorVersion      as long
    dwMinorVersion      as long
    dwBuildNumber       as long
    dwPlatformId        as long
    szCSDVersion as string * 128
end type

declare function WinMain        lib "kernel32.dll" alias "WinMain"        (hInstance&, hPrevInstance&, lpCmdLine$, nShowCmd&) as long
declare sub      FreeLibrary    lib "kernel32.dll" alias "FreeLibrary"    (hLibModule&)
declare function GetProcAddress lib "kernel32.dll" alias "GetProcAddress" (hModule&, lpProcName$) as callback
declare function GetVersion     lib "kernel32.dll" alias "GetVersion"     () as long
declare function GetVersionEx   lib "kernel32.dll" alias "GetVersionExA"  (osv as OSVERSIONINFO) as long
declare function GlobalAlloc    lib "kernel32.dll" alias "GlobalAlloc"    (uFlags&, dwBytes&) as long
declare function GlobalReAlloc  lib "kernel32.dll" alias "GlobalReAlloc"  (hMem&, dwBytes&, uFlags&) as long
declare function GlobalSize     lib "kernel32.dll" alias "GlobalSize"     (hMem&) as long
declare function GlobalFlags    lib "kernel32.dll" alias "GlobalFlags"    (hMem&) as long
declare function GlobalLock     lib "kernel32.dll" alias "GlobalLock"     (hMem&) as long

' !!!MWH My version  win31 = DWORD WINAPI GlobalHandle(UINT)

type MEMORY_BASIC_INFORMATION
    BaseAddress       as long
    AllocationBase    as long
    AllocationProtect as long
    RegionSize        as long
    State             as long
    Protect           as long
    lType             as long
end type

declare function GlobalHandle                lib "kernel32.dll" alias "GlobalHandle"                (pMem as any) as long
declare function GlobalUnlock                lib "kernel32.dll" alias "GlobalUnlock"                (hMem&) as long
declare function GlobalFree                  lib "kernel32.dll" alias "GlobalFree"                  (hMem&) as long
declare function GlobalCompact               lib "kernel32.dll" alias "GlobalCompact"               (dwMinFree&) as long
declare sub      GlobalFix                   lib "kernel32.dll" alias "GlobalFix"                   (hMem&)
declare sub      GlobalUnfix                 lib "kernel32.dll" alias "GlobalUnfix"                 (hMem&)
declare function GlobalWire                  lib "kernel32.dll" alias "GlobalWire"                  (hMem&) as long
declare function GlobalUnWire                lib "kernel32.dll" alias "GlobalUnWire"                (hMem&) as long
declare sub      GlobalMemoryStatus          lib "kernel32.dll" alias "GlobalMemoryStatus"          (lpBuffer as MEMORYSTATUS)
declare function LocalAlloc                  lib "kernel32.dll" alias "LocalAlloc"                  (uFlags&, uBytes&) as long
declare function LocalReAlloc                lib "kernel32.dll" alias "LocalReAlloc"                (hMem&, uBytes&, uFlags&) as long
declare function LocalLock                   lib "kernel32.dll" alias "LocalLock"                   (hMem&) as long
declare function LocalHandle                 lib "kernel32.dll" alias "LocalHandle"                 (pMem as any) as long
declare function LocalUnlock                 lib "kernel32.dll" alias "LocalUnlock"                 (hMem&) as long
declare function LocalSize                   lib "kernel32.dll" alias "LocalSize"                   (hMem&) as long
declare function LocalFlags                  lib "kernel32.dll" alias "LocalFlags"                  (hMem&) as long
declare function LocalFree                   lib "kernel32.dll" alias "LocalFree"                   (hMem&) as long
declare function LocalShrink                 lib "kernel32.dll" alias "LocalShrink"                 (hMem&, cbNewSize&) as long
declare function LocalCompact                lib "kernel32.dll" alias "LocalCompact"                (uMinFree&) as long
declare function FlushInstructionCache       lib "kernel32.dll" alias "FlushInstructionCache"       (hProcess&, lpBaseAddress as any, dwSize&) as long
declare function VirtualAlloc                lib "kernel32.dll" alias "VirtualAlloc"                (lpAddress as any, dwSize&, flAllocationType&, flProtect&) as long
declare function VirtualFree                 lib "kernel32.dll" alias "VirtualFree"                 (lpAddress as any, dwSize&, dwFreeType&) as long
declare function VirtualProtect              lib "kernel32.dll" alias "VirtualProtect"              (lpAddress as any, dwSize&, flNewProtect&, lpflOldProtect as pointer to long) as long
declare function VirtualQuery                lib "kernel32.dll" alias "VirtualQuery"                (lpAddress as any, lpBuffer as MEMORY_BASIC_INFORMATION, dwLength&) as long
declare function VirtualProtectEx            lib "kernel32.dll" alias "VirtualProtectEx"            (hProcess&, lpAddress as any, dwSize&, flNewProtect&, lpflOldProtect as pointer to long) as long
declare function VirtualQueryEx              lib "kernel32.dll" alias "VirtualQueryEx"              (hProcess&, lpAddress as any, lpBuffer as MEMORY_BASIC_INFORMATION, dwLength&) as long
declare function HeapCreate                  lib "kernel32.dll" alias "HeapCreate"                  (flOptions&, dwInitialSize&, dwMaximumSize&) as long
declare function HeapDestroy                 lib "kernel32.dll" alias "HeapDestroy"                 (hHeap&) as long
declare function HeapAlloc                   lib "kernel32.dll" alias "HeapAlloc"                   (hHeap&, dwFlags&, dwBytes&) as long
declare function HeapReAlloc                 lib "kernel32.dll" alias "HeapReAlloc"                 (hHeap&, dwFlags&, lpMem as any, dwBytes&) as long
declare function HeapFree                    lib "kernel32.dll" alias "HeapFree"                    (hHeap&, dwFlags&, lpMem as any) as long
declare function HeapSize                    lib "kernel32.dll" alias "HeapSize"                    (hHeap&, dwFlags&, lpMem as any) as long
declare function GetProcessHeap              lib "kernel32.dll" alias "GetProcessHeap"              () as long
declare function GetProcessTimes             lib "kernel32.dll" alias "GetProcessTimes"             (hProcess&, lpCreationTime as FILETIME, lpExitTime as FILETIME, lpKernelTime as FILETIME, lpUserTime as FILETIME) as long
declare function OpenProcess                 lib "kernel32.dll" alias "OpenProcess"                 (dwDesiredAccess&, bInheritHandle&, dwProcessId&) as long
declare function GetCurrentProcess           lib "kernel32.dll" alias "GetCurrentProcess"           () as long
declare function GetCurrentProcessId         lib "kernel32.dll" alias "GetCurrentProcessId"         () as long
declare sub      ExitProcess                 lib "kernel32.dll" alias "ExitProcess"                 (uExitCode&)
declare function TerminateProcess            lib "kernel32.dll" alias "TerminateProcess"            (hProcess&, uExitCode&) as long
declare function GetExitCodeProcess          lib "kernel32.dll" alias "GetExitCodeProcess"          (hProcess&, lpExitCode as pointer to long) as long
declare sub      FatalExit                   lib "kernel32.dll" alias "FatalExit"                   (ExitCode&)
declare function GetEnvironmentStrings       lib "kernel32.dll" alias "GetEnvironmentStrings"       () as long
declare function GetCurrentThread            lib "kernel32.dll" alias "GetCurrentThread"            () as long
declare function GetCurrentThreadId          lib "kernel32.dll" alias "GetCurrentThreadId"          () as long
declare function SetThreadPriority           lib "kernel32.dll" alias "SetThreadPriority"           (hThread&, nPriority&) as long
declare function GetThreadPriority           lib "kernel32.dll" alias "GetThreadPriority"           (hThread&) as long
declare function GetThreadTimes              lib "kernel32.dll" alias "GetThreadTimes"              (hThread&, lpCreationTime as FILETIME, lpExitTime as FILETIME, lpKernelTime as FILETIME, lpUserTime as FILETIME) as long
declare function TerminateThread             lib "kernel32.dll" alias "TerminateThread"             (hThread&, dwExitCode&) as long
declare function GetExitCodeThread           lib "kernel32.dll" alias "GetExitCodeThread"           (hThread&, lpExitCode as pointer to long) as long
declare function GetLastError                lib "kernel32.dll" alias "GetLastError"                () as long
declare sub      SetLastError                lib "kernel32.dll" alias "SetLastError"                (dwErrCode&)

'
'  SetLastErrorEx() types.
'

const SLE_ERROR      = &H00000001&
const SLE_MINORERROR = &H00000002&
const SLE_WARNING    = &H00000003&

declare sub      SetLastErrorEx      lib "kernel32.dll" alias "SetLastErrorEx"      (dwErrCode&, dwType&)
declare function GetOverlappedResult lib "kernel32.dll" alias "GetOverlappedResult" (hFile&, lpOverlapped as OVERLAPPED, lpNumberOfBytesTransferred as pointer to long, bWait&) as long

const SEM_FAILCRITICALERRORS = &H0001&
const SEM_NOGPFAULTERRORBOX  = &H0002&
const SEM_NOOPENFILEERRORBOX = &H8000&

' ***** Pointer validation *************************************************

declare function IsBadReadPtr      lib "Kernel32.dll" alias "IsBadReadPtr"      (lp as any, cb&) as long
declare function IsBadWritePtr     lib "Kernel32.dll" alias "IsBadWritePtr"     (lp as any, cb&) as long
declare function IsBadHugeReadPtr  lib "Kernel32.dll" alias "IsBadHugeReadPtr"  (lp as any, cb&) as long
declare function IsBadHugeWritePtr lib "Kernel32.dll" alias "IsBadHugeWritePtr" (lp as any, cb&) as long
declare function IsBadCodePtr      lib "Kernel32.dll" alias "IsBadCodePtr"      (lpfn as any) as long
declare function IsBadStringPtr    lib "Kernel32.dll" alias "IsBadStringPtr"    (lpsz as any, cchMax&) as long

declare function ReadProcessMemory         lib "kernel32.dll" alias "ReadProcessMemory"         (hProcess&, lpBaseAddress as any, lpBuffer as any, nSize&, lpNumberOfBytesRead as pointer to long) as long
declare function WriteProcessMemory        lib "kernel32.dll" alias "WriteProcessMemory"        (hProcess&, lpBaseAddress as any, lpBuffer as any, nSize&, lpNumberOfBytesWritten as pointer to long) as long
declare function ReleaseSemaphore          lib "kernel32.dll" alias "ReleaseSemaphore"          (hSemaphore&, lReleaseCount&, lpPreviousCount as pointer to long) as long
declare function ReleaseMutex              lib "kernel32.dll" alias "ReleaseMutex"              (hMutex&) as long
declare function WaitForSingleObject       lib "kernel32.dll" alias "WaitForSingleObject"       (hHandle&, dwMilliseconds&) as long
declare function WaitForMultipleObjects    lib "kernel32.dll" alias "WaitForMultipleObjects"    (nCount&, lph as pointer to long, bWaitAll&, dwMilliseconds&) as long
' *** Warning: Sleep(), is a Microsoft Test reserved word ***
'declare sub      Sleep                     lib "kernel32.dll" alias "Sleep"                     (dwMilliseconds&)
declare function LoadResource              lib "kernel32.dll" alias "LoadResource"              (hModule&, hResInfo&) as long
declare function SizeofResource            lib "kernel32.dll" alias "SizeofResource"            (hModule&, hResInfo&) as long
declare function GlobalDeleteAtom          lib "kernel32.dll" alias "GlobalDeleteAtom"          (nAtom as short) as short
declare function InitAtomTable             lib "kernel32.dll" alias "InitAtomTable"             (nSize&) as long
declare function DeleteAtom                lib "kernel32.dll" alias "DeleteAtom"                (nAtom as short) as short
declare function SetHandleCount            lib "kernel32.dll" alias "SetHandleCount"            (uNumber&) as long
declare function GetLogicalDrives          lib "kernel32.dll" alias "GetLogicalDrives"          () as long
declare function LockFile                  lib "kernel32.dll" alias "LockFile"                  (hFile&, dwFileOffsetLow&, dwFileOffsetHigh&, nNumberOfBytesToLockLow&, nNumberOfBytesToLockHigh&) as long
declare function UnlockFile                lib "kernel32.dll" alias "UnlockFile"                (hFile&, dwFileOffsetLow&, dwFileOffsetHigh&, nNumberOfBytesToUnlockLow&, nNumberOfBytesToUnlockHigh&) as long
declare function LockFileEx                lib "kernel32.dll" alias "LockFileEx"                (hFile&, dwFlags&, dwReserved&, nNumberOfBytesToLockLow&, nNumberOfBytesToLockHigh&, lpOverlapped as OVERLAPPED) as long

const LOCKFILE_FAIL_IMMEDIATELY = &H00000001&
const LOCKFILE_EXCLUSIVE_LOCK   = &H00000002&

declare function UnlockFileEx lib "kernel32.dll" alias "UnlockFileEx" (hFile&, dwReserved&, nNumberOfBytesToUnlockLow&, nNumberOfBytesToUnlockHigh&, lpOverlapped as OVERLAPPED) as long

type BY_HANDLE_FILE_INFORMATION
    dwFileAttributes     as long
    ftCreationTime       as FILETIME
    ftLastAccessTime     as FILETIME
    ftLastWriteTime      as FILETIME
    dwVolumeSerialNumber as long
    nFileSizeHigh        as long
    nFileSizeLow         as long
    nNumberOfLinks       as long
    nFileIndexHigh       as long
    nFileIndexLow        as long
end type

declare function GetFileInformationByHandle lib "kernel32.dll" alias "GetFileInformationByHandle" (hFile&, lpFileInformation as BY_HANDLE_FILE_INFORMATION) as long
declare function GetFileType                lib "kernel32.dll" alias "GetFileType"                (hFile&) as long
declare function GetFileSize                lib "kernel32.dll" alias "GetFileSize"                (hFile&, lpFileSizeHigh as pointer to long) as long
declare function GetStdHandle               lib "kernel32.dll" alias "GetStdHandle"               (nStdHandle&) as long
declare function SetStdHandle               lib "kernel32.dll" alias "SetStdHandle"               (nStdHandle&, hHandle&) as long
declare function WriteFile                  lib "kernel32.dll" alias "WriteFile"                  (hFile&, lpBuffer as any, nNumberOfBytesToWrite&, lpNumberOfBytesWritten as pointer to long, lpOverlapped as OVERLAPPED) as long
declare function ReadFile                   lib "kernel32.dll" alias "ReadFile"                   (hFile&, lpBuffer as any, nNumberOfBytesToRead&, lpNumberOfBytesRead as pointer to long, lpOverlapped as OVERLAPPED) as long
declare function FlushFileBuffers           lib "kernel32.dll" alias "FlushFileBuffers"           (hFile&) as long
declare function DeviceIoControl            lib "kernel32.dll" alias "DeviceIoControl"            (hDevice&, dwIoControlCode&, lpInBuffer as any, nInBufferSize&, lpOutBuffer as any, nOutBufferSize&, lpBytesReturned as pointer to long, _
                                                                                                   lpOverlapped as OVERLAPPED) as long
declare function SetEndOfFile               lib "kernel32.dll" alias "SetEndOfFile"               (hFile&) as long
declare function SetFilePointer             lib "kernel32.dll" alias "SetFilePointer"             (hFile&, lDistanceToMove&, lpDistanceToMoveHigh as pointer to long, dwMoveMethod&) as long
declare function FindClose                  lib "kernel32.dll" alias "FindClose"                  (hFindFile&) as long
declare function GetFileTime                lib "kernel32.dll" alias "GetFileTime"                (hFile&, lpCreationTime as FILETIME, lpLastAccessTime as FILETIME, lpLastWriteTime as FILETIME) as long
declare function SetFileTime                lib "kernel32.dll" alias "SetFileTime"                (hFile&, lp as FILETIME, lp as FILETIME, lp as FILETIME) as long
declare function CloseHandle                lib "kernel32.dll" alias "CloseHandle"                (hObject&) as long
declare function DuplicateHandle            lib "kernel32.dll" alias "DuplicateHandle"            (hSourceProcessHandle&, hSourceHandle&, hTargetProcessHandle&, lpTargetHandle as pointer to long, dwDesiredAccess&, bInheritHandle&, dwOptions&) as long

const HINSTANCE_ERROR = 32

declare function LoadModule              lib "kernel32.dll" alias "LoadModule"              (lpModuleName$, lpParameterBlock as any) as long
declare function WinExec                 lib "kernel32.dll" alias "WinExec"                 (lpCmdLine$, uCmdShow&) as long
declare function BuildCommDCB            lib "kernel32.dll" alias "BuildCommDCB"            (lpDef$, lpDCB as DCB) as long
declare function BuildCommDCBAndTimeouts lib "kernel32.dll" alias "BuildCommDCBAndTimeouts" (lpDef$, lpDCB as DCB, lpCommTimeouts as COMMTIMEOUTS) as long
declare function ClearCommBreak          lib "kernel32.dll" alias "ClearCommBreak"          (hFile&) as long
declare function ClearCommError          lib "kernel32.dll" alias "ClearCommError"          (hFile&, lpErrors as pointer to long, lpStat as COMSTAT) as long
declare function SetupComm               lib "kernel32.dll" alias "SetupComm"               (hFile&, dwInQueue&, dwOutQueue&) as long
declare function EscapeCommFunction      lib "kernel32.dll" alias "EscapeCommFunction"      (hFile&, dwFunc&) as long
declare function GetCommMask             lib "kernel32.dll" alias "GetCommMask"             (hFile&, lpEvtMask as pointer to long) as long
declare function GetCommProperties       lib "kernel32.dll" alias "GetCommProperties"       (hFile&, lpCommProp as COMMPROP) as long
declare function GetCommModemStatus      lib "kernel32.dll" alias "GetCommModemStatus"      (hFile&, lpModemStat as pointer to long) as long
declare function GetCommState            lib "kernel32.dll" alias "GetCommState"            (hFile&, lpDCB as DCB) as long
declare function GetCommTimeouts         lib "kernel32.dll" alias "GetCommTimeouts"         (hFile&, lpCommTimeouts as COMMTIMEOUTS) as long
declare function PurgeComm               lib "kernel32.dll" alias "PurgeComm"               (hFile&, dwFlags&) as long
declare function SetCommBreak            lib "kernel32.dll" alias "SetCommBreak"            (hFile&) as long
declare function SetCommMask             lib "kernel32.dll" alias "SetCommMask"             (hFile&, dwEvtMask&) as long
declare function SetCommState            lib "kernel32.dll" alias "SetCommState"            (hFile&, lpDCB as DCB) as long
declare function SetCommTimeouts         lib "kernel32.dll" alias "SetCommTimeouts"         (hFile&, lpCommTimeouts as COMMTIMEOUTS) as long
declare function TransmitCommChar        lib "kernel32.dll" alias "TransmitCommChar"        (hFile&, cChar as short) as long
declare function WaitCommEvent           lib "kernel32.dll" alias "WaitCommEvent"           (hFile&, lpEvtMask as pointer to long, lpOverlapped as OVERLAPPED) as long
declare function SetTapePosition         lib "kernel32.dll" alias "SetTapePosition"         (hDevice&, dwPositionMethod&, dwPartition&, dwOffsetLow&, dwOffsetHigh&, bImmediate&) as long
declare function GetTapePosition         lib "kernel32.dll" alias "GetTapePosition"         (hDevice&, dwPositionType&, lpdwPartition as pointer to long, lpdwOffsetLow as pointer to long, lpdwOffsetHigh as pointer to long) as long
declare function PrepareTape             lib "kernel32.dll" alias "PrepareTape"             (hDevice&, dwOperation&, bImmediate&) as long
declare function EraseTape               lib "kernel32.dll" alias "EraseTape"               (hDevice&, dwEraseType&, bImmediate&) as long
declare function CreateTapePartition     lib "kernel32.dll" alias "CreateTapePartition"     (hDevice&, dwPartitionMethod&, dwCount&, dwSize&) as long
declare function WriteTapemark           lib "kernel32.dll" alias "WriteTapemark"           (hDevice&, dwTapemarkType&, dwTapemarkCount&, bImmediate&) as long
declare function GetTapeStatus           lib "kernel32.dll" alias "GetTapeStatus"           (hDevice&) as long
declare function GetTapeParameters       lib "kernel32.dll" alias "GetTapeParameters"       (hDevice&, dwOperation&, lpdwSize as pointer to long, lpTapeInformation as any) as long

const GET_TAPE_MEDIA_INFORMATION = 0
const GET_TAPE_DRIVE_INFORMATION = 1

declare function SetTapeParameters lib "kernel32.dll" alias "SetTapeParameters" (hDevice&, dwOperation&, lpTapeInformation as any) as long

const SET_TAPE_MEDIA_INFORMATION = 0
const SET_TAPE_DRIVE_INFORMATION = 1

' *** Warning: Beep(), is a Microsoft Test reserved word ***
'declare function Beep               lib "kernel32.dll" alias "Beep"               (dwFreq&, dwDuration&) as long
declare sub      OpenSound          lib "kernel32.dll" alias "OpenSound"          ()
declare sub      CloseSound         lib "kernel32.dll" alias "CloseSound"         ()
declare sub      StartSound         lib "kernel32.dll" alias "StartSound"         ()
declare sub      StopSound          lib "kernel32.dll" alias "StopSound"          ()
declare function WaitSoundState     lib "kernel32.dll" alias "WaitSoundState"     (nState&) as long
declare function SyncAllVoices      lib "kernel32.dll" alias "SyncAllVoices"      () as long
declare function CountVoiceNotes    lib "kernel32.dll" alias "CountVoiceNotes"    (nVoice&) as long
declare function GetThresholdEvent  lib "kernel32.dll" alias "GetThresholdEvent"  () as pointer to long
declare function GetThresholdStatus lib "kernel32.dll" alias "GetThresholdStatus" () as long
declare function SetSoundNoise      lib "kernel32.dll" alias "SetSoundNoise"      (nSource&, nDuration&) as long
declare function SetVoiceAccent     lib "kernel32.dll" alias "SetVoiceAccent"     (nVoice&, nTempo&, nVolume&, nMode&, nPitch&) as long
declare function SetVoiceEnvelope   lib "kernel32.dll" alias "SetVoiceEnvelope"   (nVoice&, nShape&, nRepeat&) as long
declare function SetVoiceNote       lib "kernel32.dll" alias "SetVoiceNote"       (nVoice&, nValue&, nLength&, nCdots&) as long
declare function SetVoiceQueueSize  lib "kernel32.dll" alias "SetVoiceQueueSize"  (nVoice&, nBytes&) as long
declare function SetVoiceSound      lib "kernel32.dll" alias "SetVoiceSound"      (nVoice&, Frequency&, nDuration&) as long
declare function SetVoiceThreshold  lib "kernel32.dll" alias "SetVoiceThreshold"  (nVoice&, nNotes&) as long
declare function MulDiv             lib "kernel32.dll" alias "MulDiv"             (nNumber&, nNumerator&, nDenominator&) as long
declare sub      GetSystemTime      lib "kernel32.dll" alias "GetSystemTime"      (lpSystemTime as SYSTEMTIME)
declare function SetSystemTime      lib "kernel32.dll" alias "SetSystemTime"      (lp as SYSTEMTIME) as long
declare sub      GetLocalTime       lib "kernel32.dll" alias "GetLocalTime"       (lpSystemTime as SYSTEMTIME)
declare function SetLocalTime       lib "kernel32.dll" alias "SetLocalTime"       (lp as SYSTEMTIME) as long
declare sub      GetSystemInfo      lib "kernel32.dll" alias "GetSystemInfo"      (lpSystemInfo as SYSTEM_INFO)

declare function PlaySound    lib "winmm.dll" alias "PlaySoundA"    (pszSound$, hMod&, fuSound&) as long
declare function sndPlaySound lib "winmm.dll" alias "sndPlaySoundA" (pszSound$, fuSound&) as long

const SND_ASYNC       = &h00000001&
const SND_ALIAS       = &h00010000&
const SND_SYNC        = &h00000000& ' play synchronously (default)
const SND_ASYNC       = &h00000001& ' play asynchronously
const SND_NODEFAULT   = &h00000002& ' silence (!default) if sound not found
const SND_MEMORY      = &h00000004& ' pszSound points to a memory file
const SND_LOOP        = &h00000008& ' loop the sound until next sndPlaySound
const SND_NOSTOP      = &h00000010& ' don't stop any currently playing sound
const SND_NOWAIT	  = &h00002000& ' don't wait if the driver is busy
const SND_ALIAS       = &h00010000& ' name is a registry alias
const SND_ALIAS_ID	  = &h00110000& ' alias is a predefined ID
const SND_FILENAME    = &h00020000& ' name is file name
const SND_RESOURCE    = &h00040004& ' name is resource name or atom
const SND_PURGE       = &h00000040& ' purge non-static events for task
const SND_APPLICATION = &h00000080& ' look for application specific association



' The string fields of this record are unicode strings.
' They have two bytes per char.  Before you can read them, you will
' have to call WideCharToMultiByte to convert them.
type TIME_ZONE_INFORMATION
    Bias         as long
    StandardName as string * 64 ' 32 wide chars, 2 bytes each.
    StandardDate as SYSTEMTIME
    StandardBias as long
    DaylightName as string * 64 ' 32 wide chars, 2 bytes each.
    DaylightDate as SYSTEMTIME
    DaylightBias as long
end type

declare function GetTimeZoneInformation lib "kernel32.dll" alias "GetTimeZoneInformation" (lpTimeZoneInformation as TIME_ZONE_INFORMATION) as long
declare function SetTimeZoneInformation lib "kernel32.dll" alias "SetTimeZoneInformation" (lp as TIME_ZONE_INFORMATION) as long

'
'  Routines to convert back and forth between system time and file time
'

declare function SystemTimeToFileTime    lib "kernel32.dll" alias "SystemTimeToFileTime"    (lp as SYSTEMTIME, lpFileTime as FILETIME) as long
declare function FileTimeToLocalFileTime lib "kernel32.dll" alias "FileTimeToLocalFileTime" (lp as FILETIME, lpLocalFileTime as FILETIME) as long
declare function LocalFileTimeToFileTime lib "kernel32.dll" alias "LocalFileTimeToFileTime" (lp as FILETIME, lpFileTime as FILETIME) as long
declare function FileTimeToSystemTime    lib "kernel32.dll" alias "FileTimeToSystemTime"    (lp as FILETIME, lpSystemTime as SYSTEMTIME) as long
declare function CompareFileTime         lib "kernel32.dll" alias "CompareFileTime"         (lp as FILETIME, lp as FILETIME) as long
declare function FileTimeToDosDateTime   lib "kernel32.dll" alias "FileTimeToDosDateTime"   (lp as FILETIME, lpFatDate as pointer to short, lpFatTime as pointer to short) as long
declare function DosDateTimeToFileTime   lib "kernel32.dll" alias "DosDateTimeToFileTime"   (wFatDate as short, wFatTime as short, lpFileTime as FILETIME) as long
declare function GetTickCount            lib "kernel32.dll" alias "GetTickCount"            () as long
declare function FormatMessage           lib "kernel32.dll" alias "FormatMessageA"          (dwFlags&, lpSource as any, dwMessageId&, dwLanguageId&, lpBuffer$, nSize&, arglist as any) as long

const FORMAT_MESSAGE_ALLOCATE_BUFFER = &H00000100&
const FORMAT_MESSAGE_IGNORE_INSERTS  = &H00000200&
const FORMAT_MESSAGE_FROM_STRING     = &H00000400&
const FORMAT_MESSAGE_FROM_HMODULE    = &H00000800&
const FORMAT_MESSAGE_FROM_SYSTEM     = &H00001000&
const FORMAT_MESSAGE_ARGUMENT_ARRAY  = &H00002000&
const FORMAT_MESSAGE_MAX_WIDTH_MASK  = &H000000FF&

declare function CreatePipe              lib "kernel32.dll" alias "CreatePipe"              (hReadPipe as pointer to long, hWritePipe as pointer to long, lpPipeAttributes as SECURITY_ATTRIBUTES, nSize&) as long
declare function ConnectNamedPipe        lib "kernel32.dll" alias "ConnectNamedPipe"        (hNamedPipe&, lpOverlapped as OVERLAPPED) as long
declare function DisconnectNamedPipe     lib "kernel32.dll" alias "DisconnectNamedPipe"     (hNamedPipe&) as long
declare function SetNamedPipeHandleState lib "kernel32.dll" alias "SetNamedPipeHandleState" (hNamedPipe&, lpMode as pointer to long, lpMaxCollectionCount as pointer to long, lpCollectDataTimeout as pointer to long) as long
declare function GetNamedPipeInfo        lib "kernel32.dll" alias "GetNamedPipeInfo"        (hNamedPipe&, lpFlags as pointer to long, lpOutBufferSize as pointer to long, lpInBufferSize as pointer to long, lpMaxInstances as pointer to long) as long
declare function PeekNamedPipe           lib "kernel32.dll" alias "PeekNamedPipe"           (hNamedPipe&, lpBuffer as any, nBufferSize&, lpBytesRead as pointer to long, lpTotalBytesAvail as pointer to long, lpBytesLeftThisMessage as pointer to long) _
 as long
declare function TransactNamedPipe       lib "kernel32.dll" alias "TransactNamedPipe"       (hNamedPipe&, lpInBuffer as any, nInBufferSize&, lpOutBuffer as any, nOutBufferSize&, lpBytesRead as pointer to long, lpOverlapped as OVERLAPPED) as long
declare function CreateMailslot          lib "kernel32.dll" alias "CreateMailslotA"         (lpName$, nMaxMessageSize&, lReadTimeout&, lpSecurityAttributes as SECURITY_ATTRIBUTES) as long
declare function GetMailslotInfo         lib "kernel32.dll" alias "GetMailslotInfo"         (hMailslot&, lpMaxMessageSize as pointer to long, lpNextSize as pointer to long, lpMessageCount as pointer to long, lpReadTimeout as pointer to long) as long
declare function SetMailslotInfo         lib "kernel32.dll" alias "SetMailslotInfo"         (hMailslot&, lReadTimeout&) as long
declare function MapViewOfFile           lib "kernel32.dll" alias "MapViewOfFile"           (hFileMappingObject&, dwDesiredAccess&, dwFileOffsetHigh&, dwFileOffsetLow&, dwNumberOfBytesToMap&) as long
declare function FlushViewOfFile         lib "kernel32.dll" alias "FlushViewOfFile"         (lpBaseAddress as any, dwNumberOfBytesToFlush&) as long
declare function UnmapViewOfFile         lib "kernel32.dll" alias "UnmapViewOfFile"         (lpBaseAddress as any) as long

'
'  _l Compat Functions
'

declare function lstrcmp  lib "kernel32.dll" alias "lstrcmpA" (lpString1$, lpString2$) as long
declare function lstrcmpi lib "kernel32.dll" alias "lstrcmpiA" (lpString1$, lpString2$) as long
declare function lstrcpy  lib "kernel32.dll" alias "lstrcpyA" (lpString1$, lpString2$) as long
declare function lstrcat  lib "kernel32.dll" alias "lstrcatA" (lpString1$, lpString2$) as long
declare function lstrlen  lib "kernel32.dll" alias "lstrlenA" (lpString$) as long
declare function OpenFile lib "kernel32.dll" alias "OpenFile" (lpFileName$, lpReOpenBuff as OFSTRUCT, uStyle&) as long
declare function _lopen   lib "kernel32.dll" alias "_lopen"   (lpPathName$, iReadWrite&) as long
declare function _lcreat  lib "kernel32.dll" alias "_lcreat"  (lpPathName$, iAttribute&) as long
declare function _lread   lib "kernel32.dll" alias "_lread"   (hFile&, lpBuffer as any, uBytes&) as long
declare function _lwrite  lib "kernel32.dll" alias "_lwrite"  (hFile&, lpBuffer$, uBytes&) as long
declare function _hread   lib "kernel32.dll" alias "_hread"   (hFile&, lpBuffer as any, lBytes&) as long
declare function _hwrite  lib "kernel32.dll" alias "_hwrite"  (hFile&, lpBuffer$, lBytes&) as long
declare function _lclose  lib "kernel32.dll" alias "_lclose"  (hFile&) as long
declare function _llseek  lib "kernel32.dll" alias "_llseek"  (hFile&, lOffset&, iOrigin&) as long
declare function TlsAlloc lib "kernel32.dll" alias "TlsAlloc" () as long

const TLS_OUT_OF_INDEXES = &HFFFFFFFF&

declare function TlsGetValue              lib "kernel32.dll" alias "TlsGetValue"              (dwTlsIndex&) as long
declare function TlsSetValue              lib "kernel32.dll" alias "TlsSetValue"              (dwTlsIndex&, lpTlsValue as any) as long
declare function TlsFree                  lib "kernel32.dll" alias "TlsFree"                  (dwTlsIndex&) as long
declare function SleepEx                  lib "kernel32.dll" alias "SleepEx"                  (dwMilliseconds&, bAlertable&) as long
declare function WaitForSingleObjectEx    lib "kernel32.dll" alias "WaitForSingleObjectEx"    (hHandle&, dwMilliseconds&, bAlertable&) as long
declare function WaitForMultipleObjectsEx lib "kernel32.dll" alias "WaitForMultipleObjectsEx" (nCount&, lph as pointer to long, bWaitAll&, dwMilliseconds&, bAlertable&) as long
declare function ReadFileEx               lib "kernel32.dll" alias "ReadFileEx"               (hFile&, lpBuffer as any, nNumberOfBytesToRead&, lpOverlapped as OVERLAPPED, lpCompletionRoutine as pointer to sub (dwError&, BytesTransferred&, OVL as OVERLAPPED)) as long
declare function WriteFileEx              lib "kernel32.dll" alias "WriteFileEx"              (hFile&, lpBuffer as any, nNumberOfBytesToWrite&, lpOverlapped as OVERLAPPED, lpCompletionRoutine as pointer to sub (dwError&, BytesTransferred&, OVL as OVERLAPPED)) as long
declare function BackupRead               lib "kernel32.dll" alias "BackupRead"               (hFile&, lpBuffer$, nNumberOfBytesToRead&, lpNumberOfBytesRead as pointer to long, bAbort&, bProcessSecurity&, lp as any) as long
declare function BackupSeek               lib "kernel32.dll" alias "BackupSeek"               (hFile&, dwLowBytesToSeek&, dwHighBytesToSeek&, lpdwLowByteSeeked as pointer to long, lpdwHighByteSeeked as pointer to long, lp as any) as long
declare function BackupWrite              lib "kernel32.dll" alias "BackupWrite"              (hFile&, lpBuffer$, nNumberOfBytesToWrite&, lpNumberOfBytesWritten as pointer to long, bAbort&, bProcessSecurity&, lp as any) as long

'
'  Dual Mode API below this line. Dual Mode Structures also included.
'

const STARTF_USESHOWWINDOW    = &H00000001&
const STARTF_USESIZE          = &H00000002&
const STARTF_USEPOSITION      = &H00000004&
const STARTF_USECOUNTCHARS    = &H00000008&
const STARTF_USEFILLATTRIBUTE = &H00000010&
const STARTF_RUNFULLSCREEN    = &H00000020& ' ignored for non-x86 platforms
const STARTF_FORCEONFEEDBACK  = &H00000040&
const STARTF_FORCEOFFFEEDBACK = &H00000080&
const STARTF_USESTDHANDLES    = &H00000100&

type STARTUPINFO
    cb              as long
    lpReserved      as pointer to string * 1
    lpDesktop       as pointer to string * 1
    lpTitle         as pointer to string * 1
    dwX             as long
    dwY             as long
    dwXSize         as long
    dwYSize         as long
    dwXCountChars   as long
    dwYCountChars   as long
    dwFillAttribute as long
    dwFlags         as long
    wShowWindow     as short
    cbReserved2     as short
    lpReserved2     as pointer to string * 1
    hStdInput       as long
    hStdOutput      as long
    hStdError       as long
end type

const SHUTDOWN_NORETRY = &H00000001&

type WIN32_FIND_DATA
    dwFileAttributes   as long
    ftCreationTime     as FILETIME
    ftLastAccessTime   as FILETIME
    ftLastWriteTime    as FILETIME
    nFileSizeHigh      as long
    nFileSizeLow       as long
    dwReserved0        as long
    dwReserved1        as long
    cFileName          as string * MAX_PATH
    cAlternateFileName as string * 14
end type

declare function CreateMutex            lib "kernel32.dll" alias "CreateMutexA"           (lpMutexAttributes as SECURITY_ATTRIBUTES, bInitialOwner&, lpName$) as long
declare function OpenMutex              lib "kernel32.dll" alias "OpenMutexA"             (dwDesiredAccess&, bInheritHandle&, lpName$) as long
declare function CreateEvent            lib "kernel32.dll" alias "CreateEventA"           (lpEventAttributes as SECURITY_ATTRIBUTES, bManualReset&, bInitialState&, lpName$) as long
declare function OpenEvent              lib "kernel32.dll" alias "OpenEventA"             (dwDesiredAccess&, bInheritHandle&, lpName$) as long
declare function CreateSemaphore        lib "kernel32.dll" alias "CreateSemaphoreA"       (lpSemaphoreAttributes as SECURITY_ATTRIBUTES, lInitialCount&, lMaximumCount&, lpName$) as long
declare function OpenSemaphore          lib "kernel32.dll" alias "OpenSemaphoreA"         (dwDesiredAccess&, bInheritHandle&, lpName$) as long
declare function CreateFileMapping      lib "kernel32.dll" alias "CreateFileMappingA"     (hFile&, lpFileMappingAttributes as SECURITY_ATTRIBUTES, flProtect&, dwMaximumSizeHigh&, dwMaximumSizeLow&, lpName$) as long
declare function OpenFileMapping        lib "kernel32.dll" alias "OpenFileMappingA"       (dwDesiredAccess&, bInheritHandle&, lpName$) as long
declare function GetLogicalDriveStrings lib "kernel32.dll" alias "GetLogicalDriveStringsA" (nBufferLength&, lpBuf As Pointer To String * 1) as long
declare function LoadLibrary            lib "kernel32.dll" alias "LoadLibraryA"           (lpLibFileName$) as long
declare function LoadLibraryEx          lib "kernel32.dll" alias "LoadLibraryExA"         (lpLibFileName$, hFile&, dwFlags&) as long

const DONT_RESOLVE_DLL_REFERENCES = &H00000001&

declare function GetModuleFileName            lib "kernel32.dll" alias "GetModuleFileNameA"           (hModule&, lpFilename$, nSize&) as long
declare function GetModuleHandle              lib "kernel32.dll" alias "GetModuleHandleA"             (lpModuleName$) as long
declare function CreateProcess                lib "kernel32.dll" alias "CreateProcessA"               (lpApplicationName$, lpCommandLine$, lpProcessAttributes as SECURITY_ATTRIBUTES, lpThreadAttributes as SECURITY_ATTRIBUTES, bInheritHandles&, _
                                                                                                       dwCreationFlags&, lpEnvironment as any, lpCurrentDirectory$, lpStartupInfo as STARTUPINFO, lpProcessInformation as PROCESS_INFORMATION) as long
declare function SetProcessShutdownParameters lib "kernel32.dll" alias "SetProcessShutdownParameters" (dwLevel&, dwFlags&) as long
declare function GetProcessShutdownParameters lib "kernel32.dll" alias "GetProcessShutdownParameters" (lpdwLevel as pointer to long, lpdwFlags as pointer to long) as long
declare sub      FatalAppExit                 lib "kernel32.dll" alias "FatalAppExitA"                (uAction&, lpMessageText$)
declare sub      GetStartupInfo               lib "kernel32.dll" alias "GetStartupInfoA"              (lpStartupInfo as STARTUPINFO)
declare function GetCommandLine               lib "kernel32.dll" alias "GetCommandLineA"              () as long
declare function GetEnvironmentVariable       lib "kernel32.dll" alias "GetEnvironmentVariableA"      (lpName$, lpBuffer$, nSize&) as long
declare function SetEnvironmentVariable       lib "kernel32.dll" alias "SetEnvironmentVariableA"      (lpName$, lpValue$) as long
declare function ExpandEnvironmentStrings     lib "kernel32.dll" alias "ExpandEnvironmentStringsA"    (lpSrc$, lpDst$, nSize&) as long
declare sub      OutputDebugString            lib "kernel32.dll" alias "OutputDebugStringA"           (lpOutputString$)
declare function FindResource                 lib "kernel32.dll" alias "FindResourceA"                (hModule&, lpName$, lpType$) as long
declare function FindResourceEx               lib "kernel32.dll" alias "FindResourceExA"              (hModule&, lpType$, lpName$, wLanguage as short) as long
declare function EnumResourceTypes            lib "kernel32.dll" alias "EnumResourceTypesA"           (hModule&, lpEnumFunc as pointer to function (hModule&, ResType$, lParam&) as long, lParam&) as long
declare function EnumResourceNames            lib "kernel32.dll" alias "EnumResourceNamesA"           (hModule&, lpType$, lpEnumFunc as pointer to function (hModule&, ResType$, ResName$, lParam&) as long, lParam&) as long
declare function EnumResourceLanguages        lib "kernel32.dll" alias "EnumResourceLanguagesA"       (hModule&, lpType$, lpName$, lpEnumFunc as pointer to function (hModule&, ResType$, ResName$, Language%, lParam&) as long, lParam&) as long
declare function BeginUpdateResource          lib "kernel32.dll" alias "BeginUpdateResourceA"         (pFileName$, bDeleteExistingResources&) as long
declare function UpdateResource               lib "kernel32.dll" alias "UpdateResourceA"              (hUpdate&, lpType$, lpName$, wLanguage as short, lpData as any, cbData&) as long
declare function EndUpdateResource            lib "kernel32.dll" alias "EndUpdateResourceA"           (hUpdate&, fDiscard&) as long
declare function GlobalAddAtom                lib "kernel32.dll" alias "GlobalAddAtomA"               (lpString$) as short
declare function GlobalFindAtom               lib "kernel32.dll" alias "GlobalFindAtomA"              (lpString$) as short
declare function GlobalGetAtomName            lib "kernel32.dll" alias "GlobalGetAtomNameA"           (nAtom as short, lpBuffer$, nSize&) as long
declare function AddAtom                      lib "kernel32.dll" alias "AddAtomA"                     (lpString$) as short
declare function FindAtom                     lib "kernel32.dll" alias "FindAtomA"                    (lpString$) as short
declare function GetAtomName                  lib "kernel32.dll" alias "GetAtomNameA"                 (nAtom as short, lpBuffer$, nSize&) as long
declare function GetProfileInt                lib "kernel32.dll" alias "GetProfileIntA"               (lpAppName$, lpKeyName$, nDefault&) as long
declare function GetProfileString             lib "kernel32.dll" alias "GetProfileStringA"            (lpAppName$, lpKeyName$, lpDefault$, lpReturnedString$, nSize&) as long
declare function WriteProfileString           lib "kernel32.dll" alias "WriteProfileStringA"          (lpAppName$, lpKeyName$, lpString$) as long
declare function GetProfileSection            lib "kernel32.dll" alias "GetProfileSectionA"           (lpAppName$, lpReturnedString$, nSize&) as long
declare function WriteProfileSection          lib "kernel32.dll" alias "WriteProfileSectionA"         (lpAppName$, lpString$) as long
declare function GetPrivateProfileInt         lib "kernel32.dll" alias "GetPrivateProfileIntA"        (lpAppName$, lpKeyName$, nDefault&, lpFileName$) as long
declare function GetPrivateProfileString      lib "kernel32.dll" alias "GetPrivateProfileStringA"     (lpAppName$, lpKeyName$, lpDefault$, lpReturnedString$, nSize&, lpFileName$) as long
declare function WritePrivateProfileString    lib "kernel32.dll" alias "WritePrivateProfileStringA"   (lpAppName$, lpKeyName$, lpString$, lpFileName$) as long
declare function GetPrivateProfileSection     lib "kernel32.dll" alias "GetPrivateProfileSectionA"    (lpAppName$, lpReturnedString$, nSize&, lpFileName$) as long
declare function WritePrivateProfileSection   lib "kernel32.dll" alias "WritePrivateProfileSectionA"  (lpAppName$, lpString$, lpFileName$) as long
declare function GetDriveType                 lib "kernel32.dll" alias "GetDriveTypeA"                (lpRootPathName$) as long
declare function GetSystemDirectory           lib "kernel32.dll" alias "GetSystemDirectoryA"          (lpBuffer$, uSize&) as long
declare function GetTempPath                  lib "kernel32.dll" alias "GetTempPathA"                 (nBufferLength&, lpBuffer$) as long
declare function GetTempFileName              lib "kernel32.dll" alias "GetTempFileNameA"             (lpPathName$, lpPrefixString$, uUnique&, lpTempFileName$) as long
declare function GetWindowsDirectory          lib "kernel32.dll" alias "GetWindowsDirectoryA"         (lpBuffer$, uSize&) as long
declare function SetCurrentDirectory          lib "kernel32.dll" alias "SetCurrentDirectoryA"         (lpPathName$) as long
declare function GetCurrentDirectory          lib "kernel32.dll" alias "GetCurrentDirectoryA"         (nBufferLength&, lpBuffer$) as long
declare function GetDiskFreeSpace             lib "kernel32.dll" alias "GetDiskFreeSpaceA"            (lpRootPathName$, lpSectorsPerCluster as pointer to long, lpBytesPerSector as pointer to long, lpNumberOfFreeClusters as pointer to long, _
                                                                                                       lpTotalNumberOfClusters as pointer to long) as long
declare function CreateDirectory              lib "kernel32.dll" alias "CreateDirectoryA"             (lpPathName$, lpSecurityAttributes as SECURITY_ATTRIBUTES) as long
declare function CreateDirectoryEx            lib "kernel32.dll" alias "CreateDirectoryExA"           (lpTemplateDirectory$, lpNewDirectory$, lpSecurityAttributes as SECURITY_ATTRIBUTES) as long
declare function RemoveDirectory              lib "kernel32.dll" alias "RemoveDirectoryA"             (lpPathName$) as long
declare function GetFullPathName              lib "kernel32.dll" alias "GetFullPathNameA"             (lpFileName$, nBufferLength&, lpBuffer$, lp as pointer to long) as long

const DDD_RAW_TARGET_PATH       = &H00000001&
const DDD_REMOVE_DEFINITION     = &H00000002&
const DDD_EXACT_MATCH_ON_REMOVE = &H00000004&

declare function DefineDosDevice   lib "kernel32.dll" alias "DefineDosDeviceA"  (dwFlags&, lpDeviceName$, lpTargetPath$) as long
declare function QueryDosDevice    lib "kernel32.dll" alias "QueryDosDeviceA"   (lpDeviceName$, lpTargetPath$, ucchMax&) as long
declare function CreateFile        lib "kernel32.dll" alias "CreateFileA"       (lpFileName$, dwDesiredAccess&, dwShareMode&, lpSecurityAttributes as SECURITY_ATTRIBUTES, dwCreationDisposition&, dwFlagsAndAttributes&, hTemplateFile&) as long
declare function SetFileAttributes lib "kernel32.dll" alias "SetFileAttributesA" (lpFileName$, dwFileAttributes&) as long
declare function GetFileAttributes lib "kernel32.dll" alias "GetFileAttributesA" (lpFileName$) as long
declare function DeleteFile        lib "kernel32.dll" alias "DeleteFileA"       (lpFileName$) as long
declare function FindFirstFile     lib "kernel32.dll" alias "FindFirstFileA"    (lpFileName$, lpFindFileData as WIN32_FIND_DATA) as long
declare function FindNextFile      lib "kernel32.dll" alias "FindNextFileA"     (hFindFile&, lpFindFileData as WIN32_FIND_DATA) as long
declare function SearchPath        lib "kernel32.dll" alias "SearchPathA"       (lpPath$, lpFileName$, lpExtension$, nBufferLength&, lpBuffer$, sz$) as long
declare function CopyFile          lib "kernel32.dll" alias "CopyFileA"         (lpExistingFileName$, lpNewFileName$, bFailIfExists&) as long
declare function MoveFile          lib "kernel32.dll" alias "MoveFileA"         (lpExistingFileName$, lpNewFileName$) as long
declare function MoveFileEx        lib "kernel32.dll" alias "MoveFileExA"       (lpExistingFileName$, lpNewFileName$, dwFlags&) as long

const MOVEFILE_REPLACE_EXISTING   = &H00000001&
const MOVEFILE_COPY_ALLOWED       = &H00000002&
const MOVEFILE_DELAY_UNTIL_REBOOT = &H00000004&

declare function CreateNamedPipe         lib "kernel32.dll" alias "CreateNamedPipeA"        (lpName$, dwOpenMode&, dwPipeMode&, nMaxInstances&, nOutBufferSize&, nInBufferSize&, nDefaultTimeOut&, lpSecurityAttributes as SECURITY_ATTRIBUTES) as long
declare function GetNamedPipeHandleState lib "kernel32.dll" alias "GetNamedPipeHandleStateA" (hNamedPipe&, lpState as pointer to long, lpCurInstances as pointer to long, lpMaxCollectionCount as pointer to long, lpCollectDataTimeout as pointer to long, _
                                                                                              lpUserName$, nMaxUserNameSize&) as long
declare function CallNamedPipe           lib "kernel32.dll" alias "CallNamedPipeA"          (lpNamedPipeName$, lpInBuffer as any, nInBufferSize&, lpOutBuffer as any, nOutBufferSize&, lpBytesRead as pointer to long, nTimeOut&) as long
declare function WaitNamedPipe           lib "kernel32.dll" alias "WaitNamedPipeA"          (lpNamedPipeName$, nTimeOut&) as long
declare function SetVolumeLabel          lib "kernel32.dll" alias "SetVolumeLabelA"         (lpRootPathName$, lpVolumeName$) as long
declare sub      SetFileApisToOEM        lib "kernel32.dll" alias "SetFileApisToOEM"        ()
declare function GetVolumeInformation    lib "kernel32.dll" alias "GetVolumeInformationA"   (lpRootPathName$, lpVolumeNameBuffer$, nVolumeNameSize&, lpVolumeSerialNumber as pointer to long, lpMaximumComponentLength as pointer to long, _
                                                                                             lpFileSystemFlags as pointer to long, lpFileSystemNameBuffer$, nFileSystemNameSize&) as long

'
'  Event logging APIs
'

declare function ClearEventLog              lib "advapi32.dll" alias "ClearEventLogA"             (hEventLog&, lpBackupFileName$) as long
declare function BackupEventLog             lib "advapi32.dll" alias "BackupEventLogA"            (hEventLog&, lpBackupFileName$) as long
declare function CloseEventLog              lib "advapi32.dll" alias "CloseEventLog"              (hEventLog&) as long
declare function DeregisterEventSource      lib "advapi32.dll" alias "DeregisterEventSource"      (hEventLog&) as long
declare function GetNumberOfEventLogRecords lib "advapi32.dll" alias "GetNumberOfEventLogRecords" (hEventLog&, NumberOfRecords as pointer to long) as long
declare function GetOldestEventLogRecord    lib "advapi32.dll" alias "GetOldestEventLogRecord"    (hEventLog&, OldestRecord as pointer to long) as long
declare function OpenEventLog               lib "advapi32.dll" alias "OpenEventLogA"              (lpUNCServerName$, lpSourceName$) as long
declare function RegisterEventSource        lib "advapi32.dll" alias "RegisterEventSourceA"       (lpUNCServerName$, lpSourceName$) as long
declare function OpenBackupEventLog         lib "advapi32.dll" alias "OpenBackupEventLogA"        (lpUNCServerName$, lpFileName$) as long
declare function ReadEventLog               lib "advapi32.dll" alias "ReadEventLogA"              (hEventLog&, dwReadFlags&, dwRecordOffset&, lpBuffer as any, nNumberOfBytesToRead&, pdw as pointer to long, pdw as pointer to long) as long
declare function ReportEvent                lib "advapi32.dll" alias "ReportEventA"               (hEventLog&, wType as short, wCategory as short, dwEventID&, lpUserSid as any, wNumStrings as short, dwDataSize&, sz$, lpRawData as any) as long

const MAX_COMPUTERNAME_LENGTH = 15

declare function GetComputerName lib "kernel32.dll" alias "GetComputerNameA" (lpBuffer$, nSize as pointer to long) as long
declare function SetComputerName lib "kernel32.dll" alias "SetComputerNameA" (lpComputerName$) as long
declare function GetUserName     lib "advapi32.dll" alias "GetUserNameA"     (lpBuffer$, nSize as pointer to long) as long

'  DOS and OS/2 Compatible Error Code definitions returned by the Win32 Base
'  API functions.
'
'  Abnormal termination codes

const TC_NORMAL  = 0
const TC_HARDERR = 1
const TC_GP_TRAP = 2
const TC_SIGNAL  = 3

'******************************************************************************
'*** From WINGDI.H: GDI32 Types, Constants, Functions
'******************************************************************************

' Predefined by MS-Test
'
'type RECT
'    wleft   as long
'    wtop    as long
'    wright  as long
'    wbottom as long
'end type

type RECTL
    lleft   as long
    ltop    as long
    lright  as long
    lbottom as long
end type

' Predefined by MS-Test for the IME api

'type POINT
'    x as long
'    y as long
'end type

type POINTL
    x as long
    y as long
end type

type POINTS
    x as short
    y as short
end type

type SIZE
    cx as long
    cy as long
end type

type SIZEL
    cx as long
    cy as long
end type

'  Binary raster ops

const R2_BLACK       = 1 ' 0
const R2_NOTMERGEPEN = 2 ' DPon
const R2_MASKNOTPEN  = 3 ' DPna
const R2_NOTCOPYPEN  = 4 ' PN
const R2_MASKPENNOT  = 5 ' PDna
const R2_NOT         = 6 ' Dn
const R2_XORPEN      = 7 ' DPx
const R2_NOTMASKPEN  = 8 ' DPan
const R2_MASKPEN     = 9 ' DPa
const R2_NOTXORPEN   = 10 ' DPxn
const R2_NOP         = 11 ' D
const R2_MERGENOTPEN = 12 ' DPno
const R2_COPYPEN     = 13 ' P
const R2_MERGEPENNOT = 14 ' PDno
const R2_MERGEPEN    = 15 ' DPo
const R2_WHITE       = 16 ' 1
const R2_LAST        = 16

'  Ternary raster operations
' NOTE: Predefined by MS-Test for DrawBitmap() intrinsic
'
'const SRCCOPY     = &H00CC0020& ' dest = source
'const SRCPAINT    = &H00EE0086& ' dest = source OR dest
'const SRCAND      = &H008800C6& ' dest = source AND dest
'const SRCINVERT   = &H00660046& ' dest = source XOR dest
'const SRCERASE    = &H00440328& ' dest = source AND (NOT dest )
'const NOTSRCCOPY  = &H00330008& ' dest = (NOT source)
'const NOTSRCERASE = &H001100A6& ' dest = (NOT src) AND (NOT dest)
'const MERGECOPY   = &H00C000CA& ' dest = (source AND pattern)
'const MERGEPAINT  = &H00BB0226& ' dest = (NOT source) OR dest
'const PATCOPY     = &H00F00021& ' dest = pattern
'const PATPAINT    = &H00FB0A09& ' dest = DPSnoo
'const PATINVERT   = &H005A0049& ' dest = pattern XOR dest
'const DSTINVERT   = &H00550009& ' dest = (NOT dest)
'const BLACKNESS   = &H00000042& ' dest = BLACK
'const WHITENESS   = &H00FF0062& ' dest = WHITE

'  Quaternary raster codes

const GDI_ERROR  = (&HFFFFFFFF&)
const HGDI_ERROR = ((&HFFFFFFFF&))

'  Region Flags

const _ERROR        = 0
const NULLREGION    = 1
const SIMPLEREGION  = 2
const COMPLEXREGION = 3
const RGN_ERROR     = _ERROR

'  CombineRgn() Styles

const RGN_AND  = 1
const RGN_OR   = 2
const RGN_XOR  = 3
const RGN_DIFF = 4
const RGN_COPY = 5
const RGN_MIN  = RGN_AND
const RGN_MAX  = RGN_COPY

'  StretchBlt() Modes

const BLACKONWHITE      = 1
const WHITEONBLACK      = 2
const COLORONCOLOR      = 3
const HALFTONE          = 4
const MAXSTRETCHBLTMODE = 4

'  PolyFill() Modes

const ALTERNATE     = 1
const WINDING       = 2
const POLYFILL_LAST = 2

'  Text Alignment Options

const TA_NOUPDATECP    = 0
const TA_UPDATECP      = 1
const TA_LEFT          = 0
const TA_RIGHT         = 2
const TA_CENTER        = 6
const TA_TOP           = 0
const TA_BOTTOM        = 8
const TA_BASELINE      = 24
const TA_MASK          = (TA_BASELINE+TA_CENTER+TA_UPDATECP)
const VTA_BASELINE     = TA_BASELINE
const VTA_LEFT         = TA_BOTTOM
const VTA_RIGHT        = TA_TOP
const VTA_CENTER       = TA_CENTER
const VTA_BOTTOM       = TA_RIGHT
const VTA_TOP          = TA_LEFT
const ETO_GRAYED       = 1
const ETO_OPAQUE       = 2
const ETO_CLIPPED      = 4
const ASPECT_FILTERING = &H0001&

'  Bounds Accumulation APIs

const DCB_RESET      = &H0001&
const DCB_ACCUMULATE = &H0002&
const DCB_DIRTY      = DCB_ACCUMULATE
const DCB_SET        = (DCB_RESET or DCB_ACCUMULATE)
const DCB_ENABLE     = &H0004&
const DCB_DISABLE    = &H0008&

'  Metafile Functions

const META_SETBKCOLOR            = &H0201&
const META_SETBKMODE             = &H0102&
const META_SETMAPMODE            = &H0103&
const META_SETROP2               = &H0104&
const META_SETRELABS             = &H0105&
const META_SETPOLYFILLMODE       = &H0106&
const META_SETSTRETCHBLTMODE     = &H0107&
const META_SETTEXTCHAREXTRA      = &H0108&
const META_SETTEXTCOLOR          = &H0209&
const META_SETTEXTJUSTIFICATION  = &H020A&
const META_SETWINDOWORG          = &H020B&
const META_SETWINDOWEXT          = &H020C&
const META_SETVIEWPORTORG        = &H020D&
const META_SETVIEWPORTEXT        = &H020E&
const META_OFFSETWINDOWORG       = &H020F&
const META_SCALEWINDOWEXT        = &H0410&
const META_OFFSETVIEWPORTORG     = &H0211&
const META_SCALEVIEWPORTEXT      = &H0412&
const META_LINETO                = &H0213&
const META_MOVETO                = &H0214&
const META_EXCLUDECLIPRECT       = &H0415&
const META_INTERSECTCLIPRECT     = &H0416&
const META_ARC                   = &H0817&
const META_ELLIPSE               = &H0418&
const META_FLOODFILL             = &H0419&
const META_PIE                   = &H081A&
const META_RECTANGLE             = &H041B&
const META_ROUNDRECT             = &H061C&
const META_PATBLT                = &H061D&
const META_SAVEDC                = &H001E&
const META_SETPIXEL              = &H041F&
const META_OFFSETCLIPRGN         = &H0220&
const META_TEXTOUT               = &H0521&
const META_BITBLT                = &H0922&
const META_STRETCHBLT            = &H0B23&
const META_POLYGON               = &H0324&
const META_POLYLINE              = &H0325&
const META_ESCAPE                = &H0626&
const META_RESTOREDC             = &H0127&
const META_FILLREGION            = &H0228&
const META_FRAMEREGION           = &H0429&
const META_INVERTREGION          = &H012A&
const META_PAINTREGION           = &H012B&
const META_SELECTCLIPREGION      = &H012C&
const META_SELECTOBJECT          = &H012D&
const META_SETTEXTALIGN          = &H012E&
const META_CHORD                 = &H0830&
const META_SETMAPPERFLAGS        = &H0231&
const META_EXTTEXTOUT            = &H0a32&
const META_SETDIBTODEV           = &H0d33&
const META_SELECTPALETTE         = &H0234&
const META_REALIZEPALETTE        = &H0035&
const META_ANIMATEPALETTE        = &H0436&
const META_SETPALENTRIES         = &H0037&
const META_POLYPOLYGON           = &H0538&
const META_RESIZEPALETTE         = &H0139&
const META_DIBBITBLT             = &H0940&
const META_DIBSTRETCHBLT         = &H0b41&
const META_DIBCREATEPATTERNBRUSH = &H0142&
const META_STRETCHDIB            = &H0f43&
const META_EXTFLOODFILL          = &H0548&
const META_DELETEOBJECT          = &H01f0&
const META_CREATEPALETTE         = &H00f7&
const META_CREATEPATTERNBRUSH    = &H01F9&
const META_CREATEPENINDIRECT     = &H02FA&
const META_CREATEFONTINDIRECT    = &H02FB&
const META_CREATEBRUSHINDIRECT   = &H02FC&
const META_CREATEREGION          = &H06FF&

'  GDI Escapes

const NEWFRAME                = 1
const _ABORTDOC               = 2
const NEXTBAND                = 3
const SETCOLORTABLE           = 4
const GETCOLORTABLE           = 5
const FLUSHOUTPUT             = 6
const DRAFTMODE               = 7
const QUERYESCSUPPORT         = 8
const _SETABORTPROC           = 9
const _STARTDOC               = 10
const _ENDDOC                 = 11
const GETPHYSPAGESIZE         = 12
const GETPRINTINGOFFSET       = 13
const GETSCALINGFACTOR        = 14
const MFCOMMENT               = 15
const GETPENWIDTH             = 16
const SETCOPYCOUNT            = 17
const SELECTPAPERSOURCE       = 18
const DEVICEDATA              = 19
const PASSTHROUGH             = 19
const GETTECHNOLGY            = 20
const GETTECHNOLOGY           = 20
const SETLINECAP              = 21
const SETLINEJOIN             = 22
const _SETMITERLIMIT          = 23
const BANDINFO                = 24
const DRAWPATTERNRECT         = 25
const GETVECTORPENSIZE        = 26
const GETVECTORBRUSHSIZE      = 27
const ENABLEDUPLEX            = 28
const GETSETPAPERBINS         = 29
const GETSETPRINTORIENT       = 30
const ENUMPAPERBINS           = 31
const SETDIBSCALING           = 32
const EPSPRINTING             = 33
const ENUMPAPERMETRICS        = 34
const GETSETPAPERMETRICS      = 35
const POSTSCRIPT_DATA         = 37
const POSTSCRIPT_IGNORE       = 38
const MOUSETRAILS             = 39
const GETDEVICEUNITS          = 42
const GETEXTENDEDTEXTMETRICS  = 256
const GETEXTENTTABLE          = 257
const GETPAIRKERNTABLE        = 258
const GETTRACKKERNTABLE       = 259
const _EXTTEXTOUT             = 512
const GETFACENAME             = 513
const DOWNLOADFACE            = 514
const ENABLERELATIVEWIDTHS    = 768
const ENABLEPAIRKERNING       = 769
const SETKERNTRACK            = 770
const SETALLJUSTVALUES        = 771
const SETCHARSET              = 772
const _STRETCHBLT             = 2048
const GETSETSCREENPARAMS      = 3072
const BEGIN_PATH              = 4096
const CLIP_TO_PATH            = 4097
const END_PATH                = 4098
const EXT_DEVICE_CAPS         = 4099
const RESTORE_CTM             = 4100
const SAVE_CTM                = 4101
const SET_ARC_DIRECTION       = 4102
const SET_BACKGROUND_COLOR    = 4103
const SET_POLY_MODE           = 4104
const SET_SCREEN_ANGLE        = 4105
const SET_SPREAD              = 4106
const TRANSFORM_CTM           = 4107
const SET_CLIP_BOX            = 4108
const SET_BOUNDS              = 4109
const SET_MIRROR_MODE         = 4110
const OPENCHANNEL             = 4110
const DOWNLOADHEADER          = 4111
const CLOSECHANNEL            = 4112
const POSTSCRIPT_PASSTHROUGH  = 4115
const ENCAPSULATED_POSTSCRIPT = 4116

'  Spooler Error Codes

const SP_NOTREPORTED = &H4000&
const SP_ERROR       = (-1)
const SP_APPABORT    = (-2)
const SP_USERABORT   = (-3)
const SP_OUTOFDISK   = (-4)
const SP_OUTOFMEMORY = (-5)
const PR_JOBSTATUS   = &H0000&

'  Object Definitions for EnumObjects()

const OBJ_PEN         = 1
const OBJ_BRUSH       = 2
const OBJ_DC          = 3
const OBJ_METADC      = 4
const OBJ_PAL         = 5
const OBJ_FONT        = 6
const OBJ_BITMAP      = 7
const OBJ_REGION      = 8
const OBJ_METAFILE    = 9
const OBJ_MEMDC       = 10
const OBJ_EXTPEN      = 11
const OBJ_ENHMETADC   = 12
const OBJ_ENHMETAFILE = 13

'  xform stuff

const MWT_IDENTITY      = 1
const MWT_LEFTMULTIPLY  = 2
const MWT_RIGHTMULTIPLY = 3
const MWT_MIN           = MWT_IDENTITY
const MWT_MAX           = MWT_RIGHTMULTIPLY

type XFORM
    eM11 as single
    eM12 as single
    eM21 as single
    eM22 as single
    eDx  as single
    eDy  as single
end type

'  Bitmap Header Definition

type BITMAP
    bmType       as long
    bmWidth      as long
    bmHeight     as long
    bmWidthBytes as long
    bmPlanes     as short
    bmBitsPixel  as short
    bmBits       as long
end type

type RGBTRIPLE
    rgbtBlue  as string * 1
    rgbtGreen as string * 1
    rgbtRed   as string * 1
end type

type RGBQUAD
    rgbBlue     as string * 1
    rgbGreen    as string * 1
    rgbRed      as string * 1
    rgbReserved as string * 1
end type

'  structures for defining DIBs

type BITMAPCOREHEADER
    bcSize     as long ' used to get to color table
    bcWidth    as short
    bcHeight   as short
    bcPlanes   as short
    bcBitCount as short
end type

type BITMAPINFOHEADER
    biSize          as long
    biWidth         as long
    biHeight        as long
    biPlanes        as short
    biBitCount      as short
    biCompression   as long
    biSizeImage     as long
    biXPelsPerMeter as long
    biYPelsPerMeter as long
    biClrUsed       as long
    biClrImportant  as long
end type

'  constants for the biCompression field

const BI_RGB       = 0&
const BI_RLE8      = 1&
const BI_RLE4      = 2&
const BI_BITFIELDS = 3&

type BITMAPINFO
    bmiHeader as BITMAPINFOHEADER
    '         RGBQUAD bmiColors[1];
    bmiColors as RGBQUAD
end type

type BITMAPCOREINFO
    bmciHeader as BITMAPCOREHEADER
    '          RGBTRIPLE bmciColors[1];
    bmciColors as RGBTRIPLE
end type

type BITMAPFILEHEADER
    bfType      as short
    bfSize      as long
    bfReserved1 as short
    bfReserved2 as short
    bfOffBits   as long
end type

'  Clipboard Metafile Picture Structure

type HANDLETABLE
    '            HGDIOBJ objectHandle[1];
    objectHandle as long
end type

type METARECORD
    rdSize     as long
    rdFunction as short
    '          WORD rdParm[1];
    rdParm     as short
end type

type METAFILEPICT' typedef struct tagMETARECORD UNALIGNED FAR *LPMETARECORD;
    '    typedef struct tagMETAFILEPICT
            mm   as long
    xExt as long
    yExt as long
    hMF  as long
end type

type METAHEADER
    mtType         as short
    mtHeaderSize   as short
    mtVersion      as short
    mtSize         as long
    mtNoObjects    as short
    mtMaxRecord    as long
    mtNoParameters as short
end type

type ENHMETARECORD' typedef struct tagMETAHEADER UNALIGNED FAR *LPMETAHEADER;
    '     #pragma pack()
    '     Enhanced Metafile structures
    '     typedef struct tagENHMETARECORD
             iType as long ' Record type EMR_XXX
    nSize as long ' Record size in bytes
    '     DWORD dParm[1]; ' Parameters
    dParm as long ' Parameters
end type

type ENHMETAHEADER
    iType          as long ' Record type EMR_HEADER
    nSize          as long ' Record size in bytes. This may be greater
    '              than the sizeof(ENHMETAHEADER).
    rclBounds      as RECTL ' Inclusive-inclusive bounds in device units
    rclFrame       as RECTL ' Inclusive-inclusive Picture Frame of metafile in .01 mm units
    dSignature     as long ' Signature. Must be ENHMETA_SIGNATURE.
    nVersion       as long ' Version number
    nBytes         as long ' Size of the metafile in bytes
    nRecords       as long ' Number of records in the metafile
    nHandles       as short ' Number of handles in the handle table
    '              Handle index zero is reserved.
    sReserved      as short ' Reserved. Must be zero.
    nDescription   as long ' Number of chars in the unicode description string
    '              This is 0 if there is no description string
    offDescription as long ' Offset to the metafile description record.
    '              This is 0 if there is no description string
    nPalEntries    as long ' Number of entries in the metafile palette.
    szlDevice      as SIZEL ' Size of the reference device in pels
    szlMillimeters as SIZEL ' Size of the reference device in millimeters
end type

'  tmPitchAndFamily flags

const TMPF_FIXED_PITCH = &H01&
const TMPF_VECTOR      = &H02&
const TMPF_DEVICE      = &H08&
const TMPF_TRUETYPE    = &H04&

type TEXTMETRIC
    tmHeight           as long
    tmAscent           as long
    tmDescent          as long
    tmInternalLeading  as long
    tmExternalLeading  as long
    tmAveCharWidth     as long
    tmMaxCharWidth     as long
    tmWeight           as long
    tmOverhang         as long
    tmDigitizedAspectX as long
    tmDigitizedAspectY as long
    tmFirstChar        as string * 1
    tmLastChar         as string * 1
    tmDefaultChar      as string * 1
    tmBreakChar        as string * 1
    tmItalic           as string * 1
    tmUnderlined       as string * 1
    tmStruckOut        as string * 1
    tmPitchAndFamily   as string * 1
    tmCharSet          as string * 1
end type

'  ntmFlags field flags

const NTM_REGULAR = &H00000040&
const NTM_BOLD    = &H00000020&
const NTM_ITALIC  = &H00000001&

type NEWTEXTMETRIC
    tmHeight           as long
    tmAscent           as long
    tmDescent          as long
    tmInternalLeading  as long
    tmExternalLeading  as long
    tmAveCharWidth     as long
    tmMaxCharWidth     as long
    tmWeight           as long
    tmOverhang         as long
    tmDigitizedAspectX as long
    tmDigitizedAspectY as long
    tmFirstChar        as string * 1
    tmLastChar         as string * 1
    tmDefaultChar      as string * 1
    tmBreakChar        as string * 1
    tmItalic           as string * 1
    tmUnderlined       as string * 1
    tmStruckOut        as string * 1
    tmPitchAndFamily   as string * 1
    tmCharSet          as string * 1
    ntmFlags           as long
    ntmSizeEM          as long
    ntmCellHeight      as long
    ntmAvgWidth        as long
end type

'  GDI Logical Objects:
'  Pel Array

type PELARRAY
    paXCount as long
    paYCount as long
    paXExt   as long
    paYExt   as long
    paRGBs   as string * 1
end type

'  Logical Brush (or Pattern)

type LOGBRUSH
    lbStyle as long
    lbColor as long
    lbHatch as long
end type

'  Logical Pen

type LOGPEN
    lopnStyle as long
    lopnWidth as POINT
    lopnColor as long
end type

type EXTLOGPEN
    elpPenStyle   as long
    elpWidth      as long
    elpBrushStyle as long
    elpColor      as long
    elpHatch      as long
    elpNumEntries as long
    '             DWORD elpStyleEntry[1];
    elpStyleEntry as long
end type

type PALETTEENTRY
    peRed   as string * 1
    peGreen as string * 1
    peBlue  as string * 1
    peFlags as string * 1
end type

'  Logical Palette

type LOGPALETTE
    palVersion    as short
    palNumEntries as short
    '             PALETTEENTRY palPalEntry[1];
    palPalEntry   as PALETTEENTRY
end type

'  Logical Font
' Predefined by MS-Test for the IME predefined IME api

'const LF_FACESIZE = 32

'type LOGFONT
'    lfHeight         as long
'    lfWidth          as long
'    lfEscapement     as long
'    lfOrientation    as long
'    lfWeight         as long
'    lfItalic         as string * 1
'    lfUnderline      as string * 1
'    lfStrikeOut      as string * 1
'    lfCharSet        as string * 1
'    lfOutPrecision   as string * 1
'    lfClipPrecision  as string * 1
'    lfQuality        as string * 1
'    lfPitchAndFamily as string * 1
'    lfFaceName       as string * LF_FACESIZE
'end type

const LF_FULLFACESIZE = 64

'  Structure passed to FONTENUMPROC

type ENUMLOGFONT
    elfLogFont  as LOGFONT
    elfFullName as string * LF_FULLFACESIZE
    elfStyle    as string * LF_FACESIZE
end type

'  Structure passed to FONTENUMPROC

const OUT_DEFAULT_PRECIS    = 0
const OUT_STRING_PRECIS     = 1
const OUT_CHARACTER_PRECIS  = 2
const OUT_STROKE_PRECIS     = 3
const OUT_TT_PRECIS         = 4
const OUT_DEVICE_PRECIS     = 5
const OUT_RASTER_PRECIS     = 6
const OUT_TT_ONLY_PRECIS    = 7
const OUT_OUTLINE_PRECIS    = 8
const CLIP_DEFAULT_PRECIS   = 0
const CLIP_CHARACTER_PRECIS = 1
const CLIP_STROKE_PRECIS    = 2
const CLIP_MASK             = &Hf&
const CLIP_LH_ANGLES        = 16
const CLIP_TT_ALWAYS        = 32
const CLIP_EMBEDDED         = 128
const DEFAULT_QUALITY       = 0
const DRAFT_QUALITY         = 1
const PROOF_QUALITY         = 2
const DEFAULT_PITCH         = 0
const FIXED_PITCH           = 1
const VARIABLE_PITCH        = 2
const ANSI_CHARSET          = 0
const DEFAULT_CHARSET       = 1
const SYMBOL_CHARSET        = 2
const SHIFTJIS_CHARSET      = 128
const HANGEUL_CHARSET       = 129
const CHINESEBIG5_CHARSET   = 136
const OEM_CHARSET           = 255

'  Font Families

const FF_DONTCARE   = 0  ' Don't care or don't know.
const FF_ROMAN      = 16 ' Variable stroke width, serifed.
                         '  Times Roman, Century Schoolbook, etc.
const FF_SWISS      = 32 ' Variable stroke width, sans-serifed.
                         '  Helvetica, Swiss, etc.
const FF_MODERN     = 48 ' Constant stroke width, serifed or sans-serifed.
                         '  Pica, Elite, Courier, etc.
const FF_SCRIPT     = 64 ' Cursive, etc.
const FF_DECORATIVE = 80 ' Old English, etc.

'  Font Weights

const FW_DONTCARE               = 0
const FW_THIN                   = 100
const FW_EXTRALIGHT             = 200
const FW_LIGHT                  = 300
const FW_NORMAL                 = 400
const FW_MEDIUM                 = 500
const FW_SEMIBOLD               = 600
const FW_BOLD                   = 700
const FW_EXTRABOLD              = 800
const FW_HEAVY                  = 900
const FW_ULTRALIGHT             = FW_EXTRALIGHT
const FW_REGULAR                = FW_NORMAL
const FW_DEMIBOLD               = FW_SEMIBOLD
const FW_ULTRABOLD              = FW_EXTRABOLD
const FW_BLACK                  = FW_HEAVY
const PANOSE_COUNT              = 10
const PAN_FAMILYTYPE_INDEX      = 0
const PAN_SERIFSTYLE_INDEX      = 1
const PAN_WEIGHT_INDEX          = 2
const PAN_PROPORTION_INDEX      = 3
const PAN_CONTRAST_INDEX        = 4
const PAN_STROKEVARIATION_INDEX = 5
const PAN_ARMSTYLE_INDEX        = 6
const PAN_LETTERFORM_INDEX      = 7
const PAN_MIDLINE_INDEX         = 8
const PAN_XHEIGHT_INDEX         = 9
const PAN_CULTURE_LATIN         = 0

type PANOSE
    bFamilyType      as string * 1
    bSerifStyle      as string * 1
    bWeight          as string * 1
    bProportion      as string * 1
    bContrast        as string * 1
    bStrokeVariation as string * 1
    bArmStyle        as string * 1
    bLetterform      as string * 1
    bMidline         as string * 1
    bXHeight         as string * 1
end type

const PAN_ANY                        = 0 ' Any
const PAN_NO_FIT                     = 1 ' No Fit
const PAN_FAMILY_TEXT_DISPLAY        = 2 ' Text and Display
const PAN_FAMILY_SCRIPT              = 3 ' Script
const PAN_FAMILY_DECORATIVE          = 4 ' Decorative
const PAN_FAMILY_PICTORIAL           = 5 ' Pictorial
const PAN_SERIF_COVE                 = 2 ' Cove
const PAN_SERIF_OBTUSE_COVE          = 3 ' Obtuse Cove
const PAN_SERIF_SQUARE_COVE          = 4 ' Square Cove
const PAN_SERIF_OBTUSE_SQUARE_COVE   = 5 ' Obtuse Square Cove
const PAN_SERIF_SQUARE               = 6 ' Square
const PAN_SERIF_THIN                 = 7 ' Thin
const PAN_SERIF_BONE                 = 8 ' Bone
const PAN_SERIF_EXAGGERATED          = 9 ' Exaggerated
const PAN_SERIF_TRIANGLE             = 10 ' Triangle
const PAN_SERIF_NORMAL_SANS          = 11 ' Normal Sans
const PAN_SERIF_OBTUSE_SANS          = 12 ' Obtuse Sans
const PAN_SERIF_PERP_SANS            = 13 ' Prep Sans
const PAN_SERIF_FLARED               = 14 ' Flared
const PAN_SERIF_ROUNDED              = 15 ' Rounded
const PAN_WEIGHT_VERY_LIGHT          = 2 ' Very Light
const PAN_WEIGHT_LIGHT               = 3 ' Light
const PAN_WEIGHT_THIN                = 4 ' Thin
const PAN_WEIGHT_BOOK                = 5 ' Book
const PAN_WEIGHT_MEDIUM              = 6 ' Medium
const PAN_WEIGHT_DEMI                = 7 ' Demi
const PAN_WEIGHT_BOLD                = 8 ' Bold
const PAN_WEIGHT_HEAVY               = 9 ' Heavy
const PAN_WEIGHT_BLACK               = 10 ' Black
const PAN_WEIGHT_NORD                = 11 ' Nord
const PAN_PROP_OLD_STYLE             = 2 ' Old Style
const PAN_PROP_MODERN                = 3 ' Modern
const PAN_PROP_EVEN_WIDTH            = 4 ' Even Width
const PAN_PROP_EXPANDED              = 5 ' Expanded
const PAN_PROP_CONDENSED             = 6 ' Condensed
const PAN_PROP_VERY_EXPANDED         = 7 ' Very Expanded
const PAN_PROP_VERY_CONDENSED        = 8 ' Very Condensed
const PAN_PROP_MONOSPACED            = 9 ' Monospaced
const PAN_CONTRAST_NONE              = 2 ' None
const PAN_CONTRAST_VERY_LOW          = 3 ' Very Low
const PAN_CONTRAST_LOW               = 4 ' Low
const PAN_CONTRAST_MEDIUM_LOW        = 5 ' Medium Low
const PAN_CONTRAST_MEDIUM            = 6 ' Medium
const PAN_CONTRAST_MEDIUM_HIGH       = 7 ' Mediim High
const PAN_CONTRAST_HIGH              = 8 ' High
const PAN_CONTRAST_VERY_HIGH         = 9 ' Very High
const PAN_STROKE_GRADUAL_DIAG        = 2 ' Gradual/Diagonal
const PAN_STROKE_GRADUAL_TRAN        = 3 ' Gradual/Transitional
const PAN_STROKE_GRADUAL_VERT        = 4 ' Gradual/Vertical
const PAN_STROKE_GRADUAL_HORZ        = 5 ' Gradual/Horizontal
const PAN_STROKE_RAPID_VERT          = 6 ' Rapid/Vertical
const PAN_STROKE_RAPID_HORZ          = 7 ' Rapid/Horizontal
const PAN_STROKE_INSTANT_VERT        = 8 ' Instant/Vertical
const PAN_STRAIGHT_ARMS_HORZ         = 2 ' Straight Arms/Horizontal
const PAN_STRAIGHT_ARMS_WEDGE        = 3 ' Straight Arms/Wedge
const PAN_STRAIGHT_ARMS_VERT         = 4 ' Straight Arms/Vertical
const PAN_STRAIGHT_ARMS_SINGLE_SERIF = 5 ' Straight Arms/Single-Serif
const PAN_STRAIGHT_ARMS_DOUBLE_SERIF = 6 ' Straight Arms/Double-Serif
const PAN_BENT_ARMS_HORZ             = 7 ' Non-Straight Arms/Horizontal
const PAN_BENT_ARMS_WEDGE            = 8 ' Non-Straight Arms/Wedge
const PAN_BENT_ARMS_VERT             = 9 ' Non-Straight Arms/Vertical
const PAN_BENT_ARMS_SINGLE_SERIF     = 10 ' Non-Straight Arms/Single-Serif
const PAN_BENT_ARMS_DOUBLE_SERIF     = 11 ' Non-Straight Arms/Double-Serif
const PAN_LETT_NORMAL_CONTACT        = 2 ' Normal/Contact
const PAN_LETT_NORMAL_WEIGHTED       = 3 ' Normal/Weighted
const PAN_LETT_NORMAL_BOXED          = 4 ' Normal/Boxed
const PAN_LETT_NORMAL_FLATTENED      = 5 ' Normal/Flattened
const PAN_LETT_NORMAL_ROUNDED        = 6 ' Normal/Rounded
const PAN_LETT_NORMAL_OFF_CENTER     = 7 ' Normal/Off Center
const PAN_LETT_NORMAL_SQUARE         = 8 ' Normal/Square
const PAN_LETT_OBLIQUE_CONTACT       = 9 ' Oblique/Contact
const PAN_LETT_OBLIQUE_WEIGHTED      = 10 ' Oblique/Weighted
const PAN_LETT_OBLIQUE_BOXED         = 11 ' Oblique/Boxed
const PAN_LETT_OBLIQUE_FLATTENED     = 12 ' Oblique/Flattened
const PAN_LETT_OBLIQUE_ROUNDED       = 13 ' Oblique/Rounded
const PAN_LETT_OBLIQUE_OFF_CENTER    = 14 ' Oblique/Off Center
const PAN_LETT_OBLIQUE_SQUARE        = 15 ' Oblique/Square
const PAN_MIDLINE_STANDARD_TRIMMED   = 2 ' Standard/Trimmed
const PAN_MIDLINE_STANDARD_POINTED   = 3 ' Standard/Pointed
const PAN_MIDLINE_STANDARD_SERIFED   = 4 ' Standard/Serifed
const PAN_MIDLINE_HIGH_TRIMMED       = 5 ' High/Trimmed
const PAN_MIDLINE_HIGH_POINTED       = 6 ' High/Pointed
const PAN_MIDLINE_HIGH_SERIFED       = 7 ' High/Serifed
const PAN_MIDLINE_CONSTANT_TRIMMED   = 8 ' Constant/Trimmed
const PAN_MIDLINE_CONSTANT_POINTED   = 9 ' Constant/Pointed
const PAN_MIDLINE_CONSTANT_SERIFED   = 10 ' Constant/Serifed
const PAN_MIDLINE_LOW_TRIMMED        = 11 ' Low/Trimmed
const PAN_MIDLINE_LOW_POINTED        = 12 ' Low/Pointed
const PAN_MIDLINE_LOW_SERIFED        = 13 ' Low/Serifed
const PAN_XHEIGHT_CONSTANT_SMALL     = 2 ' Constant/Small
const PAN_XHEIGHT_CONSTANT_STD       = 3 ' Constant/Standard
const PAN_XHEIGHT_CONSTANT_LARGE     = 4 ' Constant/Large
const PAN_XHEIGHT_DUCKING_SMALL      = 5 ' Ducking/Small
const PAN_XHEIGHT_DUCKING_STD        = 6 ' Ducking/Standard
const PAN_XHEIGHT_DUCKING_LARGE      = 7 ' Ducking/Large
const ELF_VENDOR_SIZE                = 4

'  The extended logical font
'  An extension of the ENUMLOGFONT

type EXTLOGFONT
    elfLogFont   as LOGFONT
    elfFullName  as string * LF_FULLFACESIZE
    elfStyle     as string * LF_FACESIZE
    elfVersion   as long ' 0 for the first release of NT
    elfStyleSize as long
    elfMatch     as long
    elfReserved  as long
    elfVendorId  as string * ELF_VENDOR_SIZE
    elfCulture   as long ' 0 for Latin
    elfPanose    as PANOSE
end type

const ELF_VERSION       = 0
const ELF_CULTURE_LATIN = 0

'  EnumFonts Masks

const RASTER_FONTTYPE   = &H0001&
const DEVICE_FONTTYPE   = &H002&
const TRUETYPE_FONTTYPE = &H004&

'  palette entry flags

const PC_RESERVED   = &H01& ' palette index used for animation
const PC_EXPLICIT   = &H02& ' palette index is explicit to device
const PC_NOCOLLAPSE = &H04& ' do not match color to system palette

'  Background Modes

const TRANSPARENT = 1
const OPAQUE      = 2
const BKMODE_LAST = 2

'  Graphics Modes

const GM_COMPATIBLE = 1
const GM_ADVANCED   = 2
const GM_LAST       = 2

'  PolyDraw and GetPath point types

const PT_CLOSEFIGURE = &H01&
const PT_LINETO      = &H02&
const PT_BEZIERTO    = &H04&
const PT_MOVETO      = &H06&

'  Mapping Modes

const MM_TEXT        = 1
const MM_LOMETRIC    = 2
const MM_HIMETRIC    = 3
const MM_LOENGLISH   = 4
const MM_HIENGLISH   = 5
const MM_TWIPS       = 6
const MM_ISOTROPIC   = 7
const MM_ANISOTROPIC = 8

'  Min and Max Mapping Mode values

const MM_MIN            = MM_TEXT
const MM_MAX            = MM_ANISOTROPIC
const MM_MAX_FIXEDSCALE = MM_TWIPS

'  Coordinate Modes

const ABSOLUTE = 1
const RELATIVE = 2

'  Stock Logical Objects

const WHITE_BRUSH         = 0
const LTGRAY_BRUSH        = 1
const GRAY_BRUSH          = 2
const DKGRAY_BRUSH        = 3
const BLACK_BRUSH         = 4
const NULL_BRUSH          = 5
const HOLLOW_BRUSH        = NULL_BRUSH
const WHITE_PEN           = 6
const BLACK_PEN           = 7
const NULL_PEN            = 8
const OEM_FIXED_FONT      = 10
const ANSI_FIXED_FONT     = 11
const ANSI_VAR_FONT       = 12
const SYSTEM_FONT         = 13
const DEVICE_DEFAULT_FONT = 14
const DEFAULT_PALETTE     = 15
const SYSTEM_FIXED_FONT   = 16
const STOCK_LAST          = 16
const CLR_INVALID         = &HFFFFFFFF&

'  Brush Styles

const BS_SOLID         = 0
const BS_NULL          = 1
const BS_HOLLOW        = BS_NULL
const BS_HATCHED       = 2
const BS_PATTERN       = 3
const BS_INDEXED       = 4
const BS_DIBPATTERN    = 5
const BS_DIBPATTERNPT  = 6
const BS_PATTERN8X8    = 7
const BS_DIBPATTERN8X8 = 8

'  Hatch Styles

const HS_HORIZONTAL      = 0 ' -----
const HS_VERTICAL        = 1 ' ororororor
const HS_FDIAGONAL       = 2 ' \\\\\
const HS_BDIAGONAL       = 3 ' ' ' /
const HS_CROSS           = 4 ' +++++
const HS_DIAGCROSS       = 5 ' xxxxx
const HS_FDIAGONAL1      = 6
const HS_BDIAGONAL1      = 7
const HS_SOLID           = 8
const HS_DENSE1          = 9
const HS_DENSE2          = 10
const HS_DENSE3          = 11
const HS_DENSE4          = 12
const HS_DENSE5          = 13
const HS_DENSE6          = 14
const HS_DENSE7          = 15
const HS_DENSE8          = 16
const HS_NOSHADE         = 17
const HS_HALFTONE        = 18
const HS_SOLIDCLR        = 19
const HS_DITHEREDCLR     = 20
const HS_SOLIDTEXTCLR    = 21
const HS_DITHEREDTEXTCLR = 22
const HS_SOLIDBKCLR      = 23
const HS_DITHEREDBKCLR   = 24
const HS_API_MAX         = 25

'  Pen Styles

const PS_SOLID            = 0
const PS_DASH             = 1 ' -------
const PS_DOT              = 2 ' .......
const PS_DASHDOT          = 3 ' _._._._
const PS_DASHDOTDOT       = 4 ' _.._.._
const PS_NULL             = 5
const PS_INSIDEFRAME      = 6
const PS_USERSTYLE        = 7
const PS_ALTERNATE        = 8
const PS_STYLE_MASK       = &H0000000F&
const PS_ENDCAP_ROUND     = &H00000000&
const PS_ENDCAP_SQUARE    = &H00000100&
const PS_ENDCAP_FLAT      = &H00000200&
const PS_ENDCAP_MASK      = &H00000F00&
const PS_JOIN_ROUND       = &H00000000&
const PS_JOIN_BEVEL       = &H00001000&
const PS_JOIN_MITER       = &H00002000&
const PS_JOIN_MASK        = &H0000F000&
const PS_COSMETIC         = &H00000000&
const PS_GEOMETRIC        = &H00010000&
const PS_TYPE_MASK        = &H000F0000&
const AD_COUNTERCLOCKWISE = 1
const AD_CLOCKWISE        = 2

'  Device Parameters for GetDeviceCaps()

const DRIVERVERSION = 0 ' Device driver version
const TECHNOLOGY    = 2 ' Device classification
const HORZSIZE      = 4 ' Horizontal size in millimeters
const VERTSIZE      = 6 ' Vertical size in millimeters
const HORZRES       = 8 ' Horizontal width in pixels
const VERTRES       = 10 ' Vertical width in pixels
const BITSPIXEL     = 12 ' Number of bits per pixel
const PLANES        = 14 ' Number of planes
const NUMBRUSHES    = 16 ' Number of brushes the device has
const NUMPENS       = 18 ' Number of pens the device has
const NUMMARKERS    = 20 ' Number of markers the device has
const NUMFONTS      = 22 ' Number of fonts the device has
const NUMCOLORS     = 24 ' Number of colors the device supports
const PDEVICESIZE   = 26 ' Size required for device descriptor
const CURVECAPS     = 28 ' Curve capabilities
const LINECAPS      = 30 ' Line capabilities
const POLYGONALCAPS = 32 ' Polygonal capabilities
const TEXTCAPS      = 34 ' Text capabilities
const CLIPCAPS      = 36 ' Clipping capabilities
const RASTERCAPS    = 38 ' Bitblt capabilities
const ASPECTX       = 40 ' Length of the X leg
const ASPECTY       = 42 ' Length of the Y leg
const ASPECTXY      = 44 ' Length of the hypotenuse
const LOGPIXELSX    = 88 ' Logical pixels/inch in X
const LOGPIXELSY    = 90 ' Logical pixels/inch in Y
const SIZEPALETTE   = 104 ' Number of entries in physical palette
const NUMRESERVED   = 106 ' Number of reserved entries in palette
const COLORRES      = 108 ' Actual color resolution

'  Printing related DeviceCaps. These replace the appropriate Escapes

const PHYSICALWIDTH   = 110 ' Physical Width in device units
const PHYSICALHEIGHT  = 111 ' Physical Height in device units
const PHYSICALOFFSETX = 112 ' Physical Printable Area x margin
const PHYSICALOFFSETY = 113 ' Physical Printable Area y margin
const SCALINGFACTORX  = 114 ' Scaling factor x
const SCALINGFACTORY  = 115 ' Scaling factor y

'  Device Capability Masks:
'  Device Technologies

const DT_PLOTTER    = 0 ' Vector plotter
const DT_RASDISPLAY = 1 ' Raster display
const DT_RASPRINTER = 2 ' Raster printer
const DT_RASCAMERA  = 3 ' Raster camera
const DT_CHARSTREAM = 4 ' Character-stream, PLP
const DT_METAFILE   = 5 ' Metafile, VDM
const DT_DISPFILE   = 6 ' Display-file

'  Curve Capabilities

const CC_NONE       = 0 ' Curves not supported
const CC_CIRCLES    = 1 ' Can do circles
const CC_PIE        = 2 ' Can do pie wedges
const CC_CHORD      = 4 ' Can do chord arcs
const CC_ELLIPSES   = 8 ' Can do ellipese
const CC_WIDE       = 16 ' Can do wide lines
const CC_STYLED     = 32 ' Can do styled lines
const CC_WIDESTYLED = 64 ' Can do wide styled lines
const CC_INTERIORS  = 128 ' Can do interiors
const CC_ROUNDRECT  = 256 '

'  Line Capabilities

const LC_NONE       = 0 ' Lines not supported
const LC_POLYLINE   = 2 ' Can do polylines
const LC_MARKER     = 4 ' Can do markers
const LC_POLYMARKER = 8 ' Can do polymarkers
const LC_WIDE       = 16 ' Can do wide lines
const LC_STYLED     = 32 ' Can do styled lines
const LC_WIDESTYLED = 64 ' Can do wide styled lines
const LC_INTERIORS  = 128 ' Can do interiors

'  Polygonal Capabilities

const PC_NONE        = 0 ' Polygonals not supported
const PC_POLYGON     = 1 ' Can do polygons
const PC_RECTANGLE   = 2 ' Can do rectangles
const PC_WINDPOLYGON = 4 ' Can do winding polygons
const PC_TRAPEZOID   = 4 ' Can do trapezoids
const PC_SCANLINE    = 8 ' Can do scanlines
const PC_WIDE        = 16 ' Can do wide borders
const PC_STYLED      = 32 ' Can do styled borders
const PC_WIDESTYLED  = 64 ' Can do wide styled borders
const PC_INTERIORS   = 128 ' Can do interiors

'  Polygonal Capabilities

const CP_NONE      = 0 ' No clipping of output
const CP_RECTANGLE = 1 ' Output clipped to rects
const CP_REGION    = 2 '

'  Text Capabilities

const TC_OP_CHARACTER = &H00000001& ' Can do OutputPrecision CHARACTER
const TC_OP_STROKE    = &H00000002& ' Can do OutputPrecision STROKE
const TC_CP_STROKE    = &H00000004& ' Can do ClipPrecision STROKE
const TC_CR_90        = &H00000008& ' Can do CharRotAbility 90
const TC_CR_ANY       = &H00000010& ' Can do CharRotAbility ANY
const TC_SF_X_YINDEP  = &H00000020& ' Can do ScaleFreedom X_YINDEPENDENT
const TC_SA_DOUBLE    = &H00000040& ' Can do ScaleAbility DOUBLE
const TC_SA_INTEGER   = &H00000080& ' Can do ScaleAbility INTEGER
const TC_SA_CONTIN    = &H00000100& ' Can do ScaleAbility CONTINUOUS
const TC_EA_DOUBLE    = &H00000200& ' Can do EmboldenAbility DOUBLE
const TC_IA_ABLE      = &H00000400& ' Can do ItalisizeAbility ABLE
const TC_UA_ABLE      = &H00000800& ' Can do UnderlineAbility ABLE
const TC_SO_ABLE      = &H00001000& ' Can do StrikeOutAbility ABLE
const TC_RA_ABLE      = &H00002000& ' Can do RasterFontAble ABLE
const TC_VA_ABLE      = &H00004000& ' Can do VectorFontAble ABLE
const TC_RESERVED     = &H00008000&
const TC_SCROLLBLT    = &H00010000& ' do text scroll with blt

'  Raster Capabilities

const RC_BITBLT       = 1 ' Can do standard BLT.
const RC_BANDING      = 2 ' Device requires banding support
const RC_SCALING      = 4 ' Device requires scaling support
const RC_BITMAP64     = 8 ' Device can support >64K bitmap
const RC_GDI20_OUTPUT = &H0010& ' has 2.0 output calls
const RC_GDI20_STATE  = &H0020&
const RC_SAVEBITMAP   = &H0040&
const RC_DI_BITMAP    = &H0080& ' supports DIB to memory
const RC_PALETTE      = &H0100& ' supports a palette
const RC_DIBTODEV     = &H0200& ' supports DIBitsToDevice
const RC_BIGFONT      = &H0400& ' supports >64K fonts
const RC_STRETCHBLT   = &H0800& ' supports StretchBlt
const RC_FLOODFILL    = &H1000& ' supports FloodFill
const RC_STRETCHDIB   = &H2000& ' supports StretchDIBits
const RC_OP_DX_OUTPUT = &H4000&
const RC_DEVBITS      = &H8000&

'  DIB color table identifiers

const DIB_RGB_COLORS      = 0 ' color table in RGBs
const DIB_PAL_COLORS      = 1 ' color table in palette indices
const DIB_PAL_INDICES     = 2 ' No color table indices into surf palette
const DIB_PAL_PHYSINDICES = 2 ' No color table indices into surf palette
const DIB_PAL_LOGINDICES  = 4 ' No color table indices into DC palette

'  constants for Get/SetSystemPaletteUse()

const SYSPAL_ERROR    = 0
const SYSPAL_STATIC   = 1
const SYSPAL_NOSTATIC = 2

'  constants for CreateDIBitmap

const CBM_CREATEDIB = &H02& ' create DIB bitmap
const CBM_INIT      = &H04& ' initialize bitmap

'  ExtFloodFill style flags

const FLOODFILLBORDER  = 0
const FLOODFILLSURFACE = 1

'  size of a device name string

const CCHDEVICENAME = 32

'  size of a form name string

const CCHFORMNAME = 32

type DEVMODE
    dmDeviceName       as string * CCHDEVICENAME
    dmSpecVersion      as short
    dmDriverVersion    as short
    dmSize             as short
    dmDriverExtra      as short
    dmFields           as long
    dmOrientation      as short
    dmPaperSize        as short
    dmPaperLength      as short
    dmPaperWidth       as short
    dmScale            as short
    dmCopies           as short
    dmDefaultSource    as short
    dmPrintQuality     as short
    dmColor            as short
    dmDuplex           as short
    dmYResolution      as short
    dmTTOption         as short
    dmCollate          as short
    dmFormName         as string * CCHFORMNAME
    dmUnusedPadding    as short
    dmBitsPerPel       as long
    dmPelsWidth        as long
    dmPelsHeight       as long
    dmDisplayFlags     as long
    dmDisplayFrequency as long
end type

'  current version of specification

const DM_SPECVERSION = &H320&

'  field selection bits

const DM_ORIENTATION   = &H0000001&
const DM_PAPERSIZE     = &H0000002&
const DM_PAPERLENGTH   = &H0000004&
const DM_PAPERWIDTH    = &H0000008&
const DM_SCALE         = &H0000010&
const DM_COPIES        = &H0000100&
const DM_DEFAULTSOURCE = &H0000200&
const DM_PRINTQUALITY  = &H0000400&
const DM_COLOR         = &H0000800&
const DM_DUPLEX        = &H0001000&
const DM_YRESOLUTION   = &H0002000&
const DM_TTOPTION      = &H0004000&
const DM_COLLATE       = &H0008000&
const DM_FORMNAME      = &H0010000&

'  orientation selections

const DMORIENT_PORTRAIT  = 1
const DMORIENT_LANDSCAPE = 2

'  paper selections

const DMPAPER_LETTER             = 1 ' Letter 8 1/2 x 11 in
const DMPAPER_FIRST              = DMPAPER_LETTER
const DMPAPER_LETTERSMALL        = 2 ' Letter Small 8 1/2 x 11 in
const DMPAPER_TABLOID            = 3 ' Tabloid 11 x 17 in
const DMPAPER_LEDGER             = 4 ' Ledger 17 x 11 in
const DMPAPER_LEGAL              = 5 ' Legal 8 1/2 x 14 in
const DMPAPER_STATEMENT          = 6 ' Statement 5 1/2 x 8 1/2 in
const DMPAPER_EXECUTIVE          = 7 ' Executive 7 1/4 x 10 1/2 in
const DMPAPER_A3                 = 8 ' A3 297 x 420 mm
const DMPAPER_A4                 = 9 ' A4 210 x 297 mm
const DMPAPER_A4SMALL            = 10 ' A4 Small 210 x 297 mm
const DMPAPER_A5                 = 11 ' A5 148 x 210 mm
const DMPAPER_B4                 = 12 ' B4 250 x 354
const DMPAPER_B5                 = 13 ' B5 182 x 257 mm
const DMPAPER_FOLIO              = 14 ' Folio 8 1/2 x 13 in
const DMPAPER_QUARTO             = 15 ' Quarto 215 x 275 mm
const DMPAPER_10X14              = 16 ' 10x14 in
const DMPAPER_11X17              = 17 ' 11x17 in
const DMPAPER_NOTE               = 18 ' Note 8 1/2 x 11 in
const DMPAPER_ENV_9              = 19 ' Envelope #9 3 7/8 x 8 7/8
const DMPAPER_ENV_10             = 20 ' Envelope #10 4 1/8 x 9 1/2
const DMPAPER_ENV_11             = 21 ' Envelope #11 4 1/2 x 10 3/8
const DMPAPER_ENV_12             = 22 ' Envelope #12 4 \276 x 11
const DMPAPER_ENV_14             = 23 ' Envelope #14 5 x 11 1/2
const DMPAPER_CSHEET             = 24 ' C size sheet
const DMPAPER_DSHEET             = 25 ' D size sheet
const DMPAPER_ESHEET             = 26 ' E size sheet
const DMPAPER_ENV_DL             = 27 ' Envelope DL 110 x 220mm
const DMPAPER_ENV_C5             = 28 ' Envelope C5 162 x 229 mm
const DMPAPER_ENV_C3             = 29 ' Envelope C3 324 x 458 mm
const DMPAPER_ENV_C4             = 30 ' Envelope C4 229 x 324 mm
const DMPAPER_ENV_C6             = 31 ' Envelope C6 114 x 162 mm
const DMPAPER_ENV_C65            = 32 ' Envelope C65 114 x 229 mm
const DMPAPER_ENV_B4             = 33 ' Envelope B4 250 x 353 mm
const DMPAPER_ENV_B5             = 34 ' Envelope B5 176 x 250 mm
const DMPAPER_ENV_B6             = 35 ' Envelope B6 176 x 125 mm
const DMPAPER_ENV_ITALY          = 36 ' Envelope 110 x 230 mm
const DMPAPER_ENV_MONARCH        = 37 ' Envelope Monarch 3.875 x 7.5 in
const DMPAPER_ENV_PERSONAL       = 38 ' 6 3/4 Envelope 3 5/8 x 6 1/2 in
const DMPAPER_FANFOLD_US         = 39 ' US Std Fanfold 14 7/8 x 11 in
const DMPAPER_FANFOLD_STD_GERMAN = 40 ' German Std Fanfold 8 1/2 x 12 in
const DMPAPER_FANFOLD_LGL_GERMAN = 41 ' German Legal Fanfold 8 1/2 x 13 in
const DMPAPER_LAST               = DMPAPER_FANFOLD_LGL_GERMAN
const DMPAPER_USER               = 256

'  bin selections

const DMBIN_UPPER         = 1
const DMBIN_FIRST         = DMBIN_UPPER
const DMBIN_ONLYONE       = 1
const DMBIN_LOWER         = 2
const DMBIN_MIDDLE        = 3
const DMBIN_MANUAL        = 4
const DMBIN_ENVELOPE      = 5
const DMBIN_ENVMANUAL     = 6
const DMBIN_AUTO          = 7
const DMBIN_TRACTOR       = 8
const DMBIN_SMALLFMT      = 9
const DMBIN_LARGEFMT      = 10
const DMBIN_LARGECAPACITY = 11
const DMBIN_CASSETTE      = 14
const DMBIN_LAST          = DMBIN_CASSETTE
const DMBIN_USER          = 256 ' device specific bins start here

'  print qualities

const DMRES_DRAFT  = (-1)
const DMRES_LOW    = (-2)
const DMRES_MEDIUM = (-3)
const DMRES_HIGH   = (-4)

'  color enable/disable for color printers

const DMCOLOR_MONOCHROME = 1
const DMCOLOR_COLOR      = 2

'  duplex enable

const DMDUP_SIMPLEX    = 1
const DMDUP_VERTICAL   = 2
const DMDUP_HORIZONTAL = 3

'  TrueType options

const DMTT_BITMAP   = 1 ' print TT fonts as graphics
const DMTT_DOWNLOAD = 2 ' download TT fonts as soft fonts
const DMTT_SUBDEV   = 3 ' substitute device fonts for TT fonts

'  Collation selections

const DMCOLLATE_FALSE = 0
const DMCOLLATE_TRUE  = 1

'  DEVMODE dmDisplayFlags flags

const DM_GRAYSCALE  = &H00000001&
const DM_INTERLACED = &H00000002&

'  GetRegionData/ExtCreateRegion

const RDH_RECTANGLES = 1

type RGNDATAHEADER
    dwSize   as long
    iType    as long
    nCount   as long
    nRgnSize as long
    rcBound  as RECT
end type

type RGNDAT
    rdh    as RGNDATAHEADER
    Buffer as string * 1
end type

type ABC
    abcA as long
    abcB as long
    abcC as long
end type

type ABCFLOAT
    abcfA as single
    abcfB as single
    abcfC as single
end type

type OUTLINETEXTMETRIC
    otmSize                as long
    otmTextMetrics         as TEXTMETRIC
    otmFiller              as string * 1
    otmPanoseNumber        as PANOSE
    otmfsSelection         as long
    otmfsType              as long
    otmsCharSlopeRise      as long
    otmsCharSlopeRun       as long
    otmItalicAngle         as long
    otmEMSquare            as long
    otmAscent              as long
    otmDescent             as long
    otmLineGap             as long
    otmsCapEmHeight        as long
    otmsXHeight            as long
    otmrcFontBox           as RECT
    otmMacAscent           as long
    otmMacDescent          as long
    otmMacLineGap          as long
    otmusMinimumPPEM       as long
    otmptSubscriptSize     as POINT
    otmptSubscriptOffset   as POINT
    otmptSuperscriptSize   as POINT
    otmptSuperscriptOffset as POINT
    otmsStrikeoutSize      as long
    otmsStrikeoutPosition  as long
    otmsUnderscoreSize     as long
    otmsUnderscorePosition as long
    otmpFamilyName         as pointer to string * 1
    otmpFaceName           as pointer to string * 1
    otmpStyleName          as pointer to string * 1
    otmpFullName           as pointer to string * 1
end type

type POLYTEXT
    x       as long
    y       as long
    n       as long
    lpstr   as pointer to string * 1
    uiFlags as long
    rcl     as RECT
    pdx     as pointer to long
end type

type FIXED
    fract as short
    value as short
end type

type MAT2
    eM11 as FIXED
    eM12 as FIXED
    eM21 as FIXED
    eM22 as FIXED
end type

type GLYPHMETRICS
    gmBlackBoxX     as long
    gmBlackBoxY     as long
    gmptGlyphOrigin as POINT
    gmCellIncX      as short
    gmCellIncY      as short
end type

'   GetGlyphOutline constants

const GGO_METRICS     = 0
const GGO_BITMAP      = 1
const GGO_NATIVE      = 2
const TT_POLYGON_TYPE = 24
const TT_PRIM_LINE    = 1
const TT_PRIM_QSPLINE = 2

type POINTFX
    x as FIXED
    y as FIXED
end type

type TTPOLYCURVE
    wType as short
    cpfx  as short
    '     POINTFX apfx[1];
    apfx  as POINTFX
end type

type TTPOLYGONHEADER
    cb       as long
    dwType   as long
    pfxStart as POINTFX
end type

type RASTERIZER_STATUS
    nSize       as short
    wFlags      as short
    nLanguageID as short
end type

'  bits defined in wFlags of RASTERIZER_STATUS

const TT_AVAILABLE = &H0001&
const TT_ENABLED   = &H0002&

declare function AddFontResource            lib "gdi32.dll" alias "AddFontResourceA"           (sz$) as long
declare sub      AnimatePalette             lib "gdi32.dll" alias "AnimatePalette"             (hpal&, u&, u&, lp as PALETTEENTRY)
declare function Arc                        lib "gdi32.dll" alias "Arc"                        (hdc&, i&, i&, i&, i&, i&, i&, i&, i&) as long
declare function BitBlt                     lib "gdi32.dll" alias "BitBlt"                     (hdc&, i&, i&, i&, i&, hdc&, i&, i&, dw&) as long
declare function CancelDC                   lib "gdi32.dll" alias "CancelDC"                   (hdc&) as long
declare function Chord                      lib "gdi32.dll" alias "Chord"                      (hdc&, i&, i&, i&, i&, i&, i&, i&, i&) as long
declare function CloseMetaFile              lib "gdi32.dll" alias "CloseMetaFile"              (hdc&) as long
declare function CombineRgn                 lib "gdi32.dll" alias "CombineRgn"                 (hrgn&, hrgn&, hrgn&, i&) as long
declare function CopyMetaFile               lib "gdi32.dll" alias "CopyMetaFileA"              (h&, sz$) as long
declare function CreateBitmap               lib "gdi32.dll" alias "CreateBitmap"               (i&, i&, u&, u&, p as any) as long
declare function CreateBitmapIndirect       lib "gdi32.dll" alias "CreateBitmapIndirect"       (lp as BITMAP) as long
declare function CreateBrushIndirect        lib "gdi32.dll" alias "CreateBrushIndirect"        (lp as LOGBRUSH) as long
declare function CreateCompatibleBitmap     lib "gdi32.dll" alias "CreateCompatibleBitmap"     (hdc&, i&, i&) as long
declare function CreateDiscardableBitmap    lib "gdi32.dll" alias "CreateDiscardableBitmap"    (hdc&, i&, i&) as long
declare function CreateCompatibleDC         lib "gdi32.dll" alias "CreateCompatibleDC"         (hdc&) as long
declare function CreateDC                   lib "gdi32.dll" alias "CreateDCA"                  (sz$, sz$, sz$, lp as DEVMODE) as long
declare function CreateDIBitmap             lib "gdi32.dll" alias "CreateDIBitmap"             (hdc&, lp as BITMAPINFOHEADER, dw&, p as any, lp as BITMAPINFO, u&) as long
declare function CreateDIBPatternBrush      lib "gdi32.dll" alias "CreateDIBPatternBrush"      (hgbl&, u&) as long
declare function CreateDIBPatternBrushPt    lib "gdi32.dll" alias "CreateDIBPatternBrushPt"    (p as any, u&) as long
declare function CreateEllipticRgn          lib "gdi32.dll" alias "CreateEllipticRgn"          (i&, i&, i&, i&) as long
declare function CreateEllipticRgnIndirect  lib "gdi32.dll" alias "CreateEllipticRgnIndirect"  (lp as RECT) as long
declare function CreateFontIndirect         lib "gdi32.dll" alias "CreateFontIndirectA"        (lp as LOGFONT) as long
declare function CreateFont                 lib "gdi32.dll" alias "CreateFontA"                (i&, i&, i&, i&, i&, dw&, dw&, dw&, dw&, dw&, dw&, dw&, dw&, sz$) as long
declare function CreateHatchBrush           lib "gdi32.dll" alias "CreateHatchBrush"           (i&, clrref&) as long
declare function CreateIC                   lib "gdi32.dll" alias "CreateICA"                  (sz$, sz$, sz$, lp as DEVMODE) as long
declare function CreateMetaFile             lib "gdi32.dll" alias "CreateMetaFileA"            (sz$) as long
declare function CreatePalette              lib "gdi32.dll" alias "CreatePalette"              (lp as LOGPALETTE) as long
declare function CreatePen                  lib "gdi32.dll" alias "CreatePen"                  (i&, i&, clrref&) as long
declare function CreatePenIndirect          lib "gdi32.dll" alias "CreatePenIndirect"          (lp as LOGPEN) as long
declare function CreatePolyPolygonRgn       lib "gdi32.dll" alias "CreatePolyPolygonRgn"       (lp as POINT, pi as pointer to long, i&, i&) as long
declare function CreatePatternBrush         lib "gdi32.dll" alias "CreatePatternBrush"         (hbm&) as long
declare function CreateRectRgn              lib "gdi32.dll" alias "CreateRectRgn"              (i&, i&, i&, i&) as long
declare function CreateRectRgnIndirect      lib "gdi32.dll" alias "CreateRectRgnIndirect"      (lp as RECT) as long
declare function CreateRoundRectRgn         lib "gdi32.dll" alias "CreateRoundRectRgn"         (i&, i&, i&, i&, i&, i&) as long
declare function CreateScalableFontResource lib "gdi32.dll" alias "CreateScalableFontResourceA" (dw&, sz$, sz$, sz$) as long
declare function CreateSolidBrush           lib "gdi32.dll" alias "CreateSolidBrush"           (clrref&) as long
declare function DeleteDC                   lib "gdi32.dll" alias "DeleteDC"                   (hdc&) as long
declare function DeleteMetaFile             lib "gdi32.dll" alias "DeleteMetaFile"             (h&) as long
declare function DeleteObject               lib "gdi32.dll" alias "DeleteObject"               (hobj&) as long

'  define types of pointers to ExtDeviceMode() and DeviceCapabilities()
'  * functions for Win 3.1 compatibility
'
'  mode selections for the device mode function

const DM_UPDATE      = 1
const DM_COPY        = 2
const DM_PROMPT      = 4
const DM_MODIFY      = 8
const DM_IN_BUFFER   = DM_MODIFY
const DM_IN_PROMPT   = DM_PROMPT
const DM_OUT_BUFFER  = DM_COPY
const DM_OUT_DEFAULT = DM_UPDATE

'  device capabilities indices

const DC_FIELDS           = 1
const DC_PAPERS           = 2
const DC_PAPERSIZE        = 3
const DC_MINEXTENT        = 4
const DC_MAXEXTENT        = 5
const DC_BINS             = 6
const DC_DUPLEX           = 7
const DC_SIZE             = 8
const DC_EXTRA            = 9
const DC_VERSION          = 10
const DC_DRIVER           = 11
const DC_BINNAMES         = 12
const DC_ENUMRESOLUTIONS  = 13
const DC_FILEDEPENDENCIES = 14
const DC_TRUETYPE         = 15
const DC_PAPERNAMES       = 16
const DC_ORIENTATION      = 17
const DC_COPIES           = 18

'  bit fields of the return value (DWORD) for DC_TRUETYPE

const DCTT_BITMAP   = &H0000001&
const DCTT_DOWNLOAD = &H0000002&
const DCTT_SUBDEV   = &H0000004&

declare function DeviceCapabilities      lib "gdi32.dll" alias "DeviceCapabilitiesA"     (sz$, sz$, w as short, sz$, lp as DEVMODE) as long
declare function Ellipse                 lib "gdi32.dll" alias "Ellipse"                 (hdc&, i&, i&, i&, i&) as long
declare function EnumFontFamilies        lib "gdi32.dll" alias "EnumFontFamiliesA"       (hdc&, sz$, lpfn as pointer to function (elf as ENUMLOGFONT, lpntm&, FontType&, lParam&) as long, lParam&) as long
declare function EnumFonts               lib "gdi32.dll" alias "EnumFontsA"              (hdc&, sz$, lpfn as pointer to function (lf as LOGFONT, tm as TEXTMETRIC, dwType&, lpData&) as long, lParam&) as long
declare function EnumObjects             lib "gdi32.dll" alias "EnumObjects"             (hdc&, i&, lpfn as pointer to sub (object&, lpData&), p as any) as long
declare function EqualRgn                lib "gdi32.dll" alias "EqualRgn"                (hrgn&, hrgn&) as long
declare function Escape                  lib "gdi32.dll" alias "Escape"                  (hdc&, i&, i&, p as any, p as any) as long
declare function ExtEscape               lib "gdi32.dll" alias "ExtEscape"               (hdc&, i&, i&, sz$, i&, sz$) as long
declare function DrawEscape              lib "gdi32.dll" alias "DrawEscape"              (hdc&, i&, i&, sz$) as long
declare function ExcludeClipRect         lib "gdi32.dll" alias "ExcludeClipRect"         (hdc&, i&, i&, i&, i&) as long
declare function ExtCreateRegion         lib "gdi32.dll" alias "ExtCreateRegion"         (lp as XFORM, dw&, lp as RGNDAT) as long
declare function ExtFloodFill            lib "gdi32.dll" alias "ExtFloodFill"            (hdc&, i&, i&, clrref&, u&) as long
declare function FillRgn                 lib "gdi32.dll" alias "FillRgn"                 (hdc&, hrgn&, hbr&) as long
declare function FloodFill               lib "gdi32.dll" alias "FloodFill"               (hdc&, i&, i&, clrref&) as long
declare function FrameRgn                lib "gdi32.dll" alias "FrameRgn"                (hdc&, hrgn&, hbr&, i&, i&) as long
declare function GetROP2                 lib "gdi32.dll" alias "GetROP2"                 (hdc&) as long
declare function GetAspectRatioFilterEx  lib "gdi32.dll" alias "GetAspectRatioFilterEx"  (hdc&, lp as SIZE) as long
declare function GetBkColor              lib "gdi32.dll" alias "GetBkColor"              (hdc&) as long
declare function GetBkMode               lib "gdi32.dll" alias "GetBkMode"               (hdc&) as long
declare function GetBitmapBits           lib "gdi32.dll" alias "GetBitmapBits"           (hbm&, l&, p as any) as long
declare function GetBitmapDimensionEx    lib "gdi32.dll" alias "GetBitmapDimensionEx"    (hbm&, lp as SIZE) as long
declare function GetBoundsRect           lib "gdi32.dll" alias "GetBoundsRect"           (hdc&, lp as RECT, u&) as long
declare function GetBrushOrgEx           lib "gdi32.dll" alias "GetBrushOrgEx"           (hdc&, lp as POINT) as long
declare function GetCharWidth            lib "gdi32.dll" alias "GetCharWidthA"           (hdc&, u&, u&, pi as pointer to long) as long
declare function GetCharWidth32          lib "gdi32.dll" alias "GetCharWidth32A"         (hdc&, u&, u&, pi as pointer to long) as long
declare function GetCharWidthFloat       lib "gdi32.dll" alias "GetCharWidthFloatA"      (hdc&, u&, u&, ps as pointer to single) as long
declare function GetCharABCWidths        lib "gdi32.dll" alias "GetCharABCWidthsA"       (hdc&, u&, u&, lp as ABC) as long
declare function GetCharABCWidthsFloat   lib "gdi32.dll" alias "GetCharABCWidthsFloatA"  (hdc&, u&, u&, lp as ABCFLOAT) as long
declare function GetClipBox              lib "gdi32.dll" alias "GetClipBox"              (hdc&, lp as RECT) as long
declare function GetClipRgn              lib "gdi32.dll" alias "GetClipRgn"              (hdc&, hrgn&) as long
declare function GetMetaRgn              lib "gdi32.dll" alias "GetMetaRgn"              (hdc&, hrgn&) as long
declare function GetCurrentObject        lib "gdi32.dll" alias "GetCurrentObject"        (hdc&, u&) as long
declare function GetCurrentPositionEx    lib "gdi32.dll" alias "GetCurrentPositionEx"    (hdc&, lp as POINT) as long
declare function GetDeviceCaps           lib "gdi32.dll" alias "GetDeviceCaps"           (hdc&, i&) as long
declare function GetDIBits               lib "gdi32.dll" alias "GetDIBits"               (hdc&, hbm&, u&, u&, p as any, lp as BITMAPINFO, u&) as long
declare function GetFontData             lib "gdi32.dll" alias "GetFontData"             (hdc&, dw&, dw&, p as any, dw&) as long
declare function GetGlyphOutline         lib "gdi32.dll" alias "GetGlyphOutlineA"        (hdc&, u&, u&, lp as GLYPHMETRICS, dw&, p as any, lp as MAT2) as long
declare function GetGraphicsMode         lib "gdi32.dll" alias "GetGraphicsMode"         (hdc&) as long
declare function GetMapMode              lib "gdi32.dll" alias "GetMapMode"              (hdc&) as long
declare function GetMetaFileBitsEx       lib "gdi32.dll" alias "GetMetaFileBitsEx"       (h&, u&, p as any) as long
declare function GetMetaFile             lib "gdi32.dll" alias "GetMetaFileA"            (sz$) as long
declare function GetNearestColor         lib "gdi32.dll" alias "GetNearestColor"         (hdc&, clrref&) as long
declare function GetNearestPaletteIndex  lib "gdi32.dll" alias "GetNearestPaletteIndex"  (hpal&, clrref&) as long
declare function GetObjectType           lib "gdi32.dll" alias "GetObjectType"           (h&) as long
declare function GetOutlineTextMetrics   lib "gdi32.dll" alias "GetOutlineTextMetricsA"  (hdc&, u&, lp as OUTLINETEXTMETRIC) as long
declare function GetPaletteEntries       lib "gdi32.dll" alias "GetPaletteEntries"       (hpal&, u&, u&, lp as PALETTEENTRY) as long
declare function GetPixel                lib "gdi32.dll" alias "GetPixel"                (hdc&, i&, i&) as long
declare function GetPolyFillMode         lib "gdi32.dll" alias "GetPolyFillMode"         (hdc&) as long
declare function GetRasterizerCaps       lib "gdi32.dll" alias "GetRasterizerCaps"       (lp as RASTERIZER_STATUS, u&) as long
declare function GetRegionData           lib "gdi32.dll" alias "GetRegionData"           (hrgn&, dw&, lp as RGNDAT) as long
declare function GetRgnBox               lib "gdi32.dll" alias "GetRgnBox"               (hrgn&, lp as RECT) as long
declare function GetStockObject          lib "gdi32.dll" alias "GetStockObject"          (i&) as long
declare function GetStretchBltMode       lib "gdi32.dll" alias "GetStretchBltMode"       (hdc&) as long
declare function GetSystemPaletteEntries lib "gdi32.dll" alias "GetSystemPaletteEntries" (hdc&, u&, u&, lp as PALETTEENTRY) as long
declare function GetSystemPaletteUse     lib "gdi32.dll" alias "GetSystemPaletteUse"     (hdc&) as long
declare function GetTextCharacterExtra   lib "gdi32.dll" alias "GetTextCharacterExtra"   (hdc&) as long
declare function GetTextAlign            lib "gdi32.dll" alias "GetTextAlign"            (hdc&) as long
declare function GetTextColor            lib "gdi32.dll" alias "GetTextColor"            (hdc&) as long
declare function GetTextExtentPoint      lib "gdi32.dll" alias "GetTextExtentPointA"     (hdc&, sz$, i&, lp as SIZE) as long
declare function GetTextExtentPoint32    lib "gdi32.dll" alias "GetTextExtentPoint32A"   (hdc&, sz$, i&, lp as SIZE) as long
declare function GetTextExtentExPoint    lib "gdi32.dll" alias "GetTextExtentExPointA"   (hdc&, sz$, i&, i&, pi as pointer to long, pi as pointer to long, lp as SIZE) as long
declare function GetViewportExtEx        lib "gdi32.dll" alias "GetViewportExtEx"        (hdc&, lp as SIZE) as long
declare function GetViewportOrgEx        lib "gdi32.dll" alias "GetViewportOrgEx"        (hdc&, lp as POINT) as long
declare function GetWindowExtEx          lib "gdi32.dll" alias "GetWindowExtEx"          (hdc&, lp as SIZE) as long
declare function GetWindowOrgEx          lib "gdi32.dll" alias "GetWindowOrgEx"          (hdc&, lp as POINT) as long
declare function IntersectClipRect       lib "gdi32.dll" alias "IntersectClipRect"       (hdc&, i&, i&, i&, i&) as long
declare function InvertRgn               lib "gdi32.dll" alias "InvertRgn"               (hdc&, hrgn&) as long
declare function LineDD                  lib "gdi32.dll" alias "LineDDA"                 (i&, i&, i&, i&, lpfn as pointer to sub (x&, y&, lpData&), lParam&) as long
declare function LineTo                  lib "gdi32.dll" alias "LineTo"                  (hdc&, i&, i&) as long
declare function MaskBlt                 lib "gdi32.dll" alias "MaskBlt"                 (hdc&, i&, i&, i&, i&, hdc&, i&, i&, hbm&, i&, i&, dw&) as long
declare function PlgBlt                  lib "gdi32.dll" alias "PlgBlt"                  (hdc&, lp as POINT, hdc&, i&, i&, i&, i&, hbm&, i&, i&) as long
declare function OffsetClipRgn           lib "gdi32.dll" alias "OffsetClipRgn"           (hdc&, i&, i&) as long
declare function OffsetRgn               lib "gdi32.dll" alias "OffsetRgn"               (hrgn&, i&, i&) as long
declare function PatBlt                  lib "gdi32.dll" alias "PatBlt"                  (hdc&, i&, i&, i&, i&, dw&) as long
declare function Pie                     lib "gdi32.dll" alias "Pie"                     (hdc&, i&, i&, i&, i&, i&, i&, i&, i&) as long
declare function PlayMetaFile            lib "gdi32.dll" alias "PlayMetaFile"            (hdc&, h&) as long
declare function PaintRgn                lib "gdi32.dll" alias "PaintRgn"                (hdc&, hrgn&) as long
declare function PolyPolygon             lib "gdi32.dll" alias "PolyPolygon"             (hdc&, lp as POINT, pi as pointer to long, i&) as long
declare function PtInRegion              lib "gdi32.dll" alias "PtInRegion"              (hrgn&, i&, i&) as long
declare function PtVisible               lib "gdi32.dll" alias "PtVisible"               (hdc&, i&, i&) as long
declare function RectInRegion            lib "gdi32.dll" alias "RectInRegion"            (hrgn&, lp as RECT) as long
declare function RectVisible             lib "gdi32.dll" alias "RectVisible"             (hdc&, lp as RECT) as long
declare function Rectangle               lib "gdi32.dll" alias "Rectangle"               (hdc&, i&, i&, i&, i&) as long
declare function RestoreDC               lib "gdi32.dll" alias "RestoreDC"               (hdc&, i&) as long
declare function ResetDC                 lib "gdi32.dll" alias "ResetDCA"                (hdc&, lp as DEVMODE) as long
declare function RealizePalette          lib "gdi32.dll" alias "RealizePalette"          (hdc&) as long
declare function RemoveFontResource      lib "gdi32.dll" alias "RemoveFontResourceA"     (sz$) as long
declare function RoundRect               lib "gdi32.dll" alias "RoundRect"               (hdc&, i&, i&, i&, i&, i&, i&) as long
declare function ResizePalette           lib "gdi32.dll" alias "ResizePalette"           (hpal&, u&) as long
declare function SaveDC                  lib "gdi32.dll" alias "SaveDC"                  (hdc&) as long
declare function SelectClipRgn           lib "gdi32.dll" alias "SelectClipRgn"           (hdc&, hrgn&) as long
declare function ExtSelectClipRgn        lib "gdi32.dll" alias "ExtSelectClipRgn"        (hdc&, hrgn&, i&) as long
declare function SetMetaRgn              lib "gdi32.dll" alias "SetMetaRgn"              (hdc&) as long
declare function SelectObject            lib "gdi32.dll" alias "SelectObject"            (hdc&, hobj&) as long
declare function SelectPalette           lib "gdi32.dll" alias "SelectPalette"           (hdc&, hpal&, b&) as long
declare function SetBkColor              lib "gdi32.dll" alias "SetBkColor"              (hdc&, clrref&) as long
declare function SetBkMode               lib "gdi32.dll" alias "SetBkMode"               (hdc&, i&) as long
declare function SetBitmapBits           lib "gdi32.dll" alias "SetBitmapBits"           (hbm&, dw&, p as any) as long
declare function SetBoundsRect           lib "gdi32.dll" alias "SetBoundsRect"           (hdc&, lp as RECT, u&) as long
declare function SetDIBits               lib "gdi32.dll" alias "SetDIBits"               (hdc&, hbm&, u&, u&, p as any, lp as BITMAPINFO, u&) as long
declare function SetDIBitsToDevice       lib "gdi32.dll" alias "SetDIBitsToDevice"       (hdc&, i&, i&, dw&, dw&, i&, i&, u&, u&, p as any, lp as BITMAPINFO, u&) as long
declare function SetMapperFlags          lib "gdi32.dll" alias "SetMapperFlags"          (hdc&, dw&) as long
declare function SetGraphicsMode         lib "gdi32.dll" alias "SetGraphicsMode"         (hdc&, iMode&) as long
declare function SetMapMode              lib "gdi32.dll" alias "SetMapMode"              (hdc&, i&) as long
declare function SetMetaFileBitsEx       lib "gdi32.dll" alias "SetMetaFileBitsEx"       (u&, pb$) as long
declare function SetPaletteEntries       lib "gdi32.dll" alias "SetPaletteEntries"       (hpal&, u&, u&, lp as PALETTEENTRY) as long
declare function SetPixel                lib "gdi32.dll" alias "SetPixel"                (hdc&, i&, i&, clrref&) as long
declare function SetPixelV               lib "gdi32.dll" alias "SetPixelV"               (hdc&, i&, i&, clrref&) as long
declare function SetPolyFillMode         lib "gdi32.dll" alias "SetPolyFillMode"         (hdc&, i&) as long
declare function StretchBlt              lib "gdi32.dll" alias "StretchBlt"              (hdc&, i&, i&, i&, i&, hdc&, i&, i&, i&, i&, dw&) as long
declare sub      SetRectRgn              lib "gdi32.dll" alias "SetRectRgn"              (hrgn&, i&, i&, i&, i&)
declare function StretchDIBits           lib "gdi32.dll" alias "StretchDIBits"           (hdc&, i&, i&, i&, i&, i&, i&, i&, i&, p as any, lp as BITMAPINFO, u&, dw&) as long
declare function SetROP2                 lib "gdi32.dll" alias "SetROP2"                 (hdc&, i&) as long
declare function SetStretchBltMode       lib "gdi32.dll" alias "SetStretchBltMode"       (hdc&, i&) as long
declare function SetSystemPaletteUse     lib "gdi32.dll" alias "SetSystemPaletteUse"     (hdc&, u&) as long
declare function SetTextCharacterExtra   lib "gdi32.dll" alias "SetTextCharacterExtra"   (hdc&, i&) as long
declare function SetTextColor            lib "gdi32.dll" alias "SetTextColor"            (hdc&, clrref&) as long
declare function SetTextAlign            lib "gdi32.dll" alias "SetTextAlign"            (hdc&, u&) as long
declare function SetTextJustification    lib "gdi32.dll" alias "SetTextJustification"    (hdc&, i&, i&) as long
declare function UpdateColors            lib "gdi32.dll" alias "UpdateColors"            (hdc&) as long
declare sub      PlayMetaFileRecord      lib "gdi32.dll" alias "PlayMetaFileRecord"      (hdc&, lp as HANDLETABLE, lp as METARECORD, u&)
declare function EnumMetaFile            lib "gdi32.dll" alias "EnumMetaFile"            (hdc&, h&, lpfn as callback, lParam&) as long

'  Enhanced Metafile Function Declarations

declare function CloseEnhMetaFile             lib "gdi32.dll" alias "CloseEnhMetaFile"             (hdc&) as long
declare function CopyEnhMetaFile              lib "gdi32.dll" alias "CopyEnhMetaFileA"             (henhMeta as long, sz$) as long
declare function CreateEnhMetaFile            lib "gdi32.dll" alias "CreateEnhMetaFileA"           (hdc&, sz$, lp as RECT, sz$) as long
declare function DeleteEnhMetaFile            lib "gdi32.dll" alias "DeleteEnhMetaFile"            (henhMeta as long) as long
declare function EnumEnhMetaFile              lib "gdi32.dll" alias "EnumEnhMetaFile"              (hdc&, henhMeta as long, lpfn as pointer to function (hDC&, HT as HANDLETABLE, MR as METARECORD, lpClientData&) as long, p as any, lp as RECT) as long
declare function GetEnhMetaFile               lib "gdi32.dll" alias "GetEnhMetaFileA"              (sz$) as long
declare function GetEnhMetaFileBits           lib "gdi32.dll" alias "GetEnhMetaFileBits"           (henhMeta as long, u&, pb$) as long
declare function GetEnhMetaFileDescription    lib "gdi32.dll" alias "GetEnhMetaFileDescriptionA"   (henhMeta as long, u&, sz$) as long
declare function GetEnhMetaFileHeader         lib "gdi32.dll" alias "GetEnhMetaFileHeader"         (henhMeta as long, u&, lp as ENHMETAHEADER) as long
declare function GetEnhMetaFilePaletteEntries lib "gdi32.dll" alias "GetEnhMetaFilePaletteEntries" (henhMeta as long, u&, lp as PALETTEENTRY) as long
declare function GetWinMetaFileBits           lib "gdi32.dll" alias "GetWinMetaFileBits"           (henhMeta as long, u&, pb$, i&, hdc&) as long
declare function PlayEnhMetaFile              lib "gdi32.dll" alias "PlayEnhMetaFile"              (hdc&, henhMeta as long, lp as RECT) as long
declare function PlayEnhMetaFileRecord        lib "gdi32.dll" alias "PlayEnhMetaFileRecord"        (hdc&, lp as HANDLETABLE, lp as ENHMETARECORD, u&) as long
declare function SetEnhMetaFileBits           lib "gdi32.dll" alias "SetEnhMetaFileBits"           (u&, pb$) as long
declare function SetWinMetaFileBits           lib "gdi32.dll" alias "SetWinMetaFileBits"           (u&, pb$, hdc&, lp as METAFILEPICT) as long
declare function GdiComment                   lib "gdi32.dll" alias "GdiComment"                   (hdc&, u&, pb$) as long
declare function GetTextMetrics               lib "gdi32.dll" alias "GetTextMetricsA"              (hdc&, lp as TEXTMETRIC) as long

'  new GDI
'UNDONE: Bug in Binford
'declare function AngleArc             lib "gdi32.dll" alias "AngleArc"             (hdc&, i&, i&, dw&, s!, s!) as long
declare function PolyPolyline         lib "gdi32.dll" alias "PolyPolyline"         (hdc&, lp as POINT, pdw as pointer to long, dw&) as long
declare function GetWorldTransform    lib "gdi32.dll" alias "GetWorldTransform"    (hdc&, lp as XFORM) as long
declare function SetWorldTransform    lib "gdi32.dll" alias "SetWorldTransform"    (hdc&, lp as XFORM) as long
declare function ModifyWorldTransform lib "gdi32.dll" alias "ModifyWorldTransform" (hdc&, lp as XFORM, dw&) as long
declare function CombineTransform     lib "gdi32.dll" alias "CombineTransform"     (lp as XFORM, lp as XFORM, lp as XFORM) as long

'  Flags value for COLORADJUSTMENT

const CA_NEGATIVE   = &H0001&
const CA_LOG_FILTER = &H0002&

'  IlluminantIndex values

const ILLUMINANT_DEVICE_DEFAULT = 0
const ILLUMINANT_A              = 1
const ILLUMINANT_B              = 2
const ILLUMINANT_C              = 3
const ILLUMINANT_D50            = 4
const ILLUMINANT_D55            = 5
const ILLUMINANT_D65            = 6
const ILLUMINANT_D75            = 7
const ILLUMINANT_F2             = 8
const ILLUMINANT_MAX_INDEX      = ILLUMINANT_F2
const ILLUMINANT_DAYLIGHT       = ILLUMINANT_C
const ILLUMINANT_FLUORESCENT    = ILLUMINANT_F2
const ILLUMINANT_NTSC           = ILLUMINANT_C

'  Min and max for RedGamma, GreenGamma, BlueGamma

const RGB_GAMMA_MIN = 02500
const RGB_GAMMA_MAX = 65000

'  Min and max for ReferenceBlack and ReferenceWhite

const REFERENCE_WHITE_MIN = 6000
const REFERENCE_WHITE_MAX = 10000
const REFERENCE_BLACK_MIN = 0
const REFERENCE_BLACK_MAX = 4000

'  Min and max for Contrast, Brightness, Colorfulness, RedGreenTint

const COLOR_ADJ_MIN = -100
const COLOR_ADJ_MAX = 100

type COLORADJUSTMENT
    caSize            as short
    caFlags           as short
    caIlluminantIndex as short
    caRedGamma        as short
    caGreenGamma      as short
    caBlueGamma       as short
    caReferenceBlack  as short
    caReferenceWhite  as short
    caContrast        as short
    caBrightness      as short
    caColorfulness    as short
    caRedGreenTint    as short
end type

declare function SetColorAdjustment    lib "gdi32.dll" alias "SetColorAdjustment"    (hdc&, lp as COLORADJUSTMENT) as long
declare function GetColorAdjustment    lib "gdi32.dll" alias "GetColorAdjustment"    (hdc&, lp as COLORADJUSTMENT) as long
declare function CreateHalftonePalette lib "gdi32.dll" alias "CreateHalftonePalette" (hdc&) as long

type DOCINFO
    cbSize      as long
    lpszDocName as pointer to string * 1
    lpszOutput  as pointer to string * 1
end type

declare function StartDoc             lib "gdi32.dll" alias "StartDocA"            (hdc&, lp as DOCINFO) as long
declare function EndDoc               lib "gdi32.dll" alias "EndDoc"               (hdc&) as long
declare function StartPage            lib "gdi32.dll" alias "StartPage"            (hdc&) as long
declare function EndPage              lib "gdi32.dll" alias "EndPage"              (hdc&) as long
declare function AbortDoc             lib "gdi32.dll" alias "AbortDoc"             (hdc&) as long
declare function SetAbortProc         lib "gdi32.dll" alias "SetAbortProc"         (hdc&, lpfn as pointer to function (hDC&, iError&) as long) as long
declare function AbortPath            lib "gdi32.dll" alias "AbortPath"            (hdc&) as long
declare function ArcTo                lib "gdi32.dll" alias "ArcTo"                (hdc&, i&, i&, i&, i&, i&, i&, i&, i&) as long
declare function BeginPath            lib "gdi32.dll" alias "BeginPath"            (hdc&) as long
declare function CloseFigure          lib "gdi32.dll" alias "CloseFigure"          (hdc&) as long
declare function EndPath              lib "gdi32.dll" alias "EndPath"              (hdc&) as long
declare function FillPath             lib "gdi32.dll" alias "FillPath"             (hdc&) as long
declare function FlattenPath          lib "gdi32.dll" alias "FlattenPath"          (hdc&) as long
declare function GetPath              lib "gdi32.dll" alias "GetPath"              (hdc&, lp as POINT, pb$, i&) as long
declare function PathToRegion         lib "gdi32.dll" alias "PathToRegion"         (hdc&) as long
declare function PolyDraw             lib "gdi32.dll" alias "PolyDraw"             (hdc&, lp as POINT, pb$, i&) as long
declare function SelectClipPath       lib "gdi32.dll" alias "SelectClipPath"       (hdc&, i&) as long
declare function SetArcDirection      lib "gdi32.dll" alias "SetArcDirection"      (hdc&, i&) as long
' UNDONE: Bug in Binford
'declare function SetMiterLimit        lib "gdi32.dll" alias "SetMiterLimit"        (hdc&, s!, ps as pointer to single) as long
declare function StrokeAndFillPath    lib "gdi32.dll" alias "StrokeAndFillPath"    (hdc&) as long
declare function StrokePath           lib "gdi32.dll" alias "StrokePath"           (hdc&) as long
declare function WidenPath            lib "gdi32.dll" alias "WidenPath"            (hdc&) as long
declare function ExtCreatePen         lib "gdi32.dll" alias "ExtCreatePen"         (dw&, dw&, lp as LOGBRUSH, dw&, pdw as pointer to long) as long
declare function GetMiterLimit        lib "gdi32.dll" alias "GetMiterLimit"        (hdc&, ps as pointer to single) as long
declare function GetArcDirection      lib "gdi32.dll" alias "GetArcDirection"      (hdc&) as long
declare function GetObject            lib "gdi32.dll" alias "GetObjectA"           (hobj&, i&, p as any) as long
declare function MoveToEx             lib "gdi32.dll" alias "MoveToEx"             (hdc&, i&, i&, lp as POINT) as long
declare function TextOut              lib "gdi32.dll" alias "TextOutA"             (hdc&, i&, i&, sz$, i&) as long
declare function ExtTextOut           lib "gdi32.dll" alias "ExtTextOutA"          (hdc&, i&, i&, u&, lp as RECT, sz$, u&, pi as pointer to long) as long
declare function PolyTextOut          lib "gdi32.dll" alias "PolyTextOutA"         (hdc&, lp as POLYTEXT, i&) as long
declare function CreatePolygonRgn     lib "gdi32.dll" alias "CreatePolygonRgn"     (lp as POINT, i&, i&) as long
declare function DPtoLP               lib "gdi32.dll" alias "DPtoLP"               (hdc&, lp as POINT, i&) as long
declare function LPtoDP               lib "gdi32.dll" alias "LPtoDP"               (hdc&, lp as POINT, i&) as long
declare function Polygon              lib "gdi32.dll" alias "Polygon"              (hdc&, lp as POINT, i&) as long
declare function Polyline             lib "gdi32.dll" alias "Polyline"             (hdc&, lp as POINT, i&) as long
declare function PolyBezier           lib "gdi32.dll" alias "PolyBezier"           (hdc&, lp as POINT, dw&) as long
declare function PolyBezierTo         lib "gdi32.dll" alias "PolyBezierTo"         (hdc&, lp as POINT, dw&) as long
declare function PolylineTo           lib "gdi32.dll" alias "PolylineTo"           (hdc&, lp as POINT, dw&) as long
declare function SetViewportExtEx     lib "gdi32.dll" alias "SetViewportExtEx"     (hdc&, i&, i&, lp as SIZE) as long
declare function SetViewportOrgEx     lib "gdi32.dll" alias "SetViewportOrgEx"     (hdc&, i&, i&, lp as POINT) as long
declare function SetWindowExtEx       lib "gdi32.dll" alias "SetWindowExtEx"       (hdc&, i&, i&, lp as SIZE) as long
declare function SetWindowOrgEx       lib "gdi32.dll" alias "SetWindowOrgEx"       (hdc&, i&, i&, lp as POINT) as long
declare function OffsetViewportOrgEx  lib "gdi32.dll" alias "OffsetViewportOrgEx"  (hdc&, i&, i&, lp as POINT) as long
declare function OffsetWindowOrgEx    lib "gdi32.dll" alias "OffsetWindowOrgEx"    (hdc&, i&, i&, lp as POINT) as long
declare function ScaleViewportExtEx   lib "gdi32.dll" alias "ScaleViewportExtEx"   (hdc&, i&, i&, i&, i&, lp as SIZE) as long
declare function ScaleWindowExtEx     lib "gdi32.dll" alias "ScaleWindowExtEx"     (hdc&, i&, i&, i&, i&, lp as SIZE) as long
declare function SetBitmapDimensionEx lib "gdi32.dll" alias "SetBitmapDimensionEx" (hbm&, i&, i&, lp as SIZE) as long
declare function SetBrushOrgEx        lib "gdi32.dll" alias "SetBrushOrgEx"        (hdc&, i&, i&, lp as POINT) as long
declare function GetTextFace          lib "gdi32.dll" alias "GetTextFaceA"         (hdc&, i&, sz$) as long

const FONTMAPPER_MAX = 10

type KERNINGPAIR
    wFirst      as short
    wSecond     as short
    iKernAmount as long
end type

declare function GetKerningPairs  lib "gdi32.dll" alias "GetKerningPairsA" (hdc&, dw&, lp as KERNINGPAIR) as long
declare function GetDCOrgEx       lib "gdi32.dll" alias "GetDCOrgEx"       (hdc&, lp as POINT) as long
declare function FixBrushOrgEx    lib "gdi32.dll" alias "FixBrushOrgEx"    (hdc&, i&, i&, lp as POINT) as long
declare function UnrealizeObject  lib "gdi32.dll" alias "UnrealizeObject"  (hobj&) as long
declare function GdiFlush         lib "gdi32.dll" alias "GdiFlush"         () as long
declare function GdiSetBatchLimit lib "gdi32.dll" alias "GdiSetBatchLimit" (dw&) as long
declare function GdiGetBatchLimit lib "gdi32.dll" alias "GdiGetBatchLimit" () as long

'  Enhanced metafile constants.

const ENHMETA_SIGNATURE = &H464D4520&

'  Stock object flag used in the object handle index in the enhanced
'  metafile records.
'  E.g. The object handle index (META_STOCK_OBJECT | BLACK_BRUSH)
'  represents the stock object BLACK_BRUSH.

const ENHMETA_STOCK_OBJECT = &H80000000&

'  Enhanced metafile record types.

const EMR_HEADER                  = 1
const EMR_POLYBEZIER              = 2
const EMR_POLYGON                 = 3
const EMR_POLYLINE                = 4
const EMR_POLYBEZIERTO            = 5
const EMR_POLYLINETO              = 6
const EMR_POLYPOLYLINE            = 7
const EMR_POLYPOLYGON             = 8
const EMR_SETWINDOWEXTEX          = 9
const EMR_SETWINDOWORGEX          = 10
const EMR_SETVIEWPORTEXTEX        = 11
const EMR_SETVIEWPORTORGEX        = 12
const EMR_SETBRUSHORGEX           = 13
const EMR_EOF                     = 14
const EMR_SETPIXELV               = 15
const EMR_SETMAPPERFLAGS          = 16
const EMR_SETMAPMODE              = 17
const EMR_SETBKMODE               = 18
const EMR_SETPOLYFILLMODE         = 19
const EMR_SETROP2                 = 20
const EMR_SETSTRETCHBLTMODE       = 21
const EMR_SETTEXTALIGN            = 22
const EMR_SETCOLORADJUSTMENT      = 23
const EMR_SETTEXTCOLOR            = 24
const EMR_SETBKCOLOR              = 25
const EMR_OFFSETCLIPRGN           = 26
const EMR_MOVETOEX                = 27
const EMR_SETMETARGN              = 28
const EMR_EXCLUDECLIPRECT         = 29
const EMR_INTERSECTCLIPRECT       = 30
const EMR_SCALEVIEWPORTEXTEX      = 31
const EMR_SCALEWINDOWEXTEX        = 32
const EMR_SAVEDC                  = 33
const EMR_RESTOREDC               = 34
const EMR_SETWORLDTRANSFORM       = 35
const EMR_MODIFYWORLDTRANSFORM    = 36
const EMR_SELECTOBJECT            = 37
const EMR_CREATEPEN               = 38
const EMR_CREATEBRUSHINDIRECT     = 39
const EMR_DELETEOBJECT            = 40
const EMR_ANGLEARC                = 41
const EMR_ELLIPSE                 = 42
const EMR_RECTANGLE               = 43
const EMR_ROUNDRECT               = 44
const EMR_ARC                     = 45
const EMR_CHORD                   = 46
const EMR_PIE                     = 47
const EMR_SELECTPALETTE           = 48
const EMR_CREATEPALETTE           = 49
const EMR_SETPALETTEENTRIES       = 50
const EMR_RESIZEPALETTE           = 51
const EMR_REALIZEPALETTE          = 52
const EMR_EXTFLOODFILL            = 53
const EMR_LINETO                  = 54
const EMR_ARCTO                   = 55
const EMR_POLYDRAW                = 56
const EMR_SETARCDIRECTION         = 57
const EMR_SETMITERLIMIT           = 58
const EMR_BEGINPATH               = 59
const EMR_ENDPATH                 = 60
const EMR_CLOSEFIGURE             = 61
const EMR_FILLPATH                = 62
const EMR_STROKEANDFILLPATH       = 63
const EMR_STROKEPATH              = 64
const EMR_FLATTENPATH             = 65
const EMR_WIDENPATH               = 66
const EMR_SELECTCLIPPATH          = 67
const EMR_ABORTPATH               = 68
const EMR_GDICOMMENT              = 70
const EMR_FILLRGN                 = 71
const EMR_FRAMERGN                = 72
const EMR_INVERTRGN               = 73
const EMR_PAINTRGN                = 74
const EMR_EXTSELECTCLIPRGN        = 75
const EMR_BITBLT                  = 76
const EMR_STRETCHBLT              = 77
const EMR_MASKBLT                 = 78
const EMR_PLGBLT                  = 79
const EMR_SETDIBITSTODEVICE       = 80
const EMR_STRETCHDIBITS           = 81
const EMR_EXTCREATEFONTINDIRECTW  = 82
const EMR_EXTTEXTOUTA             = 83
const EMR_EXTTEXTOUTW             = 84
const EMR_POLYBEZIER16            = 85
const EMR_POLYGON16               = 86
const EMR_POLYLINE16              = 87
const EMR_POLYBEZIERTO16          = 88
const EMR_POLYLINETO16            = 89
const EMR_POLYPOLYLINE16          = 90
const EMR_POLYPOLYGON16           = 91
const EMR_POLYDRAW16              = 92
const EMR_CREATEMONOBRUSH         = 93
const EMR_CREATEDIBPATTERNBRUSHPT = 94
const EMR_EXTCREATEPEN            = 95
const EMR_POLYTEXTOUTA            = 96
const EMR_POLYTEXTOUTW            = 97
const EMR_MIN                     = 1
const EMR_MAX                     = 97

'  Base record type for the enhanced metafile.

type EMR
    iType as long ' Enhanced metafile record type
    nSize as long ' Length of the record in bytes.
    '     This must be a multiple of 4.
end type

'  Base text record type for the enhanced metafile.

type EMRTEXT
    ptlReference as POINTL
    nChars       as long
    offString    as long ' Offset to the string
    fOptions     as long
    rcl          as RECTL
    offDx        as long ' Offset to the inter-character spacing array.
    '            This is always given.
end type

'  Record structures for the enhanced metafile.

type EMRABORTPATH
    emr as EMR
end type

type EMRSELECTCLIPPATH
    emr   as EMR
    iMode as long
end type

type EMRSETMITERLIMIT
    emr         as EMR
    eMiterLimit as single
end type

type EMRRESTOREDC
    emr       as EMR
    iRelative as long ' Specifies a relative instance
end type

type EMRSETARCDIRECTION
    emr           as EMR
    iArcDirection as long ' Specifies the arc direction in the
    '             advanced graphics mode.
end type

type EMRSETMAPPERFLAGS
    emr     as EMR
    dwFlags as long
end type

type EMRSETBKCOLOR
    emr     as EMR
    crColor as long
end type

type EMRSELECTOBJECT
    emr      as EMR
    ihObject as long ' Object handle index
end type

type EMRSELECTPALETTE
    emr   as EMR
    ihPal as long ' Palette handle index, background mode only
end type

type EMRRESIZEPALETTE
    emr      as EMR
    ihPal    as long ' Palette handle index
    cEntries as long
end type

type EMRSETPALETTEENTRIES
    emr         as EMR
    ihPal       as long ' Palette handle index
    iStart      as long
    cEntries    as long
    '           PALETTEENTRY aPalEntries[1];' The peFlags fields do not contain any flags
    aPalEntries as PALETTEENTRY' The peFlags fields do not contain any flags
end type

type EMRSETCOLORADJUSTMENT
    emr             as EMR
    ColorAdjustment as COLORADJUSTMENT
end type

type EMRGDICOMMENT
    emr    as EMR
    cbData as long ' Size of data in bytes
    rData  as string * 1
end type

type EMREOF
    emr           as EMR
    nPalEntries   as long ' Number of palette entries
    offPalEntries as long ' Offset to the palette entries
    nSizeLast     as long ' Same as nSize and must be the last DWORD
    '             of the record. The palette entries,
    '             if exist, precede this field.
end type

type EMRLINETO
    emr as EMR
    ptl as POINTL
end type

type EMROFFSETCLIPRGN
    emr       as EMR
    ptlOffset as POINTL
end type

type EMRFILLPATH
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
end type

type EMREXCLUDECLIPRECT
    emr     as EMR
    rclClip as RECTL
end type

type EMRSETVIEWPORTORGEX
    emr       as EMR
    ptlOrigin as POINTL
end type

type EMRSETVIEWPORTEXTEX
    emr       as EMR
    szlExtent as SIZEL
end type

type EMRSCALEVIEWPORTEXTEX
    emr    as EMR
    xNum   as long
    xDenom as long
    yNum   as long
    yDenom as long
end type

type EMRSETWORLDTRANSFORM
    emr   as EMR
    xform as XFORM
end type

type EMRMODIFYWORLDTRANSFORM
    emr   as EMR
    xform as XFORM
    iMode as long
end type

type EMRSETPIXELV
    emr      as EMR
    ptlPixel as POINTL
    crColor  as long
end type

type EMREXTFLOODFILL
    emr      as EMR
    ptlStart as POINTL
    crColor  as long
    iMode    as long
end type

type EMRELLIPSE
    emr    as EMR
    rclBox as RECTL ' Inclusive-inclusive bounding rectangle
end type

type EMRROUNDRECT
    emr       as EMR
    rclBox    as RECTL ' Inclusive-inclusive bounding rectangle
    szlCorner as SIZEL
end type

type EMRARC
    emr      as EMR
    rclBox   as RECTL ' Inclusive-inclusive bounding rectangle
    ptlStart as POINTL
    ptlEnd   as POINTL
end type

type EMRANGLEARC
    emr         as EMR
    ptlCenter   as POINTL
    nRadius     as long
    eStartAngle as single
    eSweepAngle as single
end type

type EMRPOLYLINE
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
    cptl      as long
    '         POINTL aptl[1];
    aptl      as POINTL
end type

type EMRPOLYLINE16
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
    cpts      as long
    '         POINTS apts[1];
    apts      as POINTS
end type

type EMRPOLYDRAW16
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
    cpts      as long ' Number of points
    '         POINTS apts[1]; ' Array of points
    apts      as POINTS ' Array of points
    abTypes   as string * 1 ' Array of point types
end type

type EMRPOLYPOLYLINE
    emr         as EMR
    rclBounds   as RECTL ' Inclusive-inclusive bounds in device units
    nPolys      as long ' Number of polys
    cptl        as long ' Total number of points in all polys
    '           DWORD aPolyCounts[1]; ' Array of point counts for each poly
    aPolyCounts as long ' Array of point counts for each poly
    '           POINTL aptl[1]; ' Array of points
    aptl        as POINTL ' Array of points
end type

type EMRPOLYPOLYLINE16
    emr         as EMR
    rclBounds   as RECTL ' Inclusive-inclusive bounds in device units
    nPolys      as long ' Number of polys
    cpts        as long ' Total number of points in all polys
    '           DWORD aPolyCounts[1]; ' Array of point counts for each poly
    aPolyCounts as long ' Array of point counts for each poly
    '           POINTS apts[1]; ' Array of points
    apts        as POINTS ' Array of points
end type

type EMRINVERTRGN
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
    cbRgnData as long ' Size of region data in bytes
    RgnData   as string * 1
end type

type EMRFILLRGN
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
    cbRgnData as long ' Size of region data in bytes
    ihBrush   as long ' Brush handle index
    RgnData   as string * 1
end type

type EMRFRAMERGN
    emr       as EMR
    rclBounds as RECTL ' Inclusive-inclusive bounds in device units
    cbRgnData as long ' Size of region data in bytes
    ihBrush   as long ' Brush handle index
    szlStroke as SIZEL
    RgnData   as string * 1
end type

type EMREXTSELECTCLIPRGN
    emr       as EMR
    cbRgnData as long ' Size of region data in bytes
    iMode     as long
    RgnData   as string * 1
end type

type EMREXTTEXTOUT
    emr           as EMR
    rclBounds     as RECTL   ' Inclusive-inclusive bounds in device units
    iGraphicsMode as long    ' Current graphics mode
    exScale       as single  ' X and Y scales from Page units to .01mm units
    eyScale       as single  ' if graphics mode is GM_COMPATIBLE.
    emrtext       as EMRTEXT ' This is followed by the string and spacing
                             '             array
end type

type EMRPOLYTEXTOUT
    emr           as EMR
    rclBounds     as RECTL  ' Inclusive-inclusive bounds in device units
    iGraphicsMode as long   ' Current graphics mode
    exScale       as single ' X and Y scales from Page units to .01mm units
    eyScale       as single ' if graphics mode is GM_COMPATIBLE.
    cStrings      as long
    '             EMRTEXT aemrtext[1];
    aemrtext      as EMRTEXT ' Array of EMRTEXT structures. This is
                             '             followed by the strings and spacing arrays.
end type

type EMRBITBLT
    emr          as EMR
    rclBounds    as RECTL ' Inclusive-inclusive bounds in device units
    xDest        as long
    yDest        as long
    cxDest       as long
    cyDest       as long
    dwRop        as long
    xSrc         as long
    ySrc         as long
    xformSrc     as XFORM ' Source DC transform
    crBkColorSrc as long  ' Source DC BkColor in RGB
    iUsageSrc    as long  ' Source bitmap info color table usage
                          '            (DIB_RGB_COLORS)
    offBmiSrc    as long  ' Offset to the source BITMAPINFO structure
    cbBmiSrc     as long  ' Size of the source BITMAPINFO structure
    offBitsSrc   as long  ' Offset to the source bitmap bits
    cbBitsSrc    as long  ' Size of the source bitmap bits
end type

type EMRSTRETCHBLT
    emr          as EMR
    rclBounds    as RECTL ' Inclusive-inclusive bounds in device units
    xDest        as long
    yDest        as long
    cxDest       as long
    cyDest       as long
    dwRop        as long
    xSrc         as long
    ySrc         as long
    xformSrc     as XFORM ' Source DC transform
    crBkColorSrc as long  ' Source DC BkColor in RGB
    iUsageSrc    as long  ' Source bitmap info color table usage
                          '            (DIB_RGB_COLORS)
    offBmiSrc    as long  ' Offset to the source BITMAPINFO structure
    cbBmiSrc     as long  ' Size of the source BITMAPINFO structure
    offBitsSrc   as long  ' Offset to the source bitmap bits
    cbBitsSrc    as long  ' Size of the source bitmap bits
    cxSrc        as long
    cySrc        as long
end type

type EMRMASKBLT
    emr          as EMR
    rclBounds    as RECTL ' Inclusive-inclusive bounds in device units
    xDest        as long
    yDest        as long
    cxDest       as long
    cyDest       as long
    dwRop        as long
    xSrc         as long
    ySrc         as long
    xformSrc     as XFORM ' Source DC transform
    crBkColorSrc as long  ' Source DC BkColor in RGB
    iUsageSrc    as long  ' Source bitmap info color table usage
                          '            (DIB_RGB_COLORS)
    offBmiSrc    as long  ' Offset to the source BITMAPINFO structure
    cbBmiSrc     as long  ' Size of the source BITMAPINFO structure
    offBitsSrc   as long  ' Offset to the source bitmap bits
    cbBitsSrc    as long  ' Size of the source bitmap bits
    xMask        as long
    yMask        as long
    iUsageMask   as long  ' Mask bitmap info color table usage
    offBmiMask   as long  ' Offset to the mask BITMAPINFO structure if any
    cbBmiMask    as long  ' Size of the mask BITMAPINFO structure if any
    offBitsMask  as long  ' Offset to the mask bitmap bits if any
    cbBitsMask   as long  ' Size of the mask bitmap bits if any
end type

type EMRPLGBLT
    emr          as EMR
    rclBounds    as RECTL ' Inclusive-inclusive bounds in device units
    '            POINTL aptlDest[3];
    aptlDest     as POINTL
    xSrc         as long
    ySrc         as long
    cxSrc        as long
    cySrc        as long
    xformSrc     as XFORM ' Source DC transform
    crBkColorSrc as long  ' Source DC BkColor in RGB
    iUsageSrc    as long  ' Source bitmap info color table usage
                          '            (DIB_RGB_COLORS)
    offBmiSrc    as long  ' Offset to the source BITMAPINFO structure
    cbBmiSrc     as long  ' Size of the source BITMAPINFO structure
    offBitsSrc   as long  ' Offset to the source bitmap bits
    cbBitsSrc    as long  ' Size of the source bitmap bits
    xMask        as long
    yMask        as long
    iUsageMask   as long  ' Mask bitmap info color table usage
    offBmiMask   as long  ' Offset to the mask BITMAPINFO structure if any
    cbBmiMask    as long  ' Size of the mask BITMAPINFO structure if any
    offBitsMask  as long  ' Offset to the mask bitmap bits if any
    cbBitsMask   as long  ' Size of the mask bitmap bits if any
end type

type EMRSETDIBITSTODEVICE
    emr        as EMR
    rclBounds  as RECTL ' Inclusive-inclusive bounds in device units
    xDest      as long
    yDest      as long
    xSrc       as long
    ySrc       as long
    cxSrc      as long
    cySrc      as long
    offBmiSrc  as long ' Offset to the source BITMAPINFO structure
    cbBmiSrc   as long ' Size of the source BITMAPINFO structure
    offBitsSrc as long ' Offset to the source bitmap bits
    cbBitsSrc  as long ' Size of the source bitmap bits
    iUsageSrc  as long ' Source bitmap info color table usage
    iStartScan as long
    cScans     as long
end type

type EMRSTRETCHDIBITS
    emr        as EMR
    rclBounds  as RECTL ' Inclusive-inclusive bounds in device units
    xDest      as long
    yDest      as long
    xSrc       as long
    ySrc       as long
    cxSrc      as long
    cySrc      as long
    offBmiSrc  as long ' Offset to the source BITMAPINFO structure
    cbBmiSrc   as long ' Size of the source BITMAPINFO structure
    offBitsSrc as long ' Offset to the source bitmap bits
    cbBitsSrc  as long ' Size of the source bitmap bits
    iUsageSrc  as long ' Source bitmap info color table usage
    dwRop      as long
    cxDest     as long
    cyDest     as long
end type

type EMRCREATEPALETTE
    emr   as EMR
    ihPal as long       ' Palette handle index
    lgpl  as LOGPALETTE ' The peFlags fields in the palette entries
                        '     do not contain any flags
end type

type EMRCREATEPEN
    emr   as EMR
    ihPen as long ' Pen handle index
    lopn  as LOGPEN
end type

type EMREXTCREATEPEN
    emr     as EMR
    ihPen   as long ' Pen handle index
    offBmi  as long ' Offset to the BITMAPINFO structure if any
    cbBmi   as long ' Size of the BITMAPINFO structure if any
                    '       The bitmap info is followed by the bitmap
                    '       bits to form a packed DIB.
    offBits as long ' Offset to the brush bitmap bits if any
    cbBits  as long ' Size of the brush bitmap bits if any
    elp     as EXTLOGPEN ' The extended pen with the style array.
end type

type EMRCREATEBRUSHINDIRECT
    emr     as EMR
    ihBrush as long     ' Brush handle index
    lb      as LOGBRUSH ' The style must be BS_SOLID, BS_HOLLOW,
                        '       BS_NULL or BS_HATCHED.
end type

type EMRCREATEMONOBRUSH
    emr     as EMR
    ihBrush as long ' Brush handle index
    iUsage  as long ' Bitmap info color table usage
    offBmi  as long ' Offset to the BITMAPINFO structure
    cbBmi   as long ' Size of the BITMAPINFO structure
    offBits as long ' Offset to the bitmap bits
    cbBits  as long ' Size of the bitmap bits
end type

type EMRCREATEDIBPATTERNBRUSHPT
    emr     as EMR
    ihBrush as long ' Brush handle index
    iUsage  as long ' Bitmap info color table usage
    offBmi  as long ' Offset to the BITMAPINFO structure
    cbBmi   as long ' Size of the BITMAPINFO structure
                    '       The bitmap info is followed by the bitmap
                    '       bits to form a packed DIB.
    offBits as long ' Offset to the bitmap bits
    cbBits  as long ' Size of the bitmap bits
end type

'******************************************************************************
'*** From WINUSER.H: USER32 Types, Constants, Functions
'******************************************************************************

'
' Predefined Resource Types
'

const RT_CURSOR       = (1)
const RT_BITMAP       = (2)
const RT_ICON         = (3)
const RT_MENU         = (4)
const RT_DIALOG       = (5)
const RT_STRING       = (6)
const RT_FONTDIR      = (7)
const RT_FONT         = (8)
const RT_ACCELERATOR  = (9)
const RT_RCDATA       = (10)
const RT_MESSAGETABLE = (11)
const DIFFERENCE      = 11
const RT_GROUP_CURSOR = (RT_CURSOR + DIFFERENCE)
const RT_GROUP_ICON   = (RT_ICON + DIFFERENCE)
const RT_VERSION      = (16)
const RT_DLGINCLUDE   = (17)

declare function wvsprintf       lib "user32.dll" alias "wvsprintfA" (sz$, sz$, arglist as any) as long
declare function wsprintf  cdecl lib "user32.dll" alias "wsprintfA" (sz$, ...) as long

'
' Scroll Bar Constants
'

const SB_HORZ = 0
const SB_VERT = 1
const SB_CTL  = 2
const SB_BOTH = 3

'
' Scroll Bar Commands
'

const SB_LINEUP        = 0
const SB_LINELEFT      = 0
const SB_LINEDOWN      = 1
const SB_LINERIGHT     = 1
const SB_PAGEUP        = 2
const SB_PAGELEFT      = 2
const SB_PAGEDOWN      = 3
const SB_PAGERIGHT     = 3
const SB_THUMBPOSITION = 4
const SB_THUMBTRACK    = 5
const SB_TOP           = 6
const SB_LEFT          = 6
const SB_BOTTOM        = 7
const SB_RIGHT         = 7
const SB_ENDSCROLL     = 8

'
' ShowWindow() Commands
'
' NOTE: Predifined by MS-Test for use with the Run() statement
'
'const SW_HIDE            = 0
'const SW_SHOWNORMAL      = 1
'const SW_NORMAL          = 1
'const SW_SHOWMINIMIZED   = 2
'const SW_SHOWMAXIMIZED   = 3
'const SW_MAXIMIZE        = 3
'const SW_SHOWNOACTIVATE  = 4
'const SW_SHOW            = 5
'const SW_MINIMIZE        = 6
'const SW_SHOWMINNOACTIVE = 7
'const SW_SHOWNA          = 8
'const SW_RESTORE         = 9
'const SW_SHOWDEFAULT     = 10
'const SW_MAX             = 10

'
' Old ShowWindow() Commands
'

const HIDE_WINDOW         = 0
const SHOW_OPENWINDOW     = 1
const SHOW_ICONWINDOW     = 2
const SHOW_FULLSCREEN     = 3
const SHOW_OPENNOACTIVATE = 4

'
' Identifiers for the WM_SHOWWINDOW message
'

const SW_PARENTCLOSING = 1
const SW_OTHERZOOM     = 2
const SW_PARENTOPENING = 3
const SW_OTHERUNZOOM   = 4

'
' WM_KEYUP/DOWN/CHAR HIWORD(lParam) flags
'

const KF_EXTENDED = &H0100&
const KF_DLGMODE  = &H0800&
const KF_MENUMODE = &H1000&
const KF_ALTDOWN  = &H2000&
const KF_REPEAT   = &H4000&
const KF_UP       = &H8000&

'
' Virtual Keys, Standard Set
'
'const VK_LBUTTON  = &H01&  ' Predefined by MS-Test
'const VK_RBUTTON  = &H02&  ' Predefined by MS-Test
'const VK_MBUTTON  = &H04&  ' Predefined by MS-Test
const VK_CANCEL   = &H03&
const VK_BACK     = &H08&
const VK_TAB      = &H09&
const VK_CLEAR    = &H0C&
const VK_RETURN   = &H0D&
const VK_SHIFT    = &H10&
const VK_CONTROL  = &H11&
const VK_MENU     = &H12&
const VK_PAUSE    = &H13&
const VK_CAPITAL  = &H14&
const VK_ESCAPE   = &H1B&
const VK_SPACE    = &H20&
const VK_PRIOR    = &H21&
const VK_NEXT     = &H22&
const VK_END      = &H23&
const VK_HOME     = &H24&
const VK_LEFT     = &H25&
const VK_UP       = &H26&
const VK_RIGHT    = &H27&
const VK_DOWN     = &H28&
const VK_SELECT   = &H29&
const VK_PRINT    = &H2A&
const VK_EXECUTE  = &H2B&
const VK_SNAPSHOT = &H2C&
const VK_INSERT   = &H2D&
const VK_DELETE   = &H2E&
const VK_HELP     = &H2F&

'  VK_0 thru VK_9 are the same as ASCII '0' thru '9' (&H30& - &H39)
'  VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' (&H41& - &H5A)

const VK_NUMPAD0   = &H60&
const VK_NUMPAD1   = &H61&
const VK_NUMPAD2   = &H62&
const VK_NUMPAD3   = &H63&
const VK_NUMPAD4   = &H64&
const VK_NUMPAD5   = &H65&
const VK_NUMPAD6   = &H66&
const VK_NUMPAD7   = &H67&
const VK_NUMPAD8   = &H68&
const VK_NUMPAD9   = &H69&
const VK_MULTIPLY  = &H6A&
const VK_ADD       = &H6B&
const VK_SEPARATOR = &H6C&
const VK_SUBTRACT  = &H6D&
const VK_DECIMAL   = &H6E&
const VK_DIVIDE    = &H6F&
const VK_F1        = &H70&
const VK_F2        = &H71&
const VK_F3        = &H72&
const VK_F4        = &H73&
const VK_F5        = &H74&
const VK_F6        = &H75&
const VK_F7        = &H76&
const VK_F8        = &H77&
const VK_F9        = &H78&
const VK_F10       = &H79&
const VK_F11       = &H7A&
const VK_F12       = &H7B&
const VK_F13       = &H7C&
const VK_F14       = &H7D&
const VK_F15       = &H7E&
const VK_F16       = &H7F&
const VK_F17       = &H80&
const VK_F18       = &H81&
const VK_F19       = &H82&
const VK_F20       = &H83&
const VK_F21       = &H84&
const VK_F22       = &H85&
const VK_F23       = &H86&
const VK_F24       = &H87&
const VK_NUMLOCK   = &H90&
const VK_SCROLL    = &H91&

'
' VK_L* & VK_R* - left and right Alt, Ctrl and Shift virtual keys.
' Used only as parameters to GetAsyncKeyState() and GetKeyState().
' No other API or message will distinguish left and right keys in this way.
'

const VK_LSHIFT    = &HA0&
const VK_RSHIFT    = &HA1&
const VK_LCONTROL  = &HA2&
const VK_RCONTROL  = &HA3&
const VK_LMENU     = &HA4&
const VK_RMENU     = &HA5&
const VK_ATTN      = &HF6&
const VK_CRSEL     = &HF7&
const VK_EXSEL     = &HF8&
const VK_EREOF     = &HF9&
const VK_PLAY      = &HFA&
const VK_ZOOM      = &HFB&
const VK_NONAME    = &HFC&
const VK_PA1       = &HFD&
const VK_OEM_CLEAR = &HFE&

'
' SetWindowsHook() codes
'

const WH_MIN             = (-1)
const WH_MSGFILTER       = (-1)
const WH_JOURNALRECORD   = 0
const WH_JOURNALPLAYBACK = 1
const WH_KEYBOARD        = 2
const WH_GETMESSAGE      = 3
const WH_CALLWNDPROC     = 4
const WH_CBT             = 5
const WH_SYSMSGFILTER    = 6
const WH_MOUSE           = 7
const WH_HARDWARE        = 8
const WH_DEBUG           = 9
const WH_SHELL           = 10
const WH_FOREGROUNDIDLE  = 11
const WH_MAX             = 11

'
' Hook Codes
'

const HC_ACTION      = 0
const HC_GETNEXT     = 1
const HC_SKIP        = 2
const HC_NOREMOVE    = 3
const HC_NOREM       = HC_NOREMOVE
const HC_SYSMODALON  = 4
const HC_SYSMODALOFF = 5

'
' CBT Hook Codes
'

const HCBT_MOVESIZE     = 0
const HCBT_MINMAX       = 1
const HCBT_QS           = 2
const HCBT_CREATEWND    = 3
const HCBT_DESTROYWND   = 4
const HCBT_ACTIVATE     = 5
const HCBT_CLICKSKIPPED = 6
const HCBT_KEYSKIPPED   = 7
const HCBT_SYSCOMMAND   = 8
const HCBT_SETFOCUS     = 9

'
' HCBT_ACTIVATE structure pointed to by lParam
'

type CBTACTIVATESTRUCT
    fMouse     as long
    hWndActive as long
end type

'
' WH_MSGFILTER Filter Proc Codes
'

const MSGF_DIALOGBOX  = 0
const MSGF_MESSAGEBOX = 1
const MSGF_MENU       = 2
const MSGF_MOVE       = 3
const MSGF_SIZE       = 4
const MSGF_SCROLLBAR  = 5
const MSGF_NEXTWINDOW = 6
const MSGF_MAINLOOP   = 8
const MSGF_MAX        = 8
const MSGF_USER       = 4096

'
' Shell support
'

const HSHELL_WINDOWCREATED       = 1
const HSHELL_WINDOWDESTROYED     = 2
const HSHELL_ACTIVATESHELLWINDOW = 3

'
' Message Structure used in Journaling
'

type EVENTMSG
    message as long
    paramL  as long
    paramH  as long
    ltime   as long
    hwnd    as long
end type

type CWPSTRUCT'
    '       * Message structure used by WH_CALLWNDPROC
    '
               lParam  as long
    wParam  as long
    message as long
    hwnd    as long
end type

'
' Structure used by WH_DEBUG
'

type DEBUGHOOKINFO
    idThread as long
    reserved as long
    lParam   as long
    wParam   as long
    code     as long
end type

type MOUSEHOOKSTRUCT
    pt           as POINT
    hwnd         as long
    wHitTestCode as long
    dwExtraInfo  as long
end type

'
' Keyboard Layout API
'

const HKL_PREV           = 0
const HKL_NEXT           = 1
const KLF_ACTIVATE       = &H00000001&
const KLF_SUBSTITUTE_OK  = &H00000002&
const KLF_UNLOADPREVIOUS = &H00000004&
const KLF_REORDER        = &H00000008&

'
' Size of KeyboardLayoutName (number of characters), including nul terminator
'

const KL_NAMELENGTH = 9

declare function LoadKeyboardLayout     lib "user32.dll" alias "LoadKeyboardLayoutA"    (pwszKLID$, Flags&) as long
declare function ActivateKeyboardLayout lib "user32.dll" alias "ActivateKeyboardLayout" (hkl as long, Flags&) as long
declare function UnloadKeyboardLayout   lib "user32.dll" alias "UnloadKeyboardLayout"   (hkl as long) as long
declare function GetKeyboardLayoutName  lib "user32.dll" alias "GetKeyboardLayoutNameA" (pwszKLID$) as long

'
' Desktop-specific access flags
'

const DESKTOP_READOBJECTS     = &H0001&
const DESKTOP_CREATEWINDOW    = &H0002&
const DESKTOP_CREATEMENU      = &H0004&
const DESKTOP_HOOKCONTROL     = &H0008&
const DESKTOP_JOURNALRECORD   = &H0010&
const DESKTOP_JOURNALPLAYBACK = &H0020&
const DESKTOP_ENUMERATE       = &H0040&
const DESKTOP_WRITEOBJECTS    = &H0080&

declare function GetThreadDesktop lib "user32.dll" alias "GetThreadDesktop" (dw&) as long

'
' Windowstation-specific access flags
'

const WINSTA_ENUMDESKTOPS      = &H0001&
const WINSTA_READATTRIBUTES    = &H0002&
const WINSTA_ACCESSCLIPBOARD   = &H0004&
const WINSTA_CREATEDESKTOP     = &H0008&
const WINSTA_WRITEATTRIBUTES   = &H0010&
const WINSTA_ACCESSGLOBALATOMS = &H0020&
const WINSTA_EXITWINDOWS       = &H0040&
const WINSTA_ENUMERATE         = &H0100&
const WINSTA_READSCREEN        = &H0200&

declare function GetProcessWindowStation lib "user32.dll" alias "GetProcessWindowStation" () as long
declare function SetUserObjectSecurity   lib "user32.dll" alias "SetUserObjectSecurity"   (hObj&, pSIRequested as pointer to long, pSID as any) as long
declare function GetUserObjectSecurity   lib "user32.dll" alias "GetUserObjectSecurity"   (hObj&, pSIRequested as pointer to long, pSID as any, nLength&, lpnLengthNeeded as pointer to long) as long

type WNDCLASS
    style         as long
    lpfnWndProc   as wndproc
    cbClsExtra    as long
    cbWndExtra    as long
    hInstance     as long
    hIcon         as long
    hCursor       as long
    hbrBackground as long
    lpszMenuName  as pointer to string * 1
    lpszClassName as pointer to string * 1
end type

'
' Message structure
'

type MSG
    hwnd    as long
    message as long
    wParam  as long
    lParam  as long
    ltime   as long
    pt      as POINT
end type

'
' Window field offsets for GetWindowLong()
'

const GWL_WNDPROC    = (-4)
const GWL_HINSTANCE  = (-6)
const GWL_HWNDPARENT = (-8)
const GWL_STYLE      = (-16)
const GWL_EXSTYLE    = (-20)
const GWL_USERDATA   = (-21)
const GWL_ID         = (-12)

'
' Class field offsets for GetClassLong()
'

const GCL_MENUNAME      = (-8)
const GCL_HBRBACKGROUND = (-10)
const GCL_HCURSOR       = (-12)
const GCL_HICON         = (-14)
const GCL_HMODULE       = (-16)
const GCL_CBWNDEXTRA    = (-18)
const GCL_CBCLSEXTRA    = (-20)
const GCL_WNDPROC       = (-24)
const GCL_STYLE         = (-26)
const GCW_ATOM          = (-32)

'
' Window Messages
'
const WM_APP      = &H8000&
const WM_NULL     = &H0000&
const WM_CREATE   = &H0001&
const WM_DESTROY  = &H0002&
const WM_MOVE     = &H0003&
const WM_SIZE     = &H0005&
const WM_ACTIVATE = &H0006&

'
' WM_ACTIVATE state values
'

const WA_INACTIVE        = 0
const WA_ACTIVE          = 1
const WA_CLICKACTIVE     = 2
const WM_SETFOCUS        = &H0007&
const WM_KILLFOCUS       = &H0008&
const WM_ENABLE          = &H000A&
const WM_SETREDRAW       = &H000B&
const WM_SETTEXT         = &H000C&
const WM_GETTEXT         = &H000D&
const WM_GETTEXTLENGTH   = &H000E&
const WM_PAINT           = &H000F&
const WM_CLOSE           = &H0010&
const WM_QUERYENDSESSION = &H0011&
const WM_QUIT            = &H0012&
const WM_QUERYOPEN       = &H0013&
const WM_ERASEBKGND      = &H0014&
const WM_SYSCOLORCHANGE  = &H0015&
const WM_ENDSESSION      = &H0016&
const WM_SHOWWINDOW      = &H0018&
const WM_WININICHANGE    = &H001A&
const WM_DEVMODECHANGE   = &H001B&
const WM_ACTIVATEAPP     = &H001C&
const WM_FONTCHANGE      = &H001D&
const WM_TIMECHANGE      = &H001E&
const WM_CANCELMODE      = &H001F&
const WM_SETCURSOR       = &H0020&
const WM_MOUSEACTIVATE   = &H0021&
const WM_CHILDACTIVATE   = &H0022&
const WM_QUEUESYNC       = &H0023&
const WM_GETMINMAXINFO   = &H0024&

'
' Struct pointed to by WM_GETMINMAXINFO lParam
'

type MINMAXINFO
    ptReserved     as POINT
    ptMaxSize      as POINT
    ptMaxPosition  as POINT
    ptMinTrackSize as POINT
    ptMaxTrackSize as POINT
end type

const WM_PAINTICON            = &H0026&
const WM_ICONERASEBKGND       = &H0027&
const WM_NEXTDLGCTL           = &H0028&
const WM_SPOOLERSTATUS        = &H002A&
const WM_DRAWITEM             = &H002B&
const WM_MEASUREITEM          = &H002C&
const WM_DELETEITEM           = &H002D&
const WM_VKEYTOITEM           = &H002E&
const WM_CHARTOITEM           = &H002F&
const WM_SETFONT              = &H0030&
const WM_GETFONT              = &H0031&
const WM_SETHOTKEY            = &H0032&
const WM_GETHOTKEY            = &H0033&
const WM_QUERYDRAGICON        = &H0037&
const WM_COMPAREITEM          = &H0039&
const WM_COMPACTING           = &H0041&
const WM_OTHERWINDOWCREATED   = &H0042& ' no longer suported
const WM_OTHERWINDOWDESTROYED = &H0043& ' no longer suported
const WM_COMMNOTIFY           = &H0044& ' no longer suported
const WM_WINDOWPOSCHANGING    = &H0046&
const WM_WINDOWPOSCHANGED     = &H0047&
const WM_POWER                = &H0048&

'
' wParam for WM_POWER window message and DRV_POWER driver notification
'

const PWR_OK             = 1
const PWR_FAIL           = (-1)
const PWR_SUSPENDREQUEST = 1
const PWR_SUSPENDRESUME  = 2
const PWR_CRITICALRESUME = 3
const WM_COPYDATA        = &H004A&
const WM_CANCELJOURNAL   = &H004B&

'
' lParam of WM_COPYDATA message points to...
'

type COPYDATASTRUCT
    dwData as long
    cbData as long
    lpData as long
end type

const WM_CONTEXTMENU       = &H007B&

const WM_NCCREATE          = &H0081&
const WM_NCDESTROY         = &H0082&
const WM_NCCALCSIZE        = &H0083&
const WM_NCHITTEST         = &H0084&
const WM_NCPAINT           = &H0085&
const WM_NCACTIVATE        = &H0086&
const WM_GETDLGCODE        = &H0087&
const WM_NCMOUSEMOVE       = &H00A0&
const WM_NCLBUTTONDOWN     = &H00A1&
const WM_NCLBUTTONUP       = &H00A2&
const WM_NCLBUTTONDBLCLK   = &H00A3&
const WM_NCRBUTTONDOWN     = &H00A4&
const WM_NCRBUTTONUP       = &H00A5&
const WM_NCRBUTTONDBLCLK   = &H00A6&
const WM_NCMBUTTONDOWN     = &H00A7&
const WM_NCMBUTTONUP       = &H00A8&
const WM_NCMBUTTONDBLCLK   = &H00A9&
const WM_KEYFIRST          = &H0100&
const WM_KEYDOWN           = &H0100&
const WM_KEYUP             = &H0101&
const WM_CHAR              = &H0102&
const WM_DEADCHAR          = &H0103&
const WM_SYSKEYDOWN        = &H0104&
const WM_SYSKEYUP          = &H0105&
const WM_SYSCHAR           = &H0106&
const WM_SYSDEADCHAR       = &H0107&
const WM_KEYLAST           = &H0108&
const WM_INITDIALOG        = &H0110&
const WM_COMMAND           = &H0111&
const WM_SYSCOMMAND        = &H0112&
const WM_TIMER             = &H0113&
const WM_HSCROLL           = &H0114&
const WM_VSCROLL           = &H0115&
const WM_INITMENU          = &H0116&
const WM_INITMENUPOPUP     = &H0117&
const WM_MENUSELECT        = &H011F&
const WM_MENUCHAR          = &H0120&
const WM_ENTERIDLE         = &H0121&
const WM_CTLCOLORMSGBOX    = &H0132&
const WM_CTLCOLOREDIT      = &H0133&
const WM_CTLCOLORLISTBOX   = &H0134&
const WM_CTLCOLORBTN       = &H0135&
const WM_CTLCOLORDLG       = &H0136&
const WM_CTLCOLORSCROLLBAR = &H0137&
const WM_CTLCOLORSTATIC    = &H0138&
const WM_MOUSEFIRST        = &H0200&
const WM_MOUSEMOVE         = &H0200&
const WM_LBUTTONDOWN       = &H0201&
const WM_LBUTTONUP         = &H0202&
const WM_LBUTTONDBLCLK     = &H0203&
const WM_RBUTTONDOWN       = &H0204&
const WM_RBUTTONUP         = &H0205&
const WM_RBUTTONDBLCLK     = &H0206&
const WM_MBUTTONDOWN       = &H0207&
const WM_MBUTTONUP         = &H0208&
const WM_MBUTTONDBLCLK     = &H0209&
const WM_MOUSELAST         = &H0209&
const WM_PARENTNOTIFY      = &H0210&
const WM_ENTERMENULOOP     = &H0211&
const WM_EXITMENULOOP      = &H0212&
const WM_MDICREATE         = &H0220&
const WM_MDIDESTROY        = &H0221&
const WM_MDIACTIVATE       = &H0222&
const WM_MDIRESTORE        = &H0223&
const WM_MDINEXT           = &H0224&
const WM_MDIMAXIMIZE       = &H0225&
const WM_MDITILE           = &H0226&
const WM_MDICASCADE        = &H0227&
const WM_MDIICONARRANGE    = &H0228&
const WM_MDIGETACTIVE      = &H0229&
const WM_MDISETMENU        = &H0230&
const WM_DROPFILES         = &H0233&
const WM_MDIREFRESHMENU    = &H0234&
const WM_CUT               = &H0300&
const WM_COPY              = &H0301&
const WM_PASTE             = &H0302&
const WM_CLEAR             = &H0303&
const WM_UNDO              = &H0304&
const WM_RENDERFORMAT      = &H0305&
const WM_RENDERALLFORMATS  = &H0306&
const WM_DESTROYCLIPBOARD  = &H0307&
const WM_DRAWCLIPBOARD     = &H0308&
const WM_PAINTCLIPBOARD    = &H0309&
const WM_VSCROLLCLIPBOARD  = &H030A&
const WM_SIZECLIPBOARD     = &H030B&
const WM_ASKCBFORMATNAME   = &H030C&
const WM_CHANGECBCHAIN     = &H030D&
const WM_HSCROLLCLIPBOARD  = &H030E&
const WM_QUERYNEWPALETTE   = &H030F&
const WM_PALETTEISCHANGING = &H0310&
const WM_PALETTECHANGED    = &H0311&
const WM_HOTKEY            = &H0312&
const WM_PENWINFIRST       = &H0380&
const WM_PENWINLAST        = &H038F&

'
' NOTE: All Message Numbers below &H0400& are RESERVED.
'
' Private Window Messages Start Here:
'

const WM_USER = &H0400&

'
' WM_SYNCTASK Commands
'

const ST_BEGINSWP = 0
const ST_ENDSWP   = 1

'
' WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
'

const HTERROR       = (-2)
const HTTRANSPARENT = (-1)
const HTNOWHERE     = 0
const HTCLIENT      = 1
const HTCAPTION     = 2
const HTSYSMENU     = 3
const HTGROWBOX     = 4
const HTSIZE        = HTGROWBOX
const HTMENU        = 5
const HTHSCROLL     = 6
const HTVSCROLL     = 7
const HTMINBUTTON   = 8
const HTMAXBUTTON   = 9
const HTLEFT        = 10
const HTRIGHT       = 11
const HTTOP         = 12
const HTTOPLEFT     = 13
const HTTOPRIGHT    = 14
const HTBOTTOM      = 15
const HTBOTTOMLEFT  = 16
const HTBOTTOMRIGHT = 17
const HTBORDER      = 18
const HTREDUCE      = HTMINBUTTON
const HTZOOM        = HTMAXBUTTON
const HTSIZEFIRST   = HTLEFT
const HTSIZELAST    = HTBOTTOMRIGHT

'
' SendMessageTimeout values
'

const SMTO_NORMAL      = &H0000&
const SMTO_BLOCK       = &H0001&
const SMTO_ABORTIFHUNG = &H0002&

'
' WM_MOUSEACTIVATE Return Codes
'

const MA_ACTIVATE         = 1
const MA_ACTIVATEANDEAT   = 2
const MA_NOACTIVATE       = 3
const MA_NOACTIVATEANDEAT = 4

declare function RegisterWindowMessage lib "user32.dll" alias "RegisterWindowMessageA" (lpString$) as long

'
' WM_SIZE message wParam values
'

const SIZE_RESTORED  = 0
const SIZE_MINIMIZED = 1
const SIZE_MAXIMIZED = 2
const SIZE_MAXSHOW   = 3
const SIZE_MAXHIDE   = 4

'
' Obsolete constant names
'

const SIZENORMAL     = SIZE_RESTORED
const SIZEICONIC     = SIZE_MINIMIZED
const SIZEFULLSCREEN = SIZE_MAXIMIZED
const SIZEZOOMSHOW   = SIZE_MAXSHOW
const SIZEZOOMHIDE   = SIZE_MAXHIDE

'
' WM_WINDOWPOSCHANGING/CHANGED struct pointed to by lParam
'

type WINDOWPOS
    hwnd            as long
    hwndInsertAfter as long
    x               as long
    y               as long
    cx              as long
    cy              as long
    flags           as long
end type

'
' WM_NCCALCSIZE parameter structure
'

type NCCALCSIZE_PARAMS
    '     RECT rgrc[3];
    rgrc  as RECT
    lppos as pointer to WINDOWPOS
end type

'
' WM_NCCALCSIZE "window valid rect" return values
'

const WVR_ALIGNTOP    = &H0010&
const WVR_ALIGNLEFT   = &H0020&
const WVR_ALIGNBOTTOM = &H0040&
const WVR_ALIGNRIGHT  = &H0080&
const WVR_HREDRAW     = &H0100&
const WVR_VREDRAW     = &H0200&
const WVR_REDRAW      = (WVR_HREDRAW or WVR_VREDRAW)
const WVR_VALIDRECTS  = &H0400&

'
' Key State Masks for Mouse Messages
'

const MK_LBUTTON = &H0001&
const MK_RBUTTON = &H0002&
const MK_SHIFT   = &H0004&
const MK_CONTROL = &H0008&
const MK_MBUTTON = &H0010&

'
' Window Styles
'

const WS_OVERLAPPED   = &H00000000&
const WS_POPUP        = &H80000000&
const WS_CHILD        = &H40000000&
const WS_MINIMIZE     = &H20000000&
const WS_VISIBLE      = &H10000000&
const WS_DISABLED     = &H08000000&
const WS_CLIPSIBLINGS = &H04000000&
const WS_CLIPCHILDREN = &H02000000&
const WS_MAXIMIZE     = &H01000000&
const WS_CAPTION      = &H00C00000& ' WS_BORDER or WS_DLGFRAME
const WS_BORDER       = &H00800000&
const WS_DLGFRAME     = &H00400000&
const WS_VSCROLL      = &H00200000&
const WS_HSCROLL      = &H00100000&
const WS_SYSMENU      = &H00080000&
const WS_THICKFRAME   = &H00040000&
const WS_GROUP        = &H00020000&
const WS_TABSTOP      = &H00010000&
const WS_MINIMIZEBOX  = &H00020000&
const WS_MAXIMIZEBOX  = &H00010000&
const WS_TILED        = WS_OVERLAPPED
const WS_ICONIC       = WS_MINIMIZE
const WS_SIZEBOX      = WS_THICKFRAME

'
' Common Window Styles
'

const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX)
const WS_POPUPWINDOW      = (WS_POPUP or WS_BORDER or WS_SYSMENU)
const WS_CHILDWINDOW      = (WS_CHILD)

const WS_TILEDWINDOW  = WS_OVERLAPPEDWINDOW

'
' Extended Window Styles
'
const WS_EX_DLGMODALFRAME     = &h00000001&
const WS_EX_NOPARENTNOTIFY    = &h00000004&
const WS_EX_TOPMOST           = &h00000008&
const WS_EX_ACCEPTFILES       = &h00000010&
const WS_EX_TRANSPARENT       = &h00000020&
const WS_EX_MDICHILD          = &h00000040&
const WS_EX_TOOLWINDOW        = &h00000080&
const WS_EX_WINDOWEDGE        = &h00000100&
const WS_EX_CLIENTEDGE        = &h00000200&
const WS_EX_CONTEXTHELP       = &h00000400&
const WS_EX_RIGHT             = &h00001000&
const WS_EX_LEFT              = &h00000000&
const WS_EX_RTLREADING        = &h00002000&
const WS_EX_LTRREADING        = &h00000000&
const WS_EX_LEFTSCROLLBAR     = &h00004000&
const WS_EX_RIGHTSCROLLBAR    = &h00000000&
const WS_EX_CONTROLPARENT     = &h00010000&
const WS_EX_STATICEDGE        = &h00020000&
const WS_EX_APPWINDOW         = &h00040000&

const WS_EX_OVERLAPPEDWINDOW  = (WS_EX_WINDOWEDGE or WS_EX_CLIENTEDGE)
const WS_EX_PALETTEWINDOW     = (WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW or WS_EX_TOPMOST)

'
' Class styles
'

const CS_VREDRAW         = &H0001&
const CS_HREDRAW         = &H0002&
const CS_KEYCVTWINDOW    = &H0004&
const CS_DBLCLKS         = &H0008&
const CS_OWNDC           = &H0020&
const CS_CLASSDC         = &H0040&
const CS_PARENTDC        = &H0080&
const CS_NOKEYCVT        = &H0100&
const CS_NOCLOSE         = &H0200&
const CS_SAVEBITS        = &H0800&
const CS_BYTEALIGNCLIENT = &H1000&
const CS_BYTEALIGNWINDOW = &H2000&
const CS_GLOBALCLASS     = &H4000&

'
' Predefined Clipboard Formats
'
const CF_TEXT            = 1
const CF_BITMAP          = 2
const CF_METAFILEPICT    = 3
const CF_SYLK            = 4
const CF_DIF             = 5
const CF_TIFF            = 6
const CF_OEMTEXT         = 7
const CF_DIB             = 8
const CF_PALETTE         = 9
const CF_PENDATA         = 10
const CF_RIFF            = 11
const CF_WAVE            = 12

const CF_UNICODETEXT     = 13
const CF_ENHMETAFILE     = 14
const CF_OWNERDISPLAY    = &H0080&
const CF_DSPTEXT         = &H0081&
const CF_DSPBITMAP       = &H0082&
const CF_DSPMETAFILEPICT = &H0083&
const CF_DSPENHMETAFILE  = &H008E&

'
' "Private" formats don't get GlobalFree()'d
'

const CF_PRIVATEFIRST = &H0200&
const CF_PRIVATELAST  = &H02FF&

'
' "GDIOBJ" formats do get DeleteObject()'d
'

const CF_GDIOBJFIRST = &H0300&
const CF_GDIOBJLAST  = &H03FF&

'
' Defines for the fVirt field of the Accelerator table structure.
'
' Predefined by MS-Test in NOTIFY.INC
'const FVIRTKEY  = TRUE ' Assumed to be == TRUE
'const FNOINVERT = &H02&
'const FSHIFT    = &H04&
'const FCONTROL  = &H08&
'const FALT      = &H10&

type ACCEL
    fVirt as string * 1 ' Also called the flags field
    key   as short
    cmd   as short
end type

type PAINTSTRUCT
    hdc         as long
    fErase      as long
    rcPaint     as RECT
    fRestore    as long
    fIncUpdate  as long
    rgbReserved as string * 32
end type

type CREATESTRUCT
    lpCreateParams as long
    hInstance      as long
    hMenu          as long
    hwndParent     as long
    cy             as long
    cx             as long
    y              as long
    x              as long
    style          as long
    lpszName       as pointer to string * 1
    lpszClass      as pointer to string * 1
    dwExStyle      as long
end type

type WINDOWPLACEMENT
    length           as long
    flags            as long
    showCmd          as long
    ptMinPosition    as POINT
    ptMaxPosition    as POINT
    rcNormalPosition as RECT
end type

const WPF_SETMINPOSITION     = &H0001&
const WPF_RESTORETOMAXIMIZED = &H0002&

'
' HCBT_CREATEWND parameters pointed to by lParam
'

type CBT_CREATEWND
    lpcs            as pointer to CREATESTRUCT
    hwndInsertAfter as long
end type


'
' Owner draw control types
'

const ODT_MENU     = 1
const ODT_LISTBOX  = 2
const ODT_COMBOBOX = 3
const ODT_BUTTON   = 4

'
' Owner draw actions
'

const ODA_DRAWENTIRE = &H0001&
const ODA_SELECT     = &H0002&
const ODA_FOCUS      = &H0004&

'
' Owner draw state
'

const ODS_SELECTED = &H0001&
const ODS_GRAYED   = &H0002&
const ODS_DISABLED = &H0004&
const ODS_CHECKED  = &H0008&
const ODS_FOCUS    = &H0010&

'
' MEASUREITEMSTRUCT for ownerdraw
'

type MEASUREITEMSTRUCT
    CtlType    as long
    CtlID      as long
    itemID     as long
    itemWidth  as long
    itemHeight as long
    itemData   as long
end type

'
' DRAWITEMSTRUCT for ownerdraw
'

type DRAWITEMSTRUCT
    CtlType    as long
    CtlID      as long
    itemID     as long
    itemAction as long
    itemState  as long
    hwndItem   as long
    hDC        as long
    rcItem     as RECT
    itemData   as long
end type

'
' DELETEITEMSTRUCT for ownerdraw
'

type DELETEITEMSTRUCT
    CtlType  as long
    CtlID    as long
    itemID   as long
    hwndItem as long
    itemData as long
end type

'
' COMPAREITEMSTUCT for ownerdraw sorting
'

type COMPAREITEMSTRUCT
    CtlType    as long
    CtlID      as long
    hwndItem   as long
    itemID1    as long
    itemData1  as long
    itemID2    as long
    itemData2  as long
    dwLocaleId as long
end type

'
' Message Function Templates
'

declare function GetMessage lib "user32.dll" alias "GetMessageA" (lpMsg as MSG, hWnd&, wMsgFilterMin&, wMsgFilterMax&) as long

'
' Message Function Templates
'

declare function TranslateMessage lib "user32.dll" alias "TranslateMessage" (lp as MSG) as long
declare function DispatchMessage  lib "user32.dll" alias "DispatchMessageA" (lp as MSG) as long
declare function SetMessageQueue  lib "user32.dll" alias "SetMessageQueue"  (cMessagesMax&) as long
declare function PeekMessage      lib "user32.dll" alias "PeekMessageA"     (lpMsg as MSG, hWnd&, wMsgFilterMin&, wMsgFilterMax&, wRemoveMsg&) as long

'
' PeekMessage() Options
'

const PM_NOREMOVE = &H0000&
const PM_REMOVE   = &H0001&
const PM_NOYIELD  = &H0002&

declare function RegisterHotKey   lib "user32.dll" alias "RegisterHotKey"   (hWnd&, id&, fsModifiers&, vk&) as long
declare function UnregisterHotKey lib "user32.dll" alias "UnregisterHotKey" (hWnd&, id&) as long

const MOD_ALT           = &H0001&
const MOD_CONTROL       = &H0002&
const MOD_SHIFT         = &H0004&
const IDHOT_SNAPWINDOW  = (-1) ' SHIFT-PRINTSCRN
const IDHOT_SNAPDESKTOP = (-2) ' PRINTSCRN
const EWX_LOGOFF        = 0
const EWX_SHUTDOWN      = 1
const EWX_REBOOT        = 2
const EWX_FORCE         = 4

declare function ExitWindowsEx       lib "user32.dll" alias "ExitWindowsEx"       (uFlags&, dwReserved&) as long
declare function SwapMouseButton     lib "user32.dll" alias "SwapMouseButton"     (fSwap&) as long
declare function GetMessagePos       lib "user32.dll" alias "GetMessagePos"       () as long
declare function GetMessageTime      lib "user32.dll" alias "GetMessageTime"      () as long
declare function GetMessageExtraInfo lib "user32.dll" alias "GetMessageExtraInfo" () as long
declare function SendMessage         lib "user32.dll" alias "SendMessageA"        (hWnd&, Msg&, lp as any, lp as any) as long
declare function SendMessageTimeout  lib "user32.dll" alias "SendMessageTimeoutA" (hWnd&, Msg&, lp as any, lp as any, fuFlags&, uTimeout&, lpdwResult as pointer to long) as long
declare function SendNotifyMessage   lib "user32.dll" alias "SendNotifyMessageA"  (hWnd&, Msg&, lp as any, lp as any) as long
declare function SendMessageCallback lib "user32.dll" alias "SendMessageCallbackA" (hWnd&, Msg&, lp as any, lp as any, lpResultCallBack as pointer to sub (hWnd&, msg&, dwData&, lResult&), dwData&) as long
declare function PostMessage         lib "user32.dll" alias "PostMessageA"        (hWnd&, Msg&, lp as any, lp as any) as long
declare function PostThreadMessage   lib "user32.dll" alias "PostThreadMessageA"  (idThread&, Msg&, lp as any, lp as any) as long

'
' Special HWND value for use with PostMessage() and SendMessage()
'

const HWND_BROADCAST = (&Hffff)

declare function AttachThreadInput  lib "user32.dll" alias "AttachThreadInput"  (idAttach&, idAttachTo&, fAttach&) as long
declare sub      ReplyMessage       lib "user32.dll" alias "ReplyMessage"       (lResult&)
declare sub      WaitMessage        lib "user32.dll" alias "WaitMessage"        ()
declare function WaitForInputIdle   lib "user32.dll" alias "WaitForInputIdle"   (hProcess&, dwMilliseconds&) as long
declare function DefWindowProc      lib "user32.dll" alias "DefWindowProcA"     (hWnd&, Msg&, wParam&, lParam&) as long
declare sub      PostQuitMessage    lib "user32.dll" alias "PostQuitMessage"    (nExitCode&)
declare function CallWindowProc     lib "user32.dll" alias "CallWindowProcA"    (lpPrevWndFunc as wndproc, hWnd&, Msg&, wParam&, lp as any) as long
declare function InSendMessage      lib "user32.dll" alias "InSendMessage"      () as long
declare function GetDoubleClickTime lib "user32.dll" alias "GetDoubleClickTime" () as long
declare sub      SetDoubleClickTime lib "user32.dll" alias "SetDoubleClickTime" (u&)
declare function RegisterClass      lib "user32.dll" alias "RegisterClassA"     (lp as WNDCLASS) as short
declare function UnregisterClass    lib "user32.dll" alias "UnregisterClassA"   (lpClassName$, hInstance&) as long
declare function GetClassInfo       lib "user32.dll" alias "GetClassInfoA"      (hInstance&, lpClassName$, lpWndClass as WNDCLASS) as long

const CW_USEDEFAULT = (&H80000000)

'
' Special value for CreateWindow, et al.
'

const HWND_DESKTOP = (0)

declare function CreateWindow        lib "user32.dll" alias "CreateWindowA"       (lpClassName$, lpWindowName$, dwStyle&, X&, Y&, nWidth&, nHeight&, hWndParent&, hMenu&, hInstance&, lpParam as any) as long
declare function CreateWindowEx      lib "user32.dll" alias "CreateWindowExA"     (dwExStyle&, lpClassName$, lpWindowName$, dwStyle&, X&, Y&, nWidth&, nHeight&, hWndParent&, hMenu&, hInstance&, lpParam as any) as long
declare function IsWindow            lib "user32.dll" alias "IsWindow"            (hWnd&) as long
declare function IsMenu              lib "user32.dll" alias "IsMenu"              (hMenu&) as long
declare function IsChild             lib "user32.dll" alias "IsChild"             (hWndParent&, hWnd&) as long
declare function DestroyWindow       lib "user32.dll" alias "DestroyWindow"       (hWnd&) as long
declare function ShowWindow          lib "user32.dll" alias "ShowWindow"          (hWnd&, nCmdShow&) as long
declare function FlashWindow         lib "user32.dll" alias "FlashWindow"         (hWnd&, bInvert&) as long
declare sub      ShowOwnedPopups     lib "user32.dll" alias "ShowOwnedPopups"     (hWnd&, fShow&)
declare function OpenIcon            lib "user32.dll" alias "OpenIcon"            (hWnd&) as long
declare sub      CloseWindow         lib "user32.dll" alias "CloseWindow"         (hWnd&)
declare function MoveWindow          lib "user32.dll" alias "MoveWindow"          (hWnd&, X&, Y&, nWidth&, nHeight&, bRepaint&) as long
declare function SetWindowPos        lib "user32.dll" alias "SetWindowPos"        (hWnd&, hWndInsertAfter&, X&, Y&, cx&, cy&, uFlags&) as long
declare function GetWindowPlacement  lib "user32.dll" alias "GetWindowPlacement"  (hWnd&, lp as WINDOWPLACEMENT) as long
declare function SetWindowPlacement  lib "user32.dll" alias "SetWindowPlacement"  (hWnd&, lp as WINDOWPLACEMENT) as long
declare function BeginDeferWindowPos lib "user32.dll" alias "BeginDeferWindowPos" (nNumWindows&) as long
declare function DeferWindowPos      lib "user32.dll" alias "DeferWindowPos"      (hWinPosInfo&, hWnd&, hWndInsertAfter&, x&, y&, cx&, cy&, uFlags&) as long
declare function EndDeferWindowPos   lib "user32.dll" alias "EndDeferWindowPos"   (hWinPosInfo&) as long
declare function IsWindowVisible     lib "user32.dll" alias "IsWindowVisible"     (hWnd&) as long
declare function IsIconic            lib "user32.dll" alias "IsIconic"            (hWnd&) as long
declare function AnyPopup            lib "user32.dll" alias "AnyPopup"            () as long
declare function BringWindowToTop    lib "user32.dll" alias "BringWindowToTop"    (hWnd&) as long
declare function IsZoomed            lib "user32.dll" alias "IsZoomed"            (hWnd&) as long

'
' SetWindowPos Flags
'

const SWP_NOSIZE        = &H0001&
const SWP_NOMOVE        = &H0002&
const SWP_NOZORDER      = &H0004&
const SWP_NOREDRAW      = &H0008&
const SWP_NOACTIVATE    = &H0010&
const SWP_FRAMECHANGED  = &H0020& ' The frame changed: send WM_NCCALCSIZE
const SWP_SHOWWINDOW    = &H0040&
const SWP_HIDEWINDOW    = &H0080&
const SWP_NOCOPYBITS    = &H0100&
const SWP_NOOWNERZORDER = &H0200& ' Don't do owner Z ordering
const SWP_DRAWFRAME     = SWP_FRAMECHANGED
const SWP_NOREPOSITION  = SWP_NOOWNERZORDER
const HWND_TOP          = (0)
const HWND_BOTTOM       = (1)
const HWND_TOPMOST      = (-1)
const HWND_NOTOPMOST    = (-2)

'
' WARNING:
' The following structures must NOT be DWORD padded because they are
' followed by strings, etc that do not have to be DWORD aligned.
'

type DLGTEMPLATE
    style           as long
    dwExtendedStyle as long
    cdit            as short
    x               as short
    y               as short
    cx              as short
    cy              as short
end type

'
' Dialog item template (dit)
'

type DLGITEMTEMPLATE
    style           as long
    dwExtendedStyle as long
    x               as short
    y               as short
    cx              as short
    cy              as short
    id              as short
end type

declare function CreateDialogParam         lib "user32.dll" alias "CreateDialogParamA"        (hInstance&, lpTemplateName$, hWndParent&, lpDialogFunc as dlgproc, dwInitParam&) as long
declare function CreateDialogIndirectParam lib "user32.dll" alias "CreateDialogIndirectParamA" (hInstance&, lpTemplate as DLGTEMPLATE, hWndParent&, lpDialogFunc as dlgproc, dwInitParam&) as long
declare function DialogBoxParam            lib "user32.dll" alias "DialogBoxParamA"           (hInstance&, lpTemplateName$, hWndParent&, lpDialogFunc as dlgproc, dwInitParam&) as long
declare function DialogBoxIndirectParam    lib "user32.dll" alias "DialogBoxIndirectParamA"   (hInstance&, hDialogTemplate as DLGTEMPLATE, hWndParent&, lpDialogFunc as dlgproc, dwInitParam&) as long
declare Sub      EndDialog                 lib "user32.dll" alias "EndDialog"                 (hDlg&, nResult&)
declare function GetDlgItem                lib "user32.dll" alias "GetDlgItem"                (hDlg&, nIDDlgItem&) as long
declare sub      SetDlgItemInt             lib "user32.dll" alias "SetDlgItemInt"             (hDlg&, nIDDlgItem&, uValue&, bSigned&)
declare function GetDlgItemInt             lib "user32.dll" alias "GetDlgItemInt"             (hDlg&, nIDDlgItem&, pi as pointer to long, bSigned&) as long
declare Sub      SetDlgItemText            lib "user32.dll" alias "SetDlgItemTextA"           (hDlg&, nIDDlgItem&, lpString$)
declare function GetDlgItemText            lib "user32.dll" alias "GetDlgItemTextA"           (hDlg&, nIDDlgItem&, lpString$, nMaxCount&) as long
declare Sub      CheckDlgButton            lib "user32.dll" alias "CheckDlgButton"            (hDlg&, nIDButton&, uCheck&)
declare sub      CheckRadioButton          lib "user32.dll" alias "CheckRadioButton"          (hDlg&, nIDFirstButton&, nIDLastButton&, nIDCheckButton&)
declare function IsDlgButtonChecked        lib "user32.dll" alias "IsDlgButtonChecked"        (hDlg&, nIDButton&) as long
declare function SendDlgItemMessage        lib "user32.dll" alias "SendDlgItemMessageA"       (hDlg&, nIDDlgItem&, Msg&, wParam&, lp as any) as long
declare function GetNextDlgGroupItem       lib "user32.dll" alias "GetNextDlgGroupItem"       (hDlg&, hCtl&, bPrevious&) as long
declare function GetNextDlgTabItem         lib "user32.dll" alias "GetNextDlgTabItem"         (hDlg&, hCtl&, bPrevious&) as long
declare function GetDlgCtrlID              lib "user32.dll" alias "GetDlgCtrlID"              (hWnd&) as long
declare function GetDialogBaseUnits        lib "user32.dll" alias "GetDialogBaseUnits"        () as long
declare function DefDlgProc                lib "user32.dll" alias "DefDlgProcA"               (hDlg&, Msg&, wParam&, lp as any) as long

'
' Window extra byted needed for private dialog classes.
'

const DLGWINDOWEXTRA = 30

declare function CallMsgFilter lib "user32.dll" alias "CallMsgFilterA" (lpMsg as MSG, nCode&) as long

'
' Clipboard Manager Functions
'

declare function OpenClipboard              lib "user32.dll" alias "OpenClipboard"              (hWndNewOwner&) as long
declare function CloseClipboard             lib "user32.dll" alias "CloseClipboard"             () as long
declare function GetClipboardOwner          lib "user32.dll" alias "GetClipboardOwner"          () as long
declare function SetClipboardViewer         lib "user32.dll" alias "SetClipboardViewer"         (hWndNewViewer&) as long
declare function GetClipboardViewer         lib "user32.dll" alias "GetClipboardViewer"         () as long
declare function ChangeClipboardChain       lib "user32.dll" alias "ChangeClipboardChain"       (hWndRemove&, hWndNewNext&) as long
declare function SetClipboardData           lib "user32.dll" alias "SetClipboardData"           (uFormat&, hMem&) as long
declare function GetClipboardData           lib "user32.dll" alias "GetClipboardData"           (uFormat&) as long
declare function RegisterClipboardFormat    lib "user32.dll" alias "RegisterClipboardFormatA"   (lpszFormat$) as long
declare function CountClipboardFormats      lib "user32.dll" alias "CountClipboardFormats"      () as long
declare function EnumClipboardFormats       lib "user32.dll" alias "EnumClipboardFormats"       (rformat&) as long
declare function GetClipboardFormatName     lib "user32.dll" alias "GetClipboardFormatNameA"    (rformat&, lpszFormatName$, cchMaxCount&) as long
declare function EmptyClipboard             lib "user32.dll" alias "EmptyClipboard"             () as long
declare function IsClipboardFormatAvailable lib "user32.dll" alias "IsClipboardFormatAvailable" (rformat&) as long
declare function GetPriorityClipboardFormat lib "user32.dll" alias "GetPriorityClipboardFormat" (pu as pointer to long, cFormats&) as long
declare function GetOpenClipboardWindow     lib "user32.dll" alias "GetOpenClipboardWindow"     () as long

'
' Character Translation Routines
'

declare function CharToOem     lib "user32.dll" alias "CharToOemA"     (lpszSrc$, lpszDst$) as long
declare function OemToChar     lib "user32.dll" alias "OemToCharA"     (lpszSrc$, lpszDst$) as long
declare function CharToOemBuff lib "user32.dll" alias "CharToOemBuffA" (lpszSrc$, lpszDst$, cchDstLength&) as long
declare function OemToCharBuff lib "user32.dll" alias "OemToCharBuffA" (lpszSrc$, lpszDst$, cchDstLength&) as long
declare function CharUpper     lib "user32.dll" alias "CharUpperA"     (lpsz$) as long
declare function CharUpperBuff lib "user32.dll" alias "CharUpperBuffA" (lpsz$, cchLength&) as long
declare function CharLower     lib "user32.dll" alias "CharLowerA"     (lpsz$) as long
declare function CharLowerBuff lib "user32.dll" alias "CharLowerBuffA" (lpsz$, cchLength&) as long
declare function CharNext      lib "user32.dll" alias "CharNextA"      (lpsz$) as long
declare function CharPrev      lib "user32.dll" alias "CharPrevA"      (lpszStart$, lpszCurrent$) as long

'
' Compatibility defines for character translation routines
'

declare sub      AnsiToOem     lib "user32.dll" alias "CharToOemA"     (lpszSrc$, lpszDst$)
declare sub      OemToAnsi     lib "user32.dll" alias "OemToCharA"     (lpszSrc$, lpszDst$)
declare sub      AnsiToOemBuff lib "user32.dll" alias "CharToOemBuffA" (lpszSrc$, lpszDst$, cchDstLength&)
declare sub      OemToAnsiBuff lib "user32.dll" alias "OemToCharBuffA" (lpszSrc$, lpszDst$, cchDstLength&)
declare function AnsiUpper     lib "user32.dll" alias "CharUpperA"     (lpsz$) as long
declare function AnsiUpperBuff lib "user32.dll" alias "CharUpperBuffA" (lpsz$, cchLength&) as long
declare function AnsiLower     lib "user32.dll" alias "CharLowerA"     (lpsz$) as long
declare function AnsiLowerBuff lib "user32.dll" alias "CharLowerBuffA" (lpsz$, cchLength&) as long
declare function AnsiNext      lib "user32.dll" alias "CharNextA"      (lpsz$) as long
declare function AnsiPrev      lib "user32.dll" alias "CharPrevA"      (lpszStart$, lpszCurrent$) as long

'
' Language dependent Routines
'

declare function IsCharAlpha        lib "user32.dll" alias "IsCharAlphaA"       (ch as short) as long
declare function IsCharAlphaNumeric lib "user32.dll" alias "IsCharAlphaNumericA" (ch as short) as long
declare function IsCharUpper        lib "user32.dll" alias "IsCharUpperA"       (ch as short) as long
declare function IsCharLower        lib "user32.dll" alias "IsCharLowerA"       (ch as short) as long
declare function SetFocus           lib "user32.dll" alias "SetFocus"           (hWnd&) as long
declare function GetActiveWindow    lib "user32.dll" alias "GetActiveWindow"    () as long
declare function GetFocus           lib "user32.dll" alias "GetFocus"           () as long
declare function GetKBCodePage      lib "user32.dll" alias "GetKBCodePage"      () as long
declare function GetKeyState        lib "user32.dll" alias "GetKeyState"        (nVirtKey&) as short
declare function GetAsyncKeyState   lib "user32.dll" alias "GetAsyncKeyState"   (vKey&) as short
declare Sub      GetKeyboardState   lib "user32.dll" alias "GetKeyboardState"   (lpKeyState as any)
declare Sub      SetKeyboardState   lib "user32.dll" alias "SetKeyboardState"   (lpKeyState  as any)
declare function GetKeyNameText     lib "user32.dll" alias "GetKeyNameTextA"    (lParam&, lpString$, nSize&) as long
declare function GetKeyboardType    lib "user32.dll" alias "GetKeyboardType"    (nTypeFlag&) as long
declare function ToAscii            lib "user32.dll" alias "ToAscii"            (uVirtKey&, uScanCode&, lpKeyState$, lpChar as pointer to short, uFlags&) as long
declare function ToUnicode          lib "user32.dll" alias "ToUnicode"          (wVirtKey&, wScanCode&, lpKeyState$, pwszBuff$, cchBuff&, wFlags&) as long
declare function OemKeyScan         lib "user32.dll" alias "OemKeyScan"         (wOemChar as short) as long
declare function VkKeyScan          lib "user32.dll" alias "VkKeyScanA"         (ch as short) as short

const KEYEVENTF_EXTENDEDKEY = &H0001&
const KEYEVENTF_KEYUP       = &H0002&

declare sub      keybd_event lib "user32.dll" alias "keybd_event" (bVk as short, bScan as short, dwFlags&, dwExtraInfo&)

const MOUSEEVENTF_MOVE       = &H0001& ' mouse move
const MOUSEEVENTF_LEFTDOWN   = &H0002& ' left button down
const MOUSEEVENTF_LEFTUP     = &H0004& ' left button up
const MOUSEEVENTF_RIGHTDOWN  = &H0008& ' right button down
const MOUSEEVENTF_RIGHTUP    = &H0010& ' right button up
const MOUSEEVENTF_MIDDLEDOWN = &H0020& ' middle button down
const MOUSEEVENTF_MIDDLEUP   = &H0040& ' middle button up
const MOUSEEVENTF_ABSOLUTE   = &H8000& ' absolute move

declare sub      mouse_event               lib "user32.dll" alias "mouse_event"               (dwFlags&, dx&, dy&, cButtons&, dwExtraInfo&)
declare function MapVirtualKey             lib "user32.dll" alias "MapVirtualKeyA"            (uCode&, uMapType&) as long
declare function GetInputState             lib "user32.dll" alias "GetInputState"             () as long
declare function GetQueueStatus            lib "user32.dll" alias "GetQueueStatus"            (flags&) as long
declare function GetCapture                lib "user32.dll" alias "GetCapture"                () as long
declare function SetCapture                lib "user32.dll" alias "SetCapture"                (hWnd&) as long
declare sub      ReleaseCapture            lib "user32.dll" alias "ReleaseCapture"            ()
declare function MsgWaitForMultipleObjects lib "user32.dll" alias "MsgWaitForMultipleObjects" (nCount&, pHandles as pointer to long, fWaitAll&, dwMilliseconds&, dwWakeMask&) as long

'
' Queue status flags for GetQueueStatus() and MsgWaitForMultipleObjects()
'

const QS_KEY         = &H01&
const QS_MOUSEMOVE   = &H02&
const QS_MOUSEBUTTON = &H04&
const QS_POSTMESSAGE = &H08&
const QS_TIMER       = &H10&
const QS_PAINT       = &H20&
const QS_SENDMESSAGE = &H40&
const QS_HOTKEY      = &H80&
const QS_MOUSE       = (QS_MOUSEMOVE or QS_MOUSEBUTTON)
const QS_INPUT       = (QS_MOUSE or QS_KEY)
const QS_ALLEVENTS   = (QS_INPUT or QS_POSTMESSAGE or QS_TIMER or QS_PAINT or QS_HOTKEY)
const QS_ALLINPUT    = (QS_SENDMESSAGE or QS_PAINT or QS_TIMER or QS_POSTMESSAGE or QS_MOUSEBUTTON or QS_MOUSEMOVE or QS_HOTKEY or QS_KEY)

'
' Windows Functions
'
type TIMERPROC as pointer to Sub stdcall (hwnd&, msg&, id&, sysTime&)

declare function SetTimer                lib "user32.dll" alias "SetTimer"                (hWnd&, nIDEvent&, uElapse&, lpTimerFunc as TIMERPROC) as long
declare function KillTimer               lib "user32.dll" alias "KillTimer"               (hWnd&, uIDEvent&) as long
declare function IsWindowUnicode         lib "user32.dll" alias "IsWindowUnicode"         (hWnd&) as long
declare function EnableWindow            lib "user32.dll" alias "EnableWindow"            (hWnd&, bEnable&) as long
declare function IsWindowEnabled         lib "user32.dll" alias "IsWindowEnabled"         (hWnd&) as long
declare function LoadAccelerators        lib "user32.dll" alias "LoadAcceleratorsA"       (hInstance&, lp as any) as long
declare function CreateAcceleratorTable  lib "user32.dll" alias "CreateAcceleratorTableA" (lp as ACCEL, i&) as long
declare function DestroyAcceleratorTable lib "user32.dll" alias "DestroyAcceleratorTable" (hAccel&) as long
declare function CopyAcceleratorTable    lib "user32.dll" alias "CopyAcceleratorTableA"   (hAccelSrc&, lpAccelDst as ACCEL, cAccelEntries&) as long
declare function TranslateAccelerator    lib "user32.dll" alias "TranslateAcceleratorA"   (hWnd&, hAccTable&, lpMsg as MSG) as long

'
' GetSystemMetrics() codes
'

const SM_CXSCREEN          = 0
const SM_CYSCREEN          = 1
const SM_CXVSCROLL         = 2
const SM_CYHSCROLL         = 3
const SM_CYCAPTION         = 4
const SM_CXBORDER          = 5
const SM_CYBORDER          = 6
const SM_CXDLGFRAME        = 7
const SM_CYDLGFRAME        = 8
const SM_CYVTHUMB          = 9
const SM_CXHTHUMB          = 10
const SM_CXICON            = 11
const SM_CYICON            = 12
const SM_CXCURSOR          = 13
const SM_CYCURSOR          = 14
const SM_CYMENU            = 15
const SM_CXFULLSCREEN      = 16
const SM_CYFULLSCREEN      = 17
const SM_CYKANJIWINDOW     = 18
const SM_MOUSEPRESENT      = 19
const SM_CYVSCROLL         = 20
const SM_CXHSCROLL         = 21
const SM_DEBUG             = 22
const SM_SWAPBUTTON        = 23
const SM_RESERVED1         = 24
const SM_RESERVED2         = 25
const SM_RESERVED3         = 26
const SM_RESERVED4         = 27
const SM_CXMIN             = 28
const SM_CYMIN             = 29
const SM_CXSIZE            = 30
const SM_CYSIZE            = 31
const SM_CXFRAME           = 32
const SM_CYFRAME           = 33
const SM_CXMINTRACK        = 34
const SM_CYMINTRACK        = 35
const SM_CXDOUBLECLK       = 36
const SM_CYDOUBLECLK       = 37
const SM_CXICONSPACING     = 38
const SM_CYICONSPACING     = 39
const SM_MENUDROPALIGNMENT = 40
const SM_PENWINDOWS        = 41
const SM_DBCSENABLED       = 42
const SM_CMOUSEBUTTONS     = 43
const SM_CMETRICS          = 44

const SM_CXSMICON          = 49
const SM_CYSMICON          = 50

declare function GetSystemMetrics           lib "user32.dll" alias "GetSystemMetrics"           (nIndex&) as long

declare function LoadMenu                   lib "user32.dll" alias "LoadMenuA"                  (hInstance&, lp as any) as long
declare function LoadMenuIndirect           lib "user32.dll" alias "LoadMenuIndirectA"          (lp as any) as long
declare function GetMenu                    lib "user32.dll" alias "GetMenu"                    (hWnd&) as long
declare function _SetMenu                    lib "user32.dll" alias "SetMenu"                    (hWnd&, hMenu&) as long
declare function ChangeMenu                 lib "user32.dll" alias "ChangeMenuA"                (hMenu&, cmd&, lpszNewItem$, cmdInsert&, flags&) as long
declare function HiliteMenuItem             lib "user32.dll" alias "HiliteMenuItem"             (hWnd&, hMenu&, uIDHiliteItem&, uHilite&) as long
declare function GetMenuString              lib "user32.dll" alias "GetMenuStringA"             (hMenu&, uIDItem&, lpString$, nMaxCount&, uFlag&) as long
declare function GetMenuState               lib "user32.dll" alias "GetMenuState"               (hMenu&, uId&, uFlags&) as long
declare Sub      DrawMenuBar                lib "user32.dll" alias "DrawMenuBar"                (hWnd&)
declare function GetSystemMenu              lib "user32.dll" alias "GetSystemMenu"              (hWnd&, bRevert&) as long
declare function CreateMenu                 lib "user32.dll" alias "CreateMenu"                 () as long
declare function CreatePopupMenu            lib "user32.dll" alias "CreatePopupMenu"            () as long
declare function _DestroyMenu                lib "user32.dll" alias "DestroyMenu"                (hMenu&) as long
declare function CheckMenuItem              lib "user32.dll" alias "CheckMenuItem"              (hMenu&, uIDCheckItem&, uCheck&) as long
declare function EnableMenuItem             lib "user32.dll" alias "EnableMenuItem"             (hMenu&, uIDEnableItem&, uEnable&) as long
declare function GetSubMenu                 lib "user32.dll" alias "GetSubMenu"                 (hMenu&, nPos&) as long
declare function GetMenuItemID              lib "user32.dll" alias "GetMenuItemID"              (hMenu&, nPos&) as long
declare function GetMenuItemCount           lib "user32.dll" alias "GetMenuItemCount"           (hMenu&) as long
declare function InsertMenu                 lib "user32.dll" alias "InsertMenuA"                (hMenu&, uPosition&, uFlags&, uIDNewItem&, lpNewItem$) as long
declare function AppendMenu                 lib "user32.dll" alias "AppendMenuA"                (hMenu&, uFlags&, uIDNewItem&, lpNewItem$) as long
declare function ModifyMenu                 lib "user32.dll" alias "ModifyMenuA"                (hMnu&, uPosition&, uFlags&, uIDNewItem&, lpNewItem as any) as long
declare function RemoveMenu                 lib "user32.dll" alias "RemoveMenu"                 (hMenu&, uPosition&, uFlags&) as long
declare function DeleteMenu                 lib "user32.dll" alias "DeleteMenu"                 (hMenu&, uPosition&, uFlags&) as long
declare function SetMenuItemBitmaps         lib "user32.dll" alias "SetMenuItemBitmaps"         (hMenu&, uPosition&, uFlags&, hBitmapUnchecked&, hBitmapChecked&) as long
declare function GetMenuCheckMarkDimensions lib "user32.dll" alias "GetMenuCheckMarkDimensions" () as long
declare function TrackPopupMenu             lib "user32.dll" alias "TrackPopupMenu"             (hMenu&, uFlags&, x&, y&, nReserved&, hWnd&, lp as RECT) as long

'
' Flags for TrackPopupMenu
'

const TPM_LEFTBUTTON  = &H0000&
const TPM_RIGHTBUTTON = &H0002&
const TPM_LEFTALIGN   = &H0000&
const TPM_CENTERALIGN = &H0004&
const TPM_RIGHTALIGN  = &H0008&

const IMAGE_BITMAP        = 0
const IMAGE_ICON          = 1
const IMAGE_CURSOR        = 2
const IMAGE_ENHMETAFILE   = 3

const LR_DEFAULTCOLOR     = &h0000&
const LR_MONOCHROME       = &h0001&
const LR_COLOR            = &h0002&
const LR_COPYRETURNORG    = &h0004&
const LR_COPYDELETEORG    = &h0008&
const LR_LOADFROMFILE     = &h0010&
const LR_LOADTRANSPARENT  = &h0020&
const LR_DEFAULTSIZE      = &h0040&
const LR_LOADREALSIZE     = &h0080&
const LR_LOADMAP3DCOLORS  = &h1000&
const LR_CREATEDIBSECTION = &h2000&

declare function LoadImage lib "user32.dll" alias "LoadImageA" (hinst&, s$, t&, cx&, cy&, flags&) as long

declare function _DrawIcon lib "user32.dll" alias "DrawIcon" (hDC&, X&, Y&, hIcon&) as long

'
' DrawText() Format Flags
'

const DT_TOP             = &H0000&
const DT_LEFT            = &H0000&
const DT_CENTER          = &H0001&
const DT_RIGHT           = &H0002&
const DT_VCENTER         = &H0004&
const DT_BOTTOM          = &H0008&
const DT_WORDBREAK       = &H0010&
const DT_SINGLELINE      = &H0020&
const DT_EXPANDTABS      = &H0040&
const DT_TABSTOP         = &H0080&
const DT_NOCLIP          = &H0100&
const DT_EXTERNALLEADING = &H0200&
const DT_CALCRECT        = &H0400&
const DT_NOPREFIX        = &H0800&
const DT_INTERNAL        = &H1000&

declare function DrawText            lib "user32.dll" alias "DrawTextA"            (hDC&, lpString$, nCount&, lpRect as RECT, uFormat&) as long
declare function GrayString          lib "user32.dll" alias "GrayStringA"          (hDC&, hBrush&, lpOutputFunc as pointer to function (hDC&, lpData&, cchData&) as long, lpData&, nCount&, X&, Y&, nWidth&, nHeight&) as long
declare function TabbedTextOut       lib "user32.dll" alias "TabbedTextOutA"       (hDC&, X&, Y&, lpString$, nCount&, nTabPositions&, lpnTabStopPositions as pointer to long, nTabOrigin&) as long
declare function GetTabbedTextExtent lib "user32.dll" alias "GetTabbedTextExtentA" (hDC&, lpString$, nCount&, nTabPositions&, lpnTabStopPositions as pointer to long) as long
declare Sub      UpdateWindow        lib "user32.dll" alias "UpdateWindow"         (hWnd&)
declare function SetActiveWindow     lib "user32.dll" alias "SetActiveWindow"      (hWnd&) as long
declare function GetForegroundWindow lib "user32.dll" alias "GetForegroundWindow"  () as long
declare function SetForegroundWindow lib "user32.dll" alias "SetForegroundWindow"  (hWnd&) as long
declare function WindowFromDC        lib "user32.dll" alias "WindowFromDC"         (hDC&) as long
declare function GetDC               lib "user32.dll" alias "GetDC"                (hWnd&) as long
declare function GetDCEx             lib "user32.dll" alias "GetDCEx"              (hWnd&, hrgnClip&, flags&) as long

'
' GetDCEx() flags
'

const DCX_WINDOW           = &H00000001&
const DCX_CACHE            = &H00000002&
const DCX_NORESETATTRS     = &H00000004&
const DCX_CLIPCHILDREN     = &H00000008&
const DCX_CLIPSIBLINGS     = &H00000010&
const DCX_PARENTCLIP       = &H00000020&
const DCX_EXCLUDERGN       = &H00000040&
const DCX_INTERSECTRGN     = &H00000080&
const DCX_EXCLUDEUPDATE    = &H00000100&
const DCX_INTERSECTUPDATE  = &H00000200&
const DCX_LOCKWINDOWUPDATE = &H00000400&
const DCX_NORECOMPUTE      = &H00100000&
const DCX_VALIDATE         = &H00200000&

declare function GetWindowDC      lib "user32.dll" alias "GetWindowDC"      (hWnd&) as long
declare function ReleaseDC        lib "user32.dll" alias "ReleaseDC"        (hWnd&, hDC&) as long
declare function BeginPaint       lib "user32.dll" alias "BeginPaint"       (hWnd&, lpPaint as PAINTSTRUCT) as long
declare Sub      EndPaint         lib "user32.dll" alias "EndPaint"         (hWnd&, lp as PAINTSTRUCT)
declare function GetUpdateRect    lib "user32.dll" alias "GetUpdateRect"    (hWnd&, lpRect as RECT, bErase&) as long
declare function GetUpdateRgn     lib "user32.dll" alias "GetUpdateRgn"     (hWnd&, hRgn&, bErase&) as long
declare function ExcludeUpdateRgn lib "user32.dll" alias "ExcludeUpdateRgn" (hDC&, hWnd&) as long
declare Sub      InvalidateRect   lib "user32.dll" alias "InvalidateRect"   (hWnd&, lp as RECT, bErase&)
declare sub      ValidateRect     lib "user32.dll" alias "ValidateRect"     (hWnd&, lp as RECT)
declare sub      InvalidateRgn    lib "user32.dll" alias "InvalidateRgn"    (hWnd&, hRgn&, bErase&)
declare sub      ValidateRgn      lib "user32.dll" alias "ValidateRgn"      (hWnd&, hRgn&)
declare function RedrawWindow     lib "user32.dll" alias "RedrawWindow"     (hWnd&, lp as RECT, hrgnUpdate&, flags&) as long

'
' RedrawWindow() flags
'

const RDW_INVALIDATE      = &H0001&
const RDW_INTERNALPAINT   = &H0002&
const RDW_ERASE           = &H0004&
const RDW_VALIDATE        = &H0008&
const RDW_NOINTERNALPAINT = &H0010&
const RDW_NOERASE         = &H0020&
const RDW_NOCHILDREN      = &H0040&
const RDW_ALLCHILDREN     = &H0080&
const RDW_UPDATENOW       = &H0100&
const RDW_ERASENOW        = &H0200&
const RDW_FRAME           = &H0400&
const RDW_NOFRAME         = &H0800&

'
' LockWindowUpdate API
'

declare function LockWindowUpdate lib "user32.dll" alias "LockWindowUpdate" (hWndLock&) as long
declare sub      ScrollWindow     lib "user32.dll" alias "ScrollWindow"     (hWnd&, XAmount&, YAmount&, lp as RECT, lp as RECT)
declare function ScrollDC         lib "user32.dll" alias "ScrollDC"         (hDC&, dx&, dy&, lp as RECT, lp as RECT, hrgnUpdate&, lprcUpdate as RECT) as long
declare function ScrollWindowEx   lib "user32.dll" alias "ScrollWindowEx"   (hWnd&, dx&, dy&, lp as RECT, lp as RECT, hrgnUpdate&, prcUpdate as RECT, flags&) as long

const SW_SCROLLCHILDREN = &H0001& ' Scroll children within *lprcScroll.
const SW_INVALIDATE     = &H0002& ' Invalidate after scrolling
const SW_ERASE          = &H0004& ' If SW_INVALIDATE, don't send WM_ERASEBACKGROUND

declare function SetScrollPos    lib "user32.dll" alias "SetScrollPos"    (hWnd&, nBar&, nPos&, bRedraw&) as long
declare function GetScrollPos    lib "user32.dll" alias "GetScrollPos"    (hWnd&, nBar&) as long
declare sub      SetScrollRange  lib "user32.dll" alias "SetScrollRange"  (hWnd&, nBar&, nMinPos&, nMaxPos&, bRedraw&)
declare Sub      GetScrollRange  lib "user32.dll" alias "GetScrollRange"  (hWnd&, nBar&, lpMinPos as pointer to long, lpMaxPos as pointer to long)
declare sub      ShowScrollBar   lib "user32.dll" alias "ShowScrollBar"   (hWnd&, wBar&, bShow&)
declare function EnableScrollBar lib "user32.dll" alias "EnableScrollBar" (hWnd&, wSBflags&, wArrows&) as long

'
' EnableScrollBar() flags
'

const ESB_ENABLE_BOTH   = &H0000&
const ESB_DISABLE_BOTH  = &H0003&
const ESB_DISABLE_LEFT  = &H0001&
const ESB_DISABLE_RIGHT = &H0002&
const ESB_DISABLE_UP    = &H0001&
const ESB_DISABLE_DOWN  = &H0002&
const ESB_DISABLE_LTUP  = ESB_DISABLE_LEFT
const ESB_DISABLE_RTDN  = ESB_DISABLE_RIGHT

declare function SetProp             lib "user32.dll" alias "SetPropA"            (hWnd&, lpString$, hData&) as long
declare function GetProp             lib "user32.dll" alias "GetPropA"            (hWnd&, lpString$) as long
declare function RemoveProp          lib "user32.dll" alias "RemovePropA"         (hWnd&, lpString$) as long
declare function EnumPropsEx         lib "user32.dll" alias "EnumPropsExA"        (hWnd&, lpEnumFunc as pointer to function (hWnd&, s$, hData&, dwData&) as long, lParam&) as long
declare function EnumProps           lib "user32.dll" alias "EnumPropsA"          (hWnd&, lpEnumFunc as pointer to function (hWnd&, s$, hData&) as long) as long
declare Sub      SetWindowText       lib "user32.dll" alias "SetWindowTextA"      (hWnd&, lpString$)
declare function GetWindowText       lib "user32.dll" alias "GetWindowTextA"      (hWnd&, lpString$, nMaxCount&) as long
declare function GetWindowTextLength lib "user32.dll" alias "GetWindowTextLengthA" (hWnd&) as long
declare Sub      GetClientRect       lib "user32.dll" alias "GetClientRect"       (hWnd&, lpRect as RECT)
declare Sub      GetWindowRect       lib "user32.dll" alias "GetWindowRect"       (hWnd&, lpRect as RECT)
declare sub      AdjustWindowRect    lib "user32.dll" alias "AdjustWindowRect"    (lpRect as RECT, dwStyle&, bMenu&)
declare sub      AdjustWindowRectEx  lib "user32.dll" alias "AdjustWindowRectEx"  (lpRect as RECT, dwStyle&, bMenu&, dwExStyle&)

'
' MessageBox() Flags
' NOTE: Predefined by MS-Test for use with the MsgBox() intrinsic
'
'const MB_OK                   = &H00000000&
'const MB_OKCANCEL             = &H00000001&
'const MB_ABORTRETRYIGNORE     = &H00000002&
'const MB_YESNOCANCEL          = &H00000003&
'const MB_YESNO                = &H00000004&
'const MB_RETRYCANCEL          = &H00000005&
'const MB_ICONHAND             = &H00000010&
'const MB_ICONQUESTION         = &H00000020&
'const MB_ICONEXCLAMATION      = &H00000030&
'const MB_ICONASTERISK         = &H00000040&
'const MB_ICONINFORMATION      = MB_ICONASTERISK
'const MB_ICONSTOP             = MB_ICONHAND
'const MB_DEFBUTTON1           = &H00000000&
'const MB_DEFBUTTON2           = &H00000100&
'const MB_DEFBUTTON3           = &H00000200&
'const MB_APPLMODAL            = &H00000000&
'const MB_SYSTEMMODAL          = &H00001000&
'const MB_TASKMODAL            = &H00002000&
'const MB_NOFOCUS              = &H00008000&
'const MB_SETFOREGROUND        = &H00010000&
'const MB_DEFAULT_DESKTOP_ONLY = &H00020000&
'const MB_TYPEMASK             = &H0000000F&
'const MB_ICONMASK             = &H000000F0&
'const MB_DEFMASK              = &H00000F00&
'const MB_MODEMASK             = &H00003000&
'const MB_MISCMASK             = &H0000C000&

declare function MessageBox           lib "user32.dll" alias "MessageBoxA"          (hWnd&, lpText$, lpCaption$, uType&) as long
declare function MessageBoxEx         lib "user32.dll" alias "MessageBoxExA"        (hWnd&, lpText$, lpCaption$, uType&, wLanguageId as short) as long
declare sub      MessageBeep          lib "user32.dll" alias "MessageBeep"          (uType&)
declare function ShowCursor           lib "user32.dll" alias "ShowCursor"           (bShow&) as long
declare sub      SetCursorPos         lib "user32.dll" alias "SetCursorPos"         (X&, Y&)
declare function _SetCursor            lib "user32.dll" alias "SetCursor"            (hCursor&) as long
declare Sub      GetCursorPos         lib "user32.dll" alias "GetCursorPos"         (lpPoint as POINT)
declare sub      ClipCursor           lib "user32.dll" alias "ClipCursor"           (lp as RECT)
declare sub      GetClipCursor        lib "user32.dll" alias "GetClipCursor"        (lpRect as RECT)
declare function GetCursor            lib "user32.dll" alias "GetCursor"            () as long
declare sub      CreateCaret          lib "user32.dll" alias "CreateCaret"          (hWnd&, hBitmap&, nWidth&, nHeight&)
declare function GetCaretBlinkTime    lib "user32.dll" alias "GetCaretBlinkTime"    () as long
declare sub      SetCaretBlinkTime    lib "user32.dll" alias "SetCaretBlinkTime"    (uMSeconds&)
declare sub      DestroyCaret         lib "user32.dll" alias "DestroyCaret"         ()
declare sub      HideCaret            lib "user32.dll" alias "HideCaret"            (hWnd&)
declare sub      ShowCaret            lib "user32.dll" alias "ShowCaret"            (hWnd&)
declare sub      SetCaretPos          lib "user32.dll" alias "SetCaretPos"          (X&, Y&)
declare sub      GetCaretPos          lib "user32.dll" alias "GetCaretPos"          (lpPoint as POINT)
declare Sub      ClientToScreen       lib "user32.dll" alias "ClientToScreen"       (hWnd&, lpPoint as POINT)
declare Sub      ScreenToClient       lib "user32.dll" alias "ScreenToClient"       (hWnd&, lpPoint as POINT)
declare sub      MapWindowPoints      lib "user32.dll" alias "MapWindowPoints"      (hWndFrom&, hWndTo&, lpPoints as POINT, cPoints&)

declare function WindowFromPoint      lib "mstest40.dll" alias "RBWindowFromPoint"      (pt as POINT) as long
declare function ChildWindowFromPoint lib "mstest40.dll" alias "RBChildWindowFromPoint" (hWndParent&, pt as POINT) as long

'
' Color Types
'

const CTLCOLOR_MSGBOX           = 0
const CTLCOLOR_EDIT             = 1
const CTLCOLOR_LISTBOX          = 2
const CTLCOLOR_BTN              = 3
const CTLCOLOR_DLG              = 4
const CTLCOLOR_SCROLLBAR        = 5
const CTLCOLOR_STATIC           = 6
const CTLCOLOR_MAX              = 8 ' three bits max
const COLOR_SCROLLBAR           = 0
const COLOR_BACKGROUND          = 1
const COLOR_ACTIVECAPTION       = 2
const COLOR_INACTIVECAPTION     = 3
const COLOR_MENU                = 4
const COLOR_WINDOW              = 5
const COLOR_WINDOWFRAME         = 6
const COLOR_MENUTEXT            = 7
const COLOR_WINDOWTEXT          = 8
const COLOR_CAPTIONTEXT         = 9
const COLOR_ACTIVEBORDER        = 10
const COLOR_INACTIVEBORDER      = 11
const COLOR_APPWORKSPACE        = 12
const COLOR_HIGHLIGHT           = 13
const COLOR_HIGHLIGHTTEXT       = 14
const COLOR_BTNFACE             = 15
const COLOR_BTNSHADOW           = 16
const COLOR_GRAYTEXT            = 17
const COLOR_BTNTEXT             = 18
const COLOR_INACTIVECAPTIONTEXT = 19
const COLOR_BTNHIGHLIGHT        = 20

declare function GetSysColor              lib "user32.dll" alias "GetSysColor"              (nIndex&) as long
declare sub      SetSysColors             lib "user32.dll" alias "SetSysColors"             (cElements&, lpaElements as pointer to long, lpaRgbValues as pointer to long)
declare sub      DrawFocusRect            lib "user32.dll" alias "DrawFocusRect"            (hDC&, lprc as RECT)
declare function FillRect                 lib "user32.dll" alias "FillRect"                 (hDC&, lp as RECT, hbr&) as long
declare function FrameRect                lib "user32.dll" alias "FrameRect"                (hDC&, lp as RECT, hbr&) as long
declare sub      InvertRect               lib "user32.dll" alias "InvertRect"               (hDC&, lp as RECT)
declare sub      SetRect                  lib "user32.dll" alias "SetRect"                  (lprc as RECT, xLeft&, yTop&, xRight&, yBottom&)
declare sub      SetRectEmpty             lib "user32.dll" alias "SetRectEmpty"             (lprc as RECT)
declare sub      CopyRect                 lib "user32.dll" alias "CopyRect"                 (lprcDst as RECT, lp as RECT)
declare sub      InflateRect              lib "user32.dll" alias "InflateRect"              (lprc as RECT, dx&, dy&)
declare function IntersectRect            lib "user32.dll" alias "IntersectRect"            (lprcDst as RECT, lp as RECT, lp as RECT) as long
declare function UnionRect                lib "user32.dll" alias "UnionRect"                (lprcDst as RECT, lp as RECT, lp as RECT) as long
declare function SubtractRect             lib "user32.dll" alias "SubtractRect"             (lprcDst as RECT, lp as RECT, lp as RECT) as long
declare Sub      OffsetRect               lib "user32.dll" alias "OffsetRect"               (lprc as RECT, dx&, dy&)
declare function IsRectEmpty              lib "user32.dll" alias "IsRectEmpty"              (lp as RECT) as long
declare function EqualRect                lib "user32.dll" alias "EqualRect"                (lp as RECT, lp as RECT) as long
declare function GetWindowWord            lib "user32.dll" alias "GetWindowWord"            (hWnd&, nIndex&) as short
declare function SetWindowWord            lib "user32.dll" alias "SetWindowWord"            (hWnd&, nIndex&, wNewWord as short) as short
declare function GetWindowLong            lib "user32.dll" alias "GetWindowLongA"           (hWnd&, nIndex&) as long
declare function SetWindowLong            lib "user32.dll" alias "SetWindowLongA"           (hWnd&, nIndex&, dwNewLong&) as long
declare function GetClassWord             lib "user32.dll" alias "GetClassWord"             (hWnd&, nIndex&) as short
declare function SetClassWord             lib "user32.dll" alias "SetClassWord"             (hWnd&, nIndex&, wNewWord as short) as short
declare function GetClassLong             lib "user32.dll" alias "GetClassLongA"            (hWnd&, nIndex&) as long
declare function SetClassLong             lib "user32.dll" alias "SetClassLongA"            (hWnd&, nIndex&, dwNewLong&) as long
declare function GetDesktopWindow         lib "user32.dll" alias "GetDesktopWindow"         () as long
declare function GetParent                lib "user32.dll" alias "GetParent"                (hWnd&) as long
declare function SetParent                lib "user32.dll" alias "SetParent"                (hWndChild&, hWndNewParent&) as long
declare function EnumChildWindows         lib "user32.dll" alias "EnumChildWindows"         (hWndParent&, lpEnumFunc as pointer to function (hWnd&, lParam&) as long, lParam&) as long
declare function FindWindow               lib "user32.dll" alias "FindWindowA"              (lpClassName$, lpWindowName$) as long
declare function EnumWindows              lib "user32.dll" alias "EnumWindows"              (lpEnumFunc as pointer to function (hWnd&, lParam&) as long, lParam&) as long
declare function EnumThreadWindows        lib "user32.dll" alias "EnumThreadWindows"        (dwThreadId&, lpfn as pointer to function (hWnd&, lParam&) as long, lParam&) as long
declare function GetClassName             lib "user32.dll" alias "GetClassNameA"            (hWnd&, lpClassName$, nMaxCount&) as long
declare function GetTopWindow             lib "user32.dll" alias "GetTopWindow"             (hWnd&) as long
declare function GetWindowThreadProcessId lib "user32.dll" alias "GetWindowThreadProcessId" (hWnd&, lpdwProcessId as pointer to long) as long
declare function GetLastActivePopup       lib "user32.dll" alias "GetLastActivePopup"       (hWnd&) as long

declare function PtInRect                 lib "mstest40.dll" alias "RBPtInRect"              (lp as RECT, pt as POINT) as long

'
' GetWindow() Constants
'

const GW_HWNDFIRST = 0
const GW_HWNDLAST  = 1
const GW_HWNDNEXT  = 2
const GW_HWNDPREV  = 3
const GW_OWNER     = 4
const GW_CHILD     = 5
const GW_MAX       = 5

declare function GetWindow           lib "user32.dll" alias "GetWindow"           (hWnd&, uCmd&) as long
declare function SetWindowsHook      lib "user32.dll" alias "SetWindowsHookA"     (nFilterType&, pfnFilterProc as pointer to function (nCode&, wParam&, lParam&) as long) as long
declare function UnhookWindowsHook   lib "user32.dll" alias "UnhookWindowsHook"   (nCode&, pfnFilterProc as pointer to function (nCode&, wParam&, lParam&) as long) as long
declare function SetWindowsHookEx    lib "user32.dll" alias "SetWindowsHookExA"   (idHook&, lpfn as pointer to function (nCode&, wParam&, lParam&) as long, hmod&, dwThreadId&) as long
declare function UnhookWindowsHookEx lib "user32.dll" alias "UnhookWindowsHookEx" (hhk&) as long
declare function CallNextHookEx      lib "user32.dll" alias "CallNextHookEx"      (hhk&, nCode&, wParam&, lParam&) as long

'
' Macros for source-level compatibility with old functions.
'
'
' Menu flags for Add/Check/EnableMenuItem()
'

const MF_INSERT          = &H00000000&
const MF_CHANGE          = &H00000080&
const MF_APPEND          = &H00000100&
const MF_DELETE          = &H00000200&
const MF_REMOVE          = &H00001000&
const MF_BYCOMMAND       = &H00000000&
const MF_BYPOSITION      = &H00000400&
const MF_SEPARATOR       = &H00000800&
const MF_ENABLED         = &H00000000&
const MF_GRAYED          = &H00000001&
const MF_DISABLED        = &H00000002&
const MF_UNCHECKED       = &H00000000&
const MF_CHECKED         = &H00000008&
const MF_USECHECKBITMAPS = &H00000200&
const MF_STRING          = &H00000000&
const MF_BITMAP          = &H00000004&
const MF_OWNERDRAW       = &H00000100&
const MF_POPUP           = &H00000010&
const MF_MENUBARBREAK    = &H00000020&
const MF_MENUBREAK       = &H00000040&
const MF_UNHILITE        = &H00000000&
const MF_HILITE          = &H00000080&
const MF_SYSMENU         = &H00002000&
const MF_HELP            = &H00004000&
const MF_MOUSESELECT     = &H00008000&

'
' Menu item resource format
'

type MENUITEMTEMPLATEHEADER
    versionNumber as short
    offset        as short
end type

type MENUITEMTEMPLATE
    mtOption as short
    mtID     as short
    '        WCHAR mtString[1];
    mtString as string * 1
end type

const MF_END = &H00000080&

'
' System Menu Command Values
'

const SC_SIZE       = &HF000&
const SC_MOVE       = &HF010&
const SC_MINIMIZE   = &HF020&
const SC_MAXIMIZE   = &HF030&
const SC_NEXTWINDOW = &HF040&
const SC_PREVWINDOW = &HF050&
const SC_CLOSE      = &HF060&
const SC_VSCROLL    = &HF070&
const SC_HSCROLL    = &HF080&
const SC_MOUSEMENU  = &HF090&
const SC_KEYMENU    = &HF100&
const SC_ARRANGE    = &HF110&
const SC_RESTORE    = &HF120&
const SC_TASKLIST   = &HF130&
const SC_SCREENSAVE = &HF140&
const SC_HOTKEY     = &HF150&

'
' Obsolete names
'

const SC_ICON = SC_MINIMIZE
const SC_ZOOM = SC_MAXIMIZE

'
' Resource Loading Routines
'

declare function LoadBitmap    lib "user32.dll" alias "LoadBitmapA"   (hInstance&, lp as any) as long
declare function LoadCursor    lib "user32.dll" alias "LoadCursorA"   (hInstance&, lp as any) as long
declare function CreateCursor  lib "user32.dll" alias "CreateCursor"  (hInst&, xHotSpot&, yHotSpot&, nWidth&, nHeight&, p as any, p as any) as long
declare function _DestroyCursor lib "user32.dll" alias "DestroyCursor" (hCursor&) as long

'
' Standard Cursor IDs
'

const IDC_ARROW       = (32512)
const IDC_IBEAM       = (32513)
const IDC_WAIT        = (32514)
const IDC_CROSS       = (32515)
const IDC_UPARROW     = (32516)
const IDC_SIZE        = (32640)
const IDC_ICON        = (32641)
const IDC_SIZENWSE    = (32642)
const IDC_SIZENESW    = (32643)
const IDC_SIZEWE      = (32644)
const IDC_SIZENS      = (32645)
const IDC_SIZEALL     = (32646) ' not in win3.1
const IDC_NO          = (32648) ' not in win3.1
const IDC_APPSTARTING = (32650) ' not in win3.1

type ICONINFO
    fIcon    as long
    xHotspot as long
    yHotspot as long
    hbmMask  as long
    hbmColor as long
end type

declare function LoadIcon                  lib "user32.dll" alias "LoadIconA"                 (hInstance&, lp as any) as long
declare function CreateIcon                lib "user32.dll" alias "CreateIcon"                (hInstance&, nWidth&, nHeight&, cPlanes as short, cBitsPixel as short, pb$, pb$) as long
declare function _DestroyIcon               lib "user32.dll" alias "DestroyIcon"               (hIcon&) as long
declare function LookupIconIdFromDirectory lib "user32.dll" alias "LookupIconIdFromDirectory" (presbits$, fIcon&) as long
declare function CreateIconFromResource    lib "user32.dll" alias "CreateIconFromResource"    (presbits$, dwResSize&, fIcon&, dwVer&) as long
declare function CreateIconIndirect        lib "user32.dll" alias "CreateIconIndirect"        (piconinfo as ICONINFO) as long
declare function CopyIcon                  lib "user32.dll" alias "CopyIcon"                  (hIcon&) as long
declare function GetIconInfo               lib "user32.dll" alias "GetIconInfo"               (hIcon&, piconinfo as ICONINFO) as long

'
' OEM Resource Ordinal Numbers
'

const OBM_CLOSE       = 32754
const OBM_UPARROW     = 32753
const OBM_DNARROW     = 32752
const OBM_RGARROW     = 32751
const OBM_LFARROW     = 32750
const OBM_REDUCE      = 32749
const OBM_ZOOM        = 32748
const OBM_RESTORE     = 32747
const OBM_REDUCED     = 32746
const OBM_ZOOMD       = 32745
const OBM_RESTORED    = 32744
const OBM_UPARROWD    = 32743
const OBM_DNARROWD    = 32742
const OBM_RGARROWD    = 32741
const OBM_LFARROWD    = 32740
const OBM_MNARROW     = 32739
const OBM_COMBO       = 32738
const OBM_UPARROWI    = 32737
const OBM_DNARROWI    = 32736
const OBM_RGARROWI    = 32735
const OBM_LFARROWI    = 32734
const OBM_OLD_CLOSE   = 32767
const OBM_SIZE        = 32766
const OBM_OLD_UPARROW = 32765
const OBM_OLD_DNARROW = 32764
const OBM_OLD_RGARROW = 32763
const OBM_OLD_LFARROW = 32762
const OBM_BTSIZE      = 32761
const OBM_CHECK       = 32760
const OBM_CHECKBOXES  = 32759
const OBM_BTNCORNERS  = 32758
const OBM_OLD_REDUCE  = 32757
const OBM_OLD_ZOOM    = 32756
const OBM_OLD_RESTORE = 32755
const OCR_NORMAL      = 32512
const OCR_IBEAM       = 32513
const OCR_WAIT        = 32514
const OCR_CROSS       = 32515
const OCR_UP          = 32516
const OCR_SIZE        = 32640
const OCR_ICON        = 32641
const OCR_SIZENWSE    = 32642
const OCR_SIZENESW    = 32643
const OCR_SIZEWE      = 32644
const OCR_SIZENS      = 32645
const OCR_SIZEALL     = 32646
const OCR_ICOCUR      = 32647
const OCR_NO          = 32648 ' not in win3.1
const OIC_SAMPLE      = 32512
const OIC_HAND        = 32513
const OIC_QUES        = 32514
const OIC_BANG        = 32515
const OIC_NOTE        = 32516
const ORD_LANGDRIVER  = 1 ' The ordinal number for the entry point of

'* language drivers.
'
'
' Standard Icon IDs
'

const IDI_APPLICATION = (32512)
const IDI_HAND        = (32513)
const IDI_QUESTION    = (32514)
const IDI_EXCLAMATION = (32515)
const IDI_ASTERISK    = (32516)

declare function LoadString lib "user32.dll" alias "LoadStringA" (hInstance&, uID&, lpBuffer$, nBufferMax&) as long

'
' MessageBox Command IDs
' Predifined for MS-Test's MsgBox() function
'

'const IDOK     = 1
'const IDCANCEL = 2
'const IDABORT  = 3
'const IDRETRY  = 4
'const IDIGNORE = 5
'const IDYES    = 6
'const IDNO     = 7

'
' Control Manager Structures and Definitions
'
'
' Edit Control Styles
'

const ES_LEFT        = &H0000&
const ES_CENTER      = &H0001&
const ES_RIGHT       = &H0002&
const ES_MULTILINE   = &H0004&
const ES_UPPERCASE   = &H0008&
const ES_LOWERCASE   = &H0010&
const ES_PASSWORD    = &H0020&
const ES_AUTOVSCROLL = &H0040&
const ES_AUTOHSCROLL = &H0080&
const ES_NOHIDESEL   = &H0100&
const ES_OEMCONVERT  = &H0400&
const ES_READONLY    = &H0800&
const ES_WANTRETURN  = &H1000&

'
' Edit Control Notification Codes
'

const EN_SETFOCUS  = &H0100&
const EN_KILLFOCUS = &H0200&
const EN_CHANGE    = &H0300&
const EN_UPDATE    = &H0400&
const EN_ERRSPACE  = &H0500&
const EN_MAXTEXT   = &H0501&
const EN_HSCROLL   = &H0601&
const EN_VSCROLL   = &H0602&

'
' Edit Control Messages
'

const EM_GETSEL              = &H00B0&
const EM_SETSEL              = &H00B1&
const EM_GETRECT             = &H00B2&
const EM_SETRECT             = &H00B3&
const EM_SETRECTNP           = &H00B4&
const EM_SCROLL              = &H00B5&
const EM_LINESCROLL          = &H00B6&
const EM_SCROLLCARET         = &H00B7&
const EM_GETMODIFY           = &H00B8&
const EM_SETMODIFY           = &H00B9&
const EM_GETLINECOUNT        = &H00BA&
const EM_LINEINDEX           = &H00BB&
const EM_SETHANDLE           = &H00BC&
const EM_GETHANDLE           = &H00BD&
const EM_GETTHUMB            = &H00BE&
const EM_LINELENGTH          = &H00C1&
const EM_REPLACESEL          = &H00C2&
const EM_GETLINE             = &H00C4&
const EM_LIMITTEXT           = &H00C5&
const EM_CANUNDO             = &H00C6&
const EM_UNDO                = &H00C7&
const EM_FMTLINES            = &H00C8&
const EM_LINEFROMCHAR        = &H00C9&
const EM_SETTABSTOPS         = &H00CB&
const EM_SETPASSWORDCHAR     = &H00CC&
const EM_EMPTYUNDOBUFFER     = &H00CD&
const EM_GETFIRSTVISIBLELINE = &H00CE&
const EM_SETREADONLY         = &H00CF&
const EM_SETWORDBREAKPROC    = &H00D0&
const EM_GETWORDBREAKPROC    = &H00D1&
const EM_GETPASSWORDCHAR     = &H00D2&

'
' EDITWORDBREAKPROC code values
'

const WB_LEFT        = 0
const WB_RIGHT       = 1
const WB_ISDELIMITER = 2

'
' Button Control Styles
'

const BS_PUSHBUTTON      = &H00&
const BS_DEFPUSHBUTTON   = &H01&
const BS_CHECKBOX        = &H02&
const BS_AUTOCHECKBOX    = &H03&
const BS_RADIOBUTTON     = &H04&
const BS_3STATE          = &H05&
const BS_AUTO3STATE      = &H06&
const BS_GROUPBOX        = &H07&
const BS_USERBUTTON      = &H08&
const BS_AUTORADIOBUTTON = &H09&
const BS_OWNERDRAW       = &H0B&
const BS_LEFTTEXT        = &H20&

'
' User Button Notification Codes
'

const BN_CLICKED       = 0
const BN_PAINT         = 1
const BN_HILITE        = 2
const BN_UNHILITE      = 3
const BN_DISABLE       = 4
const BN_DOUBLECLICKED = 5

'
' Button Control Messages
'

const BM_GETCHECK = &H00F0&
const BM_SETCHECK = &H00F1&
const BM_GETSTATE = &H00F2&
const BM_SETSTATE = &H00F3&
const BM_SETSTYLE = &H00F4&

'
' Static Control Constants
'

const SS_LEFT           = &H00&
const SS_CENTER         = &H01&
const SS_RIGHT          = &H02&
const SS_ICON           = &H03&
const SS_BLACKRECT      = &H04&
const SS_GRAYRECT       = &H05&
const SS_WHITERECT      = &H06&
const SS_BLACKFRAME     = &H07&
const SS_GRAYFRAME      = &H08&
const SS_WHITEFRAME     = &H09&
const SS_USERITEM       = &H0A&
const SS_SIMPLE         = &H0B&
const SS_LEFTNOWORDWRAP = &H0C&
const SS_NOPREFIX       = &H80& ' Don't do "&" character translation

'
' Static Control Mesages
'

const STM_SETICON = &H170&
const STM_GETICON = &H171&
const STM_MSGMAX  = &H172&

'
' Dialog window class
'

const WC_DIALOG = ( (&H8002))

'
' Get/SetWindowWord/Long offsets for use with WC_DIALOG windows
'

const DWL_MSGRESULT = 0
const DWL_DLGPROC   = 4
const DWL_USER      = 8

'
' Dialog Manager Routines
'

declare function IsDialogMessage lib "user32.dll" alias "IsDialogMessageA" (hDlg&, lpMsg as MSG) as long
declare sub      MapDialogRect   lib "user32.dll" alias "MapDialogRect"   (hDlg&, lpRect as RECT)
declare function DlgDirList      lib "user32.dll" alias "DlgDirListA"     (hDlg&, lpPathSpec$, nIDListBox&, nIDStaticPath&, uFileType&) as long

'
' DlgDirList, DlgDirListComboBox flags values
'

const DDL_READWRITE = &H0000&
const DDL_READONLY  = &H0001&
const DDL_HIDDEN    = &H0002&
const DDL_SYSTEM    = &H0004&
const DDL_DIRECTORY = &H0010&
const DDL_ARCHIVE   = &H0020&
const DDL_POSTMSGS  = &H2000&
const DDL_DRIVES    = &H4000&
const DDL_EXCLUSIVE = &H8000&

declare function DlgDirSelectEx         lib "user32.dll" alias "DlgDirSelectExA"        (hDlg&, lpString$, nCount&, nIDListBox&) as long
declare function DlgDirListComboBox     lib "user32.dll" alias "DlgDirListComboBoxA"    (hDlg&, lpPathSpec$, nIDComboBox&, nIDStaticPath&, uFiletype&) as long
declare function DlgDirSelectComboBoxEx lib "user32.dll" alias "DlgDirSelectComboBoxExA" (hDlg&, lpString$, nCount&, nIDComboBox&) as long

'
' Dialog Styles
'

const DS_ABSALIGN      = &H01&
const DS_SYSMODAL      = &H02&
const DS_LOCALEDIT     = &H20& ' Edit items get Local storage.
const DS_SETFONT       = &H40& ' User specified font for Dlg controls
const DS_MODALFRAME    = &H80& ' Can be combined with WS_CAPTION
const DS_NOIDLEMSG     = &H100& ' WM_ENTERIDLE message will not be sent
const DS_SETFOREGROUND = &H200& ' not in win3.1
const DM_GETDEFID      = (WM_USER+0)
const DM_SETDEFID      = (WM_USER+1)

'
' Returned in HIWORD() of DM_GETDEFID result if msg is supported
'

const DC_HASDEFID = &H534B&

'
' Dialog Codes
'

const DLGC_WANTARROWS      = &H0001& ' Control wants arrow keys
const DLGC_WANTTAB         = &H0002& ' Control wants tab keys
const DLGC_WANTALLKEYS     = &H0004& ' Control wants all keys
const DLGC_WANTMESSAGE     = &H0004& ' Pass message to control
const DLGC_HASSETSEL       = &H0008& ' Understands EM_SETSEL message
const DLGC_DEFPUSHBUTTON   = &H0010& ' Default pushbutton
const DLGC_UNDEFPUSHBUTTON = &H0020& ' Non-default pushbutton
const DLGC_RADIOBUTTON     = &H0040& ' Radio button
const DLGC_WANTCHARS       = &H0080& ' Want WM_CHAR messages
const DLGC_STATIC          = &H0100& ' Static item: don't include
const DLGC_BUTTON          = &H2000& ' Button item: can be checked
const LB_CTLCODE           = 0&

'
' Listbox Return Values
'

const LB_OKAY     = 0
const LB_ERR      = (-1)
const LB_ERRSPACE = (-2)

'
'*  The idStaticPath parameter to DlgDirList can have the following values
'*  ORed if the list box should show other details of the files along with
'*  the name of the files;
'
'  all other details also will be returned
'
' Listbox Notification Codes
'

const LBN_ERRSPACE  = (-2)
const LBN_SELCHANGE = 1
const LBN_DBLCLK    = 2
const LBN_SELCANCEL = 3
const LBN_SETFOCUS  = 4
const LBN_KILLFOCUS = 5

'
' Listbox messages
'

const LB_ADDSTRING           = &H0180&
const LB_INSERTSTRING        = &H0181&
const LB_DELETESTRING        = &H0182&
const LB_SELITEMRANGEEX      = &H0183&
const LB_RESETCONTENT        = &H0184&
const LB_SETSEL              = &H0185&
const LB_SETCURSEL           = &H0186&
const LB_GETSEL              = &H0187&
const LB_GETCURSEL           = &H0188&
const LB_GETTEXT             = &H0189&
const LB_GETTEXTLEN          = &H018A&
const LB_GETCOUNT            = &H018B&
const LB_SELECTSTRING        = &H018C&
const LB_DIR                 = &H018D&
const LB_GETTOPINDEX         = &H018E&
const LB_FINDSTRING          = &H018F&
const LB_GETSELCOUNT         = &H0190&
const LB_GETSELITEMS         = &H0191&
const LB_SETTABSTOPS         = &H0192&
const LB_GETHORIZONTALEXTENT = &H0193&
const LB_SETHORIZONTALEXTENT = &H0194&
const LB_SETCOLUMNWIDTH      = &H0195&
const LB_ADDFILE             = &H0196&
const LB_SETTOPINDEX         = &H0197&
const LB_GETITEMRECT         = &H0198&
const LB_GETITEMDATA         = &H0199&
const LB_SETITEMDATA         = &H019A&
const LB_SELITEMRANGE        = &H019B&
const LB_SETANCHORINDEX      = &H019C&
const LB_GETANCHORINDEX      = &H019D&
const LB_SETCARETINDEX       = &H019E&
const LB_GETCARETINDEX       = &H019F&
const LB_SETITEMHEIGHT       = &H01A0&
const LB_GETITEMHEIGHT       = &H01A1&
const LB_FINDSTRINGEXACT     = &H01A2&
const LB_SETLOCALE           = &H01A5&
const LB_GETLOCALE           = &H01A6&
const LB_SETCOUNT            = &H01A7&
const LB_MSGMAX              = &H01A8&

'
' Listbox Styles
'

const LBS_NOTIFY            = &H0001&
const LBS_SORT              = &H0002&
const LBS_NOREDRAW          = &H0004&
const LBS_MULTIPLESEL       = &H0008&
const LBS_OWNERDRAWFIXED    = &H0010&
const LBS_OWNERDRAWVARIABLE = &H0020&
const LBS_HASSTRINGS        = &H0040&
const LBS_USETABSTOPS       = &H0080&
const LBS_NOINTEGRALHEIGHT  = &H0100&
const LBS_MULTICOLUMN       = &H0200&
const LBS_WANTKEYBOARDINPUT = &H0400&
const LBS_EXTENDEDSEL       = &H0800&
const LBS_DISABLENOSCROLL   = &H1000&
const LBS_NODATA            = &H2000&
const LBS_STANDARD          = (LBS_NOTIFY or LBS_SORT or WS_VSCROLL or WS_BORDER)

'
' Combo Box return Values
'

const CB_OKAY     = 0
const CB_ERR      = (-1)
const CB_ERRSPACE = (-2)

'
' Combo Box Notification Codes
'

const CBN_ERRSPACE     = (-1)
const CBN_SELCHANGE    = 1
const CBN_DBLCLK       = 2
const CBN_SETFOCUS     = 3
const CBN_KILLFOCUS    = 4
const CBN_EDITCHANGE   = 5
const CBN_EDITUPDATE   = 6
const CBN_DROPDOWN     = 7
const CBN_CLOSEUP      = 8
const CBN_SELENDOK     = 9
const CBN_SELENDCANCEL = 10

'
' Combo Box styles
'

const CBS_SIMPLE            = &H0001&
const CBS_DROPDOWN          = &H0002&
const CBS_DROPDOWNLIST      = &H0003&
const CBS_OWNERDRAWFIXED    = &H0010&
const CBS_OWNERDRAWVARIABLE = &H0020&
const CBS_AUTOHSCROLL       = &H0040&
const CBS_OEMCONVERT        = &H0080&
const CBS_SORT              = &H0100&
const CBS_HASSTRINGS        = &H0200&
const CBS_NOINTEGRALHEIGHT  = &H0400&
const CBS_DISABLENOSCROLL   = &H0800&

'
' Combo Box messages
'

const CB_GETEDITSEL            = &H0140&
const CB_LIMITTEXT             = &H0141&
const CB_SETEDITSEL            = &H0142&
const CB_ADDSTRING             = &H0143&
const CB_DELETESTRING          = &H0144&
const CB_DIR                   = &H0145&
const CB_GETCOUNT              = &H0146&
const CB_GETCURSEL             = &H0147&
const CB_GETLBTEXT             = &H0148&
const CB_GETLBTEXTLEN          = &H0149&
const CB_INSERTSTRING          = &H014A&
const CB_RESETCONTENT          = &H014B&
const CB_FINDSTRING            = &H014C&
const CB_SELECTSTRING          = &H014D&
const CB_SETCURSEL             = &H014E&
const CB_SHOWDROPDOWN          = &H014F&
const CB_GETITEMDATA           = &H0150&
const CB_SETITEMDATA           = &H0151&
const CB_GETDROPPEDCONTROLRECT = &H0152&
const CB_SETITEMHEIGHT         = &H0153&
const CB_GETITEMHEIGHT         = &H0154&
const CB_SETEXTENDEDUI         = &H0155&
const CB_GETEXTENDEDUI         = &H0156&
const CB_GETDROPPEDSTATE       = &H0157&
const CB_FINDSTRINGEXACT       = &H0158&
const CB_SETLOCALE             = &H0159&
const CB_GETLOCALE             = &H015a&
const CB_MSGMAX                = &H015b&

'
' Scroll Bar Styles
'

const SBS_HORZ                    = &H0000&
const SBS_VERT                    = &H0001&
const SBS_TOPALIGN                = &H0002&
const SBS_LEFTALIGN               = &H0002&
const SBS_BOTTOMALIGN             = &H0004&
const SBS_RIGHTALIGN              = &H0004&
const SBS_SIZEBOXTOPLEFTALIGN     = &H0002&
const SBS_SIZEBOXBOTTOMRIGHTALIGN = &H0004&
const SBS_SIZEBOX                 = &H0008&

'
' Scroll bar messages
'

const SBM_SETPOS         = &H00E0& ' not in win3.1
const SBM_GETPOS         = &H00E1& ' not in win3.1
const SBM_SETRANGE       = &H00E2& ' not in win3.1
const SBM_SETRANGEREDRAW = &H00E6& ' not in win3.1
const SBM_GETRANGE       = &H00E3& ' not in win3.1
const SBM_ENABLE_ARROWS  = &H00E4& ' not in win3.1

'
' MDI client style bits
'

const MDIS_ALLCHILDSTYLES = &H0001&

'
' wParam Flags for WM_MDITILE and WM_MDICASCADE messages.
'

const MDITILE_VERTICAL     = &H0000& ' not in win3.1
const MDITILE_HORIZONTAL   = &H0001& ' not in win3.1
const MDITILE_SKIPDISABLED = &H0002& ' not in win3.1

type MDICREATESTRUCT
    szClass as pointer to string * 1
    szTitle as pointer to string * 1
    hOwner  as long
    x       as long
    y       as long
    cx      as long
    cy      as long
    style   as long
    lParam  as long ' app-defined stuff
end type

type CLIENTCREATESTRUCT
    hWindowMenu  as long
    idFirstChild as long
end type

declare function DefFrameProc         lib "user32.dll" alias "DefFrameProcA"        (hWnd&, hWndMDIClient&, uMsg&, wParam&, lp as any) as long
declare function DefMDIChildProc      lib "user32.dll" alias "DefMDIChildProcA"     (hWnd&, uMsg&, wParam&, lp as any) as long
declare function TranslateMDISysAccel lib "user32.dll" alias "TranslateMDISysAccel" (hWndClient&, lpMsg as MSG) as long
declare function ArrangeIconicWindows lib "user32.dll" alias "ArrangeIconicWindows" (hWnd&) as long
declare function CreateMDIWindow      lib "user32.dll" alias "CreateMDIWindowA"     (lpClassName$, lpWindowName$, dwStyle&, X&, Y&, nWidth&, nHeight&, hWndParent&, hInstance&, lParam&) as long

'**** Help support *******************************************************

type MULTIKEYHELP
    mkSize      as long
    mkKeylist   as string * 1
    szKeyphrase as string * 1
end type

type HELPWININFO
    wStructSize as long
    x           as long
    y           as long
    dx          as long
    dy          as long
    wMax        as long
    rgchMember  as string * 2
end type

'
' Commands to pass to WinHelp()
'

const HELP_CONTEXT      = &H0001& ' Display topic in ulTopic
const HELP_QUIT         = &H0002& ' Terminate help
const HELP_INDEX        = &H0003& ' Display index
const HELP_CONTENTS     = &H0003&
const HELP_HELPONHELP   = &H0004& ' Display help on using help
const HELP_SETINDEX     = &H0005& ' Set current Index for multi index help
const HELP_SETCONTENTS  = &H0005&
const HELP_CONTEXTPOPUP = &H0008&
const HELP_FORCEFILE    = &H0009&
const HELP_KEY          = &H0101& ' Display topic for keyword in offabData
const HELP_COMMAND      = &H0102&
const HELP_PARTIALKEY   = &H0105&
const HELP_MULTIKEY     = &H0201&
const HELP_SETWINPOS    = &H0203&

declare function WinHelp lib "user32.dll" alias "WinHelpA" (hWndMain&, lpszHelp$, uCommand&, dwData as any) as long

'
' Parameter for SystemParametersInfo()
'

const SPI_GETBEEP               = 1
const SPI_SETBEEP               = 2
const SPI_GETMOUSE              = 3
const SPI_SETMOUSE              = 4
const SPI_GETBORDER             = 5
const SPI_SETBORDER             = 6
const SPI_GETKEYBOARDSPEED      = 10
const SPI_SETKEYBOARDSPEED      = 11
const SPI_LANGDRIVER            = 12
const SPI_ICONHORIZONTALSPACING = 13
const SPI_GETSCREENSAVETIMEOUT  = 14
const SPI_SETSCREENSAVETIMEOUT  = 15
const SPI_GETSCREENSAVEACTIVE   = 16
const SPI_SETSCREENSAVEACTIVE   = 17
const SPI_GETGRIDGRANULARITY    = 18
const SPI_SETGRIDGRANULARITY    = 19
const SPI_SETDESKWALLPAPER      = 20
const SPI_SETDESKPATTERN        = 21
const SPI_GETKEYBOARDDELAY      = 22
const SPI_SETKEYBOARDDELAY      = 23
const SPI_ICONVERTICALSPACING   = 24
const SPI_GETICONTITLEWRAP      = 25
const SPI_SETICONTITLEWRAP      = 26
const SPI_GETMENUDROPALIGNMENT  = 27
const SPI_SETMENUDROPALIGNMENT  = 28
const SPI_SETDOUBLECLKWIDTH     = 29
const SPI_SETDOUBLECLKHEIGHT    = 30
const SPI_GETICONTITLELOGFONT   = 31
const SPI_SETDOUBLECLICKTIME    = 32
const SPI_SETMOUSEBUTTONSWAP    = 33
const SPI_SETICONTITLELOGFONT   = 34
const SPI_GETFASTTASKSWITCH     = 35
const SPI_SETFASTTASKSWITCH     = 36

'
' Flags
'

const SPIF_UPDATEINIFILE    = &H0001&
const SPIF_SENDWININICHANGE = &H0002&

declare function SystemParametersInfo lib "user32.dll" alias "SystemParametersInfoA" (uiAction&, uiParam&, pvParam as any, fWinIni&) as long

'******************************************************************************
'*** From COMMDLG.H: Comdlg32 Types, Constants, Functions
'******************************************************************************

type OPENFILENAME
    lStructSize       as long
    hwndOwner         as long
    hInstance         as long
    lpstrFilter       as pointer to string * 1
    lpstrCustomFilter as pointer to string * 1
    nMaxCustFilter    as long
    nFilterIndex      as long
    lpstrFile         as pointer to string * 1
    nMaxFile          as long
    lpstrFileTitle    as pointer to string * 1
    nMaxFileTitle     as long
    lpstrInitialDir   as pointer to string * 1
    lpstrTitle        as pointer to string * 1
    Flags             as long
    nFileOffset       as short
    nFileExtension    as short
    lpstrDefExt       as pointer to string * 1
    lCustData         as long
    lpfnHook          as dlgproc
    lpTemplateName    as pointer to string * 1
end type

declare function GetOpenFileName lib "comdlg32.dll" alias "GetOpenFileNameA" (lp as OPENFILENAME) as long
declare function GetSaveFileName lib "comdlg32.dll" alias "GetSaveFileNameA" (lp as OPENFILENAME) as long
declare function GetFileTitle    lib "comdlg32.dll" alias "GetFileTitleA"    (sz$, sz$, w as short) as short

const OFN_READONLY             = &H00000001&
const OFN_OVERWRITEPROMPT      = &H00000002&
const OFN_HIDEREADONLY         = &H00000004&
const OFN_NOCHANGEDIR          = &H00000008&
const OFN_SHOWHELP             = &H00000010&
const OFN_ENABLEHOOK           = &H00000020&
const OFN_ENABLETEMPLATE       = &H00000040&
const OFN_ENABLETEMPLATEHANDLE = &H00000080&
const OFN_NOVALIDATE           = &H00000100&
const OFN_ALLOWMULTISELECT     = &H00000200&
const OFN_EXTENSIONDIFFERENT   = &H00000400&
const OFN_PATHMUSTEXIST        = &H00000800&
const OFN_FILEMUSTEXIST        = &H00001000&
const OFN_CREATEPROMPT         = &H00002000&
const OFN_SHAREAWARE           = &H00004000&
const OFN_NOREADONLYRETURN     = &H00008000&
const OFN_NOTESTFILECREATE     = &H00010000&
const OFN_NONETWORKBUTTON      = &H00020000&
const OFN_NOLONGNAMES          = &H00040000&

'  Return values for the registered message sent to the hook function
'  when a sharing violation occurs.  OFN_SHAREFALLTHROUGH allows the
'  filename to be accepted, OFN_SHARENOWARN rejects the name but puts
'  up no warning (returned when the app has already put up a warning
'  message), and OFN_SHAREWARN puts up the default warning message
'  for sharing violations.
'
'  Note:  Undefined return values map to OFN_SHAREWARN, but are
'         reserved for future use.

const OFN_SHAREFALLTHROUGH = 2
const OFN_SHARENOWARN      = 1
const OFN_SHAREWARN        = 0

type _CHOOSECOLOR
    lStructSize    as long
    hwndOwner      as long
    hInstance      as long
    rgbResult      as long
    lpCustColors   as pointer to long
    Flags          as long
    lCustData      as long
    lpfnHook       as dlgproc
    lpTemplateName as pointer to string * 1
end type

declare function ChooseColor lib "comdlg32.dll" alias "ChooseColorA" (lp as _CHOOSECOLOR) as long

const CC_RGBINIT              = &H00000001&
const CC_FULLOPEN             = &H00000002&
const CC_PREVENTFULLOPEN      = &H00000004&
const CC_SHOWHELP             = &H00000008&
const CC_ENABLEHOOK           = &H00000010&
const CC_ENABLETEMPLATE       = &H00000020&
const CC_ENABLETEMPLATEHANDLE = &H00000040&

type FINDREPLACE
    lStructSize      as long    ' size of this struct &H20&
    hwndOwner        as long    ' handle to owner's window
    hInstance        as long    ' instance handle of.EXE that
                                '    contains cust. dlg. template
    Flags            as long    ' one or more of the FR_??
    lpstrFindWhat    as pointer to string * 1 ' ptr. to search string
    lpstrReplaceWith as pointer to string * 1 ' ptr. to replace string
    wFindWhatLen     as short   ' size of find buffer
    wReplaceWithLen  as short   ' size of replace buffer
    lCustData        as long    ' data passed to hook fn.
    lpfnHook         as dlgproc ' ptr. to hook fn. or NULL
    lpTemplateName   as pointer to string * 1 ' custom template name
end type

const FR_DOWN                 = &H00000001&
const FR_WHOLEWORD            = &H00000002&
const FR_MATCHCASE            = &H00000004&
const FR_FINDNEXT             = &H00000008&
const FR_REPLACE              = &H00000010&
const FR_REPLACEALL           = &H00000020&
const FR_DIALOGTERM           = &H00000040&
const FR_SHOWHELP             = &H00000080&
const FR_ENABLEHOOK           = &H00000100&
const FR_ENABLETEMPLATE       = &H00000200&
const FR_NOUPDOWN             = &H00000400&
const FR_NOMATCHCASE          = &H00000800&
const FR_NOWHOLEWORD          = &H00001000&
const FR_ENABLETEMPLATEHANDLE = &H00002000&
const FR_HIDEUPDOWN           = &H00004000&
const FR_HIDEMATCHCASE        = &H00008000&
const FR_HIDEWHOLEWORD        = &H00010000&

declare function FindText    lib "comdlg32.dll" alias "FindTextA"   (lp as FINDREPLACE) as long
declare function ReplaceText lib "comdlg32.dll" alias "ReplaceTextA" (lp as FINDREPLACE) as long

type _CHOOSEFONT
    lStructSize            as long
    hwndOwner              as long ' caller's window handle
    hDC                    as long ' printer DC/IC or NULL
    lpLogFont              as pointer to LOGFONT ' ptr. to a LOGFONT struct
    iPointSize             as long ' 10 * size in points of selected font
    Flags                  as long ' enum. type flags
    rgbColors              as long ' returned text color
    lCustData              as long ' data passed to hook fn.
    lpfnHook               as dlgproc ' ptr. to hook function
    lpTemplateName         as pointer to string * 1 ' custom template name
    hInstance              as long ' instance handle of.EXE that
                                   ' contains cust. dlg. template
    lpszStyle              as pointer to string * 1 ' return the style field here
                                                    ' must be LF_FACESIZE or bigger
    nFontType              as short ' same value reported to the EnumFonts
                                    ' call back with the extra FONTTYPE_
                                    ' bits added
    ___MISSING_ALIGNMENT__ as short
    nSizeMin               as long ' minimum pt size allowed &
    nSizeMax               as long ' max pt size allowed if
                                   ' CF_LIMITSIZE is used
end type

declare function ChooseFont lib "comdlg32.dll" alias "ChooseFontA" (lp as _CHOOSEFONT) as long

const CF_SCREENFONTS          = &H00000001&
const CF_PRINTERFONTS         = &H00000002&
const CF_BOTH                 = (CF_SCREENFONTS or CF_PRINTERFONTS)
const CF_SHOWHELP             = &H00000004&
const CF_ENABLEHOOK           = &H00000008&
const CF_ENABLETEMPLATE       = &H00000010&
const CF_ENABLETEMPLATEHANDLE = &H00000020&
const CF_INITTOLOGFONTSTRUCT  = &H00000040&
const CF_USESTYLE             = &H00000080&
const CF_EFFECTS              = &H00000100&
const CF_APPLY                = &H00000200&
const CF_ANSIONLY             = &H00000400&
const CF_NOVECTORFONTS        = &H00000800&
const CF_NOOEMFONTS           = CF_NOVECTORFONTS
const CF_NOSIMULATIONS        = &H00001000&
const CF_LIMITSIZE            = &H00002000&
const CF_FIXEDPITCHONLY       = &H00004000&
const CF_WYSIWYG              = &H00008000& ' must also have CF_SCREENFONTS & CF_PRINTERFONTS
const CF_FORCEFONTEXIST       = &H00010000&
const CF_SCALABLEONLY         = &H00020000&
const CF_TTONLY               = &H00040000&
const CF_NOFACESEL            = &H00080000&
const CF_NOSTYLESEL           = &H00100000&
const CF_NOSIZESEL            = &H00200000&

'  these are extra nFontType bits that are added to what is returned to the
'  EnumFonts callback routine

const SIMULATED_FONTTYPE       = &H8000&
const PRINTER_FONTTYPE         = &H4000&
const SCREEN_FONTTYPE          = &H2000&
const BOLD_FONTTYPE            = &H0100&
const ITALIC_FONTTYPE          = &H0200&
const REGULAR_FONTTYPE         = &H0400&
const WM_CHOOSEFONT_GETLOGFONT = (WM_USER + 1)

'  strings used to obtain unique window message for communication
'  between dialog and caller

const LBSELCHSTRING = "commdlg_LBSelChangedNotify"
const SHAREVISTRING = "commdlg_ShareViolation"
const FILEOKSTRING  = "commdlg_FileNameOK"
const COLOROKSTRING = "commdlg_ColorOK"
const SETRGBSTRING  = "commdlg_SetRGBColor"
const HELPMSGSTRING = "commdlg_help"
const FINDMSGSTRING = "commdlg_FindReplace"

'  HIWORD values for lParam of commdlg_LBSelChangeNotify message

const CD_LBSELNOITEMS = -1
const CD_LBSELCHANGE  = 0
const CD_LBSELSUB     = 1
const CD_LBSELADD     = 2

type _PRINTDLG
    lStructSize         as long
    hwndOwner           as long
    hDevMode            as long
    hDevNames           as long
    hDC                 as long
    Flags               as long
    nFromPage           as short
    nToPage             as short
    nMinPage            as short
    nMaxPage            as short
    nCopies             as short
    hInstance           as long
    lCustData           as long
    lpfnPrintHook       as dlgproc
    lpfnSetupHook       as dlgproc
    lpPrintTemplateName as pointer to string * 1
    lpSetupTemplateName as pointer to string * 1
    hPrintTemplate      as long
    hSetupTemplate      as long
end type

declare function PrintDlg lib "comdlg32.dll" alias "PrintDlgA" (lp as _PRINTDLG) as long

const PD_ALLPAGES                  = &H00000000&
const PD_SELECTION                 = &H00000001&
const PD_PAGENUMS                  = &H00000002&
const PD_NOSELECTION               = &H00000004&
const PD_NOPAGENUMS                = &H00000008&
const PD_COLLATE                   = &H00000010&
const PD_PRINTTOFILE               = &H00000020&
const PD_PRINTSETUP                = &H00000040&
const PD_NOWARNING                 = &H00000080&
const PD_RETURNDC                  = &H00000100&
const PD_RETURNIC                  = &H00000200&
const PD_RETURNDEFAULT             = &H00000400&
const PD_SHOWHELP                  = &H00000800&
const PD_ENABLEPRINTHOOK           = &H00001000&
const PD_ENABLESETUPHOOK           = &H00002000&
const PD_ENABLEPRINTTEMPLATE       = &H00004000&
const PD_ENABLESETUPTEMPLATE       = &H00008000&
const PD_ENABLEPRINTTEMPLATEHANDLE = &H00010000&
const PD_ENABLESETUPTEMPLATEHANDLE = &H00020000&
const PD_USEDEVMODECOPIES          = &H00040000&
const PD_DISABLEPRINTTOFILE        = &H00080000&
const PD_HIDEPRINTTOFILE           = &H00100000&
const PD_NONETWORKBUTTON           = &H00200000&

type DEVNAMES
    wDriverOffset as short
    wDeviceOffset as short
    wOutputOffset as short
    wDefault      as short
end type

const DN_DEFAULTPRN = &H0001&

declare function CommDlgExtendedError lib "comdlg32.dll" alias "CommDlgExtendedError" () as long

'******************************************************************************
'*** From SHELLAPI.H: Shell32 Types, Constants, Functions
'******************************************************************************

declare function DragQueryFile   lib "shell32.dll" alias "DragQueryFileA"  (hdrop&, u&, sz$, u&) as long
declare function DragQueryPoint  lib "shell32.dll" alias "DragQueryPoint"  (hdrop&, lp as POINT) as long
declare sub      DragFinish      lib "shell32.dll" alias "DragFinish"      (hdrop&)
declare sub      DragAcceptFiles lib "shell32.dll" alias "DragAcceptFiles" (hwnd&, b&)
declare function ExtractIcon     lib "shell32.dll" alias "ExtractIconA"    (hInst&, lpszExeFileName$, nIconIndex&) as long

'  error values for ShellExecute() beyond the regular WinExec() codes

const SE_ERR_SHARE           = 26
const SE_ERR_ASSOCINCOMPLETE = 27
const SE_ERR_DDETIMEOUT      = 28
const SE_ERR_DDEFAIL         = 29
const SE_ERR_DDEBUSY         = 30
const SE_ERR_NOASSOC         = 31

declare function ShellExecute          lib "shell32.dll" alias "ShellExecuteA"          (hwnd&, lpOperation$, lpFile$, lpParameters$, lpDirectory$, nShowCmd&) as long
declare function FindExecutable        lib "shell32.dll" alias "FindExecutableA"        (lpFile$, lpDirectory$, lpResult$) as long
declare function ShellAbout            lib "shell32.dll" alias "ShellAboutA"            (hWnd&, szApp$, szOtherStuff$, hIcon&) as long
declare function DuplicateIcon         lib "shell32.dll" alias "DuplicateIcon"          (hInst&, hIcon&) as long
declare function ExtractAssociatedIcon lib "shell32.dll" alias "ExtractAssociatedIconA" (hInst&, lpIconPath$, lpiIcon as pointer to short) as long

'******************************************************************************
'*** From WINREG.H: Registery Types, Constants, Functions
'******************************************************************************

'
'  Reserved Key Handles.
'

const HKEY_CLASSES_ROOT     = &H80000000&
const HKEY_CURRENT_USER     = &H80000001&
const HKEY_LOCAL_MACHINE    = &H80000002&
const HKEY_USERS            = &H80000003&
const HKEY_PERFORMANCE_DATA = &H80000004&

'  Registry Specific Access Rights.
'
const KEY_QUERY_VALUE        = &H0001
const KEY_SET_VALUE          = &H0002
const KEY_CREATE_SUB_KEY     = &H0004
const KEY_ENUMERATE_SUB_KEYS = &H0008
const KEY_NOTIFY             = &H0010
const KEY_CREATE_LINK        = &H0020

const KEY_READ               = (STANDARD_RIGHTS_READ   or  _
                                KEY_QUERY_VALUE        or  _
                                KEY_ENUMERATE_SUB_KEYS or  _
                                KEY_NOTIFY)            and _
                               (NOT SYNCHRONIZE)


const KEY_WRITE               = (STANDARD_RIGHTS_WRITE or  _
                                 KEY_SET_VALUE         or  _
                                 KEY_CREATE_SUB_KEY)   and _
                                (NOT SYNCHRONIZE)

const KEY_EXECUTE             = KEY_READ and (NOT SYNCHRONIZE)

const KEY_ALL_ACCESS          = (STANDARD_RIGHTS_ALL    or  _
                                 KEY_QUERY_VALUE        or  _
                                 KEY_SET_VALUE          or  _
                                 KEY_CREATE_SUB_KEY     or  _
                                 KEY_ENUMERATE_SUB_KEYS or  _
                                 KEY_NOTIFY             or  _
                                 KEY_CREATE_LINK)       and _
                                (NOT SYNCHRONIZE)

'
'  Open/Create Options
'
const REG_OPTION_RESERVED       = &H00000000&
const REG_OPTION_NON_VOLATILE   = &H00000000&
const REG_OPTION_VOLATILE       = &H00000001&
const REG_OPTION_CREATE_LINK    = &H00000002&
const REG_OPTION_BACKUP_RESTORE = &H00000004&
const REG_LEGAL_OPTION          = REG_OPTION_RESERVED     or _
                                  REG_OPTION_NON_VOLATILE or _
                                  REG_OPTION_VOLATILE     or _
                                  REG_OPTION_CREATE_LINK  or _
                                  REG_OPTION_BACKUP_RESTORE
'
'  Key creation/open disposition
'
const REG_CREATED_NEW_KEY     = &H00000001&
const REG_OPENED_EXISTING_KEY = &H00000002&

'
'  Key restore flags
'
const REG_WHOLE_HIVE_VOLATILE = &H00000001&
const REG_REFRESH_HIVE        = &H00000002&

'
'  Notify filter values
'
const REG_NOTIFY_CHANGE_NAME       = &H00000001&
const REG_NOTIFY_CHANGE_ATTRIBUTES = &H00000002&
const REG_NOTIFY_CHANGE_LAST_SET   = &H00000004&
const REG_NOTIFY_CHANGE_SECURITY   = &H00000008&
const REG_LEGAL_CHANGE_FILTER      = REG_NOTIFY_CHANGE_NAME       or _
                                     REG_NOTIFY_CHANGE_ATTRIBUTES or _
                                     REG_NOTIFY_CHANGE_LAST_SET   or _
                                     REG_NOTIFY_CHANGE_SECURITY

'
'  Predefined Value Types.
'
const REG_NONE      = 0& ' No value type
const REG_SZ        = 1& ' Unicode nul terminated string
const REG_EXPAND_SZ = 2& ' Unicode nul terminated string

const REG_BINARY                   = 3& ' Free form binary
const REG_DWORD                    = 4& ' 32-bit number
const REG_DWORD_LITTLE_ENDIAN      = 4& ' 32-bit number (same as REG_DWORD)
const REG_DWORD_BIG_ENDIAN         = 5& ' 32-bit number
const REG_LINK                     = 6& ' Symbolic Link (unicode)
const REG_MULTI_SZ                 = 7& ' Multiple Unicode strings
const REG_RESOURCE_LIST            = 8& ' Resource list in the resource map
const REG_FULL_RESOURCE_DESCRIPTOR = 9& ' Resource list in the hardware description

'
'  API Prototypes.
'
declare function RegCloseKey        lib "advapi32.dll" alias "RegCloseKey"         (hKey&) as long
declare function RegConnectRegistry lib "advapi32.dll" alias "RegConnectRegistryA" (lpMachineName$, hKey&, phkResult as pointer to long) as long
declare function RegCreateKey       lib "advapi32.dll" alias "RegCreateKeyA"       (hKey&, lpSubKey$, phkResult as pointer to long) as long
declare function RegCreateKeyEx     lib "advapi32.dll" alias "RegCreateKeyExA"     (hKey&, lpSubKey$, Reserved&, lpClass$, dwOptions&, samDesired&, lpSecurityAttributes as any, phkResult as pointer to long, lpdwDisposition as pointer to long) as long
declare function RegDeleteKey       lib "advapi32.dll" alias "RegDeleteKeyA"       (hKey&, lpSubKey$) as long
declare function RegDeleteValue     lib "advapi32.dll" alias "RegDeleteValueA"     (hKey&, lpValueName$) as long
declare function RegEnumKey         lib "advapi32.dll" alias "RegEnumKeyA"         (hKey&, dwIndex&, lpName$, cbName&) as long

declare function RegEnumKeyEx            lib "advapi32.dll" alias "RegEnumKeyExA"           (hKey&, dwIndex&, lpName$, lpcbName as pointer to long, lpReserved as pointer to long, _
                                                                                             lpClass$, lpcbClass as pointer to long, lpftLastWriteTime as FILETIME) as long
declare function RegEnumValue            lib "advapi32.dll" alias "RegEnumValueA"           (hKey&, dwIndex&, lpValueName$, lpcbValueName as pointer to long, lpReserved as pointer to long, _
                                                                                             lpType as pointer to long, lpData$, lpcbData as pointer to long) as long
declare function RegFlushKey             lib "advapi32.dll" alias "RegFlushKey"             (hKey&) as long
declare function RegGetKeySecurity       lib "advapi32.dll" alias "RegGetKeySecurity"       (hKey&, SecurityInformation&, pSecurityDescriptor as any, lpcbSecurityDescriptor as pointer to long) as long
declare function RegLoadKey              lib "advapi32.dll" alias "RegLoadKeyA"             (hKey&, lpSubKey$, lpFile$) as long
declare function RegNotifyChangeKeyValue lib "advapi32.dll" alias "RegNotifyChangeKeyValue" (hKey&, bWatchSubtree&, dwNotifyFilter&, hEvent&, fAsynchronus&) as long
declare function RegOpenKey              lib "advapi32.dll" alias "RegOpenKeyA"             (hKey&, lpSubKey$, phkResult as pointer to long) as long
declare function RegOpenKeyEx            lib "advapi32.dll" alias "RegOpenKeyExA"           (hKey&, lpSubKey$, ulOptions&, samDesired&, phkResult as pointer to long) as long
declare function RegQueryInfoKey         lib "advapi32.dll" alias "RegQueryInfoKeyA"        (hKey&, lpClass$, lpcbClass as pointer to long, lpReserved as pointer to long, lpcSubKeys as pointer to long, lpcbMaxSubKeyLen as pointer to long, _
                                                                                             lpcbMaxClassLen as pointer to long, lpcValues as pointer to long, lpcbMaxValueNameLen as pointer to long, lpcbMaxValueLen as pointer to long, _
                                                                                             lpcbSecurityDescriptor as pointer to long, lpftLastWriteTime as FILETIME) as long
declare function RegQueryValue           lib "advapi32.dll" alias "RegQueryValueA"          (hKey&, lpSubKey$, lpValue$, lpcbValue as pointer to long) as long
declare function RegQueryValueEx         lib "advapi32.dll" alias "RegQueryValueExA"        (hKey&, lpValueName$, lpReserved as pointer to long, lpType as pointer to long, lpData as any, lpcbData as pointer to long) as long
declare function RegReplaceKey           lib "advapi32.dll" alias "RegReplaceKeyA"          (hKey&, lpSubKey$, lpNewFile$, lpOldFile$) as long
declare function RegRestoreKey           lib "advapi32.dll" alias "RegRestoreKeyA"          (hKey&, lpFile$, dwFlags&) as long
declare function RegSaveKey              lib "advapi32.dll" alias "RegSaveKeyA"             (hKey&, lpFile$, lpSecurityAttributes as any) as long
declare function RegSetKeySecurity       lib "advapi32.dll" alias "RegSetKeySecurity"       (hKey&, SecurityInformation&, pSecurityDescriptor as any) as long
declare function RegSetValue             lib "advapi32.dll" alias "RegSetValueA"            (hKey&, lpSubKey$, dwType&, lpData$, cbData&) as long
declare function RegSetValueEx           lib "advapi32.dll" alias "RegSetValueExA"          (hKey&, lpValueName$, Reserved&, dwType&, lpData as any, cbData&) as long
declare function RegUnLoadKey            lib "advapi32.dll" alias "RegUnLoadKeyA"           (hKey&, lpSubKey$) as long

'
'  Remoteable System Shutdown APIs
'

declare function InitiateSystemShutdown lib "advapi32.dll" alias "InitiateSystemShutdownA" (lpMachineName$, lpMessage$, dwTimeout&, bForceAppsClosed&, bRebootAfterShutdown&) as long
declare function AbortSystemShutdown    lib "advapi32.dll" alias "AbortSystemShutdownA"   (lpMachineName$) as long

'
'  RESOURCE ENUMERATION
'

const RESOURCE_CONNECTED          = &H00000001&
const RESOURCE_GLOBALNET          = &H00000002&
const RESOURCE_REMEMBERED         = &H00000003&
const RESOURCETYPE_ANY            = &H00000000&
const RESOURCETYPE_DISK           = &H00000001&
const RESOURCETYPE_PRINT          = &H00000002&
const RESOURCETYPE_UNKNOWN        = &HFFFFFFFF&
const RESOURCEUSAGE_CONNECTABLE   = &H00000001&
const RESOURCEUSAGE_CONTAINER     = &H00000002&
const RESOURCEUSAGE_RESERVED      = &H80000000&
const RESOURCEDISPLAYTYPE_GENERIC = &H00000000&
const RESOURCEDISPLAYTYPE_DOMAIN  = &H00000001&
const RESOURCEDISPLAYTYPE_SERVER  = &H00000002&
const RESOURCEDISPLAYTYPE_SHARE   = &H00000003&
const RESOURCEDISPLAYTYPE_FILE    = &H00000004&
const RESOURCEDISPLAYTYPE_GROUP   = &H00000005&

type NETRESOURCE
    dwScope       as long
    dwType        as long
    dwDisplayType as long
    dwUsage       as long
    lpLocalName   as pointer to string * 1
    lpRemoteName  as pointer to string * 1
    lpComment     as pointer to string * 1
    lpProvider    as pointer to string * 1
end type

'
'   CONNECTIONS
'

const CONNECT_UPDATE_PROFILE = &H00000001&

declare function WNetAddConnection     lib "mpr.dll" alias "WNetAddConnectionA"    (lpRemoteName$, lpPassword$, lpLocalName$) as long
declare function WNetAddConnection2    lib "mpr.dll" alias "WNetAddConnection2A"   (lpNetResource as NETRESOURCE, lpPassword$, lpUserName$, dwFlags&) as long
declare function WNetCancelConnection  lib "mpr.dll" alias "WNetCancelConnectionA" (lpName$, fForce&) as long
declare function WNetCancelConnection2 lib "mpr.dll" alias "WNetCancelConnection2A" (lpName$, dwFlags&, fForce&) as long
declare function WNetGetConnection     lib "mpr.dll" alias "WNetGetConnectionA"    (lpLocalName$, lpRemoteName$, lpnLength as pointer to long) as long
declare function WNetOpenEnum          lib "mpr.dll" alias "WNetOpenEnumA"         (dwScope&, dwType&, dwUsage&, lpNetResource as NETRESOURCE, lphEnum as pointer to long) as long
declare function WNetEnumResource      lib "mpr.dll" alias "WNetEnumResourceA"     (hEnum&, lpcCount as pointer to long, lpBuffer as any, lpBufferSize as pointer to long) as long
declare function WNetCloseEnum         lib "mpr.dll" alias "WNetCloseEnum"         (hEnum&) as long

'
'   OTHER
'

declare function WNetGetUser lib "mpr.dll" alias "WNetGetUserA" (lpName$, lpUserName$, lpnLength as pointer to long) as long

'
'   BROWSE DIALOGS
'

declare function WNetConnectionDialog lib "mpr.dll" alias "WNetConnectionDialog" (hwnd&, dwType&) as long
declare function WNetDisconnectDialog lib "mpr.dll" alias "WNetDisconnectDialog" (hwnd&, dwType&) as long

'
'   ERRORS
'

declare function WNetGetLastError lib "mpr.dll" alias "WNetGetLastErrorA" (lpError as pointer to long, lpErrorBuf$, nErrorBufSize&, lpNameBuf$, nNameBufSize&) as long

'
'   STATUS CODES
'
'   This section is provided for backward compatibility.  Use of the ERROR_*
'   codes is preferred.  The WN_* error codes may not be available in future
'   releases.
'
'  General

const WN_SUCCESS        = NO_ERROR
const WN_NOT_SUPPORTED  = ERROR_NOT_SUPPORTED
const WN_NET_ERROR      = ERROR_UNEXP_NET_ERR
const WN_MORE_DATA      = ERROR_MORE_DATA
const WN_BAD_POINTER    = ERROR_INVALID_ADDRESS
const WN_BAD_VALUE      = ERROR_INVALID_PARAMETER
const WN_BAD_PASSWORD   = ERROR_INVALID_PASSWORD
const WN_ACCESS_DENIED  = ERROR_ACCESS_DENIED
const WN_FUNCTION_BUSY  = ERROR_BUSY
const WN_WINDOWS_ERROR  = ERROR_UNEXP_NET_ERR
const WN_BAD_USER       = ERROR_BAD_USERNAME
const WN_OUT_OF_MEMORY  = ERROR_NOT_ENOUGH_MEMORY
const WN_NO_NETWORK     = ERROR_NO_NETWORK
const WN_EXTENDED_ERROR = ERROR_EXTENDED_ERROR

'  Connection

const WN_NOT_CONNECTED       = ERROR_NOT_CONNECTED
const WN_OPEN_FILES          = ERROR_OPEN_FILES
const WN_DEVICE_IN_USE       = ERROR_DEVICE_IN_USE
const WN_BAD_NETNAME         = ERROR_BAD_NET_NAME
const WN_BAD_LOCALNAME       = ERROR_BAD_DEVICE
const WN_ALREADY_CONNECTED   = ERROR_ALREADY_ASSIGNED
const WN_DEVICE_ERROR        = ERROR_GEN_FAILURE
const WN_CONNECTION_CLOSED   = ERROR_CONNECTION_UNAVAIL
const WN_NO_NET_OR_BAD_PATH  = ERROR_NO_NET_OR_BAD_PATH
const WN_BAD_PROVIDER        = ERROR_BAD_PROVIDER
const WN_CANNOT_OPEN_PROFILE = ERROR_CANNOT_OPEN_PROFILE
const WN_BAD_PROFILE         = ERROR_BAD_PROFILE

'  Enumeration

const WN_BAD_HANDLE      = ERROR_INVALID_HANDLE
const WN_NO_MORE_ENTRIES = ERROR_NO_MORE_ITEMS
const WN_NOT_CONTAINER   = ERROR_NOT_CONTAINER
const WN_NO_ERROR        = NO_ERROR

' Macros for wParam and lParam paramaters various messages for backward
' compatibility with 3.00a scripts
'-------------------------------------------------------------------------------
macro GET_COMMAND_ID       (wParam, lParam) = loword(wParam)
macro GET_COMMAND_CMD      (wParam, lParam) = hiword(wParam)
macro GET_COMMAND_HWND     (wParam, lParam) = lParam
macro GET_MENUSELECT_ID    (wParam, lParam) = loword(wParam)
macro GET_MENUSELECT_FLAGS (wParam, lParam) = hiword(wParam)
macro GET_MENUSELECT_MENU  (wParam, lParam) = lParam
macro GET_VKEYTOITEM_VKEY  (wParam, lParam) = loword(wParam)
macro GET_VKEYTOITEM_CTRL  (wParam, lParam) = lParam
macro GET_VKEYTOITEM_POS   (wParam, lParam) = hiword(wParam)
macro GET_SCROLL_CODE      (wParam, lParam) = loword(wParam)
macro GET_SCROLL_POS       (wParam, lParam) = hiword(wParam)
macro GET_SCROLL_CTRL      (wParam, lParam) = lParam

' Simply determinng if DBCS is enabled or not
'-------------------------------------------------------------------------------
macro DBCS_ENABLED = (GetSystemMetrics(SM_DBCSENABLED) <> 0)

'*******************************************************************************
'*******************************************************************************
'
'                   New COMMCTRL.H for Win95 and Cairo stuff
'
'*******************************************************************************
'*******************************************************************************

declare sub InitCommonControls lib "comctl32.dll" alias "InitCommonControls" ()

const WM_NOTIFY = &h004E&

type NMHDR
    hwndFrom as long
    idFrom   as long
    code     as long ' NM_ code
end type

const ODT_HEADER   = 100
const ODT_TAB      = 101
const ODT_LISTVIEW = 102

' ====== Ranges for control message IDs =======================================

const LVM_FIRST = &H1000& ' ListView messages
const TV_FIRST  = &H1100& ' TreeView messages
const HDM_FIRST = &H1200& ' Header messages

' ====== WM_NOTIFY codes (NMHDR.code values) ==================================

const NM_FIRST  = (0-  0) ' generic to all controls
const NM_LAST   = (0- 99)
const LVN_FIRST = (0-100) ' listview
const LVN_LAST  = (0-199)
const HDN_FIRST = (0-300) ' header
const HDN_LAST  = (0-399)
const TVN_FIRST = (0-400) ' treeview
const TVN_LAST  = (0-499)
const TTN_FIRST = (0-520) ' tooltips
const TTN_LAST  = (0-549)
const TCN_FIRST = (0-550) ' tab control
const TCN_LAST  = (0-580)

' ====== Generic WM_NOTIFY notification codes =================================

const NM_OUTOFMEMORY = (NM_FIRST-1)
const NM_CLICK       = (NM_FIRST-2)
const NM_DBLCLK      = (NM_FIRST-3)
const NM_RETURN      = (NM_FIRST-4)
const NM_RCLICK      = (NM_FIRST-5)
const NM_RDBLCLK     = (NM_FIRST-6)
const NM_SETFOCUS    = (NM_FIRST-7)
const NM_KILLFOCUS   = (NM_FIRST-8)
const NM_STARTWAIT   = (NM_FIRST-9)
const NM_ENDWAIT     = (NM_FIRST-10)
const NM_BTNCLK      = (NM_FIRST-10)


'  Shell reserved               (0U-580U) -  (0U-589U)

const CDN_FIRST                 = (0-601) ' common dialog (new)
const CDN_LAST                  = (0-699)
const TBN_FIRST                 = (0-700) ' toolbar
const TBN_LAST                  = (0-720)
const UDN_FIRST                 = (0-721) ' updown
const UDN_LAST                  = (0-740)
const MSGF_COMMCTRL_BEGINDRAG   = &H4200&
const MSGF_COMMCTRL_SIZEHEADER  = &H4201&
const MSGF_COMMCTRL_DRAGSELECT  = &H4202&
const MSGF_COMMCTRL_TOOLBARCUST = &H4203&

' ====== IMAGE APIS ===========================================================

const CLR_NONE     = &HFFFFFFFF&
const CLR_DEFAULT  = &HFF000000&
const ILC_MASK     = &H0001&
const ILC_COLOR    = &H00FE&
const ILC_COLORDDB = &H00FE&
const ILC_COLOR4   = &H0004&
const ILC_COLOR8   = &H0008&
const ILC_COLOR16  = &H0010&
const ILC_COLOR24  = &H0018&
const ILC_COLOR32  = &H0020&
const ILC_PALETTE  = &H0800&

declare function ImageList_Create          lib "comctl32.dll" alias "ImageList_Create"          (cx&, cy&, flags&, cInitial&, cGrow&) as long
declare function ImageList_Destroy         lib "comctl32.dll" alias "ImageList_Destroy"         (himl as long) as long
declare function ImageList_GetImageCount   lib "comctl32.dll" alias "ImageList_GetImageCount"   (himl as long) as long
declare function ImageList_Add             lib "comctl32.dll" alias "ImageList_Add"             (himl as long, hbmImage&, hbmMask&) as long
declare function ImageList_ReplaceIcon     lib "comctl32.dll" alias "ImageList_ReplaceIcon"     (himl as long, i&, hicon&) as long
declare function ImageList_SetBkColor      lib "comctl32.dll" alias "ImageList_SetBkColor"      (himl as long, clrBk&) as long
declare function ImageList_GetBkColor      lib "comctl32.dll" alias "ImageList_GetBkColor"      (himl as long) as long
declare function ImageList_SetOverlayImage lib "comctl32.dll" alias "ImageList_SetOverlayImage" (himl as long, iImage&, iOverlay&) as long

const ILD_NORMAL      = &H0000&
const ILD_TRANSPARENT = &H0001&
const ILD_MASK        = &H0010&
const ILD_IMAGE       = &H0020&
const ILD_BLEND       = &H000E&
const ILD_BLEND25     = &H0002&
const ILD_BLEND50     = &H0004&
const ILD_OVERLAYMASK = &H0F00&
const ILD_SELECTED    = ILD_BLEND50
const ILD_FOCUS       = ILD_BLEND25
const CLR_HILIGHT     = CLR_DEFAULT

declare function ImageList_Draw               lib "comctl32.dll" alias "ImageList_Draw"               (himl as long, i&, hdcDst&, x&, y&, fStyle&) as long
declare function ImageList_Replace            lib "comctl32.dll" alias "ImageList_Replace"            (himl as long, i&, hbmImage&, hbmMask&) as long
declare function ImageList_AddMasked          lib "comctl32.dll" alias "ImageList_AddMasked"          (himl as long, hbmImage&, crMask&) as long
declare function ImageList_DrawEx             lib "comctl32.dll" alias "ImageList_DrawEx"             (himl as long, i&, hdcDst&, x&, y&, dx&, dy&, rgbBk&, rgbFg&, fStyle&) as long
declare function ImageList_Remove             lib "comctl32.dll" alias "ImageList_Remove"             (himl as long, i&) as long
declare function ImageList_GetIcon            lib "comctl32.dll" alias "ImageList_GetIcon"            (himl as long, i&, flags&) as long
declare function ImageList_LoadImage          lib "comctl32.dll" alias "ImageList_LoadImage"          (hi&, lpbmp$, cx&, cGrow&, crMask&, uType&, uFlags&) as long
declare function ImageList_BeginDrag          lib "comctl32.dll" alias "ImageList_BeginDrag"          (himlTrack as long, iTrack&, dxHotspot&, dyHotspot&) as long
declare sub      ImageList_EndDrag            lib "comctl32.dll" alias "ImageList_EndDrag"            ()
declare function ImageList_DragEnter          lib "comctl32.dll" alias "ImageList_DragEnter"          (hwndLock&, x&, y&) as long
declare function ImageList_DragLeave          lib "comctl32.dll" alias "ImageList_DragLeave"          (hwndLock&) as long
declare function ImageList_DragMove           lib "comctl32.dll" alias "ImageList_DragMove"           (x&, y&) as long
declare function ImageList_SetDragCursorImage lib "comctl32.dll" alias "ImageList_SetDragCursorImage" (himlDrag as long, iDrag&, dxHotspot&, dyHotspot&) as long
declare function ImageList_DragShowNolock     lib "comctl32.dll" alias "ImageList_DragShowNolock"     (fShow&) as long
declare function ImageList_GetDragImage       lib "comctl32.dll" alias "ImageList_GetDragImage"       (ppt as POINT, pptHotspot as POINT) as long

type IMAGEINFO
    hbmImage as long
    hbmMask  as long
    Unused1  as long
    Unused2  as long
    rcImage  as RECT
end type

declare function ImageList_GetIconSize  lib "comctl32.dll" alias "ImageList_GetIconSize"  (himl as long, FAR&, FAR&) as long
declare function ImageList_SetIconSize  lib "comctl32.dll" alias "ImageList_SetIconSize"  (himl as long, cx&, cy&) as long
declare function ImageList_GetImageInfo lib "comctl32.dll" alias "ImageList_GetImageInfo" (himl as long, i&, pImageInfo as IMAGEINFO) as long
declare function ImageList_Merge        lib "comctl32.dll" alias "ImageList_Merge"        (himl1 as long, i1&, himl2 as long, i2&, dx&, dy&) as long

' ====== HEADER CONTROL =======================================================

const HDS_HORZ    = &H00000000&
const HDS_BUTTONS = &H00000002&
const HDS_HIDDEN  = &H00000008&

type HD_ITEM
    mask       as long
    cxy        as long
    pszText    as pointer to string * 1
    hbm        as long
    cchTextMax as long
    fmt        as long
    lParam     as long
end type

const HDI_WIDTH        = &H0001&
const HDI_HEIGHT       = HDI_WIDTH
const HDI_TEXT         = &H0002&
const HDI_FORMAT       = &H0004&
const HDI_LPARAM       = &H0008&
const HDI_BITMAP       = &H0010&
const HDF_LEFT         = 0
const HDF_RIGHT        = 1
const HDF_CENTER       = 2
const HDF_JUSTIFYMASK  = &H0003&
const HDF_OWNERDRAW    = &H8000&
const HDF_STRING       = &H4000&
const HDF_BITMAP       = &H2000&
const HDM_GETITEMCOUNT = (HDM_FIRST + 0)
const HDM_INSERTITEM   = (HDM_FIRST + 1)
const HDM_DELETEITEM   = (HDM_FIRST + 2)
const HDM_GETITEM      = (HDM_FIRST + 3)
const HDM_SETITEM      = (HDM_FIRST + 4)

type HD_LAYOUT
    prc   as RECT
    pwpos as WINDOWPOS
end type

const HDM_LAYOUT    = (HDM_FIRST + 5)
const HHT_NOWHERE   = &H0001&
const HHT_ONHEADER  = &H0002&
const HHT_ONDIVIDER = &H0004&
const HHT_ONDIVOPEN = &H0008&
const HHT_ABOVE     = &H0100&
const HHT_BELOW     = &H0200&
const HHT_TORIGHT   = &H0400&
const HHT_TOLEFT    = &H0800&

type HD_HITTESTINFO
    pt    as POINT
    flags as long
    iItem as long
end type

const HDM_HITTEST         = (HDM_FIRST + 6)
const HDN_ITEMCHANGING    = (HDN_FIRST-0)
const HDN_ITEMCHANGED     = (HDN_FIRST-1)
const HDN_ITEMCLICK       = (HDN_FIRST-2)
const HDN_ITEMDBLCLICK    = (HDN_FIRST-3)
const HDN_DIVIDERDBLCLICK = (HDN_FIRST-5)
const HDN_BEGINTRACK      = (HDN_FIRST-6)
const HDN_ENDTRACK        = (HDN_FIRST-7)
const HDN_TRACK           = (HDN_FIRST-8)

type HD_NOTIFY
    hdr     as NMHDR
    iItem   as long
    iButton as long
    pitem   as HD_ITEM
end type

' ====== TOOLBAR CONTROL ======================================================

type TBBUTTON
    iBitmap   as long
    idCommand as long
    fsState   as string * 1
    fsStyle   as string * 1
    bReserved as string * 2
    dwData    as long
    iString   as long
end type

type COLORMAP
    lfrom as long
    lto   as long
end type

declare function CreateToolbarEx    lib "comctl32.dll" alias "CreateToolbarEx"    (hwnd&, ws&, wID&, nBitmaps&, hBMInst&, wBMID&, lpButtons as TBBUTTON, iNumButtons&, dxButton&, dyButton&, dxBitmap&, dyBitmap&, uStructSize&) as long
declare function CreateMappedBitmap lib "comctl32.dll" alias "CreateMappedBitmap" (hInstance&, idBitmap&, wFlags&, lpColorMap as COLORMAP, iNumMaps&) as long

const CMB_MASKED               = &H02&
const TBSTATE_CHECKED          = &H01&
const TBSTATE_PRESSED          = &H02&
const TBSTATE_ENABLED          = &H04&
const TBSTATE_HIDDEN           = &H08&
const TBSTATE_INDETERMINATE    = &H10&
const TBSTATE_WRAP             = &H20&
const TBSTYLE_BUTTON           = &H00&
const TBSTYLE_SEP              = &H01&
const TBSTYLE_CHECK            = &H02&
const TBSTYLE_GROUP            = &H04&
const TBSTYLE_CHECKGROUP       = (TBSTYLE_GROUP or TBSTYLE_CHECK)
const TBSTYLE_TOOLTIPS         = &H0100&
const TBSTYLE_WRAPABLE         = &H0200&
const TBSTYLE_ALTDRAG          = &H0400&
const TB_ENABLEBUTTON          = (WM_USER + 1)
const TB_CHECKBUTTON           = (WM_USER + 2)
const TB_PRESSBUTTON           = (WM_USER + 3)
const TB_HIDEBUTTON            = (WM_USER + 4)
const TB_INDETERMINATE         = (WM_USER + 5)
const TB_ISBUTTONENABLED       = (WM_USER + 9)
const TB_ISBUTTONCHECKED       = (WM_USER + 10)
const TB_ISBUTTONPRESSED       = (WM_USER + 11)
const TB_ISBUTTONHIDDEN        = (WM_USER + 12)
const TB_ISBUTTONINDETERMINATE = (WM_USER + 13)
const TB_SETSTATE              = (WM_USER + 17)
const TB_GETSTATE              = (WM_USER + 18)
const TB_ADDBITMAP             = (WM_USER + 19)

type TBADDBITMAP
    hInst as long
    nID   as long
end type

const HINST_COMMCTRL       = (-1)
const IDB_STD_SMALL_COLOR  = 0
const IDB_STD_LARGE_COLOR  = 1
const IDB_VIEW_SMALL_COLOR = 4
const IDB_VIEW_LARGE_COLOR = 5

'  icon indexes for standard bitmap

const STD_CUT        = 0
const STD_COPY       = 1
const STD_PASTE      = 2
const STD_UNDO       = 3
const STD_REDOW      = 4
const STD_DELETE     = 5
const STD_FILENEW    = 6
const STD_FILEOPEN   = 7
const STD_FILESAVE   = 8
const STD_PRINTPRE   = 9
const STD_PROPERTIES = 10
const STD_HELP       = 11
const STD_FIND       = 12
const STD_REPLACE    = 13
const STD_PRINT      = 14

'  icon indexes for standard view bitmap

const VIEW_LARGEICONS    = 0
const VIEW_SMALLICONS    = 1
const VIEW_LIST          = 2
const VIEW_DETAILS       = 3
const VIEW_SORTNAME      = 4
const VIEW_SORTSIZE      = 5
const VIEW_SORTDATE      = 6
const VIEW_SORTTYPE      = 7
const VIEW_PARENTFOLDER  = 8
const VIEW_NETCONNECT    = 9
const VIEW_NETDISCONNECT = 10
const VIEW_NEWFOLDER     = 11
const TB_ADDBUTTONS      = (WM_USER + 20)
const TB_INSERTBUTTON    = (WM_USER + 21)
const TB_DELETEBUTTON    = (WM_USER + 22)
const TB_GETBUTTON       = (WM_USER + 23)
const TB_BUTTONCOUNT     = (WM_USER + 24)
const TB_COMMANDTOINDEX  = (WM_USER + 25)

type TBSAVEPARAMS
    hkr          as long
    pszSubKey    as pointer to string * 1
    pszValueName as pointer to string * 1
end type

const TB_SAVERESTORE      = (WM_USER + 26)
const TB_CUSTOMIZE        = (WM_USER + 27)
const TB_ADDSTRING        = (WM_USER + 28)
const TB_GETITEMRECT      = (WM_USER + 29)
const TB_BUTTONSTRUCTSIZE = (WM_USER + 30)
const TB_SETBUTTONSIZE    = (WM_USER + 31)
const TB_SETBITMAPSIZE    = (WM_USER + 32)
const TB_AUTOSIZE         = (WM_USER + 33)
const TB_SETBUTTONTYPE    = (WM_USER + 34)
const TB_GETTOOLTIPS      = (WM_USER + 35)
const TB_SETTOOLTIPS      = (WM_USER + 36)
const TB_SETPARENT        = (WM_USER + 37)
const TB_SETROWS          = (WM_USER + 39)
const TB_GETROWS          = (WM_USER + 40)
const TB_SETCMDID         = (WM_USER + 42)
const TB_CHANGEBITMAP     = (WM_USER + 43)
const TB_GETBITMAP        = (WM_USER + 44)
const TB_GETBUTTONTEXT    = (WM_USER + 45)
const TBBF_LARGE          = &H0001&
const TB_GETBITMAPFLAGS   = (WM_USER + 41)
const TBN_GETBUTTONINFO   = (TBN_FIRST-0)
const TBN_BEGINDRAG       = (TBN_FIRST-1)
const TBN_ENDDRAG         = (TBN_FIRST-2)
const TBN_BEGINADJUST     = (TBN_FIRST-3)
const TBN_ENDADJUST       = (TBN_FIRST-4)
const TBN_RESET           = (TBN_FIRST-5)
const TBN_QUERYINSERT     = (TBN_FIRST-6)
const TBN_QUERYDELETE     = (TBN_FIRST-7)
const TBN_TOOLBARCHANGE   = (TBN_FIRST-8)
const TBN_CUSTHELP        = (TBN_FIRST-9)

type TBNOTIFY
    hdr      as NMHDR
    iItem    as long
    tbButton as TBBUTTON
    cchText  as long
    pszText  as pointer to string * 1
end type

' ====== TOOLTIPS CONTROL =====================================================

type TOOLINFO
    cbSize   as long
    uFlags   as long
    hwnd     as long
    uId      as long
    rect     as RECT
    hinst    as long
    lpszText as pointer to string * 1
end type

const TTS_ALWAYSTIP      = &H01&
const TTS_NOPREFIX       = &H02&
const TTF_IDISHWND       = &H01&
const TTF_CENTERTIP      = &H02&
const TTDT_AUTOMATIC     = 0
const TTDT_RESHOW        = 1
const TTDT_AUTOPOP       = 2
const TTDT_INITIAL       = 3
const TTM_ACTIVATE       = (WM_USER + 1)
const TTM_SETDELAYTIME   = (WM_USER + 3)
const TTM_ADDTOOL        = (WM_USER + 4)
const TTM_DELTOOL        = (WM_USER + 5)
const TTM_NEWTOOLRECT    = (WM_USER + 6)
const TTM_RELAYEVENT     = (WM_USER + 7)
const TTM_GETTOOLINFO    = (WM_USER + 8)
const TTM_SETTOOLINFO    = (WM_USER + 9)
const TTM_HITTEST        = (WM_USER +10)
const TTM_GETTEXT        = (WM_USER +11)
const TTM_UPDATETIPTEXT  = (WM_USER +12)
const TTM_GETTOOLCOUNT   = (WM_USER +13)
const TTM_ENUMTOOLS      = (WM_USER +14)
const TTM_GETCURRENTTOOL = (WM_USER + 15)

type TTHITTESTINFO
    hwnd as long
    pt   as POINT
    ti   as TOOLINFO
end type

const TTN_NEEDTEXT = (TTN_FIRST - 0)
const TTN_SHOW     = (TTN_FIRST - 1)
const TTN_POP      = (TTN_FIRST - 2)

type TOOLTIPTEXT
    hdr      as NMHDR
    lpszText as pointer to string * 1
    szText   as string * 80
    hinst    as long
    uFlags   as long
end type

' ====== STATUS BAR CONTROL ===================================================

const SBARS_SIZEGRIP = &H0100&

declare sub      DrawStatusText     lib "comctl32.dll" alias "DrawStatusText"     (hDC&, lprc as RECT, pszText$, uFlags&)
declare function CreateStatusWindow lib "comctl32.dll" alias "CreateStatusWindow" (style&, lpszText$, hwndParent&, wID&) as long

const SB_SETTEXT       = (WM_USER+1)
const SB_GETTEXT       = (WM_USER+2)
const SB_GETTEXTLENGTH = (WM_USER+3)
const SB_SETPARTS      = (WM_USER+4)
const SB_GETPARTS      = (WM_USER+6)
const SB_GETBORDERS    = (WM_USER+7)
const SB_SETMINHEIGHT  = (WM_USER+8)
const SB_SIMPLE        = (WM_USER+9)
const SB_GETRECT       = (WM_USER + 10)
const SBT_OWNERDRAW    = &H1000&
const SBT_NOBORDERS    = &H0100&
const SBT_POPOUT       = &H0200&
const HBT_SPRING       = &H0400&

declare sub      MenuHelp               lib "comctl32.dll" alias "MenuHelp"               (uMsg&, wParam&, lParam&, hMainMenu&, hInst&, hwndStatus&, FAR&)
declare function ShowHideMenuCtl        lib "comctl32.dll" alias "ShowHideMenuCtl"        (hWnd&, uFlags&, lpInfo as pointer to long) as long
declare sub      GetEffectiveClientRect lib "comctl32.dll" alias "GetEffectiveClientRect" (hWnd&, lprc as RECT, lpInfo as pointer to long)

const MINSYSCOMMAND = SC_SIZE

' ====== TRACKBAR CONTROL =====================================================

const TBS_AUTOTICKS      = &H0001&
const TBS_VERT           = &H0002&
const TBS_HORZ           = &H0000&
const TBS_TOP            = &H0004&
const TBS_BOTTOM         = &H0000&
const TBS_LEFT           = &H0004&
const TBS_RIGHT          = &H0000&
const TBS_BOTH           = &H0008&
const TBS_NOTICKS        = &H0010&
const TBS_ENABLESELRANGE = &H0020&
const TBS_FIXEDLENGTH    = &H0040&
const TBS_NOTHUMB        = &H0080&
const TBM_GETPOS         = (WM_USER)
const TBM_GETRANGEMIN    = (WM_USER+1)
const TBM_GETRANGEMAX    = (WM_USER+2)
const TBM_GETTIC         = (WM_USER+3)
const TBM_SETTIC         = (WM_USER+4)
const TBM_SETPOS         = (WM_USER+5)
const TBM_SETRANGE       = (WM_USER+6)
const TBM_SETRANGEMIN    = (WM_USER+7)
const TBM_SETRANGEMAX    = (WM_USER+8)
const TBM_CLEARTICS      = (WM_USER+9)
const TBM_SETSEL         = (WM_USER+10)
const TBM_SETSELSTART    = (WM_USER+11)
const TBM_SETSELEND      = (WM_USER+12)
const TBM_GETPTICS       = (WM_USER+14)
const TBM_GETTICPOS      = (WM_USER+15)
const TBM_GETNUMTICS     = (WM_USER+16)
const TBM_GETSELSTART    = (WM_USER+17)
const TBM_GETSELEND      = (WM_USER+18)
const TBM_CLEARSEL       = (WM_USER+19)
const TBM_SETTICFREQ     = (WM_USER+20)
const TBM_SETPAGESIZE    = (WM_USER+21)
const TBM_GETPAGESIZE    = (WM_USER+22)
const TBM_SETLINESIZE    = (WM_USER+23)
const TBM_GETLINESIZE    = (WM_USER+24)
const TBM_GETTHUMBRECT   = (WM_USER+25)
const TBM_GETCHANNELRECT = (WM_USER+26)
const TBM_SETTHUMBLENGTH = (WM_USER+27)
const TBM_GETTHUMBLENGTH = (WM_USER+28)
const TB_LINEUP          = 0
const TB_LINEDOWN        = 1
const TB_PAGEUP          = 2
const TB_PAGEDOWN        = 3
const TB_THUMBPOSITION   = 4
const TB_THUMBTRACK      = 5
const TB_TOP             = 6
const TB_BOTTOM          = 7
const TB_ENDTRACK        = 8

' ====== DRAG LIST CONTROL ====================================================

type DRAGLISTINFO
    uNotification as long
    hWnd          as long
    ptCursor      as POINT
end type

const DL_BEGINDRAG  = (WM_USER+133)
const DL_DRAGGING   = (WM_USER+134)
const DL_DROPPED    = (WM_USER+135)
const DL_CANCELDRAG = (WM_USER+136)
const DL_CURSORSET  = 0
const DL_STOPCURSOR = 1
const DL_COPYCURSOR = 2
const DL_MOVECURSOR = 3

declare function MakeDragList lib "comctl32.dll" alias "MakeDragList" (hLB&) as long
declare sub      DrawInsert   lib "comctl32.dll" alias "DrawInsert"   (handParent&, hLB&, nItem&)
declare function LBItemFromPt lib "comctl32.dll" alias "LBItemFromPt" (hLB&, pt as POINT, bAutoScroll&) as long

' ====== UPDOWN CONTROL =======================================================

type UDACCEL
    nSec as long
    nInc as long
end type

const UD_MAXVAL       = &H7fff&
const UD_MINVAL       = (-UD_MAXVAL)
const UDS_WRAP        = &H0001&
const UDS_SETBUDDYINT = &H0002&
const UDS_ALIGNRIGHT  = &H0004&
const UDS_ALIGNLEFT   = &H0008&
const UDS_AUTOBUDDY   = &H0010&
const UDS_ARROWKEYS   = &H0020&
const UDS_HORZ        = &H0040&
const UDS_NOTHOUSANDS = &H0080&
const UDM_SETRANGE    = (WM_USER+101)
const UDM_GETRANGE    = (WM_USER+102)
const UDM_SETPOS      = (WM_USER+103)
const UDM_GETPOS      = (WM_USER+104)
const UDM_SETBUDDY    = (WM_USER+105)
const UDM_GETBUDDY    = (WM_USER+106)
const UDM_SETACCEL    = (WM_USER+107)
const UDM_GETACCEL    = (WM_USER+108)
const UDM_SETBASE     = (WM_USER+109)
const UDM_GETBASE     = (WM_USER+110)

declare function CreateUpDownControl lib "comctl32.dll" alias "CreateUpDownControl" (dwStyle&, x&, y&, cx&, cy&, hParent&, nID&, hInst&, hBuddy&, nUpper&, nLower&, nPos&) as long

type NM_UPDOWN
    hdr    as NMHDR
    iPos   as long
    iDelta as long
end type

const UDN_DELTAPOS = (UDN_FIRST - 1)

' ====== PROGRESS CONTROL =====================================================

const PBM_SETRANGE = (WM_USER+1)
const PBM_SETPOS   = (WM_USER+2)
const PBM_DELTAPOS = (WM_USER+3)
const PBM_SETSTEP  = (WM_USER+4)
const PBM_STEPIT   = (WM_USER+5)

' ====== HOTKEY CONTROL =======================================================

const HOTKEYF_SHIFT   = &H01&
const HOTKEYF_CONTROL = &H02&
const HOTKEYF_ALT     = &H04&
const HOTKEYF_EXT     = &H08&
const HKCOMB_NONE     = &H0001&
const HKCOMB_S        = &H0002&
const HKCOMB_C        = &H0004&
const HKCOMB_A        = &H0008&
const HKCOMB_SC       = &H0010&
const HKCOMB_SA       = &H0020&
const HKCOMB_CA       = &H0040&
const HKCOMB_SCA      = &H0080&
const HKM_SETHOTKEY   = (WM_USER+1)
const HKM_GETHOTKEY   = (WM_USER+2)
const HKM_SETRULES    = (WM_USER+3)

' ====== COMMON CONTROL STYLES ================================================

const CCS_TOP           = &H00000001&
const CCS_NOMOVEY       = &H00000002&
const CCS_BOTTOM        = &H00000003&
const CCS_NORESIZE      = &H00000004&
const CCS_NOPARENTALIGN = &H00000008&
const CCS_NOHILITE      = &H00000010&
const CCS_ADJUSTABLE    = &H00000020&
const CCS_NODIVIDER     = &H00000040&

' ====== LISTVIEW CONTROL =====================================================

'const LVS_ICON            = &H0000& 'Predifined by MS-Test
'const LVS_REPORT          = &H0001& 'Predifined by MS-Test
'const LVS_SMALLICON       = &H0002& 'Predifined by MS-Test
'const LVS_LIST            = &H0003& 'Predifined by MS-Test
const LVS_TYPEMASK        = &H0003&
const LVS_SINGLESEL       = &H0004&
const LVS_SHOWSELALWAYS   = &H0008&
const LVS_SORTASCENDING   = &H0010&
const LVS_SORTDESCENDING  = &H0020&
const LVS_SHAREIMAGELISTS = &H0040&
const LVS_NOLABELWRAP     = &H0080&
const LVS_AUTOARRANGE     = &H0100&
const LVS_EDITLABELS      = &H0200&
const LVS_NOSCROLL        = &H2000&
const LVS_TYPESTYLEMASK   = &Hfc00&
const LVS_ALIGNTOP        = &H0000&
const LVS_ALIGNLEFT       = &H0800&
const LVS_ALIGNMASK       = &H0c00&
const LVS_OWNERDRAWFIXED  = &H0400&
const LVS_NOCOLUMNHEADER  = &H4000&
const LVS_NOSORTHEADER    = &H8000&
const LVM_GETBKCOLOR      = (LVM_FIRST + 0)
const LVM_SETBKCOLOR      = (LVM_FIRST + 1)
const LVM_GETIMAGELIST    = (LVM_FIRST + 2)
const LVSIL_NORMAL        = 0
const LVSIL_SMALL         = 1
const LVSIL_STATE         = 2
const LVM_SETIMAGELIST    = (LVM_FIRST + 3)
const LVM_GETITEMCOUNT    = (LVM_FIRST + 4)
const LVIF_TEXT           = &H0001&
const LVIF_IMAGE          = &H0002&
const LVIF_PARAM          = &H0004&
const LVIF_STATE          = &H0008&
const LVIS_FOCUSED        = &H0001&
const LVIS_SELECTED       = &H0002&
const LVIS_CUT            = &H0004&
const LVIS_DROPHILITED    = &H0008&
const LVIS_LINK           = &H0040&
const LVIS_OVERLAYMASK    = &H0F00&
const LVIS_STATEIMAGEMASK = &HF000&

type LV_ITEM
    mask       as long
    iItem      as long
    iSubItem   as long
    state      as long
    stateMask  as long
    pszText    as pointer to string * 1
    cchTextMax as long
    iImage     as long
    lParam     as long
end type

const LPSTR_TEXTCALLBACK  = (-1&)
const I_IMAGECALLBACK     = (-1)
const LVM_GETITEM         = (LVM_FIRST + 5)
const LVM_SETITEM         = (LVM_FIRST + 6)
const LVM_INSERTITEM      = (LVM_FIRST + 7)
const LVM_DELETEITEM      = (LVM_FIRST + 8)
const LVM_DELETEALLITEMS  = (LVM_FIRST + 9)
const LVM_GETCALLBACKMASK = (LVM_FIRST + 10)
const LVM_SETCALLBACKMASK = (LVM_FIRST + 11)
const LVNI_ALL            = &H0000&
const LVNI_FOCUSED        = &H0001&
const LVNI_SELECTED       = &H0002&
const LVNI_CUT            = &H0004&
const LVNI_DROPHILITED    = &H0008&
const LVNI_PREVIOUS       = &H0020&
const LVNI_ABOVE          = &H0100&
const LVNI_BELOW          = &H0200&
const LVNI_TOLEFT         = &H0400&
const LVNI_TORIGHT        = &H0800&
const LVM_GETNEXTITEM     = (LVM_FIRST + 12)
const LVFI_PARAM          = &H0001&
const LVFI_STRING         = &H0002&
const LVFI_PARTIAL        = &H0008&
const LVFI_WRAP           = &H0020&
const LVFI_NEARESTXY      = &H0040&

type LV_FINDINFO
    flags       as long
    psz         as pointer to string * 1
    lParam      as long
    pt          as POINT
    vkDirection as long
end type

const LVM_FINDITEM         = (LVM_FIRST + 13)
const LVIR_BOUNDS          = 0
const LVIR_ICON            = 1
const LVIR_LABEL           = 2
const LVIR_SELECTBOUNDS    = 3
const LVM_GETITEMRECT      = (LVM_FIRST + 14)
const LVM_SETITEMPOSITION  = (LVM_FIRST + 15)
const LVM_GETITEMPOSITION  = (LVM_FIRST + 16)
const LVM_GETSTRINGWIDTH   = (LVM_FIRST + 17)
const LVHT_NOWHERE         = &H0001&
const LVHT_ONITEMICON      = &H0002&
const LVHT_ONITEMLABEL     = &H0004&
const LVHT_ONITEMSTATEICON = &H0008&
const LVHT_ONITEM          = (LVHT_ONITEMICON or LVHT_ONITEMLABEL or LVHT_ONITEMSTATEICON)
const LVHT_ABOVE           = &H0008&
const LVHT_BELOW           = &H0010&
const LVHT_TORIGHT         = &H0020&
const LVHT_TOLEFT          = &H0040&

type LV_HITTESTINFO
    pt    as POINT
    flags as long
    iItem as long
end type

const LVM_HITTEST        = (LVM_FIRST + 18)
const LVM_ENSUREVISIBLE  = (LVM_FIRST + 19)
const LVM_SCROLL         = (LVM_FIRST + 20)
const LVM_REDRAWITEMS    = (LVM_FIRST + 21)
const LVA_DEFAULT        = &H0000&
const LVA_ALIGNLEFT      = &H0001&
const LVA_ALIGNTOP       = &H0002&
const LVA_ALIGNRIGHT     = &H0003&
const LVA_ALIGNBOTTOM    = &H0004&
const LVA_SNAPTOGRID     = &H0005&
const LVA_SORTASCENDING  = &H0100&
const LVA_SORTDESCENDING = &H0200&
const LVM_ARRANGE        = (LVM_FIRST + 22)
const LVM_EDITLABEL      = (LVM_FIRST + 23)
const LVM_GETEDITCONTROL = (LVM_FIRST + 24)

type LV_COLUMN
    mask       as long
    fmt        as long
    cx         as long
    pszText    as pointer to string * 1
    cchTextMax as long
    iSubItem   as long
end type

const LVCF_FMT                 = &H0001&
const LVCF_WIDTH               = &H0002&
const LVCF_TEXT                = &H0004&
const LVCF_SUBITEM             = &H0008&
const LVCFMT_LEFT              = 0
const LVCFMT_RIGHT             = 1
const LVCFMT_CENTER            = 2
const LVM_GETCOLUMN            = (LVM_FIRST + 25)
const LVM_SETCOLUMN            = (LVM_FIRST + 26)
const LVM_INSERTCOLUMN         = (LVM_FIRST + 27)
const LVM_DELETECOLUMN         = (LVM_FIRST + 28)
const LVM_GETCOLUMNWIDTH       = (LVM_FIRST + 29)
const LVSCW_AUTOSIZE           = -1
const LVSCW_AUTOSIZE_USEHEADER = -2
const LVM_SETCOLUMNWIDTH       = (LVM_FIRST + 30)
const LVM_CREATEDRAGIMAGE      = (LVM_FIRST + 33)
const LVM_GETVIEWRECT          = (LVM_FIRST + 34)
const LVM_GETTEXTCOLOR         = (LVM_FIRST + 35)
const LVM_SETTEXTCOLOR         = (LVM_FIRST + 36)
const LVM_GETTEXTBKCOLOR       = (LVM_FIRST + 37)
const LVM_SETTEXTBKCOLOR       = (LVM_FIRST + 38)
const LVM_GETTOPINDEX          = (LVM_FIRST + 39)
const LVM_GETCOUNTPERPAGE      = (LVM_FIRST + 40)
const LVM_GETORIGIN            = (LVM_FIRST + 41)
const LVM_UPDATE               = (LVM_FIRST + 42)
const LVM_SETITEMSTATE         = (LVM_FIRST + 43)
const LVM_GETITEMSTATE         = (LVM_FIRST + 44)
const LVM_GETITEMTEXT          = (LVM_FIRST + 45)
const LVM_SETITEMTEXT          = (LVM_FIRST + 46)
const LVM_SETITEMCOUNT         = (LVM_FIRST + 47)
const LVM_SORTITEMS            = (LVM_FIRST + 48)
const LVM_SETITEMPOSITION32    = (LVM_FIRST + 49)
const LVM_GETSELECTEDCOUNT     = (LVM_FIRST + 50)
const LVM_GETITEMSPACING       = (LVM_FIRST + 51)
const LVM_GETISEARCHSTRING     = (LVM_FIRST + 52)

type NM_LISTVIEW
    hdr       as NMHDR
    iItem     as long
    iSubItem  as long
    uNewState as long
    uOldState as long
    uChanged  as long
    ptAction  as POINT
    lParam    as long
end type

const LVN_ITEMCHANGING         = (LVN_FIRST-0)
const LVN_ITEMCHANGED          = (LVN_FIRST-1)
const LVN_INSERTITEM           = (LVN_FIRST-2)
const LVN_DELETEITEM           = (LVN_FIRST-3)
const LVN_DELETEALLITEMS       = (LVN_FIRST-4)
const LVN_BEGINLABELEDIT       = (LVN_FIRST-5)
const LVN_ENDLABELEDIT         = (LVN_FIRST-6)
const LVN_COLUMNCLICK          = (LVN_FIRST-8)
const LVN_BEGINDRAG            = (LVN_FIRST-9)
const LVN_ENDDRAG              = (LVN_FIRST-10)
const LVN_BEGINRDRAG           = (LVN_FIRST-11)
const LVN_ENDRDRAG             = (LVN_FIRST-12)
const LVN_PEN                  = (LVN_FIRST-20)
const LVN_GETDISPINFO          = (LVN_FIRST-50)
const LVN_SETDISPINFO          = (LVN_FIRST-51)
const LVIF_DI_SETITEM          = &H1000&

type LV_DISPINFO
    hdr  as NMHDR
    item as LV_ITEM
end type

const LVN_KEYDOWN = (LVN_FIRST-55)

type LV_KEYDOWN
    hdr   as NMHDR
    wVKey as short
    flags as long
end type

' ====== TREEVIEW CONTROL =====================================================

const TVS_HASBUTTONS      = &H0001&
const TVS_HASLINES        = &H0002&
const TVS_LINESATROOT     = &H0004&
const TVS_EDITLABELS      = &H0008&
const TVS_DISABLEDRAGDROP = &H0010&
const TVS_SHOWSELALWAYS   = &H0020&
const TVIF_TEXT           = &H0001&
const TVIF_IMAGE          = &H0002&
const TVIF_PARAM          = &H0004&
const TVIF_STATE          = &H0008&
const TVIF_HANDLE         = &H0010&
const TVIF_SELECTEDIMAGE  = &H0020&
const TVIF_CHILDREN       = &H0040&
const TVIS_FOCUSED        = &H0001&
const TVIS_SELECTED       = &H0002&
const TVIS_CUT            = &H0004&
const TVIS_DROPHILITED    = &H0008&
const TVIS_BOLD           = &H0010&
const TVIS_EXPANDED       = &H0020&
const TVIS_EXPANDEDONCE   = &H0040&
const TVIS_OVERLAYMASK    = &H0F00&
const TVIS_STATEIMAGEMASK = &HF000&
const TVIS_USERMASK       = &HF000&
const I_CHILDRENCALLBACK  = (-1)

type TV_ITEM
    mask           as long
    hItem          as long
    state          as long
    stateMask      as long
    pszText        as pointer to string * 1
    cchTextMax     as long
    iImage         as long
    iSelectedImage as long
    cChildren      as long
    lParam         as long
end type

const TVI_ROOT  = (&HFFFF0000&)
const TVI_FIRST = (&HFFFF0001&)
const TVI_LAST  = (&HFFFF0002&)
const TVI_SORT  = (&HFFFF0003&)

type TV_INSERTSTRUCT
    hParent      as long
    hInsertAfter as long
    item         as TV_ITEM
end type

const TVM_INSERTITEM       = (TV_FIRST + 0)
const TVM_DELETEITEM       = (TV_FIRST + 1)
const TVM_EXPAND           = (TV_FIRST + 2)

const TVE_COLLAPSE         = &H0001&
const TVE_EXPAND           = &H0002&
const TVE_TOGGLE           = &H0003&
const TVE_COLLAPSERESET    = &H8000&
const TVM_GETITEMRECT      = (TV_FIRST + 4)
const TVM_GETCOUNT         = (TV_FIRST + 5)
const TVM_GETINDENT        = (TV_FIRST + 6)
const TVM_SETINDENT        = (TV_FIRST + 7)
const TVM_GETIMAGELIST     = (TV_FIRST + 8)

const TVSIL_NORMAL         = 0
const TVSIL_STATE          = 2

const TVM_SETIMAGELIST     = (TV_FIRST + 9)
const TVM_GETNEXTITEM      = (TV_FIRST + 10)
const TVGN_ROOT            = &H0000&
const TVGN_NEXT            = &H0001&
const TVGN_PREVIOUS        = &H0002&
const TVGN_PARENT          = &H0003&
const TVGN_CHILD           = &H0004&
const TVGN_FIRSTVISIBLE    = &H0005&
const TVGN_NEXTVISIBLE     = &H0006&
const TVGN_PREVIOUSVISIBLE = &H0007&
const TVGN_DROPHILITE      = &H0008&
const TVGN_CARET           = &H0009&
const TVM_SELECTITEM       = (TV_FIRST + 11)
const TVM_GETITEM          = (TV_FIRST + 12)
const TVM_SETITEM          = (TV_FIRST + 13)
const TVM_EDITLABEL        = (TV_FIRST + 14)
const TVM_GETEDITCONTROL   = (TV_FIRST + 15)
const TVM_GETVISIBLECOUNT  = (TV_FIRST + 16)
const TVM_HITTEST          = (TV_FIRST + 17)

type TV_HITTESTINFO
    pt    as POINT
    flags as long
    hItem as long
end type

const TVHT_NOWHERE         = &H0001&
const TVHT_ONITEMICON      = &H0002&
const TVHT_ONITEMLABEL     = &H0004&
const TVHT_ONITEMINDENT    = &H0008&
const TVHT_ONITEMBUTTON    = &H0010&
const TVHT_ONITEMRIGHT     = &H0020&
const TVHT_ONITEMSTATEICON = &H0040&
const TVHT_ABOVE           = &H0100&
const TVHT_BELOW           = &H0200&
const TVHT_TORIGHT         = &H0400&
const TVHT_TOLEFT          = &H0800&
const TVHT_ONITEM          = (TVHT_ONITEMICON or TVHT_ONITEMLABEL or TVHT_ONITEMSTATEICON)

const TVM_CREATEDRAGIMAGE  = (TV_FIRST + 18)
const TVM_SORTCHILDREN     = (TV_FIRST + 19)
const TVM_ENSUREVISIBLE    = (TV_FIRST + 20)
const TVM_SORTCHILDRENCB   = (TV_FIRST + 21)
const TVM_ENDEDITLABELNOW  = (TV_FIRST + 22)
const TVM_GETISEARCHSTRING = (TV_FIRST + 23)

type PFNTVCOMPARE as pointer to Sub (lParam1&, lParam2&, lParamSort&)

type TV_SORTCB
    hParent     as long
    lpfnCompare as PFNTVCOMPARE
    lParam      as long
end type

type NM_TREEVIEW
    hdr     as NMHDR
    action  as long
    itemOld as TV_ITEM
    itemNew as TV_ITEM
    ptDrag  as point
end type

const TVN_SELCHANGING = (TVN_FIRST-1)
const TVN_SELCHANGED  = (TVN_FIRST-2)
const TVC_UNKNOWN     = &H0000&
const TVC_BYMOUSE     = &H0001&
const TVC_BYKEYBOARD  = &H0002&
const TVN_GETDISPINFO = (TVN_FIRST-3)
const TVN_SETDISPINFO = (TVN_FIRST-4)
const TVIF_DI_SETITEM = &H1000&

type TV_DISPINFO
    hdr  as NMHDR
    item as TV_ITEM
end type

const TVN_ITEMEXPANDING  = (TVN_FIRST-5)
const TVN_ITEMEXPANDED   = (TVN_FIRST-6)
const TVN_BEGINDRAG      = (TVN_FIRST-7)
const TVN_BEGINRDRAG     = (TVN_FIRST-8)
const TVN_DELETEITEM     = (TVN_FIRST-9)
const TVN_BEGINLABELEDIT = (TVN_FIRST-10)
const TVN_ENDLABELEDIT   = (TVN_FIRST-11)
const TVN_KEYDOWN        = (TVN_FIRST-12)

type TV_KEYDOWN
    hdr   as NMHDR
    wVKey as short
    flags as long
end type

' ====== TAB CONTROL ==========================================================

const TCS_FORCEICONLEFT     = &H0010&
const TCS_FORCELABELLEFT    = &H0020&
const TCS_SHAREIMAGELISTS   = &H0040&
const TCS_TABS              = &H0000&
const TCS_BUTTONS           = &H0100&
const TCS_SINGLELINE        = &H0000&
const TCS_MULTILINE         = &H0200&
const TCS_RIGHTJUSTIFY      = &H0000&
const TCS_FIXEDWIDTH        = &H0400&
const TCS_RAGGEDRIGHT       = &H0800&
const TCS_FOCUSONBUTTONDOWN = &H1000&
const TCS_OWNERDRAWFIXED    = &H2000&
const TCS_TOOLTIPS          = &H4000&
const TCS_FOCUSNEVER        = &H8000&
const TCM_FIRST             = &H1300&
const TCM_GETBKCOLOR        = (TCM_FIRST + 0)
const TCM_SETBKCOLOR        = (TCM_FIRST + 1)
const TCM_GETIMAGELIST      = (TCM_FIRST + 2)
const TCM_SETIMAGELIST      = (TCM_FIRST + 3)
const TCM_GETITEMCOUNT      = (TCM_FIRST + 4)
const TCIF_TEXT             = &H0001&
const TCIF_IMAGE            = &H0002&
const TCIF_PARAM            = &H0008&

type TC_ITEMHEADER
    mask        as long
    lpReserved1 as long
    lpReserved2 as long
    pszText     as pointer to string * 1
    cchTextMax  as long
    iImage      as long
end type

type TC_ITEM
    mask        as long
    lpReserved1 as long
    lpReserved2 as long
    pszText     as pointer to string * 1
    cchTextMax  as long
    iImage      as long
                   lParam      as long
end type

const TCM_GETITEM        = (TCM_FIRST + 5)
const TCM_SETITEM        = (TCM_FIRST + 6)
const TCM_INSERTITEM     = (TCM_FIRST + 7)
const TCM_DELETEITEM     = (TCM_FIRST + 8)
const TCM_DELETEALLITEMS = (TCM_FIRST + 9)
const TCM_GETITEMRECT    = (TCM_FIRST + 10)
const TCM_GETCURSEL      = (TCM_FIRST + 11)
const TCM_SETCURSEL      = (TCM_FIRST + 12)
const TCHT_NOWHERE       = &H0001&
const TCHT_ONITEMICON    = &H0002&
const TCHT_ONITEMLABEL   = &H0004&
const TCHT_ONITEM        = (TCHT_ONITEMICON or TCHT_ONITEMLABEL)

type TC_HITTESTINFO
    pt    as POINT
    flags as long
end type

const TCM_HITTEST      = (TCM_FIRST + 13)
const TCM_SETITEMEXTRA = (TCM_FIRST + 14)
const TCM_ADJUSTRECT   = (TCM_FIRST + 40)
const TCM_SETITEMSIZE  = (TCM_FIRST + 41)
const TCM_REMOVEIMAGE  = (TCM_FIRST + 42)
const TCM_SETPADDING   = (TCM_FIRST + 43)
const TCM_GETROWCOUNT  = (TCM_FIRST + 44)
const TCM_GETTOOLTIPS  = (TCM_FIRST + 45)
const TCM_SETTOOLTIPS  = (TCM_FIRST + 46)
const TCM_GETCURFOCUS  = (TCM_FIRST + 47)
const TCM_SETCURFOCUS  = (TCM_FIRST + 48)
const TCN_KEYDOWN      = (TCN_FIRST - 0)

type TC_KEYDOWN
    hdr   as NMHDR
    wVKey as short
    flags as long
end type

const TCN_SELCHANGE   = (TCN_FIRST - 1)
const TCN_SELCHANGING = (TCN_FIRST - 2)

' ====== ANIMATE CONTROL ======================================================

const ACS_CENTER      = &H0001&
const ACS_TRANSPARENT = &H0002&
const ACS_AUTOPLAY    = &H0004&
const ACM_OPEN        = (WM_USER+100)
const ACM_PLAY        = (WM_USER+101)
const ACM_STOP        = (WM_USER+102)
const ACN_START       = 1
const ACN_STOP        = 2

' *****************************************************************************
' *  ddeml.h -    DDEML API header file                                       *
' *                                                                           *
' *               Version 3.10                                                *
' *                                                                           *
' *               Copyright (c) 1993-95, Microsoft Corp.  All rights reserved.*
' *                                                                           *
' *****************************************************************************

const SecurityAnonymous      = (0)
const SecurityIdentification = (1)
const SecurityImpersonation  = (2)
const SecurityDelegation     = (3)

'  Quality Of Service
'

type SECURITY_QUALITY_OF_SERVICE
    Length              as long
    ImpersonationLevel  as long
    ContextTrackingMode as long
    EffectiveOnly       as long
end type

'  the following structure is for use with XTYP_WILDCONNECT processing.

type HSZPAIR
    hszSvc   as long
    hszTopic as long
end type

'  The following structure is used by DdeConnect() and DdeConnectList() and
' by XTYP_CONNECT and XTYP_WILDCONNECT callbacks.

type CONVCONTEXT
    cb         as long ' set to sizeof(CONVCONTEXT)
    wFlags     as long ' none currently defined.
    wCountryID as long ' country code for topic/item strings used.
    iCodePage  as long ' codepage used for topic/item strings.
    dwLangID   as long ' language ID for topic/item strings.
    dwSecurity as long ' Private security code.
    qos        as SECURITY_QUALITY_OF_SERVICE ' client side's quality of service
end type

'  The following structure is used by DdeQueryConvInfo():

type CONVINFO
    cb            as long ' sizeof(CONVINFO)
    hUser         as long ' user specified field
    hConvPartner  as long ' hConv on other end or 0 if non-ddemgr partner
    hszSvcPartner as long ' app name of partner if obtainable
    hszServiceReq as long ' AppName requested for connection
    hszTopic      as long ' Topic name for conversation
    hszItem       as long ' transaction item name or NULL if quiescent
    wFmt          as long ' transaction format or NULL if quiescent
    wType         as long ' XTYP_ for current transaction
    wStatus       as long ' ST_ constant for current conversation
    wConvst       as long ' XST_ constant for current transaction
    wLastError    as long ' last transaction error.
    hConvList     as long ' parent hConvList if this conversation is in a list
    ConvCtxt      as CONVCONTEXT ' conversation context
    hwnd          as long ' window handle for this conversation
    hwndPartner   as long ' partner window handle for this conversation
end type

' **** conversation states (usState) ****

const XST_NULL           = 0 ' quiescent states
const XST_INCOMPLETE     = 1
const XST_CONNECTED      = 2
const XST_INIT1          = 3 ' mid-initiation states
const XST_INIT2          = 4
const XST_REQSENT        = 5 ' active conversation states
const XST_DATARCVD       = 6
const XST_POKESENT       = 7
const XST_POKEACKRCVD    = 8
const XST_EXECSENT       = 9
const XST_EXECACKRCVD    = 10
const XST_ADVSENT        = 11
const XST_UNADVSENT      = 12
const XST_ADVACKRCVD     = 13
const XST_UNADVACKRCVD   = 14
const XST_ADVDATASENT    = 15
const XST_ADVDATAACKRCVD = 16

'  used in LOWORD(dwData1) of XTYP_ADVREQ callbacks...

const CADV_LATEACK = &HFFFF&

' **** conversation status bits (fsStatus) ****

const ST_CONNECTED  = &H0001&
const ST_ADVISE     = &H0002&
const ST_ISLOCAL    = &H0004&
const ST_BLOCKED    = &H0008&
const ST_CLIENT     = &H0010&
const ST_TERMINATED = &H0020&
const ST_INLIST     = &H0040&
const ST_BLOCKNEXT  = &H0080&
const ST_ISSELF     = &H0100&

'  DDE constants for wStatus field
const DDE_FACK          = &H8000&
const DDE_FBUSY         = &H4000&
const DDE_FDEFERUPD     = &H4000&
const DDE_FACKREQ       = &H8000&
const DDE_FRELEASE      = &H2000&
const DDE_FREQUESTED    = &H1000&
const DDE_FAPPSTATUS    = &H00ff&
const DDE_FNOTPROCESSED = &H0000&
const DDE_FACKRESERVED  = not (DDE_FACK or DDE_FBUSY or DDE_FAPPSTATUS)
const DDE_FADVRESERVED  = not (DDE_FACKREQ or DDE_FDEFERUPD)
const DDE_FDATRESERVED  = not (DDE_FACKREQ or DDE_FRELEASE or DDE_FREQUESTED)
const DDE_FPOKRESERVED  = not (DDE_FRELEASE)

' **** message filter hook types ****

const MSGF_DDEMGR = &H8001&

' **** codepage constants ***

const CP_WINANSI    = 1004 ' default codepage for windows & old DDE convs.
const CP_WINUNICODE = 1200

' **** transaction types ****

const XTYPF_NOBLOCK        = &H0002& ' CBR_BLOCK will not work
const XTYPF_NODATA         = &H0004& ' DDE_FDEFERUPD
const XTYPF_ACKREQ         = &H0008& ' DDE_FACKREQ
const XCLASS_MASK          = &HFC00&
const XCLASS_BOOL          = &H1000&
const XCLASS_DATA          = &H2000&
const XCLASS_FLAGS         = &H4000&
const XCLASS_NOTIFICATION  = &H8000&
const XTYP_ERROR           = (&H0000& or XCLASS_NOTIFICATION or XTYPF_NOBLOCK )
const XTYP_ADVDATA         = (&H0010& or XCLASS_FLAGS )
const XTYP_ADVREQ          = (&H0020& or XCLASS_DATA or XTYPF_NOBLOCK )
const XTYP_ADVSTART        = (&H0030& or XCLASS_BOOL )
const XTYP_ADVSTOP         = (&H0040& or XCLASS_NOTIFICATION)
const XTYP_EXECUTE         = (&H0050& or XCLASS_FLAGS )
const XTYP_CONNECT         = (&H0060& or XCLASS_BOOL or XTYPF_NOBLOCK)
const XTYP_CONNECT_CONFIRM = (&H0070& or XCLASS_NOTIFICATION or XTYPF_NOBLOCK)
const XTYP_XACT_COMPLETE   = (&H0080& or XCLASS_NOTIFICATION )
const XTYP_POKE            = (&H0090& or XCLASS_FLAGS )
const XTYP_REGISTER        = (&H00A0& or XCLASS_NOTIFICATION or XTYPF_NOBLOCK)
const XTYP_REQUEST         = (&H00B0& or XCLASS_DATA )
const XTYP_DISCONNECT      = (&H00C0& or XCLASS_NOTIFICATION or XTYPF_NOBLOCK)
const XTYP_UNREGISTER      = (&H00D0& or XCLASS_NOTIFICATION or XTYPF_NOBLOCK)
const XTYP_WILDCONNECT     = (&H00E0& or XCLASS_DATA or XTYPF_NOBLOCK)
const XTYP_MASK            = &H00F0&
const XTYP_SHIFT           = 4 ' shift to turn XTYP_ into an index

' **** Timeout constants ****

const TIMEOUT_ASYNC = &HFFFFFFFF&

' **** Transaction ID constants ****

const QID_SYNC = &HFFFFFFFF&

' ***** public strings used in DDE *****

const SZDDESYS_TOPIC         = "System"
const SZDDESYS_ITEM_TOPICS   = "Topics"
const SZDDESYS_ITEM_SYSITEMS = "SysItems"
const SZDDESYS_ITEM_RTNMSG   = "ReturnMessage"
const SZDDESYS_ITEM_STATUS   = "Status"
const SZDDESYS_ITEM_FORMATS  = "Formats"
const SZDDESYS_ITEM_HELP     = "Help"
const SZDDE_ITEM_ITEMLIST    = "TopicItemList"
const SZDDESYS_TOPIC         = "System"
const SZDDESYS_ITEM_TOPICS   = "Topics"
const SZDDESYS_ITEM_SYSITEMS = "SysItems"
const SZDDESYS_ITEM_RTNMSG   = "ReturnMessage"
const SZDDESYS_ITEM_STATUS   = "Status"
const SZDDESYS_ITEM_FORMATS  = "Formats"
const SZDDESYS_ITEM_HELP     = "Help"
const SZDDE_ITEM_ITEMLIST    = "TopicItemList"

' ***** API entry points *****

const CBR_BLOCK = (&Hffffffff&)

'  DLL registration functions

declare function DdeInitialize lib "ddeml.dll"     alias "DdeInitialize"    (pidInst as pointer to long, pfnCallback as pointer to function (uType&, uFmt&, hConv&, hsz1&, hsz2&, hData&, dwData1, dwdata2&) as long, afCmd&, ulRes&) as long

'
' * Callback filter flags for use with standard apps.
'

const CBF_FAIL_SELFCONNECTIONS  = &H00001000&
const CBF_FAIL_CONNECTIONS      = &H00002000&
const CBF_FAIL_ADVISES          = &H00004000&
const CBF_FAIL_EXECUTES         = &H00008000&
const CBF_FAIL_POKES            = &H00010000&
const CBF_FAIL_REQUESTS         = &H00020000&
const CBF_FAIL_ALLSVRXACTIONS   = &H0003f000&
const CBF_SKIP_CONNECT_CONFIRMS = &H00040000&
const CBF_SKIP_REGISTRATIONS    = &H00080000&
const CBF_SKIP_UNREGISTRATIONS  = &H00100000&
const CBF_SKIP_DISCONNECTS      = &H00200000&
const CBF_SKIP_ALLNOTIFICATIONS = &H003c0000&

'
' * Application command flags
'

const APPCMD_CLIENTONLY  = &H00000010&
const APPCMD_FILTERINITS = &H00000020&
const APPCMD_MASK        = &H00000FF0&

'
' * Application classification flags
'

const APPCLASS_STANDARD = &H00000000&
const APPCLASS_MASK     = &H0000000F&

declare function DdeUninitialize lib "ddeml.dll" alias "DdeUninitialize" (idInst&) as long

'
' * conversation enumeration functions
'

declare function DdeConnectList     lib "ddeml.dll" alias "DdeConnectList"     (idInst&, hszService as long, hszTopic as long, hConvList as long, pCC as PCONVCONTEXT) as long
declare function DdeQueryNextServer lib "ddeml.dll" alias "DdeQueryNextServer" (hConvList as long, hConvPrev as long) as long
declare function DdeDisconnectList  lib "ddeml.dll" alias "DdeDisconnectList"  (hConvList as long) as long

'
' * conversation control functions
'

declare function DdeConnect            lib "ddeml.dll" alias "DdeConnect"            (idInst&, hszService as long, hszTopic as long, pCC as PCONVCONTEXT) as long
declare function DdeDisconnect         lib "ddeml.dll" alias "DdeDisconnect"         (hConv as long) as long
declare function DdeReconnect          lib "ddeml.dll" alias "DdeReconnect"          (hConv as long) as long
declare function DdeQueryConvInfo      lib "ddeml.dll" alias "DdeQueryConvInfo"      (hConv as long, idTransaction&, pConvInfo as PCONVINFO) as long
declare function DdeSetUserHandle      lib "ddeml.dll" alias "DdeSetUserHandle"      (hConv as long, id&, hUser&) as long
declare function DdeAbandonTransaction lib "ddeml.dll" alias "DdeAbandonTransaction" (idInst&, hConv as long, idTransaction&) as long

'
' * app server interface functions
'

declare function DdePostAdvise        lib "ddeml.dll" alias "DdePostAdvise"        (idInst&, hszTopic as long, hszItem as long) as long
declare function DdeEnableCallback    lib "ddeml.dll" alias "DdeEnableCallback"    (idInst&, hConv as long, wCmd&) as long
declare function DdeImpersonateClient lib "ddeml.dll" alias "DdeImpersonateClient" (hConv as long) as long

const EC_ENABLEALL    = 0
const EC_ENABLEONE    = ST_BLOCKNEXT
const EC_DISABLE      = ST_BLOCKED
const EC_QUERYWAITING = 2

declare function DdeNameService lib "ddeml.dll" alias "DdeNameService" (idInst&, hsz1 as long, hsz2 as long, afCmd&) as long

const DNS_REGISTER   = &H0001&
const DNS_UNREGISTER = &H0002&
const DNS_FILTERON   = &H0004&
const DNS_FILTEROFF  = &H0008&

'
' * app client interface functions
'

declare function DdeClientTransaction lib "ddeml.dll" alias "DdeClientTransaction" (pData$, cbData&, hConv as long, hszItem as long, wFmt&, wType&, dwTimeout&, pdwResult as pointer to long) as long

'
' *data transfer functions
'

declare function DdeCreateDataHandle lib "ddeml.dll" alias "DdeCreateDataHandle" (idInst&, pSrc$, cb&, cbOff&, hszItem as long, wFmt&, afCmd&) as long
declare function DdeAddData          lib "ddeml.dll" alias "DdeAddData"          (hData as long, pSrc$, cb&, cbOff&) as long
declare function DdeGetData          lib "ddeml.dll" alias "DdeGetData"          (hData as long, pDst$, cbMax&, cbOff&) as long
declare function DdeAccessData       lib "ddeml.dll" alias "DdeAccessData"       (hData as long, pcbDataSize as pointer to long) as long
declare function DdeUnaccessData     lib "ddeml.dll" alias "DdeUnaccessData"     (hData as long) as long
declare function DdeFreeDataHandle   lib "ddeml.dll" alias "DdeFreeDataHandle"   (hData as long) as long

const HDATA_APPOWNED = &H0001&

declare function DdeGetLastError lib "ddeml.dll" alias "DdeGetLastError" (idInst&) as long

const DMLERR_NO_ERROR            = 0 ' must be 0
const DMLERR_FIRST               = &H4000&
const DMLERR_ADVACKTIMEOUT       = &H4000&
const DMLERR_BUSY                = &H4001&
const DMLERR_DATAACKTIMEOUT      = &H4002&
const DMLERR_DLL_NOT_INITIALIZED = &H4003&
const DMLERR_DLL_USAGE           = &H4004&
const DMLERR_EXECACKTIMEOUT      = &H4005&
const DMLERR_INVALIDPARAMETER    = &H4006&
const DMLERR_LOW_MEMORY          = &H4007&
const DMLERR_MEMORY_ERROR        = &H4008&
const DMLERR_NOTPROCESSED        = &H4009&
const DMLERR_NO_CONV_ESTABLISHED = &H400a&
const DMLERR_POKEACKTIMEOUT      = &H400b&
const DMLERR_POSTMSG_FAILED      = &H400c&
const DMLERR_REENTRANCY          = &H400d&
const DMLERR_SERVER_DIED         = &H400e&
const DMLERR_SYS_ERROR           = &H400f&
const DMLERR_UNADVACKTIMEOUT     = &H4010&
const DMLERR_UNFOUND_QUEUE_ID    = &H4011&
const DMLERR_LAST                = &H4011&

declare function DdeCreateStringHandle lib "ddeml.dll" alias "DdeCreateStringHandle" (idInst&, psz$, iCodePage&) as long
declare function DdeQueryString        lib "ddeml.dll" alias "DdeQueryString"        (idInst&, hsz as long, psz$, cchMax&, iCodePage&) as long
declare function DdeFreeStringHandle   lib "ddeml.dll" alias "DdeFreeStringHandle"   (idInst&, hsz as long) as long
declare function DdeKeepStringHandle   lib "ddeml.dll" alias "DdeKeepStringHandle"   (idInst&, hsz as long) as long
declare function DdeCmpStringHandles   lib "ddeml.dll" alias "DdeCmpStringHandles"   (hsz1 as long, hsz2 as long) as long

'
' * DDEML public debugging header file info
'

type DDEML_MSG_HOOK_DAT    '  new for NT
    uiLo   as long ' unpacked lo and hi parts of lParam
    uiHi   as long
    cbData as long ' amount of data in message, if any. May be > than 32 bytes.
    dwData as array of long 'DWORD Data[8]; data peeking by DDESPY is limited to 32 bytes.
    dData  as long ' data peeking by DDESPY is limited to 32 bytes.
end type

type MONMSGSTRUCT
    cb     as long
    hwndTo as long
    dwTime as long
    hTask  as long
    wMsg   as long
    wParam as long
    lParam as long
    dmhd   as DDEML_MSG_HOOK_DAT ' new for NT
end type

type MONCBSTRUCT
    cb      as long
    dwTime  as long
    hTask   as long
    dwRet   as long
    wType   as long
    wFmt    as long
    hConv   as long
    hsz1    as long
    hsz2    as long
    hData   as long
    dwData1 as long
    dwData2 as long
    cc      as CONVCONTEXT ' new for NT for XTYP_CONNECT callbacks
    cbData  as long ' new for NT for data peeking
    dwAData as array of long 'DWORD Data[8]; new for NT for data peeking
    dwData  as long ' new for NT for data peeking
end type

type MONHSZSTRUCT
    cb       as long
    fsAction as long ' MH_ value
    dwTime   as long
    hsz      as long
    hTask    as long
    szStr    as string * 1
end type

const MH_CREATE  = 1
const MH_KEEP    = 2
const MH_DELETE  = 3
const MH_CLEANUP = 4

type MONERRSTRUCT
    cb         as long
    wLastError as long
    dwTime     as long
    hTask      as long
end type

type MONLINKSTRUCT
    cb           as long
    dwTime       as long
    hTask        as long
    fEstablished as long
    fNoData      as long
    hszSvc       as long
    hszTopic     as long
    hszItem      as long
    wFmt         as long
    fServer      as long
    hConvServer  as long
    hConvClient  as long
end type

type MONCONVSTRUCT
    cb          as long
    fConnect    as long
    dwTime      as long
    hTask       as long
    hszSvc      as long
    hszTopic    as long
    hConvClient as long ' Globally unique value != apps local hConv
    hConvServer as long ' Globally unique value != apps local hConv
end type

const MAX_MONITORS     = 4
const APPCLASS_MONITOR = &H00000001&
const XTYP_MONITOR     = (&H00F0& or XCLASS_NOTIFICATION or XTYPF_NOBLOCK)

'
' * Callback filter flags for use with MONITOR apps - 0 implies no monitor
' * callbacks.
'

const MF_HSZ_INFO  = &H01000000&
const MF_SENDMSGS  = &H02000000&
const MF_POSTMSGS  = &H04000000&
const MF_CALLBACKS = &H08000000&
const MF_ERRORS    = &H10000000&
const MF_LINKS     = &H20000000&
const MF_CONV      = &H40000000&
const MF_MASK      = &HFF000000&

'$endif _WIN_API_INCLUDED_
